/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/platform","vs/base/common/arrays","vs/base/common/lifecycle","vs/base/common/arraysFind","vs/base/common/event","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/path","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/cancellation","vs/base/common/types","vs/base/common/network","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codiconsUtil","vs/base/common/objects","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/extpath","vs/base/common/hash","vs/base/common/resources","vs/base/common/async","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/editorWorkerHost","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/textModelSync/textModelSync.impl","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ue=function(W){for(var t=[],n=0,i=W.length;n<i;n++)t[n]=se[W[n]];return t};const Qe=this,Je=typeof global=="object"?global:{};var _e;(function(W){W.global=Qe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(_e||(_e={}));var _e;(function(W){class t{constructor(m,A,b){this.type=m,this.detail=A,this.timestamp=b}}W.LoaderEvent=t;class n{constructor(m){this._events=[new t(1,"",m)]}record(m,A){this._events.push(new t(m,A,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=n;class i{record(m,A){}getEvents(){return[]}}i.INSTANCE=new i,W.NullLoaderEventRecorder=i})(_e||(_e={}));var _e;(function(W){class t{static fileUriToFilePath(i,T){if(T=decodeURI(T).replace(/%23/g,"#"),i){if(/^file:\/\/\//.test(T))return T.substr(8);if(/^file:\/\//.test(T))return T.substr(5)}else if(/^file:\/\//.test(T))return T.substr(7);return T}static startsWith(i,T){return i.length>=T.length&&i.substr(0,T.length)===T}static endsWith(i,T){return i.length>=T.length&&i.substr(i.length-T.length)===T}static containsQueryString(i){return/^[^\#]*\?/gi.test(i)}static isAbsolutePath(i){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(i)}static forEachProperty(i,T){if(i){let m;for(m in i)i.hasOwnProperty(m)&&T(m,i[m])}}static isEmpty(i){let T=!0;return t.forEachProperty(i,()=>{T=!1}),T}static recursiveClone(i){if(!i||typeof i!="object"||i instanceof RegExp||!Array.isArray(i)&&Object.getPrototypeOf(i)!==Object.prototype)return i;let T=Array.isArray(i)?[]:{};return t.forEachProperty(i,(m,A)=>{A&&typeof A=="object"?T[m]=t.recursiveClone(A):T[m]=A}),T}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(i){return t.startsWith(i,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(_e||(_e={}));var _e;(function(W){function t(T){if(T instanceof Error)return T;const m=new Error(T.message||String(T)||"Unknown Error");return T.stack&&(m.stack=T.stack),m}W.ensureError=t;class n{static validateConfigurationOptions(m){function A(b){if(b.phase==="loading"){console.error('Loading "'+b.moduleId+'" failed'),console.error(b),console.error("Here are the modules that depend on it:"),console.error(b.neededBy);return}if(b.phase==="factory"){console.error('The factory function of "'+b.moduleId+'" has thrown an exception'),console.error(b),console.error("Here are the modules that depend on it:"),console.error(b.neededBy);return}}if(m=m||{},typeof m.baseUrl!="string"&&(m.baseUrl=""),typeof m.isBuild!="boolean"&&(m.isBuild=!1),typeof m.paths!="object"&&(m.paths={}),typeof m.config!="object"&&(m.config={}),typeof m.catchError>"u"&&(m.catchError=!1),typeof m.recordStats>"u"&&(m.recordStats=!1),typeof m.urlArgs!="string"&&(m.urlArgs=""),typeof m.onError!="function"&&(m.onError=A),Array.isArray(m.ignoreDuplicateModules)||(m.ignoreDuplicateModules=[]),m.baseUrl.length>0&&(W.Utilities.endsWith(m.baseUrl,"/")||(m.baseUrl+="/")),typeof m.cspNonce!="string"&&(m.cspNonce=""),typeof m.preferScriptTags>"u"&&(m.preferScriptTags=!1),m.nodeCachedData&&typeof m.nodeCachedData=="object"&&(typeof m.nodeCachedData.seed!="string"&&(m.nodeCachedData.seed="seed"),(typeof m.nodeCachedData.writeDelay!="number"||m.nodeCachedData.writeDelay<0)&&(m.nodeCachedData.writeDelay=1e3*7),!m.nodeCachedData.path||typeof m.nodeCachedData.path!="string")){const b=t(new Error("INVALID cached data configuration, 'path' MUST be set"));b.phase="configuration",m.onError(b),m.nodeCachedData=void 0}return m}static mergeConfigurationOptions(m=null,A=null){let b=W.Utilities.recursiveClone(A||{});return W.Utilities.forEachProperty(m,(a,u)=>{a==="ignoreDuplicateModules"&&typeof b.ignoreDuplicateModules<"u"?b.ignoreDuplicateModules=b.ignoreDuplicateModules.concat(u):a==="paths"&&typeof b.paths<"u"?W.Utilities.forEachProperty(u,(g,E)=>b.paths[g]=E):a==="config"&&typeof b.config<"u"?W.Utilities.forEachProperty(u,(g,E)=>b.config[g]=E):b[a]=W.Utilities.recursiveClone(u)}),n.validateConfigurationOptions(b)}}W.ConfigurationOptionsUtil=n;class i{constructor(m,A){if(this._env=m,this.options=n.mergeConfigurationOptions(A),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let b=this.options.nodeRequire.main.filename,a=Math.max(b.lastIndexOf("/"),b.lastIndexOf("\\"));this.options.baseUrl=b.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let m=0;m<this.options.ignoreDuplicateModules.length;m++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[m]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(m,A)=>{Array.isArray(A)?this.sortedPathsRules.push({from:m,to:A}):this.sortedPathsRules.push({from:m,to:[A]})}),this.sortedPathsRules.sort((m,A)=>A.from.length-m.from.length)}cloneAndMerge(m){return new i(this._env,n.mergeConfigurationOptions(m,this.options))}getOptionsLiteral(){return this.options}_applyPaths(m){let A;for(let b=0,a=this.sortedPathsRules.length;b<a;b++)if(A=this.sortedPathsRules[b],W.Utilities.startsWith(m,A.from)){let u=[];for(let g=0,E=A.to.length;g<E;g++)u.push(A.to[g]+m.substr(A.from.length));return u}return[m]}_addUrlArgsToUrl(m){return W.Utilities.containsQueryString(m)?m+"&"+this.options.urlArgs:m+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(m){return this.options.urlArgs?this._addUrlArgsToUrl(m):m}_addUrlArgsIfNecessaryToUrls(m){if(this.options.urlArgs)for(let A=0,b=m.length;A<b;A++)m[A]=this._addUrlArgsToUrl(m[A]);return m}moduleIdToPaths(m){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(m))return this.isBuild()?["empty:"]:["node|"+m];let A=m,b;if(!W.Utilities.endsWith(A,".js")&&!W.Utilities.isAbsolutePath(A)){b=this._applyPaths(A);for(let a=0,u=b.length;a<u;a++)this.isBuild()&&b[a]==="empty:"||(W.Utilities.isAbsolutePath(b[a])||(b[a]=this.options.baseUrl+b[a]),!W.Utilities.endsWith(b[a],".js")&&!W.Utilities.containsQueryString(b[a])&&(b[a]=b[a]+".js"))}else!W.Utilities.endsWith(A,".js")&&!W.Utilities.containsQueryString(A)&&(A=A+".js"),b=[A];return this._addUrlArgsIfNecessaryToUrls(b)}requireToUrl(m){let A=m;return W.Utilities.isAbsolutePath(A)||(A=this._applyPaths(A)[0],W.Utilities.isAbsolutePath(A)||(A=this.options.baseUrl+A)),this._addUrlArgsIfNecessaryToUrl(A)}isBuild(){return this.options.isBuild}shouldInvokeFactory(m){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(m)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[m])}isDuplicateMessageIgnoredFor(m){return this.ignoreDuplicateModulesMap.hasOwnProperty(m)}getConfigForModule(m){if(this.options.config)return this.options.config[m]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(m){this.options.onError(m)}}W.Configuration=i})(_e||(_e={}));var _e;(function(W){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,g,E,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new T;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new n:this._scriptLoader=new m(this._env)}else this._env.isNode?this._scriptLoader=new m(this._env):this._scriptLoader=new n;let c={callback:E,errorback:d};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(c);return}this._callbackMap[g]=[c],this._scriptLoader.load(u,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(u){let g=this._callbackMap[u];delete this._callbackMap[u];for(let E=0;E<g.length;E++)g[E].callback()}triggerErrorback(u,g){let E=this._callbackMap[u];delete this._callbackMap[u];for(let d=0;d<E.length;d++)E[d].errorback(g)}}class n{attachListeners(u,g,E){let d=()=>{u.removeEventListener("load",c),u.removeEventListener("error",e)},c=l=>{d(),g()},e=l=>{d(),E(l)};u.addEventListener("load",c),u.addEventListener("error",e)}load(u,g,E,d){if(/^node\|/.test(g)){let c=u.getConfig().getOptionsLiteral(),e=A(u.getRecorder(),c.nodeRequire||W.global.nodeRequire),l=g.split("|"),h=null;try{h=e(l[1])}catch(w){d(w);return}u.enqueueDefineAnonymousModule([],()=>h),E()}else{let c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript"),this.attachListeners(c,E,d);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),c.setAttribute("src",g);const{cspNonce:l}=u.getConfig().getOptionsLiteral();l&&c.setAttribute("nonce",l),document.getElementsByTagName("head")[0].appendChild(c)}}}function i(a){const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class T{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=i(u)),this._cachedCanUseEval}load(u,g,E,d){if(/^node\|/.test(g)){const c=u.getConfig().getOptionsLiteral(),e=A(u.getRecorder(),c.nodeRequire||W.global.nodeRequire),l=g.split("|");let h=null;try{h=e(l[1])}catch(w){d(w);return}u.enqueueDefineAnonymousModule([],function(){return h}),E()}else{const{trustedTypesPolicy:c}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(g).then(l=>{if(l.status!==200)throw new Error(l.statusText);return l.text()}).then(l=>{l=`${l}
//# sourceURL=${g}`,(c?self.eval(c.createScript("",l)):new Function(l)).call(self),E()}).then(void 0,d);return}try{c&&(g=c.createScriptURL(g)),importScripts(g),E()}catch(l){d(l)}}}}class m{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,g){const{nodeCachedData:E}=g.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,c=u("module");function e(l){const h=l.constructor;let w=function(N){try{return l.require(N)}finally{}};return w.resolve=function(N,_){return h._resolveFilename(N,l,!1,_)},w.resolve.paths=function(N){return h._resolveLookupPaths(N,l)},w.main=process.mainModule,w.extensions=h._extensions,w.cache=h._cache,w}c.prototype._compile=function(l,h){const w=c.wrap(l.replace(/^#!.*/,"")),L=g.getRecorder(),N=d._getCachedDataPath(E,h),_={filename:h};let $;try{const j=d._fs.readFileSync(N);$=j.slice(0,16),_.cachedData=j.slice(16),L.record(60,N)}catch{L.record(61,N)}const o=new d._vm.Script(w,_),s=o.runInThisContext(_),f=d._path.dirname(h),v=e(this),k=[this.exports,v,this,h,f,process,Je,Buffer],R=s.apply(this.exports,k);return d._handleCachedData(o,w,N,!_.cachedData,g),d._verifyCachedData(o,w,N,$,g),R}}load(u,g,E,d){const c=u.getConfig().getOptionsLiteral(),e=A(u.getRecorder(),c.nodeRequire||W.global.nodeRequire),l=c.nodeInstrumenter||function(w){return w};this._init(e),this._initNodeRequire(e,u);let h=u.getRecorder();if(/^node\|/.test(g)){let w=g.split("|"),L=null;try{L=e(w[1])}catch(N){d(N);return}u.enqueueDefineAnonymousModule([],()=>L),E()}else{g=W.Utilities.fileUriToFilePath(this._env.isWindows,g);const w=this._path.normalize(g),L=this._getElectronRendererScriptPathOrUri(w),N=!!c.nodeCachedData,_=N?this._getCachedDataPath(c.nodeCachedData,g):void 0;this._readSourceAndCachedData(w,_,h,($,o,s,f)=>{if($){d($);return}let v;o.charCodeAt(0)===m._BOM?v=m._PREFIX+o.substring(1)+m._SUFFIX:v=m._PREFIX+o+m._SUFFIX,v=l(v,w);const k={filename:L,cachedData:s},R=this._createAndEvalScript(u,v,k,E,d);this._handleCachedData(R,v,_,N&&!s,u),this._verifyCachedData(R,v,_,f,u)})}}_createAndEvalScript(u,g,E,d,c){const e=u.getRecorder();e.record(31,E.filename);const l=new this._vm.Script(g,E),h=l.runInThisContext(E),w=u.getGlobalAMDDefineFunc();let L=!1;const N=function(){return L=!0,w.apply(null,arguments)};return N.amd=w.amd,h.call(W.global,u.getGlobalAMDRequireFunc(),N,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),L?d():c(new Error(`Didn't receive define call in ${E.filename}!`)),l}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let g=u.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,g){const E=this._crypto.createHash("md5").update(g,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(g).replace(/\.js$/,"");return this._path.join(u.path,`${d}-${E}.code`)}_handleCachedData(u,g,E,d,c){u.cachedDataRejected?this._fs.unlink(E,e=>{c.getRecorder().record(62,E),this._createAndWriteCachedData(u,g,E,c),e&&c.getConfig().onError(e)}):d&&this._createAndWriteCachedData(u,g,E,c)}_createAndWriteCachedData(u,g,E,d){let c=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,l=0,h;const w=()=>{setTimeout(()=>{h||(h=this._crypto.createHash("md5").update(g,"utf8").digest());const L=u.createCachedData();if(!(L.length===0||L.length===e||l>=5)){if(L.length<e){w();return}e=L.length,this._fs.writeFile(E,Buffer.concat([h,L]),N=>{N&&d.getConfig().onError(N),d.getRecorder().record(63,E),w()})}},c*Math.pow(4,l++))};w()}_readSourceAndCachedData(u,g,E,d){if(!g)this._fs.readFile(u,{encoding:"utf8"},d);else{let c,e,l,h=2;const w=L=>{L?d(L):--h===0&&d(void 0,c,e,l)};this._fs.readFile(u,{encoding:"utf8"},(L,N)=>{c=N,w(L)}),this._fs.readFile(g,(L,N)=>{!L&&N&&N.length>0?(l=N.slice(0,16),e=N.slice(16),E.record(60,g)):E.record(61,g),w()})}}_verifyCachedData(u,g,E,d,c){d&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();d.equals(e)||(c.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,l=>{l&&c.getConfig().onError(l)}))},Math.ceil(5e3*(1+Math.random()))))}}m._BOM=65279,m._PREFIX="(function (require, define, __filename, __dirname) { ",m._SUFFIX=`
});`;function A(a,u){if(u.__$__isRecorded)return u;const g=function(d){a.record(33,d);try{return u(d)}finally{a.record(34,d)}};return g.__$__isRecorded=!0,g}W.ensureRecordedNodeRequire=A;function b(a){return new t(a)}W.createScriptLoader=b})(_e||(_e={}));var _e;(function(W){class t{constructor(a){let u=a.lastIndexOf("/");u!==-1?this.fromModulePath=a.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(a){let u=a,g;for(g=/\/\.\//;g.test(u);)u=u.replace(g,"/");for(u=u.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(u);)u=u.replace(g,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(a){let u=a;return W.Utilities.isAbsolutePath(u)||(W.Utilities.startsWith(u,"./")||W.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),W.ModuleIdResolver=t;class n{constructor(a,u,g,E,d,c){this.id=a,this.strId=u,this.dependencies=g,this._callback=E,this._errorback=d,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,u){try{return{returnedValue:a.apply(W.global,u),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(a,u,g,E){return a.shouldInvokeFactory(u)?a.shouldCatchError()?this._safeInvokeFunction(g,E):{returnedValue:g.apply(W.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(a,u,g,E){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let c=n._invokeFactory(u,this.strId,this._callback,g);d=c.producedError,a.record(22,this.strId),!d&&typeof c.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=c.returnedValue)}else this.exports=this._callback;if(d){let c=W.ensureError(d);c.phase="factory",c.moduleId=this.strId,c.neededBy=E(this.id),this.error=c,u.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}W.Module=n;class i{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let u=this._strModuleIdToIntModuleId.get(a);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(a,u),this._intModuleIdToStrModuleId[u]=a),u}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class T{constructor(a){this.id=a}}T.EXPORTS=new T(0),T.MODULE=new T(1),T.REQUIRE=new T(2),W.RegularDependency=T;class m{constructor(a,u,g){this.id=a,this.pluginId=u,this.pluginParam=g}}W.PluginDependency=m;class A{constructor(a,u,g,E,d=0){this._env=a,this._scriptLoader=u,this._loaderAvailableTimestamp=d,this._defineFunc=g,this._requireFunc=E,this._moduleIdProvider=new i,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new A(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,u){let g=c=>c.replace(/\\/g,"/"),E=g(a),d=u.split(/\n/);for(let c=0;c<d.length;c++){let e=d[c].match(/(.*):(\d+):(\d+)\)?$/);if(e){let l=e[1],h=e[2],w=e[3],L=Math.max(l.lastIndexOf(" ")+1,l.lastIndexOf("(")+1);if(l=l.substr(L),l=g(l),l===E){let N={line:parseInt(h,10),col:parseInt(w,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],u=0;for(let g=0,E=this._modules2.length;g<E;g++){let d=this._modules2[g];if(!d)continue;let c=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,l=this._buildInfoDependencies[d.id];a[u++]={id:d.strId,path:c,defineLocation:c&&e?A._findRelevantLocationInStack(c,e):null,dependencies:l,shim:null,exports:d.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:a,callback:u}}defineModule(a,u,g,E,d,c=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let l=new n(e,a,this._normalizeDependencies(u,c),g,E,c);this._modules2[e]=l,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(l.dependencies||[]).map(h=>this._moduleIdProvider.getStrModuleId(h.id))),this._resolve(l)}_normalizeDependency(a,u){if(a==="exports")return T.EXPORTS;if(a==="module")return T.MODULE;if(a==="require")return T.REQUIRE;let g=a.indexOf("!");if(g>=0){let E=u.resolveModule(a.substr(0,g)),d=u.resolveModule(a.substr(g+1)),c=this._moduleIdProvider.getModuleId(E+"!"+d),e=this._moduleIdProvider.getModuleId(E);return new m(c,e,d)}return new T(this._moduleIdProvider.getModuleId(u.resolveModule(a)))}_normalizeDependencies(a,u){let g=[],E=0;for(let d=0,c=a.length;d<c;d++)g[E++]=this._normalizeDependency(a[d],u);return g}_relativeRequire(a,u,g,E){if(typeof u=="string")return this.synchronousRequire(u,a);this.defineModule(W.Utilities.generateAnonymousModule(),u,g,E,null,a)}synchronousRequire(a,u=new t(a)){let g=this._normalizeDependency(a,u),E=this._modules2[g.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(a,u){let g=this._config.shouldRecordStats();u?this._config=new W.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),u.dependencies,u.callback,null,u.stack)}}_createLoadError(a,u){let g=this._moduleIdProvider.getStrModuleId(a),E=(this._inverseDependencies2[a]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));const d=W.ensureError(u);return d.phase="loading",d.moduleId=g,d.neededBy=E,d}_onLoadError(a,u){const g=this._createLoadError(a,u);this._modules2[a]||(this._modules2[a]=new n(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let E=[];for(let e=0,l=this._moduleIdProvider.getMaxModuleId();e<l;e++)E[e]=!1;let d=!1,c=[];for(c.push(a),E[a]=!0;c.length>0;){let e=c.shift(),l=this._modules2[e];l&&(d=l.onDependencyError(g)||d);let h=this._inverseDependencies2[e];if(h)for(let w=0,L=h.length;w<L;w++){let N=h[w];E[N]||(c.push(N),E[N]=!0)}}d||this._config.onError(g)}_hasDependencyPath(a,u){let g=this._modules2[a];if(!g)return!1;let E=[];for(let c=0,e=this._moduleIdProvider.getMaxModuleId();c<e;c++)E[c]=!1;let d=[];for(d.push(g),E[a]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let l=0,h=e.length;l<h;l++){let w=e[l];if(w.id===u)return!0;let L=this._modules2[w.id];L&&!E[w.id]&&(E[w.id]=!0,d.push(L))}}return!1}_findCyclePath(a,u,g){if(a===u||g===50)return[a];let E=this._modules2[a];if(!E)return null;let d=E.dependencies;if(d)for(let c=0,e=d.length;c<e;c++){let l=this._findCyclePath(d[c].id,u,g+1);if(l!==null)return l.push(a),l}return null}_createRequire(a){let u=(g,E,d)=>this._relativeRequire(a,g,E,d);return u.toUrl=g=>this._config.requireToUrl(a.resolveModule(g)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(g,E=!1)=>{this.configure(g,E)},u.__$__nodeRequire=W.global.nodeRequire,u}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let u=this._moduleIdProvider.getStrModuleId(a),g=this._config.moduleIdToPaths(u),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||E.test(u))&&g.push("node|"+u);let d=-1,c=e=>{if(d++,d>=g.length)this._onLoadError(a,e);else{let l=g[d],h=this.getRecorder();if(this._config.isBuild()&&l==="empty:"){this._buildInfoPath[a]=l,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}h.record(10,l),this._scriptLoader.load(this,l,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=l),h.record(11,l),this._onLoad(a)},w=>{h.record(12,l),c(w)})}};c(null)}_loadPluginDependency(a,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let g=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],E,null,null)};g.error=E=>{this._config.onError(this._createLoadError(u.id,E))},a.load(u.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(a){let u=a.dependencies;if(u)for(let g=0,E=u.length;g<E;g++){let d=u[g];if(d===T.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(d===T.MODULE){a.unresolvedDependenciesCount--;continue}if(d===T.REQUIRE){a.unresolvedDependenciesCount--;continue}let c=this._modules2[d.id];if(c&&c.isComplete()){if(c.error){a.onDependencyError(c.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,a.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(l=>this._moduleIdProvider.getStrModuleId(l)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(a.id),d instanceof m){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let l=this._inversePluginDependencies2.get(d.pluginId);l||(l=[],this._inversePluginDependencies2.set(d.pluginId,l)),l.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let u=this.getRecorder();if(a.isComplete())return;let g=a.dependencies,E=[];if(g)for(let l=0,h=g.length;l<h;l++){let w=g[l];if(w===T.EXPORTS){E[l]=a.exports;continue}if(w===T.MODULE){E[l]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(w===T.REQUIRE){E[l]=this._createRequire(a.moduleIdResolver);continue}let L=this._modules2[w.id];if(L){E[l]=L.exports;continue}E[l]=null}const d=l=>(this._inverseDependencies2[l]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));a.complete(u,this._config,E,d);let c=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,c)for(let l=0,h=c.length;l<h;l++){let w=c[l],L=this._modules2[w];L.unresolvedDependenciesCount--,L.unresolvedDependenciesCount===0&&this._onModuleComplete(L)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let l=0,h=e.length;l<h;l++)this._loadPluginDependency(a.exports,e[l])}}}W.ModuleManager=A})(_e||(_e={}));var ie,_e;(function(W){const t=new W.Environment;let n=null;const i=function(b,a,u){typeof b!="string"&&(u=a,a=b,b=null),(typeof a!="object"||!Array.isArray(a))&&(u=a,a=null),a||(a=["require","exports","module"]),b?n.defineModule(b,a,u,null,null):n.enqueueDefineAnonymousModule(a,u)};i.amd={jQuery:!0};const T=function(b,a=!1){n.configure(b,a)},m=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){T(arguments[0]);return}if(typeof arguments[0]=="string")return n.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){n.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};m.config=T,m.getConfig=function(){return n.getConfig().getOptionsLiteral()},m.reset=function(){n=n.reset()},m.getBuildInfo=function(){return n.getBuildInfo()},m.getStats=function(){return n.getLoaderEvents()},m.define=i;function A(){if(typeof W.global.require<"u"||typeof require<"u"){const b=W.global.require||require;if(typeof b=="function"&&typeof b.resolve=="function"){const a=W.ensureRecordedNodeRequire(n.getRecorder(),b);W.global.nodeRequire=a,m.nodeRequire=a,m.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=m:(t.isElectronRenderer||(W.global.define=i),W.global.require=m)}W.init=A,(typeof W.global.define!="function"||!W.global.define.amd)&&(n=new W.ModuleManager(t,W.createScriptLoader(t),i,m,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&m.config(W.global.require),ie=function(){return i.apply(null,arguments)},ie.amd=i.amd,typeof doNotInitLoader>"u"&&A())})(_e||(_e={})),ie(se[82],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=n;function n(b,a,u,g){if(g=g||{},(g["vs/css"]||{}).disabled){u({});return}const d=a.toUrl(b+".css");i(b,d,()=>{u({})},c=>{typeof u.error=="function"&&u.error("Could not find "+d+".")})}function i(b,a,u,g){if(T(b,a)){u();return}m(b,a,u,g)}function T(b,a){const u=window.document.getElementsByTagName("link");for(let g=0,E=u.length;g<E;g++){const d=u[g].getAttribute("data-name"),c=u[g].getAttribute("href");if(d===b||c===a)return!0}return!1}function m(b,a,u,g){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",b),A(b,E,u,g),E.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(E)}function A(b,a,u,g){const E=()=>{a.removeEventListener("load",d),a.removeEventListener("error",c)},d=e=>{E(),u()},c=e=>{E(),g(e)};a.addEventListener("load",d),a.addEventListener("error",c)}}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function n(E,d){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(E,d)}catch(c){console.warn(c);return}try{return self.trustedTypes?.createPolicy(E,d)}catch(c){console.warn(c);return}}const i=n("amdLoader",{createScriptURL:E=>E,createScript:(E,...d)=>{const c=d.slice(0,-1).join(","),e=d.pop().toString();return`(function anonymous(${c}) { ${e}
})`}});function T(){try{return(i?globalThis.eval(i.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function m(){return new Promise((E,d)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return E();const c=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,globalThis.origin.length)!==globalThis.origin)&&T()){fetch(c).then(l=>{if(l.status!==200)throw new Error(l.statusText);return l.text()}).then(l=>{l=`${l}
//# sourceURL=${c}`,(i?globalThis.eval(i.createScript("",l)):new Function(l)).call(globalThis),E()}).then(void 0,d);return}i?importScripts(i.createScriptURL(c)):importScripts(c),E()})}function A(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:i,amdModulesPattern:/^vs\//})}function b(E){return m().then(()=>(A(),new Promise((d,c)=>{require([E],d,c)})))}function a(E){setTimeout(function(){const d=E.create((c,e)=>{globalThis.postMessage(c,e)});for(self.onmessage=c=>d.onmessage(c.data,c.ports);g.length>0;)self.onmessage(g.shift())},0)}typeof globalThis.define=="function"&&globalThis.define.amd&&A();let u=!0;const g=[];globalThis.onmessage=E=>{if(!u){g.push(E);return}u=!1,b(E.data).then(d=>{a(d)},d=>{console.error(d)})}}(),ie(se[11],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ob=void 0,t.$hb=n,t.$ib=i,t.$jb=T,t.$kb=m,t.$lb=A,t.$mb=b,t.$nb=a,t.$pb=g,t.$qb=E,t.$rb=d,t.$sb=c,t.$tb=e;function n(l,h){const w=i(l,h);if(w!==-1)return l[w]}function i(l,h,w=l.length-1){for(let L=w;L>=0;L--){const N=l[L];if(h(N))return L}return-1}function T(l,h){const w=m(l,h);return w===-1?void 0:l[w]}function m(l,h,w=0,L=l.length){let N=w,_=L;for(;N<_;){const $=Math.floor((N+_)/2);h(l[$])?N=$+1:_=$}return N-1}function A(l,h){const w=b(l,h);return w===l.length?void 0:l[w]}function b(l,h,w=0,L=l.length){let N=w,_=L;for(;N<_;){const $=Math.floor((N+_)/2);h(l[$])?_=$:N=$+1}return N}function a(l,h,w=0,L=l.length){const N=b(l,h,w,L);return N===l.length?-1:N}class u{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(u.assertInvariants){if(this.d){for(const L of this.e)if(this.d(L)&&!h(L))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const w=m(this.e,h,this.c);return this.c=w+1,w===-1?void 0:this.e[w]}}t.$ob=u;function g(l,h){if(l.length===0)return;let w=l[0];for(let L=1;L<l.length;L++){const N=l[L];h(N,w)>0&&(w=N)}return w}function E(l,h){if(l.length===0)return;let w=l[0];for(let L=1;L<l.length;L++){const N=l[L];h(N,w)>=0&&(w=N)}return w}function d(l,h){return g(l,(w,L)=>-h(w,L))}function c(l,h){if(l.length===0)return-1;let w=0;for(let L=1;L<l.length;L++){const N=l[L];h(N,l[w])>0&&(w=L)}return w}function e(l,h){for(const w of l){const L=h(w);if(L!==void 0)return L}}}),ie(se[3],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var n;(function(i){i[i.Null=0]="Null",i[i.Backspace=8]="Backspace",i[i.Tab=9]="Tab",i[i.LineFeed=10]="LineFeed",i[i.CarriageReturn=13]="CarriageReturn",i[i.Space=32]="Space",i[i.ExclamationMark=33]="ExclamationMark",i[i.DoubleQuote=34]="DoubleQuote",i[i.Hash=35]="Hash",i[i.DollarSign=36]="DollarSign",i[i.PercentSign=37]="PercentSign",i[i.Ampersand=38]="Ampersand",i[i.SingleQuote=39]="SingleQuote",i[i.OpenParen=40]="OpenParen",i[i.CloseParen=41]="CloseParen",i[i.Asterisk=42]="Asterisk",i[i.Plus=43]="Plus",i[i.Comma=44]="Comma",i[i.Dash=45]="Dash",i[i.Period=46]="Period",i[i.Slash=47]="Slash",i[i.Digit0=48]="Digit0",i[i.Digit1=49]="Digit1",i[i.Digit2=50]="Digit2",i[i.Digit3=51]="Digit3",i[i.Digit4=52]="Digit4",i[i.Digit5=53]="Digit5",i[i.Digit6=54]="Digit6",i[i.Digit7=55]="Digit7",i[i.Digit8=56]="Digit8",i[i.Digit9=57]="Digit9",i[i.Colon=58]="Colon",i[i.Semicolon=59]="Semicolon",i[i.LessThan=60]="LessThan",i[i.Equals=61]="Equals",i[i.GreaterThan=62]="GreaterThan",i[i.QuestionMark=63]="QuestionMark",i[i.AtSign=64]="AtSign",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.OpenSquareBracket=91]="OpenSquareBracket",i[i.Backslash=92]="Backslash",i[i.CloseSquareBracket=93]="CloseSquareBracket",i[i.Caret=94]="Caret",i[i.Underline=95]="Underline",i[i.BackTick=96]="BackTick",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.OpenCurlyBrace=123]="OpenCurlyBrace",i[i.Pipe=124]="Pipe",i[i.CloseCurlyBrace=125]="CloseCurlyBrace",i[i.Tilde=126]="Tilde",i[i.NoBreakSpace=160]="NoBreakSpace",i[i.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",i[i.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",i[i.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",i[i.U_Combining_Tilde=771]="U_Combining_Tilde",i[i.U_Combining_Macron=772]="U_Combining_Macron",i[i.U_Combining_Overline=773]="U_Combining_Overline",i[i.U_Combining_Breve=774]="U_Combining_Breve",i[i.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",i[i.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",i[i.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",i[i.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",i[i.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",i[i.U_Combining_Caron=780]="U_Combining_Caron",i[i.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",i[i.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",i[i.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",i[i.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",i[i.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",i[i.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",i[i.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",i[i.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",i[i.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",i[i.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",i[i.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",i[i.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",i[i.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",i[i.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",i[i.U_Combining_Horn=795]="U_Combining_Horn",i[i.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",i[i.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",i[i.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",i[i.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",i[i.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",i[i.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",i[i.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",i[i.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",i[i.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",i[i.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",i[i.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",i[i.U_Combining_Cedilla=807]="U_Combining_Cedilla",i[i.U_Combining_Ogonek=808]="U_Combining_Ogonek",i[i.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",i[i.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",i[i.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",i[i.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",i[i.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",i[i.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",i[i.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",i[i.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",i[i.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",i[i.U_Combining_Low_Line=818]="U_Combining_Low_Line",i[i.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",i[i.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",i[i.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",i[i.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",i[i.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",i[i.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",i[i.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",i[i.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",i[i.U_Combining_Square_Below=827]="U_Combining_Square_Below",i[i.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",i[i.U_Combining_X_Above=829]="U_Combining_X_Above",i[i.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",i[i.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",i[i.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",i[i.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",i[i.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",i[i.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",i[i.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",i[i.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",i[i.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",i[i.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",i[i.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",i[i.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",i[i.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",i[i.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",i[i.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",i[i.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",i[i.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",i[i.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",i[i.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",i[i.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",i[i.U_Combining_Fermata=850]="U_Combining_Fermata",i[i.U_Combining_X_Below=851]="U_Combining_X_Below",i[i.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",i[i.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",i[i.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",i[i.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",i[i.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",i[i.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",i[i.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",i[i.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",i[i.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",i[i.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",i[i.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",i[i.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",i[i.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",i[i.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",i[i.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",i[i.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",i[i.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",i[i.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",i[i.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",i[i.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",i[i.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",i[i.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",i[i.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",i[i.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",i[i.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",i[i.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",i[i.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",i[i.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",i[i.LINE_SEPARATOR=8232]="LINE_SEPARATOR",i[i.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",i[i.NEXT_LINE=133]="NEXT_LINE",i[i.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",i[i.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",i[i.U_DIAERESIS=168]="U_DIAERESIS",i[i.U_MACRON=175]="U_MACRON",i[i.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",i[i.U_CEDILLA=184]="U_CEDILLA",i[i.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",i[i.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",i[i.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",i[i.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",i[i.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",i[i.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",i[i.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",i[i.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",i[i.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",i[i.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",i[i.U_BREVE=728]="U_BREVE",i[i.U_DOT_ABOVE=729]="U_DOT_ABOVE",i[i.U_RING_ABOVE=730]="U_RING_ABOVE",i[i.U_OGONEK=731]="U_OGONEK",i[i.U_SMALL_TILDE=732]="U_SMALL_TILDE",i[i.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",i[i.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",i[i.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",i[i.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",i[i.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",i[i.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",i[i.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",i[i.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",i[i.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",i[i.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",i[i.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",i[i.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",i[i.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",i[i.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",i[i.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",i[i.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",i[i.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",i[i.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",i[i.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",i[i.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",i[i.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",i[i.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",i[i.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",i[i.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",i[i.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",i[i.U_GREEK_TONOS=900]="U_GREEK_TONOS",i[i.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",i[i.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",i[i.U_GREEK_PSILI=8127]="U_GREEK_PSILI",i[i.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",i[i.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",i[i.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",i[i.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",i[i.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",i[i.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",i[i.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",i[i.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",i[i.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",i[i.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",i[i.U_GREEK_VARIA=8175]="U_GREEK_VARIA",i[i.U_GREEK_OXIA=8189]="U_GREEK_OXIA",i[i.U_GREEK_DASIA=8190]="U_GREEK_DASIA",i[i.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",i[i.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",i[i.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",i[i.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",i[i.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",i[i.U_OVERLINE=8254]="U_OVERLINE",i[i.UTF8_BOM=65279]="UTF8_BOM",i[i.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",i[i.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(t.CharCode=n={}))}),ie(se[40],ue([0,1]),function(W,t){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.$g=void 0,t.$c=i,t.$d=T,t.$e=m,t.$f=A;function i(a,u){const g=Object.create(null);for(const E of a){const d=u(E);let c=g[d];c||(c=g[d]=[]),c.push(E)}return g}function T(a,u){const g=[],E=[];for(const d of a)u.has(d)||g.push(d);for(const d of u)a.has(d)||E.push(d);return{removed:g,added:E}}function m(a,u){const g=[],E=[];for(const[d,c]of a)u.has(d)||g.push(c);for(const[d,c]of u)a.has(d)||E.push(c);return{removed:g,added:E}}function A(a,u){const g=new Set;for(const E of u)a.has(E)&&g.add(E);return g}class b{static{n=Symbol.toStringTag}constructor(u,g){this.b=g,this.a=new Map,this[n]="SetWithKey";for(const E of u)this.add(E)}get size(){return this.a.size}add(u){const g=this.b(u);return this.a.set(g,u),this}delete(u){return this.a.delete(this.b(u))}has(u){return this.a.has(this.b(u))}*entries(){for(const u of this.a.values())yield[u,u]}keys(){return this.values()}*values(){for(const u of this.a.values())yield u}clear(){this.a.clear()}forEach(u,g){this.a.forEach(E=>u.call(g,E,E,this))}[Symbol.iterator](){return this.values()}}t.$g=b}),ie(se[41],ue([0,1,3]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uu=t.$tu=t.$su=t.$ru=void 0;function i(a,u){const g=Math.pow(10,u);return Math.round(a*g)/g}class T{constructor(u,g,E,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,E))|0,this.a=i(Math.max(Math.min(1,d),0),3)}static equals(u,g){return u.r===g.r&&u.g===g.g&&u.b===g.b&&u.a===g.a}}t.$ru=T;class m{constructor(u,g,E,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.l=i(Math.max(Math.min(1,E),0),3),this.a=i(Math.max(Math.min(1,d),0),3)}static equals(u,g){return u.h===g.h&&u.s===g.s&&u.l===g.l&&u.a===g.a}static fromRGBA(u){const g=u.r/255,E=u.g/255,d=u.b/255,c=u.a,e=Math.max(g,E,d),l=Math.min(g,E,d);let h=0,w=0;const L=(l+e)/2,N=e-l;if(N>0){switch(w=Math.min(L<=.5?N/(2*L):N/(2-2*L),1),e){case g:h=(E-d)/N+(E<d?6:0);break;case E:h=(d-g)/N+2;break;case d:h=(g-E)/N+4;break}h*=60,h=Math.round(h)}return new m(h,w,L,c)}static i(u,g,E){return E<0&&(E+=1),E>1&&(E-=1),E<1/6?u+(g-u)*6*E:E<1/2?g:E<2/3?u+(g-u)*(2/3-E)*6:u}static toRGBA(u){const g=u.h/360,{s:E,l:d,a:c}=u;let e,l,h;if(E===0)e=l=h=d;else{const w=d<.5?d*(1+E):d+E-d*E,L=2*d-w;e=m.i(L,w,g+1/3),l=m.i(L,w,g),h=m.i(L,w,g-1/3)}return new T(Math.round(e*255),Math.round(l*255),Math.round(h*255),c)}}t.$su=m;class A{constructor(u,g,E,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.v=i(Math.max(Math.min(1,E),0),3),this.a=i(Math.max(Math.min(1,d),0),3)}static equals(u,g){return u.h===g.h&&u.s===g.s&&u.v===g.v&&u.a===g.a}static fromRGBA(u){const g=u.r/255,E=u.g/255,d=u.b/255,c=Math.max(g,E,d),e=Math.min(g,E,d),l=c-e,h=c===0?0:l/c;let w;return l===0?w=0:c===g?w=((E-d)/l%6+6)%6:c===E?w=(d-g)/l+2:w=(g-E)/l+4,new A(Math.round(w*60),h,c,u.a)}static toRGBA(u){const{h:g,s:E,v:d,a:c}=u,e=d*E,l=e*(1-Math.abs(g/60%2-1)),h=d-e;let[w,L,N]=[0,0,0];return g<60?(w=e,L=l):g<120?(w=l,L=e):g<180?(L=e,N=l):g<240?(L=l,N=e):g<300?(w=l,N=e):g<=360&&(w=e,N=l),w=Math.round((w+h)*255),L=Math.round((L+h)*255),N=Math.round((N+h)*255),new T(w,L,N,c)}}t.$tu=A;class b{static fromHex(u){return b.Format.CSS.parseHex(u)||b.red}static equals(u,g){return!u&&!g?!0:!u||!g?!1:u.equals(g)}get hsla(){return this.i?this.i:m.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof T)this.rgba=u;else if(u instanceof m)this.i=u,this.rgba=m.toRGBA(u);else if(u instanceof A)this.j=u,this.rgba=A.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&T.equals(this.rgba,u.rgba)&&m.equals(this.hsla,u.hsla)&&A.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=b.k(this.rgba.r),g=b.k(this.rgba.g),E=b.k(this.rgba.b),d=.2126*u+.7152*g+.0722*E;return i(d,4)}static k(u){const g=u/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(u){const g=this.getRelativeLuminance(),E=u.getRelativeLuminance();return g>E?(g+.05)/(E+.05):(E+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const g=this.getRelativeLuminance(),E=u.getRelativeLuminance();return g>E}isDarkerThan(u){const g=this.getRelativeLuminance(),E=u.getRelativeLuminance();return g<E}lighten(u){return new b(new m(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new b(new m(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:g,g:E,b:d,a:c}=this.rgba;return new b(new T(g,E,d,c*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new b(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const g=u.rgba,E=this.rgba.a,d=g.a,c=E+d*(1-E);if(c<1e-6)return b.transparent;const e=this.rgba.r*E/c+g.r*d*(1-E)/c,l=this.rgba.g*E/c+g.g*d*(1-E)/c,h=this.rgba.b*E/c+g.b*d*(1-E)/c;return new b(new T(e,l,h,c))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:g,g:E,b:d,a:c}=this.rgba;return new b(new T(u.rgba.r-c*(u.rgba.r-g),u.rgba.g-c*(u.rgba.g-E),u.rgba.b-c*(u.rgba.b-d),1))}flatten(...u){const g=u.reduceRight((E,d)=>b.o(d,E));return b.o(this,g)}static o(u,g){const E=1-u.rgba.a;return new b(new T(E*g.rgba.r+u.rgba.a*u.rgba.r,E*g.rgba.g+u.rgba.a*u.rgba.g,E*g.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=b.Format.CSS.format(this)),this.u}static getLighterColor(u,g,E){if(u.isLighterThan(g))return u;E=E||.5;const d=u.getRelativeLuminance(),c=g.getRelativeLuminance();return E=E*(c-d)/c,u.lighten(E)}static getDarkerColor(u,g,E){if(u.isDarkerThan(g))return u;E=E||.5;const d=u.getRelativeLuminance(),c=g.getRelativeLuminance();return E=E*(d-c)/d,u.darken(E)}static{this.white=new b(new T(255,255,255,1))}static{this.black=new b(new T(0,0,0,1))}static{this.red=new b(new T(255,0,0,1))}static{this.blue=new b(new T(0,0,255,1))}static{this.green=new b(new T(0,255,0,1))}static{this.cyan=new b(new T(0,255,255,1))}static{this.lightgrey=new b(new T(211,211,211,1))}static{this.transparent=new b(new T(0,0,0,0))}}t.$uu=b,function(a){let u;(function(g){let E;(function(d){function c(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:a.Format.CSS.formatRGBA(s)}d.formatRGB=c;function e(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}d.formatRGBA=e;function l(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:a.Format.CSS.formatHSLA(s)}d.formatHSL=l;function h(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}d.formatHSLA=h;function w(s){const f=s.toString(16);return f.length!==2?"0"+f:f}function L(s){return`#${w(s.rgba.r)}${w(s.rgba.g)}${w(s.rgba.b)}`}d.formatHex=L;function N(s,f=!1){return f&&s.rgba.a===1?a.Format.CSS.formatHex(s):`#${w(s.rgba.r)}${w(s.rgba.g)}${w(s.rgba.b)}${w(Math.round(s.rgba.a*255))}`}d.formatHexA=N;function _(s){return s.isOpaque()?a.Format.CSS.formatHex(s):a.Format.CSS.formatRGBA(s)}d.format=_;function $(s){const f=s.length;if(f===0||s.charCodeAt(0)!==n.CharCode.Hash)return null;if(f===7){const v=16*o(s.charCodeAt(1))+o(s.charCodeAt(2)),k=16*o(s.charCodeAt(3))+o(s.charCodeAt(4)),R=16*o(s.charCodeAt(5))+o(s.charCodeAt(6));return new a(new T(v,k,R,1))}if(f===9){const v=16*o(s.charCodeAt(1))+o(s.charCodeAt(2)),k=16*o(s.charCodeAt(3))+o(s.charCodeAt(4)),R=16*o(s.charCodeAt(5))+o(s.charCodeAt(6)),j=16*o(s.charCodeAt(7))+o(s.charCodeAt(8));return new a(new T(v,k,R,j/255))}if(f===4){const v=o(s.charCodeAt(1)),k=o(s.charCodeAt(2)),R=o(s.charCodeAt(3));return new a(new T(16*v+v,16*k+k,16*R+R))}if(f===5){const v=o(s.charCodeAt(1)),k=o(s.charCodeAt(2)),R=o(s.charCodeAt(3)),j=o(s.charCodeAt(4));return new a(new T(16*v+v,16*k+k,16*R+R,(16*j+j)/255))}return null}d.parseHex=$;function o(s){switch(s){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(E=g.CSS||(g.CSS={}))})(u=a.Format||(a.Format={}))}(b||(t.$uu=b={}))}),ie(se[42],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xt=void 0;class n{constructor(T,m,A,b){this.originalStart=T,this.originalLength=m,this.modifiedStart=A,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Xt=n}),ie(se[4],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eb=t.$db=t.$cb=t.$bb=t.$ab=t.$$=t.$7=t.$Y=t.$X=void 0,t.setUnexpectedErrorHandler=i,t.$1=T,t.$2=m,t.$3=A,t.$4=b,t.$5=a,t.$6=g,t.$8=d,t.$9=c,t.$0=e,t.$_=h;class n{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?_.isErrorNoTelemetry(s)?new _(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(f=>{f(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}t.$X=n,t.$Y=new n;function i(o){t.$Y.setUnexpectedErrorHandler(o)}function T(o){if(!o||typeof o!="object")return!1;const s=o;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}function m(o){g(o)||t.$Y.onUnexpectedError(o)}function A(o){g(o)||t.$Y.onUnexpectedExternalError(o)}function b(o){if(o instanceof Error){const{name:s,message:f}=o,v=o.stacktrace||o.stack;return{$isError:!0,name:s,message:f,stack:v,noTelemetry:_.isErrorNoTelemetry(o)}}return o}function a(o){let s;return o.noTelemetry?s=new _:(s=new Error,s.name=o.name),s.message=o.message,s.stack=o.stack,s}const u="Canceled";function g(o){return o instanceof E?!0:o instanceof Error&&o.name===u&&o.message===u}class E extends Error{constructor(){super(u),this.name=this.message}}t.$7=E;function d(){const o=new Error(u);return o.name=o.message,o}function c(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function e(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class l extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$$=l;function h(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class w extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.$ab=w;class L extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.$bb=L;class N extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$cb=N;class _ extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof _)return s;const f=new _;return f.message=s.message,f.stack=s.stack,f}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.$db=_;class $ extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}t.$eb=$}),ie(se[9],ue([0,1,4,11]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cc=t.$bc=t.$ac=t.$$b=t.$0b=t.CompareResult=void 0,t.$ub=T,t.$vb=m,t.$wb=A,t.$xb=b,t.$yb=a,t.$zb=u,t.$Ab=g,t.$Bb=E,t.$Cb=d,t.$Db=c,t.$Eb=e,t.$Fb=l,t.$Gb=h,t.top=w,t.$Ib=L,t.$Jb=_,t.$Kb=$,t.$Lb=o,t.$Mb=s,t.$Nb=f,t.$Ob=v,t.$Pb=k,t.$Qb=R,t.$Rb=j,t.$Sb=M,t.$Tb=p,t.$Ub=D,t.$Vb=I,t.$Wb=F,t.$Xb=q,t.$Yb=z,t.$Zb=H,t.$1b=U,t.$2b=C,t.$3b=ee,t.$4b=J,t.$5b=K,t.$6b=ne,t.$7b=P,t.$8b=ge,t.$9b=Ee,t.$_b=Pe,t.$dc=qe;function T(x,G=0){return x[x.length-(1+G)]}function m(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function A(x,G,O=(y,B)=>y===B){if(x===G)return!0;if(!x||!G||x.length!==G.length)return!1;for(let y=0,B=x.length;y<B;y++)if(!O(x[y],G[y]))return!1;return!0}function b(x,G){const O=x.length-1;G<O&&(x[G]=x[O]),x.pop()}function a(x,G,O){return u(x.length,y=>O(x[y],G))}function u(x,G){let O=0,y=x-1;for(;O<=y;){const B=(O+y)/2|0,Y=G(B);if(Y<0)O=B+1;else if(Y>0)y=B-1;else return B}return-(O+1)}function g(x,G,O){if(x=x|0,x>=G.length)throw new TypeError("invalid index");const y=G[Math.floor(G.length*Math.random())],B=[],Y=[],Q=[];for(const ae of G){const we=O(ae,y);we<0?B.push(ae):we>0?Y.push(ae):Q.push(ae)}return x<B.length?g(x,B,O):x<B.length+Q.length?Q[0]:g(x-(B.length+Q.length),Y,O)}function E(x,G){const O=[];let y;for(const B of x.slice(0).sort(G))!y||G(y[0],B)!==0?(y=[B],O.push(y)):y.push(B);return O}function*d(x,G){let O,y;for(const B of x)y!==void 0&&G(y,B)?O.push(B):(O&&(yield O),O=[B]),y=B;O&&(yield O)}function c(x,G){for(let O=0;O<=x.length;O++)G(O===0?void 0:x[O-1],O===x.length?void 0:x[O])}function e(x,G){for(let O=0;O<x.length;O++)G(O===0?void 0:x[O-1],x[O],O+1===x.length?void 0:x[O+1])}function l(x,G,O){const y=[];function B(ae,we,Le){if(we===0&&Le.length===0)return;const Re=y[y.length-1];Re&&Re.start+Re.deleteCount===ae?(Re.deleteCount+=we,Re.toInsert.push(...Le)):y.push({start:ae,deleteCount:we,toInsert:Le})}let Y=0,Q=0;for(;;){if(Y===x.length){B(Y,0,G.slice(Q));break}if(Q===G.length){B(Y,x.length-Y,[]);break}const ae=x[Y],we=G[Q],Le=O(ae,we);Le===0?(Y+=1,Q+=1):Le<0?(B(Y,1,[]),Y+=1):Le>0&&(B(Y,0,[we]),Q+=1)}return y}function h(x,G,O){const y=l(x,G,O),B=[],Y=[];for(const Q of y)B.push(...x.slice(Q.start,Q.start+Q.deleteCount)),Y.push(...Q.toInsert);return{removed:B,added:Y}}function w(x,G,O){if(O===0)return[];const y=x.slice(0,O).sort(G);return N(x,G,y,O,x.length),y}function L(x,G,O,y,B){return O===0?Promise.resolve([]):new Promise((Y,Q)=>{(async()=>{const ae=x.length,we=x.slice(0,O).sort(G);for(let Le=O,Re=Math.min(O+y,ae);Le<ae;Le=Re,Re=Math.min(Re+y,ae)){if(Le>O&&await new Promise(oe=>setTimeout(oe)),B&&B.isCancellationRequested)throw new n.$7;N(x,G,we,Le,Re)}return we})().then(Y,Q)})}function N(x,G,O,y,B){for(const Y=O.length;y<B;y++){const Q=x[y];if(G(Q,O[Y-1])<0){O.pop();const ae=(0,i.$mb)(O,we=>G(Q,we)<0);O.splice(ae,0,Q)}}}function _(x){return x.filter(G=>!!G)}function $(x){let G=0;for(let O=0;O<x.length;O++)x[O]&&(x[G]=x[O],G+=1);x.length=G}function o(x,G,O){x.splice(O,0,x.splice(G,1)[0])}function s(x){return!Array.isArray(x)||x.length===0}function f(x){return Array.isArray(x)&&x.length>0}function v(x,G=O=>O){const O=new Set;return x.filter(y=>{const B=G(y);return O.has(B)?!1:(O.add(B),!0)})}function k(x){const G=new Set;return O=>{const y=x(O);return G.has(y)?!1:(G.add(y),!0)}}function R(x,G){return x.length>0?x[0]:G}function j(x,G){return x.length>0?x[x.length-1]:G}function M(x,G,O=(y,B)=>y===B){let y=0;for(let B=0,Y=Math.min(x.length,G.length);B<Y&&O(x[B],G[B]);B++)y++;return y}function p(x,G){let O=typeof G=="number"?x:0;typeof G=="number"?O=x:(O=0,G=x);const y=[];if(O<=G)for(let B=O;B<G;B++)y.push(B);else for(let B=O;B>G;B--)y.push(B);return y}function D(x,G,O){return x.reduce((y,B)=>(y[G(B)]=O?O(B):B,y),Object.create(null))}function I(x,G){return x.push(G),()=>F(x,G)}function F(x,G){const O=x.indexOf(G);if(O>-1)return x.splice(O,1),G}function q(x,G,O){const y=x.slice(0,G),B=x.slice(G);return y.concat(O,B)}function z(x,G){let O;if(typeof G=="number"){let y=G;O=()=>{const B=Math.sin(y++)*179426549;return B-Math.floor(B)}}else O=Math.random;for(let y=x.length-1;y>0;y-=1){const B=Math.floor(O()*(y+1)),Y=x[y];x[y]=x[B],x[B]=Y}}function H(x,G){const O=x.indexOf(G);O>-1&&(x.splice(O,1),x.unshift(G))}function U(x,G){const O=x.indexOf(G);O>-1&&(x.splice(O,1),x.push(G))}function C(x,G){for(const O of G)x.push(O)}function ee(x,G){return Array.isArray(x)?x.map(G):G(x)}function J(x){return Array.isArray(x)?x:[x]}function K(x){return x[Math.floor(Math.random()*x.length)]}function ne(x,G,O){const y=X(x,G),B=x.length,Y=O.length;x.length=B+Y;for(let Q=B-1;Q>=y;Q--)x[Q+Y]=x[Q];for(let Q=0;Q<Y;Q++)x[Q+y]=O[Q]}function P(x,G,O,y){const B=X(x,G);let Y=x.splice(B,O);return Y===void 0&&(Y=[]),ne(x,B,y),Y}function X(x,G){return G<0?Math.max(G+x.length,0):Math.min(G,x.length)}var he;(function(x){function G(Y){return Y<0}x.isLessThan=G;function O(Y){return Y<=0}x.isLessThanOrEqual=O;function y(Y){return Y>0}x.isGreaterThan=y;function B(Y){return Y===0}x.isNeitherLessOrGreaterThan=B,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(he||(t.CompareResult=he={}));function ge(x,G){return(O,y)=>G(x(O),x(y))}function Ee(...x){return(G,O)=>{for(const y of x){const B=y(G,O);if(!he.isNeitherLessOrGreaterThan(B))return B}return he.neitherLessOrGreaterThan}}const r=(x,G)=>x-G;t.$0b=r;const je=(x,G)=>(0,t.$0b)(x?1:0,G?1:0);t.$$b=je;function Pe(x){return(G,O)=>-x(G,O)}class Ue{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let O=this.c;for(;O<this.g.length&&G(this.g[O]);)O++;const y=O===this.c?null:this.g.slice(this.c,O);return this.c=O,y}takeFromEndWhile(G){let O=this.d;for(;O>=0&&G(this.g[O]);)O--;const y=O===this.d?null:this.g.slice(O+1,this.d+1);return this.d=O,y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const O=this.g.slice(this.c,this.c+G);return this.c+=G,O}}t.$ac=Ue;class Ae{static{this.empty=new Ae(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(O=>(G(O),!0))}toArray(){const G=[];return this.iterate(O=>(G.push(O),!0)),G}filter(G){return new Ae(O=>this.iterate(y=>G(y)?O(y):!0))}map(G){return new Ae(O=>this.iterate(y=>O(G(y))))}some(G){let O=!1;return this.iterate(y=>(O=G(y),!O)),O}findFirst(G){let O;return this.iterate(y=>G(y)?(O=y,!1):!0),O}findLast(G){let O;return this.iterate(y=>(G(y)&&(O=y),!0)),O}findLastMaxBy(G){let O,y=!0;return this.iterate(B=>((y||he.isGreaterThan(G(B,O)))&&(y=!1,O=B),!0)),O}}t.$bc=Ae;class Ne{constructor(G){this.c=G}static createSortPermutation(G,O){const y=Array.from(G.keys()).sort((B,Y)=>O(G[B],G[Y]));return new Ne(y)}apply(G){return G.map((O,y)=>G[this.c[y]])}inverse(){const G=this.c.slice();for(let O=0;O<this.c.length;O++)G[this.c[O]]=O;return new Ne(G)}}t.$cc=Ne;async function qe(x,G){return(await Promise.all(x.map(async(y,B)=>({element:y,ok:await G(y,B)})))).find(y=>y.ok)?.element}}),ie(se[15],ue([0,1,4]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=i,t.$hd=T,t.$id=m,t.$jd=A,t.$kd=b,t.$ld=a;function i(u,g){if(!u)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function T(u,g="Unreachable"){throw new Error(g)}function m(u,g="unexpected state"){if(!u)throw new n.$eb(`Assertion Failed: ${g}`)}function A(u){u||(0,n.$2)(new n.$eb("Soft Assertion Failed"))}function b(u){if(!u()){debugger;u(),(0,n.$2)(new n.$eb("Assertion Failed"))}}function a(u,g){let E=0;for(;E<u.length-1;){const d=u[E],c=u[E+1];if(!g(d,c))return!1;E++}return!0}}),ie(se[25],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fb=n;function n(i,T){const m=this;let A=!1,b;return function(){if(A)return b;if(A=!0,T)try{b=i.apply(m,arguments)}finally{T()}else b=i.apply(m,arguments);return b}}}),ie(se[26],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var n;(function(i){function T(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}i.is=T;const m=Object.freeze([]);function A(){return m}i.empty=A;function*b(s){yield s}i.single=b;function a(s){return T(s)?s:b(s)}i.wrap=a;function u(s){return s||m}i.from=u;function*g(s){for(let f=s.length-1;f>=0;f--)yield s[f]}i.reverse=g;function E(s){return!s||s[Symbol.iterator]().next().done===!0}i.isEmpty=E;function d(s){return s[Symbol.iterator]().next().value}i.first=d;function c(s,f){let v=0;for(const k of s)if(f(k,v++))return!0;return!1}i.some=c;function e(s,f){for(const v of s)if(f(v))return v}i.find=e;function*l(s,f){for(const v of s)f(v)&&(yield v)}i.filter=l;function*h(s,f){let v=0;for(const k of s)yield f(k,v++)}i.map=h;function*w(s,f){let v=0;for(const k of s)yield*f(k,v++)}i.flatMap=w;function*L(...s){for(const f of s)yield*f}i.concat=L;function N(s,f,v){let k=v;for(const R of s)k=f(k,R);return k}i.reduce=N;function*_(s,f,v=s.length){for(f<0&&(f+=s.length),v<0?v+=s.length:v>s.length&&(v=s.length);f<v;f++)yield s[f]}i.slice=_;function $(s,f=Number.POSITIVE_INFINITY){const v=[];if(f===0)return[v,s];const k=s[Symbol.iterator]();for(let R=0;R<f;R++){const j=k.next();if(j.done)return[v,i.empty()];v.push(j.value)}return[v,{[Symbol.iterator](){return k}}]}i.consume=$;async function o(s){const f=[];for await(const v of s)f.push(v);return Promise.resolve(f)}i.asyncToArray=o})(n||(t.Iterable=n={}))}),ie(se[43],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$4r=t.$3r=t.$2r=t.$1r=t.$Zr=t.ScanCode=t.KeyCode=void 0,t.$5r=c;var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i||(t.ScanCode=i={}));class T{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(l,h){this._keyCodeToStr[l]=h,this._strToKeyCode[h.toLowerCase()]=l}keyCodeToStr(l){return this._keyCodeToStr[l]}strToKeyCode(l){return this._strToKeyCode[l.toLowerCase()]||n.Unknown}}const m=new T,A=new T,b=new T;t.$Zr=new Array(230),t.$1r={};const a=[],u=Object.create(null),g=Object.create(null);t.$2r={lowerCaseToEnum:e=>g[e]||i.None,toEnum:e=>u[e]||i.None,toString:e=>a[e]||"None"},t.$3r=[],t.$4r=[];for(let e=0;e<=i.MAX_VALUE;e++)t.$3r[e]=n.DependsOnKbLayout;for(let e=0;e<=n.MAX_VALUE;e++)t.$4r[e]=i.DependsOnKbLayout;(function(){const e="",l=[[1,i.None,"None",n.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,i.Hyper,"Hyper",n.Unknown,e,0,e,e,e],[1,i.Super,"Super",n.Unknown,e,0,e,e,e],[1,i.Fn,"Fn",n.Unknown,e,0,e,e,e],[1,i.FnLock,"FnLock",n.Unknown,e,0,e,e,e],[1,i.Suspend,"Suspend",n.Unknown,e,0,e,e,e],[1,i.Resume,"Resume",n.Unknown,e,0,e,e,e],[1,i.Turbo,"Turbo",n.Unknown,e,0,e,e,e],[1,i.Sleep,"Sleep",n.Unknown,e,0,"VK_SLEEP",e,e],[1,i.WakeUp,"WakeUp",n.Unknown,e,0,e,e,e],[0,i.KeyA,"KeyA",n.KeyA,"A",65,"VK_A",e,e],[0,i.KeyB,"KeyB",n.KeyB,"B",66,"VK_B",e,e],[0,i.KeyC,"KeyC",n.KeyC,"C",67,"VK_C",e,e],[0,i.KeyD,"KeyD",n.KeyD,"D",68,"VK_D",e,e],[0,i.KeyE,"KeyE",n.KeyE,"E",69,"VK_E",e,e],[0,i.KeyF,"KeyF",n.KeyF,"F",70,"VK_F",e,e],[0,i.KeyG,"KeyG",n.KeyG,"G",71,"VK_G",e,e],[0,i.KeyH,"KeyH",n.KeyH,"H",72,"VK_H",e,e],[0,i.KeyI,"KeyI",n.KeyI,"I",73,"VK_I",e,e],[0,i.KeyJ,"KeyJ",n.KeyJ,"J",74,"VK_J",e,e],[0,i.KeyK,"KeyK",n.KeyK,"K",75,"VK_K",e,e],[0,i.KeyL,"KeyL",n.KeyL,"L",76,"VK_L",e,e],[0,i.KeyM,"KeyM",n.KeyM,"M",77,"VK_M",e,e],[0,i.KeyN,"KeyN",n.KeyN,"N",78,"VK_N",e,e],[0,i.KeyO,"KeyO",n.KeyO,"O",79,"VK_O",e,e],[0,i.KeyP,"KeyP",n.KeyP,"P",80,"VK_P",e,e],[0,i.KeyQ,"KeyQ",n.KeyQ,"Q",81,"VK_Q",e,e],[0,i.KeyR,"KeyR",n.KeyR,"R",82,"VK_R",e,e],[0,i.KeyS,"KeyS",n.KeyS,"S",83,"VK_S",e,e],[0,i.KeyT,"KeyT",n.KeyT,"T",84,"VK_T",e,e],[0,i.KeyU,"KeyU",n.KeyU,"U",85,"VK_U",e,e],[0,i.KeyV,"KeyV",n.KeyV,"V",86,"VK_V",e,e],[0,i.KeyW,"KeyW",n.KeyW,"W",87,"VK_W",e,e],[0,i.KeyX,"KeyX",n.KeyX,"X",88,"VK_X",e,e],[0,i.KeyY,"KeyY",n.KeyY,"Y",89,"VK_Y",e,e],[0,i.KeyZ,"KeyZ",n.KeyZ,"Z",90,"VK_Z",e,e],[0,i.Digit1,"Digit1",n.Digit1,"1",49,"VK_1",e,e],[0,i.Digit2,"Digit2",n.Digit2,"2",50,"VK_2",e,e],[0,i.Digit3,"Digit3",n.Digit3,"3",51,"VK_3",e,e],[0,i.Digit4,"Digit4",n.Digit4,"4",52,"VK_4",e,e],[0,i.Digit5,"Digit5",n.Digit5,"5",53,"VK_5",e,e],[0,i.Digit6,"Digit6",n.Digit6,"6",54,"VK_6",e,e],[0,i.Digit7,"Digit7",n.Digit7,"7",55,"VK_7",e,e],[0,i.Digit8,"Digit8",n.Digit8,"8",56,"VK_8",e,e],[0,i.Digit9,"Digit9",n.Digit9,"9",57,"VK_9",e,e],[0,i.Digit0,"Digit0",n.Digit0,"0",48,"VK_0",e,e],[1,i.Enter,"Enter",n.Enter,"Enter",13,"VK_RETURN",e,e],[1,i.Escape,"Escape",n.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,i.Backspace,"Backspace",n.Backspace,"Backspace",8,"VK_BACK",e,e],[1,i.Tab,"Tab",n.Tab,"Tab",9,"VK_TAB",e,e],[1,i.Space,"Space",n.Space,"Space",32,"VK_SPACE",e,e],[0,i.Minus,"Minus",n.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,i.Equal,"Equal",n.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,i.BracketLeft,"BracketLeft",n.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,i.BracketRight,"BracketRight",n.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,i.Backslash,"Backslash",n.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,i.IntlHash,"IntlHash",n.Unknown,e,0,e,e,e],[0,i.Semicolon,"Semicolon",n.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,i.Quote,"Quote",n.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,i.Backquote,"Backquote",n.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,i.Comma,"Comma",n.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,i.Period,"Period",n.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,i.Slash,"Slash",n.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,i.CapsLock,"CapsLock",n.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,i.F1,"F1",n.F1,"F1",112,"VK_F1",e,e],[1,i.F2,"F2",n.F2,"F2",113,"VK_F2",e,e],[1,i.F3,"F3",n.F3,"F3",114,"VK_F3",e,e],[1,i.F4,"F4",n.F4,"F4",115,"VK_F4",e,e],[1,i.F5,"F5",n.F5,"F5",116,"VK_F5",e,e],[1,i.F6,"F6",n.F6,"F6",117,"VK_F6",e,e],[1,i.F7,"F7",n.F7,"F7",118,"VK_F7",e,e],[1,i.F8,"F8",n.F8,"F8",119,"VK_F8",e,e],[1,i.F9,"F9",n.F9,"F9",120,"VK_F9",e,e],[1,i.F10,"F10",n.F10,"F10",121,"VK_F10",e,e],[1,i.F11,"F11",n.F11,"F11",122,"VK_F11",e,e],[1,i.F12,"F12",n.F12,"F12",123,"VK_F12",e,e],[1,i.PrintScreen,"PrintScreen",n.Unknown,e,0,e,e,e],[1,i.ScrollLock,"ScrollLock",n.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,i.Pause,"Pause",n.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,i.Insert,"Insert",n.Insert,"Insert",45,"VK_INSERT",e,e],[1,i.Home,"Home",n.Home,"Home",36,"VK_HOME",e,e],[1,i.PageUp,"PageUp",n.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,i.Delete,"Delete",n.Delete,"Delete",46,"VK_DELETE",e,e],[1,i.End,"End",n.End,"End",35,"VK_END",e,e],[1,i.PageDown,"PageDown",n.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,i.ArrowRight,"ArrowRight",n.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,i.ArrowLeft,"ArrowLeft",n.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,i.ArrowDown,"ArrowDown",n.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,i.ArrowUp,"ArrowUp",n.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,i.NumLock,"NumLock",n.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,i.NumpadDivide,"NumpadDivide",n.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,i.NumpadMultiply,"NumpadMultiply",n.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,i.NumpadSubtract,"NumpadSubtract",n.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,i.NumpadAdd,"NumpadAdd",n.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,i.NumpadEnter,"NumpadEnter",n.Enter,e,0,e,e,e],[1,i.Numpad1,"Numpad1",n.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,i.Numpad2,"Numpad2",n.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,i.Numpad3,"Numpad3",n.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,i.Numpad4,"Numpad4",n.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,i.Numpad5,"Numpad5",n.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,i.Numpad6,"Numpad6",n.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,i.Numpad7,"Numpad7",n.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,i.Numpad8,"Numpad8",n.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,i.Numpad9,"Numpad9",n.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,i.Numpad0,"Numpad0",n.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,i.NumpadDecimal,"NumpadDecimal",n.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,i.IntlBackslash,"IntlBackslash",n.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,i.ContextMenu,"ContextMenu",n.ContextMenu,"ContextMenu",93,e,e,e],[1,i.Power,"Power",n.Unknown,e,0,e,e,e],[1,i.NumpadEqual,"NumpadEqual",n.Unknown,e,0,e,e,e],[1,i.F13,"F13",n.F13,"F13",124,"VK_F13",e,e],[1,i.F14,"F14",n.F14,"F14",125,"VK_F14",e,e],[1,i.F15,"F15",n.F15,"F15",126,"VK_F15",e,e],[1,i.F16,"F16",n.F16,"F16",127,"VK_F16",e,e],[1,i.F17,"F17",n.F17,"F17",128,"VK_F17",e,e],[1,i.F18,"F18",n.F18,"F18",129,"VK_F18",e,e],[1,i.F19,"F19",n.F19,"F19",130,"VK_F19",e,e],[1,i.F20,"F20",n.F20,"F20",131,"VK_F20",e,e],[1,i.F21,"F21",n.F21,"F21",132,"VK_F21",e,e],[1,i.F22,"F22",n.F22,"F22",133,"VK_F22",e,e],[1,i.F23,"F23",n.F23,"F23",134,"VK_F23",e,e],[1,i.F24,"F24",n.F24,"F24",135,"VK_F24",e,e],[1,i.Open,"Open",n.Unknown,e,0,e,e,e],[1,i.Help,"Help",n.Unknown,e,0,e,e,e],[1,i.Select,"Select",n.Unknown,e,0,e,e,e],[1,i.Again,"Again",n.Unknown,e,0,e,e,e],[1,i.Undo,"Undo",n.Unknown,e,0,e,e,e],[1,i.Cut,"Cut",n.Unknown,e,0,e,e,e],[1,i.Copy,"Copy",n.Unknown,e,0,e,e,e],[1,i.Paste,"Paste",n.Unknown,e,0,e,e,e],[1,i.Find,"Find",n.Unknown,e,0,e,e,e],[1,i.AudioVolumeMute,"AudioVolumeMute",n.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,i.AudioVolumeUp,"AudioVolumeUp",n.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,i.AudioVolumeDown,"AudioVolumeDown",n.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,i.NumpadComma,"NumpadComma",n.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,i.IntlRo,"IntlRo",n.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,i.KanaMode,"KanaMode",n.Unknown,e,0,e,e,e],[0,i.IntlYen,"IntlYen",n.Unknown,e,0,e,e,e],[1,i.Convert,"Convert",n.Unknown,e,0,e,e,e],[1,i.NonConvert,"NonConvert",n.Unknown,e,0,e,e,e],[1,i.Lang1,"Lang1",n.Unknown,e,0,e,e,e],[1,i.Lang2,"Lang2",n.Unknown,e,0,e,e,e],[1,i.Lang3,"Lang3",n.Unknown,e,0,e,e,e],[1,i.Lang4,"Lang4",n.Unknown,e,0,e,e,e],[1,i.Lang5,"Lang5",n.Unknown,e,0,e,e,e],[1,i.Abort,"Abort",n.Unknown,e,0,e,e,e],[1,i.Props,"Props",n.Unknown,e,0,e,e,e],[1,i.NumpadParenLeft,"NumpadParenLeft",n.Unknown,e,0,e,e,e],[1,i.NumpadParenRight,"NumpadParenRight",n.Unknown,e,0,e,e,e],[1,i.NumpadBackspace,"NumpadBackspace",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryStore,"NumpadMemoryStore",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryRecall,"NumpadMemoryRecall",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryClear,"NumpadMemoryClear",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryAdd,"NumpadMemoryAdd",n.Unknown,e,0,e,e,e],[1,i.NumpadMemorySubtract,"NumpadMemorySubtract",n.Unknown,e,0,e,e,e],[1,i.NumpadClear,"NumpadClear",n.Clear,"Clear",12,"VK_CLEAR",e,e],[1,i.NumpadClearEntry,"NumpadClearEntry",n.Unknown,e,0,e,e,e],[1,i.None,e,n.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,i.None,e,n.Shift,"Shift",16,"VK_SHIFT",e,e],[1,i.None,e,n.Alt,"Alt",18,"VK_MENU",e,e],[1,i.None,e,n.Meta,"Meta",91,"VK_COMMAND",e,e],[1,i.ControlLeft,"ControlLeft",n.Ctrl,e,0,"VK_LCONTROL",e,e],[1,i.ShiftLeft,"ShiftLeft",n.Shift,e,0,"VK_LSHIFT",e,e],[1,i.AltLeft,"AltLeft",n.Alt,e,0,"VK_LMENU",e,e],[1,i.MetaLeft,"MetaLeft",n.Meta,e,0,"VK_LWIN",e,e],[1,i.ControlRight,"ControlRight",n.Ctrl,e,0,"VK_RCONTROL",e,e],[1,i.ShiftRight,"ShiftRight",n.Shift,e,0,"VK_RSHIFT",e,e],[1,i.AltRight,"AltRight",n.Alt,e,0,"VK_RMENU",e,e],[1,i.MetaRight,"MetaRight",n.Meta,e,0,"VK_RWIN",e,e],[1,i.BrightnessUp,"BrightnessUp",n.Unknown,e,0,e,e,e],[1,i.BrightnessDown,"BrightnessDown",n.Unknown,e,0,e,e,e],[1,i.MediaPlay,"MediaPlay",n.Unknown,e,0,e,e,e],[1,i.MediaRecord,"MediaRecord",n.Unknown,e,0,e,e,e],[1,i.MediaFastForward,"MediaFastForward",n.Unknown,e,0,e,e,e],[1,i.MediaRewind,"MediaRewind",n.Unknown,e,0,e,e,e],[1,i.MediaTrackNext,"MediaTrackNext",n.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,i.MediaTrackPrevious,"MediaTrackPrevious",n.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,i.MediaStop,"MediaStop",n.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,i.Eject,"Eject",n.Unknown,e,0,e,e,e],[1,i.MediaPlayPause,"MediaPlayPause",n.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,i.MediaSelect,"MediaSelect",n.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,i.LaunchMail,"LaunchMail",n.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,i.LaunchApp2,"LaunchApp2",n.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,i.LaunchApp1,"LaunchApp1",n.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,i.SelectTask,"SelectTask",n.Unknown,e,0,e,e,e],[1,i.LaunchScreenSaver,"LaunchScreenSaver",n.Unknown,e,0,e,e,e],[1,i.BrowserSearch,"BrowserSearch",n.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,i.BrowserHome,"BrowserHome",n.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,i.BrowserBack,"BrowserBack",n.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,i.BrowserForward,"BrowserForward",n.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,i.BrowserStop,"BrowserStop",n.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,i.BrowserRefresh,"BrowserRefresh",n.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,i.BrowserFavorites,"BrowserFavorites",n.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,i.ZoomToggle,"ZoomToggle",n.Unknown,e,0,e,e,e],[1,i.MailReply,"MailReply",n.Unknown,e,0,e,e,e],[1,i.MailForward,"MailForward",n.Unknown,e,0,e,e,e],[1,i.MailSend,"MailSend",n.Unknown,e,0,e,e,e],[1,i.None,e,n.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,i.None,e,n.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,i.None,e,n.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,i.None,e,n.Unknown,e,0,"VK_KANA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HANGUL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_JUNJA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_FINAL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HANJA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_KANJI",e,e],[1,i.None,e,n.Unknown,e,0,"VK_CONVERT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_NONCONVERT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ACCEPT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_MODECHANGE",e,e],[1,i.None,e,n.Unknown,e,0,"VK_SELECT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PRINT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EXECUTE",e,e],[1,i.None,e,n.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HELP",e,e],[1,i.None,e,n.Unknown,e,0,"VK_APPS",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PACKET",e,e],[1,i.None,e,n.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,i.None,e,n.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ATTN",e,e],[1,i.None,e,n.Unknown,e,0,"VK_CRSEL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EXSEL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EREOF",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PLAY",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ZOOM",e,e],[1,i.None,e,n.Unknown,e,0,"VK_NONAME",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PA1",e,e],[1,i.None,e,n.Unknown,e,0,"VK_OEM_CLEAR",e,e]],h=[],w=[];for(const L of l){const[N,_,$,o,s,f,v,k,R]=L;if(w[_]||(w[_]=!0,a[_]=$,u[$]=_,g[$.toLowerCase()]=_,N&&(t.$3r[_]=o,o!==n.Unknown&&o!==n.Enter&&o!==n.Ctrl&&o!==n.Shift&&o!==n.Alt&&o!==n.Meta&&(t.$4r[o]=_))),!h[o]){if(h[o]=!0,!s)throw new Error(`String representation missing for key code ${o} around scan code ${$}`);m.define(o,s),A.define(o,k||s),b.define(o,R||k||s)}f&&(t.$Zr[f]=o),v&&(t.$1r[v]=o)}t.$4r[n.Enter]=i.Enter})();var E;(function(e){function l($){return m.keyCodeToStr($)}e.toString=l;function h($){return m.strToKeyCode($)}e.fromString=h;function w($){return A.keyCodeToStr($)}e.toUserSettingsUS=w;function L($){return b.keyCodeToStr($)}e.toUserSettingsGeneral=L;function N($){return A.strToKeyCode($)||b.strToKeyCode($)}e.fromUserSettings=N;function _($){if($>=n.Numpad0&&$<=n.NumpadDivide)return null;switch($){case n.UpArrow:return"Up";case n.DownArrow:return"Down";case n.LeftArrow:return"Left";case n.RightArrow:return"Right"}return m.keyCodeToStr($)}e.toElectronAccelerator=_})(E||(t.KeyCodeUtils=E={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(t.KeyMod=d={}));function c(e,l){const h=(l&65535)<<16>>>0;return(e|h)>>>0}}),ie(se[27],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W=void 0;class n{constructor(T){this.d=T,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$W=n}),ie(se[28],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(m){this.element=m,this.next=n.Undefined,this.prev=n.Undefined}}class i{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let m=this.a;for(;m!==n.Undefined;){const A=m.next;m.prev=n.Undefined,m.next=n.Undefined,m=A}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(m){return this.d(m,!1)}push(m){return this.d(m,!0)}d(m,A){const b=new n(m);if(this.a===n.Undefined)this.a=b,this.b=b;else if(A){const u=this.b;this.b=b,b.prev=u,u.next=b}else{const u=this.a;this.a=b,b.next=u,u.prev=b}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(b))}}shift(){if(this.a!==n.Undefined){const m=this.a.element;return this.e(this.a),m}}pop(){if(this.b!==n.Undefined){const m=this.b.element;return this.e(this.b),m}}e(m){if(m.prev!==n.Undefined&&m.next!==n.Undefined){const A=m.prev;A.next=m.next,m.next.prev=A}else m.prev===n.Undefined&&m.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):m.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):m.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let m=this.a;for(;m!==n.Undefined;)yield m.element,m=m.next}}t.$8c=i}),ie(se[19],ue([0,1]),function(W,t){"use strict";var n,i,T;Object.defineProperty(t,"__esModule",{value:!0}),t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.Touch=t.$Ec=t.$Dc=void 0,t.$Ac=m,t.$Bc=A,t.$Cc=b,t.$Lc=_;function m($,o,s){let f=$.get(o);return f===void 0&&(f=s,$.set(o,f)),f}function A($){const o=[];return $.forEach((s,f)=>{o.push(`${f} => ${s}`)}),`Map(${$.size}) {${o.join(", ")}}`}function b($){const o=[];return $.forEach(s=>{o.push(s)}),`Set(${$.size}) {${o.join(", ")}}`}class a{constructor(o,s){this.uri=o,this.value=s}}function u($){return Array.isArray($)}class g{static{this.c=o=>o.toString()}constructor(o,s){if(this[n]="ResourceMap",o instanceof g)this.d=new Map(o.d),this.e=s??g.c;else if(u(o)){this.d=new Map,this.e=s??g.c;for(const[f,v]of o)this.set(f,v)}else this.d=new Map,this.e=o??g.c}set(o,s){return this.d.set(this.e(o),new a(o,s)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,s){typeof s<"u"&&(o=o.bind(s));for(const[f,v]of this.d)o(v.value,v.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}t.$Dc=g;class E{constructor(o,s){this[i]="ResourceSet",!o||typeof o=="function"?this.c=new g(o):(this.c=new g(s),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,s){this.c.forEach((f,v)=>o.call(s,v,v,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ec=E;var d;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(d||(t.Touch=d={}));class c{constructor(){this[T]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,s=d.None){const f=this.c.get(o);if(f)return s!==d.None&&this.m(f,s),f.value}set(o,s,f=d.None){let v=this.c.get(o);if(v)v.value=s,f!==d.None&&this.m(v,f);else{switch(v={key:o,value:s,next:void 0,previous:void 0},f){case d.None:this.k(v);break;case d.AsOld:this.j(v);break;case d.AsNew:this.k(v);break;default:this.k(v);break}this.c.set(o,v),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const s=this.c.get(o);if(s)return this.c.delete(o),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,s){const f=this.g;let v=this.d;for(;v;){if(s?o.bind(s)(v.value,v.key,this):o(v.value,v.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const o=this,s=this.g;let f=this.d;const v={[Symbol.iterator](){return v},next(){if(o.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.key,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return v}values(){const o=this,s=this.g;let f=this.d;const v={[Symbol.iterator](){return v},next(){if(o.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.value,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return v}entries(){const o=this,s=this.g;let f=this.d;const v={[Symbol.iterator](){return v},next(){if(o.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:[f.key,f.value],done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return v}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let s=this.d,f=this.size;for(;s&&f>o;)this.c.delete(s.key),s=s.next,f--;this.d=s,this.f=f,s&&(s.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let s=this.e,f=this.size;for(;s&&f>o;)this.c.delete(s.key),s=s.previous,f--;this.e=s,this.f=f,s&&(s.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const s=o.next,f=o.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}o.next=void 0,o.previous=void 0,this.g++}m(o,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==d.AsOld&&s!==d.AsNew)){if(s===d.AsOld){if(o===this.d)return;const f=o.next,v=o.previous;o===this.e?(v.next=void 0,this.e=v):(f.previous=v,v.next=f),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(s===d.AsNew){if(o===this.e)return;const f=o.next,v=o.previous;o===this.d?(f.previous=void 0,this.d=f):(f.previous=v,v.next=f),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((s,f)=>{o.push([f,s])}),o}fromJSON(o){this.clear();for(const[s,f]of o)this.set(s,f)}}t.$Fc=c;class e extends c{constructor(o,s=1){super(),this.n=o,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,s=d.AsNew){return super.get(o,s)}peek(o){return super.get(o,d.None)}set(o,s){return super.set(o,s,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class l extends e{constructor(o,s=1){super(o,s)}q(o){this.h(o)}set(o,s){return super.set(o,s),this.p(),this}}t.$Gc=l;class h extends e{constructor(o,s=1){super(o,s)}q(o){this.i(o)}set(o,s){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,s),this}}t.$Hc=h;class w{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let s=this.c.get(o)||0;return s===0?!1:(s--,s===0?this.c.delete(o):this.c.set(o,s),!0)}has(o){return this.c.has(o)}}t.$Ic=w;class L{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[s,f]of o)this.set(s,f)}clear(){this.c.clear(),this.d.clear()}set(o,s){this.c.set(o,s),this.d.set(s,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const s=this.c.get(o);return s===void 0?!1:(this.c.delete(o),this.d.delete(s),!0)}forEach(o,s){this.c.forEach((f,v)=>{o.call(s,f,v,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Jc=L;class N{constructor(){this.c=new Map}add(o,s){let f=this.c.get(o);f||(f=new Set,this.c.set(o,f)),f.add(s)}delete(o,s){const f=this.c.get(o);f&&(f.delete(s),f.size===0&&this.c.delete(o))}forEach(o,s){const f=this.c.get(o);f&&f.forEach(s)}get(o){const s=this.c.get(o);return s||new Set}}t.$Kc=N;function _($,o){if($===o)return!0;if($.size!==o.size)return!1;for(const[s,f]of $)if(!o.has(s)||o.get(s)!==f)return!1;for(const[s]of o)if(!$.has(s))return!1;return!0}}),ie(se[10],ue([0,1,9,40,19,25,26]),function(W,t,n,i,T,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=t.$5c=t.$4c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Mc=void 0,t.$Nc=g,t.$Oc=E,t.$Pc=d,t.$Qc=l,t.$Rc=h,t.$Sc=w,t.$Tc=L,t.$Uc=N,t.$Vc=_,t.$6c=p;const b=!1;let a=null;class u{constructor(){this.b=new Map}static{this.a=0}c(F){let q=this.b.get(F);return q||(q={parent:null,source:null,isSingleton:!1,value:F,idx:u.a++},this.b.set(F,q)),q}trackDisposable(F){const q=this.c(F);q.source||(q.source=new Error().stack)}setParent(F,q){const z=this.c(F);z.parent=q}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,q){const z=q.get(F);if(z)return z;const H=F.parent?this.f(this.c(F.parent),q):F;return q.set(F,H),H}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,F).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(F=10,q){let z;if(q)z=q;else{const J=new Map,K=[...this.b.values()].filter(P=>P.source!==null&&!this.f(P,J).isSingleton);if(K.length===0)return;const ne=new Set(K.map(P=>P.value));if(z=K.filter(P=>!(P.parent&&ne.has(P.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function H(J){function K(P,X){for(;P.length>0&&X.some(he=>typeof he=="string"?he===P[0]:P[0].match(he));)P.shift()}const ne=J.source.split(`
`).map(P=>P.trim().replace("at ","")).filter(P=>P!=="");return K(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const U=new T.$Kc;for(const J of z){const K=H(J);for(let ne=0;ne<=K.length;ne++)U.add(K.slice(0,ne).join(`
`),J)}z.sort((0,n.$8b)(J=>J.idx,n.$0b));let C="",ee=0;for(const J of z.slice(0,F)){ee++;const K=H(J),ne=[];for(let P=0;P<K.length;P++){let X=K[P];X=`(shared with ${U.get(K.slice(0,P+1).join(`
`)).size}/${z.length} leaks) at ${X}`;const ge=U.get(K.slice(0,P).join(`
`)),Ee=(0,i.$c)([...ge].map(r=>H(r)[P]),r=>r);delete Ee[K[P]];for(const[r,je]of Object.entries(Ee))ne.unshift(`    - stacktraces of ${je.length} other leaks continue with ${r}`);ne.unshift(X)}C+=`


==================== Leaking disposable ${ee}/${z.length}: ${J.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return z.length>F&&(C+=`


... and ${z.length-F} more leaking disposables

`),{leaks:z,details:C}}}t.$Mc=u;function g(I){a=I}if(b){const I="__is_disposable_tracked__";g(new class{trackDisposable(F){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[I]||console.log(q)},3e3)}setParent(F,q){if(F&&F!==o.None)try{F[I]=!0}catch{}}markAsDisposed(F){if(F&&F!==o.None)try{F[I]=!0}catch{}}markAsSingleton(F){}})}function E(I){return a?.trackDisposable(I),I}function d(I){a?.markAsDisposed(I)}function c(I,F){a?.setParent(I,F)}function e(I,F){if(a)for(const q of I)a.setParent(q,F)}function l(I){return a?.markAsSingleton(I),I}function h(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function w(I){if(A.Iterable.is(I)){const F=[];for(const q of I)if(q)try{q.dispose()}catch(z){F.push(z)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function L(I){for(const F of I)h(F)&&F.dispose();return[]}function N(...I){const F=_(()=>w(I));return e(I,F),F}function _(I){const F=E({dispose:(0,m.$fb)(()=>{d(F),I()})});return F}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{w(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return c(F,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),c(F,null))}}t.$Wc=$;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,E(this),c(this.q,this)}dispose(){d(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}t.$Xc=o;class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&c(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&c(F,null),F}}t.$Yc=s;class f{constructor(F){this.a=new s,this.b=!1,this.a.value=F}get value(){return this.a.value}set value(F){this.b||F===this.a.value||(this.a.value=F)}dispose(){this.b=!0,this.a.dispose()}}t.$Zc=f;class v{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$1c=v;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(F){let q=F;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,d(this))},this}}t.$2c=k;class R{constructor(){this.a=new Map}acquire(F,...q){let z=this.a.get(F);z||(z={counter:0,object:this.b(F,...q)},this.a.set(F,z));const{object:H}=z,U=(0,m.$fb)(()=>{--z.counter===0&&(this.c(F,z.object),this.a.delete(F))});return z.counter++,{object:H,dispose:U}}}t.$3c=R;class j{constructor(F){this.a=F}async acquire(F,...q){const z=this.a.acquire(F,...q);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(H){throw z.dispose(),H}}}t.$4c=j;class M{constructor(F){this.object=F}dispose(){}}t.$5c=M;function p(I){const F=new $;try{I(F)}finally{F.dispose()}}class D{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,q,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(F)?.dispose(),this.a.set(F,q)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}deleteAndLeak(F){const q=this.a.get(F);return this.a.delete(F),q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$7c=D}),ie(se[44],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadInstance=8]="CommentThreadInstance",i[i.CommentThreadReply=9]="CommentThreadReply",i[i.CommentNode=10]="CommentNode",i[i.CommentThreadNode=11]="CommentThreadNode",i[i.TimelineActionContext=12]="TimelineActionContext",i[i.NotebookCellActionContext=13]="NotebookCellActionContext",i[i.NotebookActionContext=14]="NotebookActionContext",i[i.TerminalContext=15]="TerminalContext",i[i.TestItemContext=16]="TestItemContext",i[i.Date=17]="Date",i[i.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(t.MarshalledId=n={}))}),ie(se[8],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.OS=t.OperatingSystem=t.$C=t.$B=t.$A=t.$z=t.$y=t.Language=t.$x=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.Platform=t.$h=void 0,t.$i=o,t.$E=j,t.$K=M,t.$h="en";let n=!1,i=!1,T=!1,m=!1,A=!1,b=!1,a=!1,u=!1,g=!1,E=!1,d,c=t.$h,e=t.$h,l,h;const w=globalThis;let L;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?L=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(L=process);const N=typeof L?.versions?.electron=="string",_=N&&L?.type==="renderer";if(typeof L=="object"){n=L.platform==="win32",i=L.platform==="darwin",T=L.platform==="linux",m=T&&!!L.env.SNAP&&!!L.env.SNAP_REVISION,a=N,g=!!L.env.CI||!!L.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=t.$h,c=t.$h;const p=L.env.VSCODE_NLS_CONFIG;if(p)try{const D=JSON.parse(p);d=D.userLocale,e=D.osLocale,c=D.resolvedLanguage||t.$h,l=D.languagePack?.translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!_?(h=navigator.userAgent,n=h.indexOf("Windows")>=0,i=h.indexOf("Macintosh")>=0,u=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=h.indexOf("Linux")>=0,E=h?.indexOf("Mobi")>=0,b=!0,c=globalThis._VSCODE_NLS_LANGUAGE||t.$h,d=navigator.language.toLowerCase(),e=d):console.error("Unable to resolve platform.");var $;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})($||(t.Platform=$={}));function o(p){switch(p){case $.Web:return"Web";case $.Mac:return"Mac";case $.Linux:return"Linux";case $.Windows:return"Windows"}}let s=$.Web;i?s=$.Mac:n?s=$.Windows:T&&(s=$.Linux),t.$j=n,t.$k=i,t.$l=T,t.$m=m,t.$n=A,t.$o=a,t.$p=b,t.$q=b&&typeof w.importScripts=="function",t.$r=t.$q?w.origin:void 0,t.$s=u,t.$t=E,t.$u=g,t.$v=s,t.$w=h,t.$x=c;var f;(function(p){function D(){return t.$x}p.value=D;function I(){return t.$x.length===2?t.$x==="en":t.$x.length>=3?t.$x[0]==="e"&&t.$x[1]==="n"&&t.$x[2]==="-":!1}p.isDefaultVariant=I;function F(){return t.$x==="en"}p.isDefault=F})(f||(t.Language=f={})),t.$y=d,t.$z=e,t.$A=l,t.$B=typeof w.postMessage=="function"&&!w.importScripts,t.$C=(()=>{if(t.$B){const p=[];w.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let F=0,q=p.length;F<q;F++){const z=p[F];if(z.id===I.data.vscodeScheduleAsyncWork){p.splice(F,1),z.callback();return}}});let D=0;return I=>{const F=++D;p.push({id:F,callback:I}),w.postMessage({vscodeScheduleAsyncWork:F},"*")}}return p=>setTimeout(p)})();var v;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(v||(t.OperatingSystem=v={})),t.OS=i||u?v.Macintosh:n?v.Windows:v.Linux;let k=!0,R=!1;function j(){if(!R){R=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,k=new Uint16Array(p.buffer)[0]===513}return k}t.$F=!!(t.$w&&t.$w.indexOf("Chrome")>=0),t.$G=!!(t.$w&&t.$w.indexOf("Firefox")>=0),t.$H=!!(!t.$F&&t.$w&&t.$w.indexOf("Safari")>=0),t.$I=!!(t.$w&&t.$w.indexOf("Edg/")>=0),t.$J=!!(t.$w&&t.$w.indexOf("Android")>=0);function M(p){return parseFloat(p)>=20}}),ie(se[45],ue([0,1,8]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hc=t.$gc=t.env=t.cwd=void 0;let i;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const m=T.process;i={get platform(){return m.platform},get arch(){return m.arch},get env(){return m.env},cwd(){return m.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return n.$j?"win32":n.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.$gc=i.platform,t.$hc=i.arch});var Ce=this&&this.__createBinding||(Object.create?function(W,t,n,i){i===void 0&&(i=n);var T=Object.getOwnPropertyDescriptor(t,n);(!T||("get"in T?!t.__esModule:T.writable||T.configurable))&&(T={enumerable:!0,get:function(){return t[n]}}),Object.defineProperty(W,i,T)}:function(W,t,n,i){i===void 0&&(i=n),W[i]=t[n]}),Ke=this&&this.__setModuleDefault||(Object.create?function(W,t){Object.defineProperty(W,"default",{enumerable:!0,value:t})}:function(W,t){W.default=t}),ke=this&&this.__importStar||function(W){if(W&&W.__esModule)return W;var t={};if(W!=null)for(var n in W)n!=="default"&&Object.prototype.hasOwnProperty.call(W,n)&&Ce(t,W,n);return Ke(t,W),t};ie(se[16],ue([0,1,45]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.sep=t.$uc=t.$tc=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=void 0,n=ke(n);const i=65,T=97,m=90,A=122,b=46,a=47,u=92,g=58,E=63;class d extends Error{constructor(f,v,k){let R;typeof v=="string"&&v.indexOf("not ")===0?(R="must not be",v=v.replace(/^not /,"")):R="must be";const j=f.indexOf(".")!==-1?"property":"argument";let M=`The "${f}" ${j} ${R} of type ${v}`;M+=`. Received type ${typeof k}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,f){if(s===null||typeof s!="object")throw new d(f,"Object",s)}function e(s,f){if(typeof s!="string")throw new d(f,"string",s)}const l=n.$gc==="win32";function h(s){return s===a||s===u}function w(s){return s===a}function L(s){return s>=i&&s<=m||s>=T&&s<=A}function N(s,f,v,k){let R="",j=0,M=-1,p=0,D=0;for(let I=0;I<=s.length;++I){if(I<s.length)D=s.charCodeAt(I);else{if(k(D))break;D=a}if(k(D)){if(!(M===I-1||p===1))if(p===2){if(R.length<2||j!==2||R.charCodeAt(R.length-1)!==b||R.charCodeAt(R.length-2)!==b){if(R.length>2){const F=R.lastIndexOf(v);F===-1?(R="",j=0):(R=R.slice(0,F),j=R.length-1-R.lastIndexOf(v)),M=I,p=0;continue}else if(R.length!==0){R="",j=0,M=I,p=0;continue}}f&&(R+=R.length>0?`${v}..`:"..",j=2)}else R.length>0?R+=`${v}${s.slice(M+1,I)}`:R=s.slice(M+1,I),j=I-M-1;M=I,p=0}else D===b&&p!==-1?++p:p=-1}return R}function _(s){return s?`${s[0]==="."?"":"."}${s}`:""}function $(s,f){c(f,"pathObject");const v=f.dir||f.root,k=f.base||`${f.name||""}${_(f.ext)}`;return v?v===f.root?`${v}${k}`:`${v}${s}${k}`:k}t.$ic={resolve(...s){let f="",v="",k=!1;for(let R=s.length-1;R>=-1;R--){let j;if(R>=0){if(j=s[R],e(j,`paths[${R}]`),j.length===0)continue}else f.length===0?j=n.cwd():(j=n.env[`=${f}`]||n.cwd(),(j===void 0||j.slice(0,2).toLowerCase()!==f.toLowerCase()&&j.charCodeAt(2)===u)&&(j=`${f}\\`));const M=j.length;let p=0,D="",I=!1;const F=j.charCodeAt(0);if(M===1)h(F)&&(p=1,I=!0);else if(h(F))if(I=!0,h(j.charCodeAt(1))){let q=2,z=q;for(;q<M&&!h(j.charCodeAt(q));)q++;if(q<M&&q!==z){const H=j.slice(z,q);for(z=q;q<M&&h(j.charCodeAt(q));)q++;if(q<M&&q!==z){for(z=q;q<M&&!h(j.charCodeAt(q));)q++;(q===M||q!==z)&&(D=`\\\\${H}\\${j.slice(z,q)}`,p=q)}}}else p=1;else L(F)&&j.charCodeAt(1)===g&&(D=j.slice(0,2),p=2,M>2&&h(j.charCodeAt(2))&&(I=!0,p=3));if(D.length>0)if(f.length>0){if(D.toLowerCase()!==f.toLowerCase())continue}else f=D;if(k){if(f.length>0)break}else if(v=`${j.slice(p)}\\${v}`,k=I,I&&f.length>0)break}return v=N(v,!k,"\\",h),k?`${f}\\${v}`:`${f}${v}`||"."},normalize(s){e(s,"path");const f=s.length;if(f===0)return".";let v=0,k,R=!1;const j=s.charCodeAt(0);if(f===1)return w(j)?"\\":s;if(h(j))if(R=!0,h(s.charCodeAt(1))){let p=2,D=p;for(;p<f&&!h(s.charCodeAt(p));)p++;if(p<f&&p!==D){const I=s.slice(D,p);for(D=p;p<f&&h(s.charCodeAt(p));)p++;if(p<f&&p!==D){for(D=p;p<f&&!h(s.charCodeAt(p));)p++;if(p===f)return`\\\\${I}\\${s.slice(D)}\\`;p!==D&&(k=`\\\\${I}\\${s.slice(D,p)}`,v=p)}}}else v=1;else L(j)&&s.charCodeAt(1)===g&&(k=s.slice(0,2),v=2,f>2&&h(s.charCodeAt(2))&&(R=!0,v=3));let M=v<f?N(s.slice(v),!R,"\\",h):"";return M.length===0&&!R&&(M="."),M.length>0&&h(s.charCodeAt(f-1))&&(M+="\\"),k===void 0?R?`\\${M}`:M:R?`${k}\\${M}`:`${k}${M}`},isAbsolute(s){e(s,"path");const f=s.length;if(f===0)return!1;const v=s.charCodeAt(0);return h(v)||f>2&&L(v)&&s.charCodeAt(1)===g&&h(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let f,v;for(let j=0;j<s.length;++j){const M=s[j];e(M,"path"),M.length>0&&(f===void 0?f=v=M:f+=`\\${M}`)}if(f===void 0)return".";let k=!0,R=0;if(typeof v=="string"&&h(v.charCodeAt(0))){++R;const j=v.length;j>1&&h(v.charCodeAt(1))&&(++R,j>2&&(h(v.charCodeAt(2))?++R:k=!1))}if(k){for(;R<f.length&&h(f.charCodeAt(R));)R++;R>=2&&(f=`\\${f.slice(R)}`)}return t.$ic.normalize(f)},relative(s,f){if(e(s,"from"),e(f,"to"),s===f)return"";const v=t.$ic.resolve(s),k=t.$ic.resolve(f);if(v===k||(s=v.toLowerCase(),f=k.toLowerCase(),s===f))return"";let R=0;for(;R<s.length&&s.charCodeAt(R)===u;)R++;let j=s.length;for(;j-1>R&&s.charCodeAt(j-1)===u;)j--;const M=j-R;let p=0;for(;p<f.length&&f.charCodeAt(p)===u;)p++;let D=f.length;for(;D-1>p&&f.charCodeAt(D-1)===u;)D--;const I=D-p,F=M<I?M:I;let q=-1,z=0;for(;z<F;z++){const U=s.charCodeAt(R+z);if(U!==f.charCodeAt(p+z))break;U===u&&(q=z)}if(z!==F){if(q===-1)return k}else{if(I>F){if(f.charCodeAt(p+z)===u)return k.slice(p+z+1);if(z===2)return k.slice(p+z)}M>F&&(s.charCodeAt(R+z)===u?q=z:z===2&&(q=3)),q===-1&&(q=0)}let H="";for(z=R+q+1;z<=j;++z)(z===j||s.charCodeAt(z)===u)&&(H+=H.length===0?"..":"\\..");return p+=q,H.length>0?`${H}${k.slice(p,D)}`:(k.charCodeAt(p)===u&&++p,k.slice(p,D))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const f=t.$ic.resolve(s);if(f.length<=2)return s;if(f.charCodeAt(0)===u){if(f.charCodeAt(1)===u){const v=f.charCodeAt(2);if(v!==E&&v!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(L(f.charCodeAt(0))&&f.charCodeAt(1)===g&&f.charCodeAt(2)===u)return`\\\\?\\${f}`;return s},dirname(s){e(s,"path");const f=s.length;if(f===0)return".";let v=-1,k=0;const R=s.charCodeAt(0);if(f===1)return h(R)?s:".";if(h(R)){if(v=k=1,h(s.charCodeAt(1))){let p=2,D=p;for(;p<f&&!h(s.charCodeAt(p));)p++;if(p<f&&p!==D){for(D=p;p<f&&h(s.charCodeAt(p));)p++;if(p<f&&p!==D){for(D=p;p<f&&!h(s.charCodeAt(p));)p++;if(p===f)return s;p!==D&&(v=k=p+1)}}}}else L(R)&&s.charCodeAt(1)===g&&(v=f>2&&h(s.charCodeAt(2))?3:2,k=v);let j=-1,M=!0;for(let p=f-1;p>=k;--p)if(h(s.charCodeAt(p))){if(!M){j=p;break}}else M=!1;if(j===-1){if(v===-1)return".";j=v}return s.slice(0,j)},basename(s,f){f!==void 0&&e(f,"suffix"),e(s,"path");let v=0,k=-1,R=!0,j;if(s.length>=2&&L(s.charCodeAt(0))&&s.charCodeAt(1)===g&&(v=2),f!==void 0&&f.length>0&&f.length<=s.length){if(f===s)return"";let M=f.length-1,p=-1;for(j=s.length-1;j>=v;--j){const D=s.charCodeAt(j);if(h(D)){if(!R){v=j+1;break}}else p===-1&&(R=!1,p=j+1),M>=0&&(D===f.charCodeAt(M)?--M===-1&&(k=j):(M=-1,k=p))}return v===k?k=p:k===-1&&(k=s.length),s.slice(v,k)}for(j=s.length-1;j>=v;--j)if(h(s.charCodeAt(j))){if(!R){v=j+1;break}}else k===-1&&(R=!1,k=j+1);return k===-1?"":s.slice(v,k)},extname(s){e(s,"path");let f=0,v=-1,k=0,R=-1,j=!0,M=0;s.length>=2&&s.charCodeAt(1)===g&&L(s.charCodeAt(0))&&(f=k=2);for(let p=s.length-1;p>=f;--p){const D=s.charCodeAt(p);if(h(D)){if(!j){k=p+1;break}continue}R===-1&&(j=!1,R=p+1),D===b?v===-1?v=p:M!==1&&(M=1):v!==-1&&(M=-1)}return v===-1||R===-1||M===0||M===1&&v===R-1&&v===k+1?"":s.slice(v,R)},format:$.bind(null,"\\"),parse(s){e(s,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return f;const v=s.length;let k=0,R=s.charCodeAt(0);if(v===1)return h(R)?(f.root=f.dir=s,f):(f.base=f.name=s,f);if(h(R)){if(k=1,h(s.charCodeAt(1))){let q=2,z=q;for(;q<v&&!h(s.charCodeAt(q));)q++;if(q<v&&q!==z){for(z=q;q<v&&h(s.charCodeAt(q));)q++;if(q<v&&q!==z){for(z=q;q<v&&!h(s.charCodeAt(q));)q++;q===v?k=q:q!==z&&(k=q+1)}}}}else if(L(R)&&s.charCodeAt(1)===g){if(v<=2)return f.root=f.dir=s,f;if(k=2,h(s.charCodeAt(2))){if(v===3)return f.root=f.dir=s,f;k=3}}k>0&&(f.root=s.slice(0,k));let j=-1,M=k,p=-1,D=!0,I=s.length-1,F=0;for(;I>=k;--I){if(R=s.charCodeAt(I),h(R)){if(!D){M=I+1;break}continue}p===-1&&(D=!1,p=I+1),R===b?j===-1?j=I:F!==1&&(F=1):j!==-1&&(F=-1)}return p!==-1&&(j===-1||F===0||F===1&&j===p-1&&j===M+1?f.base=f.name=s.slice(M,p):(f.name=s.slice(M,j),f.base=s.slice(M,p),f.ext=s.slice(j,p))),M>0&&M!==k?f.dir=s.slice(0,M-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(l){const s=/\\/g;return()=>{const f=n.cwd().replace(s,"/");return f.slice(f.indexOf("/"))}}return()=>n.cwd()})();t.$jc={resolve(...s){let f="",v=!1;for(let k=s.length-1;k>=-1&&!v;k--){const R=k>=0?s[k]:o();e(R,`paths[${k}]`),R.length!==0&&(f=`${R}/${f}`,v=R.charCodeAt(0)===a)}return f=N(f,!v,"/",w),v?`/${f}`:f.length>0?f:"."},normalize(s){if(e(s,"path"),s.length===0)return".";const f=s.charCodeAt(0)===a,v=s.charCodeAt(s.length-1)===a;return s=N(s,!f,"/",w),s.length===0?f?"/":v?"./":".":(v&&(s+="/"),f?`/${s}`:s)},isAbsolute(s){return e(s,"path"),s.length>0&&s.charCodeAt(0)===a},join(...s){if(s.length===0)return".";let f;for(let v=0;v<s.length;++v){const k=s[v];e(k,"path"),k.length>0&&(f===void 0?f=k:f+=`/${k}`)}return f===void 0?".":t.$jc.normalize(f)},relative(s,f){if(e(s,"from"),e(f,"to"),s===f||(s=t.$jc.resolve(s),f=t.$jc.resolve(f),s===f))return"";const v=1,k=s.length,R=k-v,j=1,M=f.length-j,p=R<M?R:M;let D=-1,I=0;for(;I<p;I++){const q=s.charCodeAt(v+I);if(q!==f.charCodeAt(j+I))break;q===a&&(D=I)}if(I===p)if(M>p){if(f.charCodeAt(j+I)===a)return f.slice(j+I+1);if(I===0)return f.slice(j+I)}else R>p&&(s.charCodeAt(v+I)===a?D=I:I===0&&(D=0));let F="";for(I=v+D+1;I<=k;++I)(I===k||s.charCodeAt(I)===a)&&(F+=F.length===0?"..":"/..");return`${F}${f.slice(j+D)}`},toNamespacedPath(s){return s},dirname(s){if(e(s,"path"),s.length===0)return".";const f=s.charCodeAt(0)===a;let v=-1,k=!0;for(let R=s.length-1;R>=1;--R)if(s.charCodeAt(R)===a){if(!k){v=R;break}}else k=!1;return v===-1?f?"/":".":f&&v===1?"//":s.slice(0,v)},basename(s,f){f!==void 0&&e(f,"ext"),e(s,"path");let v=0,k=-1,R=!0,j;if(f!==void 0&&f.length>0&&f.length<=s.length){if(f===s)return"";let M=f.length-1,p=-1;for(j=s.length-1;j>=0;--j){const D=s.charCodeAt(j);if(D===a){if(!R){v=j+1;break}}else p===-1&&(R=!1,p=j+1),M>=0&&(D===f.charCodeAt(M)?--M===-1&&(k=j):(M=-1,k=p))}return v===k?k=p:k===-1&&(k=s.length),s.slice(v,k)}for(j=s.length-1;j>=0;--j)if(s.charCodeAt(j)===a){if(!R){v=j+1;break}}else k===-1&&(R=!1,k=j+1);return k===-1?"":s.slice(v,k)},extname(s){e(s,"path");let f=-1,v=0,k=-1,R=!0,j=0;for(let M=s.length-1;M>=0;--M){const p=s.charCodeAt(M);if(p===a){if(!R){v=M+1;break}continue}k===-1&&(R=!1,k=M+1),p===b?f===-1?f=M:j!==1&&(j=1):f!==-1&&(j=-1)}return f===-1||k===-1||j===0||j===1&&f===k-1&&f===v+1?"":s.slice(f,k)},format:$.bind(null,"/"),parse(s){e(s,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return f;const v=s.charCodeAt(0)===a;let k;v?(f.root="/",k=1):k=0;let R=-1,j=0,M=-1,p=!0,D=s.length-1,I=0;for(;D>=k;--D){const F=s.charCodeAt(D);if(F===a){if(!p){j=D+1;break}continue}M===-1&&(p=!1,M=D+1),F===b?R===-1?R=D:I!==1&&(I=1):R!==-1&&(I=-1)}if(M!==-1){const F=j===0&&v?1:j;R===-1||I===0||I===1&&R===M-1&&R===j+1?f.base=f.name=s.slice(F,M):(f.name=s.slice(F,R),f.base=s.slice(F,M),f.ext=s.slice(R,M))}return j>0?f.dir=s.slice(0,j-1):v&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},t.$jc.win32=t.$ic.win32=t.$ic,t.$jc.posix=t.$ic.posix=t.$jc,t.$kc=l?t.$ic.normalize:t.$jc.normalize,t.$lc=l?t.$ic.isAbsolute:t.$jc.isAbsolute,t.$mc=l?t.$ic.join:t.$jc.join,t.$nc=l?t.$ic.resolve:t.$jc.resolve,t.$oc=l?t.$ic.relative:t.$jc.relative,t.$pc=l?t.$ic.dirname:t.$jc.dirname,t.$qc=l?t.$ic.basename:t.$jc.basename,t.$rc=l?t.$ic.extname:t.$jc.extname,t.$sc=l?t.$ic.format:t.$jc.format,t.$tc=l?t.$ic.parse:t.$jc.parse,t.$uc=l?t.$ic.toNamespacedPath:t.$jc.toNamespacedPath,t.sep=l?t.$ic.sep:t.$jc.sep,t.$wc=l?t.$ic.delimiter:t.$jc.delimiter}),ie(se[29],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class i{static create(m){return new i(m)}constructor(m){this.c=n&&m===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ie=i}),ie(se[12],ue([0,1,4,25,10,28,29]),function(W,t,n,i,T,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$ke=t.Event=void 0,t.$le=c;const b=!1,a=!1,u=!1;var g;(function(H){H.None=()=>T.$Xc.None;function U(oe){if(u){const{onDidAddListener:re}=oe,ce=l.create();let le=0;oe.onDidAddListener=()=>{++le===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),re?.()}}}function C(oe,re){return je(oe,()=>{},0,void 0,!0,void 0,re)}H.defer=C;function ee(oe){return(re,ce=null,le)=>{let me=!1,be;return be=oe(ve=>{if(!me)return be?be.dispose():me=!0,re.call(ce,ve)},null,le),me&&be.dispose(),be}}H.once=ee;function J(oe,re){return H.once(H.filter(oe,re))}H.onceIf=J;function K(oe,re,ce){return Ee((le,me=null,be)=>oe(ve=>le.call(me,re(ve)),null,be),ce)}H.map=K;function ne(oe,re,ce){return Ee((le,me=null,be)=>oe(ve=>{re(ve),le.call(me,ve)},null,be),ce)}H.forEach=ne;function P(oe,re,ce){return Ee((le,me=null,be)=>oe(ve=>re(ve)&&le.call(me,ve),null,be),ce)}H.filter=P;function X(oe){return oe}H.signal=X;function he(...oe){return(re,ce=null,le)=>{const me=(0,T.$Uc)(...oe.map(be=>be(ve=>re.call(ce,ve))));return r(me,le)}}H.any=he;function ge(oe,re,ce,le){let me=ce;return K(oe,be=>(me=re(me,be),me),le)}H.reduce=ge;function Ee(oe,re){let ce;const le={onWillAddFirstListener(){ce=oe(me.fire,me)},onDidRemoveLastListener(){ce?.dispose()}};re||U(le);const me=new s(le);return re?.add(me),me.event}function r(oe,re){return re instanceof Array?re.push(oe):re&&re.add(oe),oe}function je(oe,re,ce=100,le=!1,me=!1,be,ve){let Te,pe,de,Fe=0,We;const ze={leakWarningThreshold:be,onWillAddFirstListener(){Te=oe(Ye=>{Fe++,pe=re(pe,Ye),le&&!de&&(He.fire(pe),pe=void 0),We=()=>{const Ve=pe;pe=void 0,de=void 0,(!le||Fe>1)&&He.fire(Ve),Fe=0},typeof ce=="number"?(clearTimeout(de),de=setTimeout(We,ce)):de===void 0&&(de=0,queueMicrotask(We))})},onWillRemoveListener(){me&&Fe>0&&We?.()},onDidRemoveLastListener(){We=void 0,Te.dispose()}};ve||U(ze);const He=new s(ze);return ve?.add(He),He.event}H.debounce=je;function Pe(oe,re=0,ce){return H.debounce(oe,(le,me)=>le?(le.push(me),le):[me],re,void 0,!0,void 0,ce)}H.accumulate=Pe;function Ue(oe,re=(le,me)=>le===me,ce){let le=!0,me;return P(oe,be=>{const ve=le||!re(be,me);return le=!1,me=be,ve},ce)}H.latch=Ue;function Ae(oe,re,ce){return[H.filter(oe,re,ce),H.filter(oe,le=>!re(le),ce)]}H.split=Ae;function Ne(oe,re=!1,ce=[],le){let me=ce.slice(),be=oe(pe=>{me?me.push(pe):Te.fire(pe)});le&&le.add(be);const ve=()=>{me?.forEach(pe=>Te.fire(pe)),me=null},Te=new s({onWillAddFirstListener(){be||(be=oe(pe=>Te.fire(pe)),le&&le.add(be))},onDidAddFirstListener(){me&&(re?setTimeout(ve):ve())},onDidRemoveLastListener(){be&&be.dispose(),be=null}});return le&&le.add(Te),Te.event}H.buffer=Ne;function qe(oe,re){return(le,me,be)=>{const ve=re(new G);return oe(function(Te){const pe=ve.evaluate(Te);pe!==x&&le.call(me,pe)},void 0,be)}}H.chain=qe;const x=Symbol("HaltChainable");class G{constructor(){this.f=[]}map(re){return this.f.push(re),this}forEach(re){return this.f.push(ce=>(re(ce),ce)),this}filter(re){return this.f.push(ce=>re(ce)?ce:x),this}reduce(re,ce){let le=ce;return this.f.push(me=>(le=re(le,me),le)),this}latch(re=(ce,le)=>ce===le){let ce=!0,le;return this.f.push(me=>{const be=ce||!re(me,le);return ce=!1,le=me,be?me:x}),this}evaluate(re){for(const ce of this.f)if(re=ce(re),re===x)break;return re}}function O(oe,re,ce=le=>le){const le=(...Te)=>ve.fire(ce(...Te)),me=()=>oe.on(re,le),be=()=>oe.removeListener(re,le),ve=new s({onWillAddFirstListener:me,onDidRemoveLastListener:be});return ve.event}H.fromNodeEventEmitter=O;function y(oe,re,ce=le=>le){const le=(...Te)=>ve.fire(ce(...Te)),me=()=>oe.addEventListener(re,le),be=()=>oe.removeEventListener(re,le),ve=new s({onWillAddFirstListener:me,onDidRemoveLastListener:be});return ve.event}H.fromDOMEventEmitter=y;function B(oe){return new Promise(re=>ee(oe)(re))}H.toPromise=B;function Y(oe){const re=new s;return oe.then(ce=>{re.fire(ce)},()=>{re.fire(void 0)}).finally(()=>{re.dispose()}),re.event}H.fromPromise=Y;function Q(oe,re){return oe(ce=>re.fire(ce))}H.forward=Q;function ae(oe,re,ce){return re(ce),oe(le=>re(le))}H.runAndSubscribe=ae;class we{constructor(re,ce){this._observable=re,this.f=0,this.g=!1;const le={onWillAddFirstListener:()=>{re.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{re.removeObserver(this)}};ce||U(le),this.emitter=new s(le),ce&&ce.add(this.emitter)}beginUpdate(re){this.f++}handlePossibleChange(re){}handleChange(re,ce){this.g=!0}endUpdate(re){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Le(oe,re){return new we(oe,re).emitter.event}H.fromObservable=Le;function Re(oe){return(re,ce,le)=>{let me=0,be=!1;const ve={beginUpdate(){me++},endUpdate(){me--,me===0&&(oe.reportChanges(),be&&(be=!1,re.call(ce)))},handlePossibleChange(){},handleChange(){be=!0}};oe.addObserver(ve),oe.reportChanges();const Te={dispose(){oe.removeObserver(ve)}};return le instanceof T.$Wc?le.add(Te):Array.isArray(le)&&le.push(Te),Te}}H.fromObservableLight=Re})(g||(t.Event=g={}));class E{static{this.all=new Set}static{this.f=0}constructor(U){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${U}_${E.f++}`,E.all.add(this)}start(U){this.g=new A.$ie,this.listenerCount=U}stop(){if(this.g){const U=this.g.elapsed();this.durations.push(U),this.elapsedOverall+=U,this.invocationCount+=1,this.g=void 0}}}t.$ke=E;let d=-1;function c(H){const U=d;return d=H,{dispose(){d=U}}}class e{static{this.f=1}constructor(U,C,ee=(e.f++).toString(16).padStart(3,"0")){this.j=U,this.threshold=C,this.name=ee,this.h=0}dispose(){this.g?.clear()}check(U,C){const ee=this.threshold;if(ee<=0||C<ee)return;this.g||(this.g=new Map);const J=this.g.get(U.value)||0;if(this.g.set(U.value,J+1),this.h-=1,this.h<=0){this.h=ee*.5;const[K,ne]=this.getMostFrequentStack(),P=`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${ne}):`;console.warn(P),console.warn(K);const X=new h(P,K);this.j(X)}return()=>{const K=this.g.get(U.value)||0;this.g.set(U.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let U,C=0;for(const[ee,J]of this.g)(!U||C<J)&&(U=[ee,J],C=J);return U}}class l{static create(){const U=new Error;return new l(U.stack??"")}constructor(U){this.value=U}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h extends Error{constructor(U,C){super(U),this.name="ListenerLeakError",this.stack=C}}t.$me=h;class w extends Error{constructor(U,C){super(U),this.name="ListenerRefusalError",this.stack=C}}t.$ne=w;let L=0;class N{constructor(U){this.value=U,this.id=L++}}const _=2,$=(H,U)=>{if(H instanceof N)U(H);else for(let C=0;C<H.length;C++){const ee=H[C];ee&&U(ee)}};let o;if(b){const H=[];setInterval(()=>{H.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(H.join(`
`)),H.length=0)},3e3),o=new FinalizationRegistry(U=>{typeof U=="string"&&H.push(U)})}class s{constructor(U){this.z=0,this.f=U,this.g=d>0||this.f?.leakWarningThreshold?new e(U?.onListenerError??n.$2,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(a){const U=this.u;queueMicrotask(()=>{$(U,C=>C.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(U,C,ee)=>{if(this.g&&this.z>this.g.threshold**2){const X=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(X);const he=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ge=new w(`${X}. HINT: Stack shows most frequent listener (${he[1]}-times)`,he[0]);return(this.f?.onListenerError||n.$2)(ge),T.$Xc.None}if(this.m)return T.$Xc.None;C&&(U=U.bind(C));const J=new N(U);let K,ne;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(J.stack=l.create(),K=this.g.check(J.stack,this.z+1)),a&&(J.stack=ne??l.create()),this.u?this.u instanceof N?(this.w??=new v,this.u=[this.u,J]):this.u.push(J):(this.f?.onWillAddFirstListener?.(this),this.u=J,this.f?.onDidAddFirstListener?.(this)),this.z++;const P=(0,T.$Vc)(()=>{o?.unregister(P),K?.(),this.A(J)});if(ee instanceof T.$Wc?ee.add(P):Array.isArray(ee)&&ee.push(P),o){const X=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),he=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(X);o.register(P,he?.[2]??X,P)}return P},this.q}A(U){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const C=this.u,ee=C.indexOf(U);if(ee===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,C[ee]=void 0;const J=this.w.current===this;if(this.z*_<=C.length){let K=0;for(let ne=0;ne<C.length;ne++)C[ne]?C[K++]=C[ne]:J&&(this.w.end--,K<this.w.i&&this.w.i--);C.length=K}}B(U,C){if(!U)return;const ee=this.f?.onListenerError||n.$2;if(!ee){U.value(C);return}try{U.value(C)}catch(J){ee(J)}}C(U){const C=U.current.u;for(;U.i<U.end;)this.B(C[U.i++],U.value);U.reset()}fire(U){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof N)this.B(this.u,U);else{const C=this.w;C.enqueue(this,U,this.u.length),this.C(C)}this.j?.stop()}hasListeners(){return this.z>0}}t.$oe=s;const f=()=>new v;t.$pe=f;class v{constructor(){this.i=-1,this.end=0}enqueue(U,C,ee){this.i=0,this.end=ee,this.current=U,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class k extends s{async fireAsync(U,C,ee){if(this.u)for(this.h||(this.h=new m.$8c),$(this.u,J=>this.h.push([J.value,U]));this.h.size>0&&!C.isCancellationRequested;){const[J,K]=this.h.shift(),ne=[],P={...K,token:C,waitUntil:X=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");ee&&(X=ee(X,J)),ne.push(X)}};try{J(P)}catch(X){(0,n.$2)(X);continue}Object.freeze(ne),await Promise.allSettled(ne).then(X=>{for(const he of X)he.status==="rejected"&&(0,n.$2)(he.reason)})}}}t.$qe=k;class R extends s{get isPaused(){return this.h!==0}constructor(U){super(U),this.h=0,this.s=new m.$8c,this.t=U?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const U=Array.from(this.s);this.s.clear(),super.fire(this.t(U))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(U){this.z&&(this.h!==0?this.s.push(U):super.fire(U))}}t.$re=R;class j extends R{constructor(U){super(U),this.k=U.delay??100}fire(U){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(U)}}t.$se=j;class M extends s{constructor(U){super(U),this.h=[],this.k=U?.merge}fire(U){this.hasListeners()&&(this.h.push(U),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}t.$te=M;class p{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(U){const C={event:U,listener:null};this.h.push(C),this.g&&this.m(C);const ee=()=>{this.g&&this.o(C);const J=this.h.indexOf(C);this.h.splice(J,1)};return(0,T.$Vc)((0,i.$fb)(ee))}j(){this.g=!0,this.h.forEach(U=>this.m(U))}k(){this.g=!1,this.h.forEach(U=>this.o(U))}m(U){U.listener=U.event(C=>this.f.fire(C))}o(U){U.listener?.dispose(),U.listener=null}dispose(){this.f.dispose();for(const U of this.h)U.listener?.dispose();this.h=[]}}t.$ue=p;class D{constructor(U,C,ee,J){this.f=new T.$Wc;const K=this.f.add(new p),ne=this.f.add(new T.$7c);function P(X){ne.set(X,K.add(J(X)))}for(const X of U)P(X);this.f.add(C(X=>{P(X)})),this.f.add(ee(X=>{ne.deleteAndDispose(X)})),this.event=K.event}dispose(){this.f.dispose()}}t.$ve=D;class I{constructor(){this.f=[]}wrapEvent(U,C,ee){return(J,K,ne)=>U(P=>{const X=this.f[this.f.length-1];if(!C){X?X.buffers.push(()=>J.call(K,P)):J.call(K,P);return}const he=X;if(!he){J.call(K,C(ee,P));return}he.items??=[],he.items.push(P),he.buffers.length===0&&X.buffers.push(()=>{he.reducedResult??=ee?he.items.reduce(C,ee):he.items.reduce(C),J.call(K,he.reducedResult)})},void 0,ne)}bufferEvents(U){const C={buffers:new Array};this.f.push(C);const ee=U();return this.f.pop(),C.buffers.forEach(J=>J()),ee}}t.$we=I;class F{constructor(){this.f=!1,this.g=g.None,this.h=T.$Xc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(U){this.g=U,this.f&&(this.h.dispose(),this.h=U(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$xe=F;class q{static const(U){return new z(U)}constructor(U){this.g=U,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(U){U!==this.g&&(this.g=U,this.f.fire(void 0))}}t.$ye=q;class z{constructor(U){this.value=U,this.onDidChange=g.None}}}),ie(se[20],ue([0,1,12]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.CancellationToken=void 0,t.$Ae=b;const i=Object.freeze(function(a,u){const g=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(g)}}});var T;(function(a){function u(g){return g===a.None||g===a.Cancelled||g instanceof m?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(T||(t.CancellationToken=T={}));class m{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new n.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new m),this.f}cancel(){this.f?this.f instanceof m&&this.f.cancel():this.f=T.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof m&&this.f.dispose():this.f=T.None}}t.$ze=A;function b(a){const u=new A;return a.add({dispose(){u.cancel()}}),u.token}}),ie(se[46],ue([0,1,20]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cf=t.$bf=t.$_e=void 0,t.$af=T;class i{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new n.$ze,u=this.b(a.token);return this.a={promise:u,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}t.$_e=i;function T(b){return b}class m{constructor(a,u){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=T):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);return this.b!==u&&(this.b=u,this.a=this.c(a)),this.a}}t.$bf=m;class A{get cachedValues(){return this.a}constructor(a,u){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=T):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);if(this.b.has(u))return this.b.get(u);const g=this.c(a);return this.a.set(a,g),this.b.set(u,g),g}}t.$cf=A}),ie(se[47],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$je=void 0,t.$je=Symbol("MicrotaskDelay")}),ie(se[21],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hg=n,t.$ig=i,t.$jg=T,t.$kg=m,t.$lg=A,t.$mg=b,t.$ng=a,t.$og=u,t.$pg=g,t.$qg=E,t.$rg=d,t.$sg=c,t.$tg=e,t.$ug=h,t.$vg=w,t.$wg=L,t.$xg=N,t.$yg=_,t.$zg=$;function n(o){return typeof o=="string"}function i(o){return Array.isArray(o)&&o.every(s=>n(s))}function T(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function m(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}function A(o){return typeof o=="number"&&!isNaN(o)}function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}function a(o){return o===!0||o===!1}function u(o){return typeof o>"u"}function g(o){return!E(o)}function E(o){return u(o)||o===null}function d(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}function c(o){if(E(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function e(...o){const s=[];for(let f=0;f<o.length;f++){const v=o[f];if(E(v))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);s.push(v)}return s}const l=Object.prototype.hasOwnProperty;function h(o){if(!T(o))return!1;for(const s in o)if(l.call(o,s))return!1;return!0}function w(o){return typeof o=="function"}function L(...o){return o.length>0&&o.every(w)}function N(o,s){const f=Math.min(o.length,s.length);for(let v=0;v<f;v++)_(o[v],s[v])}function _(o,s){if(n(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(w(s)){try{if(o instanceof s)return}catch{}if(!E(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function $(o){return o}}),ie(se[30],ue([0,1,21]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3j=T,t.$4j=m;const i=Object.create(null);function T(A,b){if((0,n.$hg)(b)){const a=i[b];if(a===void 0)throw new Error(`${A} references an unknown codicon: ${b}`);b=a}return i[A]=b,{id:A}}function m(){return i}}),ie(se[48],ue([0,1,30]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5j=void 0,t.$5j={add:(0,n.$3j)("add",6e4),plus:(0,n.$3j)("plus",6e4),gistNew:(0,n.$3j)("gist-new",6e4),repoCreate:(0,n.$3j)("repo-create",6e4),lightbulb:(0,n.$3j)("lightbulb",60001),lightBulb:(0,n.$3j)("light-bulb",60001),repo:(0,n.$3j)("repo",60002),repoDelete:(0,n.$3j)("repo-delete",60002),gistFork:(0,n.$3j)("gist-fork",60003),repoForked:(0,n.$3j)("repo-forked",60003),gitPullRequest:(0,n.$3j)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$3j)("git-pull-request-abandoned",60004),recordKeys:(0,n.$3j)("record-keys",60005),keyboard:(0,n.$3j)("keyboard",60005),tag:(0,n.$3j)("tag",60006),gitPullRequestLabel:(0,n.$3j)("git-pull-request-label",60006),tagAdd:(0,n.$3j)("tag-add",60006),tagRemove:(0,n.$3j)("tag-remove",60006),person:(0,n.$3j)("person",60007),personFollow:(0,n.$3j)("person-follow",60007),personOutline:(0,n.$3j)("person-outline",60007),personFilled:(0,n.$3j)("person-filled",60007),gitBranch:(0,n.$3j)("git-branch",60008),gitBranchCreate:(0,n.$3j)("git-branch-create",60008),gitBranchDelete:(0,n.$3j)("git-branch-delete",60008),sourceControl:(0,n.$3j)("source-control",60008),mirror:(0,n.$3j)("mirror",60009),mirrorPublic:(0,n.$3j)("mirror-public",60009),star:(0,n.$3j)("star",60010),starAdd:(0,n.$3j)("star-add",60010),starDelete:(0,n.$3j)("star-delete",60010),starEmpty:(0,n.$3j)("star-empty",60010),comment:(0,n.$3j)("comment",60011),commentAdd:(0,n.$3j)("comment-add",60011),alert:(0,n.$3j)("alert",60012),warning:(0,n.$3j)("warning",60012),search:(0,n.$3j)("search",60013),searchSave:(0,n.$3j)("search-save",60013),logOut:(0,n.$3j)("log-out",60014),signOut:(0,n.$3j)("sign-out",60014),logIn:(0,n.$3j)("log-in",60015),signIn:(0,n.$3j)("sign-in",60015),eye:(0,n.$3j)("eye",60016),eyeUnwatch:(0,n.$3j)("eye-unwatch",60016),eyeWatch:(0,n.$3j)("eye-watch",60016),circleFilled:(0,n.$3j)("circle-filled",60017),primitiveDot:(0,n.$3j)("primitive-dot",60017),closeDirty:(0,n.$3j)("close-dirty",60017),debugBreakpoint:(0,n.$3j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$3j)("debug-breakpoint-disabled",60017),debugHint:(0,n.$3j)("debug-hint",60017),terminalDecorationSuccess:(0,n.$3j)("terminal-decoration-success",60017),primitiveSquare:(0,n.$3j)("primitive-square",60018),edit:(0,n.$3j)("edit",60019),pencil:(0,n.$3j)("pencil",60019),info:(0,n.$3j)("info",60020),issueOpened:(0,n.$3j)("issue-opened",60020),gistPrivate:(0,n.$3j)("gist-private",60021),gitForkPrivate:(0,n.$3j)("git-fork-private",60021),lock:(0,n.$3j)("lock",60021),mirrorPrivate:(0,n.$3j)("mirror-private",60021),close:(0,n.$3j)("close",60022),removeClose:(0,n.$3j)("remove-close",60022),x:(0,n.$3j)("x",60022),repoSync:(0,n.$3j)("repo-sync",60023),sync:(0,n.$3j)("sync",60023),clone:(0,n.$3j)("clone",60024),desktopDownload:(0,n.$3j)("desktop-download",60024),beaker:(0,n.$3j)("beaker",60025),microscope:(0,n.$3j)("microscope",60025),vm:(0,n.$3j)("vm",60026),deviceDesktop:(0,n.$3j)("device-desktop",60026),file:(0,n.$3j)("file",60027),fileText:(0,n.$3j)("file-text",60027),more:(0,n.$3j)("more",60028),ellipsis:(0,n.$3j)("ellipsis",60028),kebabHorizontal:(0,n.$3j)("kebab-horizontal",60028),mailReply:(0,n.$3j)("mail-reply",60029),reply:(0,n.$3j)("reply",60029),organization:(0,n.$3j)("organization",60030),organizationFilled:(0,n.$3j)("organization-filled",60030),organizationOutline:(0,n.$3j)("organization-outline",60030),newFile:(0,n.$3j)("new-file",60031),fileAdd:(0,n.$3j)("file-add",60031),newFolder:(0,n.$3j)("new-folder",60032),fileDirectoryCreate:(0,n.$3j)("file-directory-create",60032),trash:(0,n.$3j)("trash",60033),trashcan:(0,n.$3j)("trashcan",60033),history:(0,n.$3j)("history",60034),clock:(0,n.$3j)("clock",60034),folder:(0,n.$3j)("folder",60035),fileDirectory:(0,n.$3j)("file-directory",60035),symbolFolder:(0,n.$3j)("symbol-folder",60035),logoGithub:(0,n.$3j)("logo-github",60036),markGithub:(0,n.$3j)("mark-github",60036),github:(0,n.$3j)("github",60036),terminal:(0,n.$3j)("terminal",60037),console:(0,n.$3j)("console",60037),repl:(0,n.$3j)("repl",60037),zap:(0,n.$3j)("zap",60038),symbolEvent:(0,n.$3j)("symbol-event",60038),error:(0,n.$3j)("error",60039),stop:(0,n.$3j)("stop",60039),variable:(0,n.$3j)("variable",60040),symbolVariable:(0,n.$3j)("symbol-variable",60040),array:(0,n.$3j)("array",60042),symbolArray:(0,n.$3j)("symbol-array",60042),symbolModule:(0,n.$3j)("symbol-module",60043),symbolPackage:(0,n.$3j)("symbol-package",60043),symbolNamespace:(0,n.$3j)("symbol-namespace",60043),symbolObject:(0,n.$3j)("symbol-object",60043),symbolMethod:(0,n.$3j)("symbol-method",60044),symbolFunction:(0,n.$3j)("symbol-function",60044),symbolConstructor:(0,n.$3j)("symbol-constructor",60044),symbolBoolean:(0,n.$3j)("symbol-boolean",60047),symbolNull:(0,n.$3j)("symbol-null",60047),symbolNumeric:(0,n.$3j)("symbol-numeric",60048),symbolNumber:(0,n.$3j)("symbol-number",60048),symbolStructure:(0,n.$3j)("symbol-structure",60049),symbolStruct:(0,n.$3j)("symbol-struct",60049),symbolParameter:(0,n.$3j)("symbol-parameter",60050),symbolTypeParameter:(0,n.$3j)("symbol-type-parameter",60050),symbolKey:(0,n.$3j)("symbol-key",60051),symbolText:(0,n.$3j)("symbol-text",60051),symbolReference:(0,n.$3j)("symbol-reference",60052),goToFile:(0,n.$3j)("go-to-file",60052),symbolEnum:(0,n.$3j)("symbol-enum",60053),symbolValue:(0,n.$3j)("symbol-value",60053),symbolRuler:(0,n.$3j)("symbol-ruler",60054),symbolUnit:(0,n.$3j)("symbol-unit",60054),activateBreakpoints:(0,n.$3j)("activate-breakpoints",60055),archive:(0,n.$3j)("archive",60056),arrowBoth:(0,n.$3j)("arrow-both",60057),arrowDown:(0,n.$3j)("arrow-down",60058),arrowLeft:(0,n.$3j)("arrow-left",60059),arrowRight:(0,n.$3j)("arrow-right",60060),arrowSmallDown:(0,n.$3j)("arrow-small-down",60061),arrowSmallLeft:(0,n.$3j)("arrow-small-left",60062),arrowSmallRight:(0,n.$3j)("arrow-small-right",60063),arrowSmallUp:(0,n.$3j)("arrow-small-up",60064),arrowUp:(0,n.$3j)("arrow-up",60065),bell:(0,n.$3j)("bell",60066),bold:(0,n.$3j)("bold",60067),book:(0,n.$3j)("book",60068),bookmark:(0,n.$3j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$3j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$3j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$3j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$3j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$3j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$3j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$3j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$3j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$3j)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$3j)("briefcase",60076),broadcast:(0,n.$3j)("broadcast",60077),browser:(0,n.$3j)("browser",60078),bug:(0,n.$3j)("bug",60079),calendar:(0,n.$3j)("calendar",60080),caseSensitive:(0,n.$3j)("case-sensitive",60081),check:(0,n.$3j)("check",60082),checklist:(0,n.$3j)("checklist",60083),chevronDown:(0,n.$3j)("chevron-down",60084),chevronLeft:(0,n.$3j)("chevron-left",60085),chevronRight:(0,n.$3j)("chevron-right",60086),chevronUp:(0,n.$3j)("chevron-up",60087),chromeClose:(0,n.$3j)("chrome-close",60088),chromeMaximize:(0,n.$3j)("chrome-maximize",60089),chromeMinimize:(0,n.$3j)("chrome-minimize",60090),chromeRestore:(0,n.$3j)("chrome-restore",60091),circleOutline:(0,n.$3j)("circle-outline",60092),circle:(0,n.$3j)("circle",60092),debugBreakpointUnverified:(0,n.$3j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$3j)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$3j)("circle-slash",60093),circuitBoard:(0,n.$3j)("circuit-board",60094),clearAll:(0,n.$3j)("clear-all",60095),clippy:(0,n.$3j)("clippy",60096),closeAll:(0,n.$3j)("close-all",60097),cloudDownload:(0,n.$3j)("cloud-download",60098),cloudUpload:(0,n.$3j)("cloud-upload",60099),code:(0,n.$3j)("code",60100),collapseAll:(0,n.$3j)("collapse-all",60101),colorMode:(0,n.$3j)("color-mode",60102),commentDiscussion:(0,n.$3j)("comment-discussion",60103),creditCard:(0,n.$3j)("credit-card",60105),dash:(0,n.$3j)("dash",60108),dashboard:(0,n.$3j)("dashboard",60109),database:(0,n.$3j)("database",60110),debugContinue:(0,n.$3j)("debug-continue",60111),debugDisconnect:(0,n.$3j)("debug-disconnect",60112),debugPause:(0,n.$3j)("debug-pause",60113),debugRestart:(0,n.$3j)("debug-restart",60114),debugStart:(0,n.$3j)("debug-start",60115),debugStepInto:(0,n.$3j)("debug-step-into",60116),debugStepOut:(0,n.$3j)("debug-step-out",60117),debugStepOver:(0,n.$3j)("debug-step-over",60118),debugStop:(0,n.$3j)("debug-stop",60119),debug:(0,n.$3j)("debug",60120),deviceCameraVideo:(0,n.$3j)("device-camera-video",60121),deviceCamera:(0,n.$3j)("device-camera",60122),deviceMobile:(0,n.$3j)("device-mobile",60123),diffAdded:(0,n.$3j)("diff-added",60124),diffIgnored:(0,n.$3j)("diff-ignored",60125),diffModified:(0,n.$3j)("diff-modified",60126),diffRemoved:(0,n.$3j)("diff-removed",60127),diffRenamed:(0,n.$3j)("diff-renamed",60128),diff:(0,n.$3j)("diff",60129),diffSidebyside:(0,n.$3j)("diff-sidebyside",60129),discard:(0,n.$3j)("discard",60130),editorLayout:(0,n.$3j)("editor-layout",60131),emptyWindow:(0,n.$3j)("empty-window",60132),exclude:(0,n.$3j)("exclude",60133),extensions:(0,n.$3j)("extensions",60134),eyeClosed:(0,n.$3j)("eye-closed",60135),fileBinary:(0,n.$3j)("file-binary",60136),fileCode:(0,n.$3j)("file-code",60137),fileMedia:(0,n.$3j)("file-media",60138),filePdf:(0,n.$3j)("file-pdf",60139),fileSubmodule:(0,n.$3j)("file-submodule",60140),fileSymlinkDirectory:(0,n.$3j)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$3j)("file-symlink-file",60142),fileZip:(0,n.$3j)("file-zip",60143),files:(0,n.$3j)("files",60144),filter:(0,n.$3j)("filter",60145),flame:(0,n.$3j)("flame",60146),foldDown:(0,n.$3j)("fold-down",60147),foldUp:(0,n.$3j)("fold-up",60148),fold:(0,n.$3j)("fold",60149),folderActive:(0,n.$3j)("folder-active",60150),folderOpened:(0,n.$3j)("folder-opened",60151),gear:(0,n.$3j)("gear",60152),gift:(0,n.$3j)("gift",60153),gistSecret:(0,n.$3j)("gist-secret",60154),gist:(0,n.$3j)("gist",60155),gitCommit:(0,n.$3j)("git-commit",60156),gitCompare:(0,n.$3j)("git-compare",60157),compareChanges:(0,n.$3j)("compare-changes",60157),gitMerge:(0,n.$3j)("git-merge",60158),githubAction:(0,n.$3j)("github-action",60159),githubAlt:(0,n.$3j)("github-alt",60160),globe:(0,n.$3j)("globe",60161),grabber:(0,n.$3j)("grabber",60162),graph:(0,n.$3j)("graph",60163),gripper:(0,n.$3j)("gripper",60164),heart:(0,n.$3j)("heart",60165),home:(0,n.$3j)("home",60166),horizontalRule:(0,n.$3j)("horizontal-rule",60167),hubot:(0,n.$3j)("hubot",60168),inbox:(0,n.$3j)("inbox",60169),issueReopened:(0,n.$3j)("issue-reopened",60171),issues:(0,n.$3j)("issues",60172),italic:(0,n.$3j)("italic",60173),jersey:(0,n.$3j)("jersey",60174),json:(0,n.$3j)("json",60175),kebabVertical:(0,n.$3j)("kebab-vertical",60176),key:(0,n.$3j)("key",60177),law:(0,n.$3j)("law",60178),lightbulbAutofix:(0,n.$3j)("lightbulb-autofix",60179),linkExternal:(0,n.$3j)("link-external",60180),link:(0,n.$3j)("link",60181),listOrdered:(0,n.$3j)("list-ordered",60182),listUnordered:(0,n.$3j)("list-unordered",60183),liveShare:(0,n.$3j)("live-share",60184),loading:(0,n.$3j)("loading",60185),location:(0,n.$3j)("location",60186),mailRead:(0,n.$3j)("mail-read",60187),mail:(0,n.$3j)("mail",60188),markdown:(0,n.$3j)("markdown",60189),megaphone:(0,n.$3j)("megaphone",60190),mention:(0,n.$3j)("mention",60191),milestone:(0,n.$3j)("milestone",60192),gitPullRequestMilestone:(0,n.$3j)("git-pull-request-milestone",60192),mortarBoard:(0,n.$3j)("mortar-board",60193),move:(0,n.$3j)("move",60194),multipleWindows:(0,n.$3j)("multiple-windows",60195),mute:(0,n.$3j)("mute",60196),noNewline:(0,n.$3j)("no-newline",60197),note:(0,n.$3j)("note",60198),octoface:(0,n.$3j)("octoface",60199),openPreview:(0,n.$3j)("open-preview",60200),package:(0,n.$3j)("package",60201),paintcan:(0,n.$3j)("paintcan",60202),pin:(0,n.$3j)("pin",60203),play:(0,n.$3j)("play",60204),run:(0,n.$3j)("run",60204),plug:(0,n.$3j)("plug",60205),preserveCase:(0,n.$3j)("preserve-case",60206),preview:(0,n.$3j)("preview",60207),project:(0,n.$3j)("project",60208),pulse:(0,n.$3j)("pulse",60209),question:(0,n.$3j)("question",60210),quote:(0,n.$3j)("quote",60211),radioTower:(0,n.$3j)("radio-tower",60212),reactions:(0,n.$3j)("reactions",60213),references:(0,n.$3j)("references",60214),refresh:(0,n.$3j)("refresh",60215),regex:(0,n.$3j)("regex",60216),remoteExplorer:(0,n.$3j)("remote-explorer",60217),remote:(0,n.$3j)("remote",60218),remove:(0,n.$3j)("remove",60219),replaceAll:(0,n.$3j)("replace-all",60220),replace:(0,n.$3j)("replace",60221),repoClone:(0,n.$3j)("repo-clone",60222),repoForcePush:(0,n.$3j)("repo-force-push",60223),repoPull:(0,n.$3j)("repo-pull",60224),repoPush:(0,n.$3j)("repo-push",60225),report:(0,n.$3j)("report",60226),requestChanges:(0,n.$3j)("request-changes",60227),rocket:(0,n.$3j)("rocket",60228),rootFolderOpened:(0,n.$3j)("root-folder-opened",60229),rootFolder:(0,n.$3j)("root-folder",60230),rss:(0,n.$3j)("rss",60231),ruby:(0,n.$3j)("ruby",60232),saveAll:(0,n.$3j)("save-all",60233),saveAs:(0,n.$3j)("save-as",60234),save:(0,n.$3j)("save",60235),screenFull:(0,n.$3j)("screen-full",60236),screenNormal:(0,n.$3j)("screen-normal",60237),searchStop:(0,n.$3j)("search-stop",60238),server:(0,n.$3j)("server",60240),settingsGear:(0,n.$3j)("settings-gear",60241),settings:(0,n.$3j)("settings",60242),shield:(0,n.$3j)("shield",60243),smiley:(0,n.$3j)("smiley",60244),sortPrecedence:(0,n.$3j)("sort-precedence",60245),splitHorizontal:(0,n.$3j)("split-horizontal",60246),splitVertical:(0,n.$3j)("split-vertical",60247),squirrel:(0,n.$3j)("squirrel",60248),starFull:(0,n.$3j)("star-full",60249),starHalf:(0,n.$3j)("star-half",60250),symbolClass:(0,n.$3j)("symbol-class",60251),symbolColor:(0,n.$3j)("symbol-color",60252),symbolConstant:(0,n.$3j)("symbol-constant",60253),symbolEnumMember:(0,n.$3j)("symbol-enum-member",60254),symbolField:(0,n.$3j)("symbol-field",60255),symbolFile:(0,n.$3j)("symbol-file",60256),symbolInterface:(0,n.$3j)("symbol-interface",60257),symbolKeyword:(0,n.$3j)("symbol-keyword",60258),symbolMisc:(0,n.$3j)("symbol-misc",60259),symbolOperator:(0,n.$3j)("symbol-operator",60260),symbolProperty:(0,n.$3j)("symbol-property",60261),wrench:(0,n.$3j)("wrench",60261),wrenchSubaction:(0,n.$3j)("wrench-subaction",60261),symbolSnippet:(0,n.$3j)("symbol-snippet",60262),tasklist:(0,n.$3j)("tasklist",60263),telescope:(0,n.$3j)("telescope",60264),textSize:(0,n.$3j)("text-size",60265),threeBars:(0,n.$3j)("three-bars",60266),thumbsdown:(0,n.$3j)("thumbsdown",60267),thumbsup:(0,n.$3j)("thumbsup",60268),tools:(0,n.$3j)("tools",60269),triangleDown:(0,n.$3j)("triangle-down",60270),triangleLeft:(0,n.$3j)("triangle-left",60271),triangleRight:(0,n.$3j)("triangle-right",60272),triangleUp:(0,n.$3j)("triangle-up",60273),twitter:(0,n.$3j)("twitter",60274),unfold:(0,n.$3j)("unfold",60275),unlock:(0,n.$3j)("unlock",60276),unmute:(0,n.$3j)("unmute",60277),unverified:(0,n.$3j)("unverified",60278),verified:(0,n.$3j)("verified",60279),versions:(0,n.$3j)("versions",60280),vmActive:(0,n.$3j)("vm-active",60281),vmOutline:(0,n.$3j)("vm-outline",60282),vmRunning:(0,n.$3j)("vm-running",60283),watch:(0,n.$3j)("watch",60284),whitespace:(0,n.$3j)("whitespace",60285),wholeWord:(0,n.$3j)("whole-word",60286),window:(0,n.$3j)("window",60287),wordWrap:(0,n.$3j)("word-wrap",60288),zoomIn:(0,n.$3j)("zoom-in",60289),zoomOut:(0,n.$3j)("zoom-out",60290),listFilter:(0,n.$3j)("list-filter",60291),listFlat:(0,n.$3j)("list-flat",60292),listSelection:(0,n.$3j)("list-selection",60293),selection:(0,n.$3j)("selection",60293),listTree:(0,n.$3j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$3j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$3j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$3j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$3j)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$3j)("circle-small-filled",60298),debugStackframeDot:(0,n.$3j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$3j)("terminal-decoration-mark",60298),debugStackframe:(0,n.$3j)("debug-stackframe",60299),debugStackframeFocused:(0,n.$3j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$3j)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$3j)("symbol-string",60301),debugReverseContinue:(0,n.$3j)("debug-reverse-continue",60302),debugStepBack:(0,n.$3j)("debug-step-back",60303),debugRestartFrame:(0,n.$3j)("debug-restart-frame",60304),debugAlt:(0,n.$3j)("debug-alt",60305),callIncoming:(0,n.$3j)("call-incoming",60306),callOutgoing:(0,n.$3j)("call-outgoing",60307),menu:(0,n.$3j)("menu",60308),expandAll:(0,n.$3j)("expand-all",60309),feedback:(0,n.$3j)("feedback",60310),gitPullRequestReviewer:(0,n.$3j)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$3j)("group-by-ref-type",60311),ungroupByRefType:(0,n.$3j)("ungroup-by-ref-type",60312),account:(0,n.$3j)("account",60313),gitPullRequestAssignee:(0,n.$3j)("git-pull-request-assignee",60313),bellDot:(0,n.$3j)("bell-dot",60314),debugConsole:(0,n.$3j)("debug-console",60315),library:(0,n.$3j)("library",60316),output:(0,n.$3j)("output",60317),runAll:(0,n.$3j)("run-all",60318),syncIgnored:(0,n.$3j)("sync-ignored",60319),pinned:(0,n.$3j)("pinned",60320),githubInverted:(0,n.$3j)("github-inverted",60321),serverProcess:(0,n.$3j)("server-process",60322),serverEnvironment:(0,n.$3j)("server-environment",60323),pass:(0,n.$3j)("pass",60324),issueClosed:(0,n.$3j)("issue-closed",60324),stopCircle:(0,n.$3j)("stop-circle",60325),playCircle:(0,n.$3j)("play-circle",60326),record:(0,n.$3j)("record",60327),debugAltSmall:(0,n.$3j)("debug-alt-small",60328),vmConnect:(0,n.$3j)("vm-connect",60329),cloud:(0,n.$3j)("cloud",60330),merge:(0,n.$3j)("merge",60331),export:(0,n.$3j)("export",60332),graphLeft:(0,n.$3j)("graph-left",60333),magnet:(0,n.$3j)("magnet",60334),notebook:(0,n.$3j)("notebook",60335),redo:(0,n.$3j)("redo",60336),checkAll:(0,n.$3j)("check-all",60337),pinnedDirty:(0,n.$3j)("pinned-dirty",60338),passFilled:(0,n.$3j)("pass-filled",60339),circleLargeFilled:(0,n.$3j)("circle-large-filled",60340),circleLarge:(0,n.$3j)("circle-large",60341),circleLargeOutline:(0,n.$3j)("circle-large-outline",60341),combine:(0,n.$3j)("combine",60342),gather:(0,n.$3j)("gather",60342),table:(0,n.$3j)("table",60343),variableGroup:(0,n.$3j)("variable-group",60344),typeHierarchy:(0,n.$3j)("type-hierarchy",60345),typeHierarchySub:(0,n.$3j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$3j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$3j)("git-pull-request-create",60348),runAbove:(0,n.$3j)("run-above",60349),runBelow:(0,n.$3j)("run-below",60350),notebookTemplate:(0,n.$3j)("notebook-template",60351),debugRerun:(0,n.$3j)("debug-rerun",60352),workspaceTrusted:(0,n.$3j)("workspace-trusted",60353),workspaceUntrusted:(0,n.$3j)("workspace-untrusted",60354),workspaceUnknown:(0,n.$3j)("workspace-unknown",60355),terminalCmd:(0,n.$3j)("terminal-cmd",60356),terminalDebian:(0,n.$3j)("terminal-debian",60357),terminalLinux:(0,n.$3j)("terminal-linux",60358),terminalPowershell:(0,n.$3j)("terminal-powershell",60359),terminalTmux:(0,n.$3j)("terminal-tmux",60360),terminalUbuntu:(0,n.$3j)("terminal-ubuntu",60361),terminalBash:(0,n.$3j)("terminal-bash",60362),arrowSwap:(0,n.$3j)("arrow-swap",60363),copy:(0,n.$3j)("copy",60364),personAdd:(0,n.$3j)("person-add",60365),filterFilled:(0,n.$3j)("filter-filled",60366),wand:(0,n.$3j)("wand",60367),debugLineByLine:(0,n.$3j)("debug-line-by-line",60368),inspect:(0,n.$3j)("inspect",60369),layers:(0,n.$3j)("layers",60370),layersDot:(0,n.$3j)("layers-dot",60371),layersActive:(0,n.$3j)("layers-active",60372),compass:(0,n.$3j)("compass",60373),compassDot:(0,n.$3j)("compass-dot",60374),compassActive:(0,n.$3j)("compass-active",60375),azure:(0,n.$3j)("azure",60376),issueDraft:(0,n.$3j)("issue-draft",60377),gitPullRequestClosed:(0,n.$3j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$3j)("git-pull-request-draft",60379),debugAll:(0,n.$3j)("debug-all",60380),debugCoverage:(0,n.$3j)("debug-coverage",60381),runErrors:(0,n.$3j)("run-errors",60382),folderLibrary:(0,n.$3j)("folder-library",60383),debugContinueSmall:(0,n.$3j)("debug-continue-small",60384),beakerStop:(0,n.$3j)("beaker-stop",60385),graphLine:(0,n.$3j)("graph-line",60386),graphScatter:(0,n.$3j)("graph-scatter",60387),pieChart:(0,n.$3j)("pie-chart",60388),bracket:(0,n.$3j)("bracket",60175),bracketDot:(0,n.$3j)("bracket-dot",60389),bracketError:(0,n.$3j)("bracket-error",60390),lockSmall:(0,n.$3j)("lock-small",60391),azureDevops:(0,n.$3j)("azure-devops",60392),verifiedFilled:(0,n.$3j)("verified-filled",60393),newline:(0,n.$3j)("newline",60394),layout:(0,n.$3j)("layout",60395),layoutActivitybarLeft:(0,n.$3j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$3j)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$3j)("layout-panel-left",60398),layoutPanelCenter:(0,n.$3j)("layout-panel-center",60399),layoutPanelJustify:(0,n.$3j)("layout-panel-justify",60400),layoutPanelRight:(0,n.$3j)("layout-panel-right",60401),layoutPanel:(0,n.$3j)("layout-panel",60402),layoutSidebarLeft:(0,n.$3j)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$3j)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$3j)("layout-statusbar",60405),layoutMenubar:(0,n.$3j)("layout-menubar",60406),layoutCentered:(0,n.$3j)("layout-centered",60407),target:(0,n.$3j)("target",60408),indent:(0,n.$3j)("indent",60409),recordSmall:(0,n.$3j)("record-small",60410),errorSmall:(0,n.$3j)("error-small",60411),terminalDecorationError:(0,n.$3j)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$3j)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$3j)("arrow-circle-left",60413),arrowCircleRight:(0,n.$3j)("arrow-circle-right",60414),arrowCircleUp:(0,n.$3j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$3j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$3j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$3j)("layout-sidebar-left-off",60418),blank:(0,n.$3j)("blank",60419),heartFilled:(0,n.$3j)("heart-filled",60420),map:(0,n.$3j)("map",60421),mapHorizontal:(0,n.$3j)("map-horizontal",60421),foldHorizontal:(0,n.$3j)("fold-horizontal",60421),mapFilled:(0,n.$3j)("map-filled",60422),mapHorizontalFilled:(0,n.$3j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$3j)("fold-horizontal-filled",60422),circleSmall:(0,n.$3j)("circle-small",60423),bellSlash:(0,n.$3j)("bell-slash",60424),bellSlashDot:(0,n.$3j)("bell-slash-dot",60425),commentUnresolved:(0,n.$3j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$3j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$3j)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$3j)("search-fuzzy",60429),commentDraft:(0,n.$3j)("comment-draft",60430),send:(0,n.$3j)("send",60431),sparkle:(0,n.$3j)("sparkle",60432),insert:(0,n.$3j)("insert",60433),mic:(0,n.$3j)("mic",60434),thumbsdownFilled:(0,n.$3j)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$3j)("thumbsup-filled",60436),coffee:(0,n.$3j)("coffee",60437),snake:(0,n.$3j)("snake",60438),game:(0,n.$3j)("game",60439),vr:(0,n.$3j)("vr",60440),chip:(0,n.$3j)("chip",60441),piano:(0,n.$3j)("piano",60442),music:(0,n.$3j)("music",60443),micFilled:(0,n.$3j)("mic-filled",60444),repoFetch:(0,n.$3j)("repo-fetch",60445),copilot:(0,n.$3j)("copilot",60446),lightbulbSparkle:(0,n.$3j)("lightbulb-sparkle",60447),robot:(0,n.$3j)("robot",60448),sparkleFilled:(0,n.$3j)("sparkle-filled",60449),diffSingle:(0,n.$3j)("diff-single",60450),diffMultiple:(0,n.$3j)("diff-multiple",60451),surroundWith:(0,n.$3j)("surround-with",60452),share:(0,n.$3j)("share",60453),gitStash:(0,n.$3j)("git-stash",60454),gitStashApply:(0,n.$3j)("git-stash-apply",60455),gitStashPop:(0,n.$3j)("git-stash-pop",60456),vscode:(0,n.$3j)("vscode",60457),vscodeInsiders:(0,n.$3j)("vscode-insiders",60458),codeOss:(0,n.$3j)("code-oss",60459),runCoverage:(0,n.$3j)("run-coverage",60460),runAllCoverage:(0,n.$3j)("run-all-coverage",60461),coverage:(0,n.$3j)("coverage",60462),githubProject:(0,n.$3j)("github-project",60463),mapVertical:(0,n.$3j)("map-vertical",60464),foldVertical:(0,n.$3j)("fold-vertical",60464),mapVerticalFilled:(0,n.$3j)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$3j)("fold-vertical-filled",60465),goToSearch:(0,n.$3j)("go-to-search",60466),percentage:(0,n.$3j)("percentage",60467),sortPercentage:(0,n.$3j)("sort-percentage",60467),attach:(0,n.$3j)("attach",60468)}}),ie(se[49],ue([0,1,30,48]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8j=t.$7j=void 0,t.$6j=T;function T(){return Object.values(t.$8j)}t.$7j={dialogError:(0,n.$3j)("dialog-error","error"),dialogWarning:(0,n.$3j)("dialog-warning","warning"),dialogInfo:(0,n.$3j)("dialog-info","info"),dialogClose:(0,n.$3j)("dialog-close","close"),treeItemExpanded:(0,n.$3j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$3j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$3j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$3j)("tree-filter-clear","close"),treeItemLoading:(0,n.$3j)("tree-item-loading","loading"),menuSelection:(0,n.$3j)("menu-selection","check"),menuSubmenu:(0,n.$3j)("menu-submenu","chevron-right"),menuBarMore:(0,n.$3j)("menubar-more","more"),scrollbarButtonLeft:(0,n.$3j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$3j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$3j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$3j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$3j)("toolbar-more","more"),quickInputBack:(0,n.$3j)("quick-input-back","arrow-left"),dropDownButton:(0,n.$3j)("drop-down-button",60084),symbolCustomColor:(0,n.$3j)("symbol-customcolor",60252),exportIcon:(0,n.$3j)("export",60332),workspaceUnspecified:(0,n.$3j)("workspace-unspecified",60355),newLine:(0,n.$3j)("newline",60394),thumbsDownFilled:(0,n.$3j)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$3j)("thumbsup-filled",60436),gitFetch:(0,n.$3j)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$3j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$3j)("debug-breakpoint-pending",60377)},t.$8j={...i.$5j,...t.$7j}}),ie(se[31],ue([0,1,21]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$io=i,t.$jo=T,t.$ko=A,t.$lo=a,t.$mo=u,t.$no=g,t.$oo=E,t.$po=d,t.$qo=c,t.$ro=e,t.$so=l,t.$to=h,t.$uo=w;function i(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const N=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([_,$])=>{N[_]=$&&typeof $=="object"?i($):$}),N}function T(L){if(!L||typeof L!="object")return L;const N=[L];for(;N.length>0;){const _=N.shift();Object.freeze(_);for(const $ in _)if(m.call(_,$)){const o=_[$];typeof o=="object"&&!Object.isFrozen(o)&&!(0,n.$kg)(o)&&N.push(o)}}return L}const m=Object.prototype.hasOwnProperty;function A(L,N){return b(L,N,new Set)}function b(L,N,_){if((0,n.$qg)(L))return L;const $=N(L);if(typeof $<"u")return $;if(Array.isArray(L)){const o=[];for(const s of L)o.push(b(s,N,_));return o}if((0,n.$jg)(L)){if(_.has(L))throw new Error("Cannot clone recursive data-structure");_.add(L);const o={};for(const s in L)m.call(L,s)&&(o[s]=b(L[s],N,_));return _.delete(L),o}return L}function a(L,N,_=!0){return(0,n.$jg)(L)?((0,n.$jg)(N)&&Object.keys(N).forEach($=>{$ in L?_&&((0,n.$jg)(L[$])&&(0,n.$jg)(N[$])?a(L[$],N[$],_):L[$]=N[$]):L[$]=N[$]}),L):N}function u(L,N){if(L===N)return!0;if(L==null||N===null||N===void 0||typeof L!=typeof N||typeof L!="object"||Array.isArray(L)!==Array.isArray(N))return!1;let _,$;if(Array.isArray(L)){if(L.length!==N.length)return!1;for(_=0;_<L.length;_++)if(!u(L[_],N[_]))return!1}else{const o=[];for($ in L)o.push($);o.sort();const s=[];for($ in N)s.push($);if(s.sort(),!u(o,s))return!1;for(_=0;_<o.length;_++)if(!u(L[o[_]],N[o[_]]))return!1}return!0}function g(L){const N=new Set;return JSON.stringify(L,(_,$)=>{if((0,n.$jg)($)||Array.isArray($)){if(N.has($))return"[Circular]";N.add($)}return typeof $=="bigint"?`[BigInt ${$.toString()}]`:$})}function E(L,N){const _=Object.create(null);return!L||!N||Object.keys(N).forEach(o=>{const s=L[o],f=N[o];u(s,f)||(_[o]=f)}),_}function d(L,N){const _=N.toLowerCase(),$=Object.keys(L).find(o=>o.toLowerCase()===_);return $?L[$]:L[N]}function c(L,N){const _=Object.create(null);for(const[$,o]of Object.entries(L))N($,o)&&(_[$]=o);return _}function e(L){let N=[];for(;Object.prototype!==L;)N=N.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return N}function l(L){const N=[];for(const _ of e(L))typeof L[_]=="function"&&N.push(_);return N}function h(L,N){const _=o=>function(){const s=Array.prototype.slice.call(arguments,0);return N(o,s)},$={};for(const o of L)$[o]=_(o);return $}function w(L,N){const _={};for(const[$,o]of Object.entries(L))_[$]=N(o,$);return _}}),ie(se[17],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$df=i,t.$ef=T;var n;(function(m){m[m.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",m[m.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",m[m.MAX_UINT_8=255]="MAX_UINT_8",m[m.MAX_UINT_16=65535]="MAX_UINT_16",m[m.MAX_UINT_32=4294967295]="MAX_UINT_32",m[m.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(t.Constants=n={}));function i(m){return m<0?0:m>n.MAX_UINT_8?n.MAX_UINT_8:m|0}function T(m){return m<0?0:m>n.MAX_UINT_32?n.MAX_UINT_32:m|0}}),ie(se[6],ue([0,1,46,3,27,17]),function(W,t,n,i,T,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gg=t.$fg=t.$eg=t.GraphemeBreakType=t.$7f=t.$Yf=t.$Rf=t.$Qf=void 0,t.$ff=A,t.$gf=a,t.$hf=g,t.$if=E,t.$jf=d,t.$kf=c,t.$lf=e,t.$mf=l,t.$nf=h,t.$of=w,t.$pf=L,t.$qf=N,t.$rf=_,t.$sf=$,t.$tf=o,t.$uf=s,t.$vf=f,t.$wf=v,t.$xf=k,t.$yf=R,t.$zf=j,t.$Af=M,t.$Bf=p,t.$Cf=D,t.$Df=I,t.$Ef=F,t.$Ff=q,t.$Gf=z,t.$Hf=H,t.$If=U,t.$Jf=C,t.$Kf=ee,t.$Lf=J,t.$Mf=K,t.$Nf=ne,t.$Of=P,t.$Pf=X,t.$Sf=r,t.$Tf=je,t.$Uf=Pe,t.$Vf=Ue,t.$Wf=qe,t.$Xf=G,t.$Zf=O,t.$1f=y,t.$2f=B,t.$3f=Y,t.$4f=ae,t.$5f=we,t.$6f=Re,t.$8f=oe,t.$9f=re,t.$0f=ce,t.$$f=le,t.$_f=me,t.$ag=be,t.$bg=ve,t.$cg=Te,t.$dg=ze;function A(S){return!S||typeof S!="string"?!0:S.trim().length===0}const b=/{(\d+)}/g;function a(S,...V){return V.length===0?S:S.replace(b,function(Z,te){const fe=parseInt(te,10);return isNaN(fe)||fe<0||fe>=V.length?Z:V[fe]})}const u=/{([^}]+)}/g;function g(S,V){return Object.keys(V).length===0?S:S.replace(u,(Z,te)=>V[te]??Z)}function E(S){return S.replace(/[<>"'&]/g,V=>{switch(V){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return V})}function d(S){return S.replace(/[<>&]/g,function(V){switch(V){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return V}})}function c(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(S,V){let Z=0,te=S.indexOf(V);for(;te!==-1;)Z++,te=S.indexOf(V,te+V.length);return Z}function l(S,V,Z="\u2026"){return S.length<=V?S:`${S.substr(0,V)}${Z}`}function h(S,V,Z="\u2026"){if(S.length<=V)return S;const te=Math.ceil(V/2)-Z.length/2,fe=Math.floor(V/2)-Z.length/2;return`${S.substr(0,te)}${Z}${S.substr(S.length-fe)}`}function w(S,V=" "){const Z=L(S,V);return N(Z,V)}function L(S,V){if(!S||!V)return S;const Z=V.length;if(Z===0||S.length===0)return S;let te=0;for(;S.indexOf(V,te)===te;)te=te+Z;return S.substring(te)}function N(S,V){if(!S||!V)return S;const Z=V.length,te=S.length;if(Z===0||te===0)return S;let fe=te,$e=-1;for(;$e=S.lastIndexOf(V,fe-1),!($e===-1||$e+Z!==fe);){if($e===0)return"";fe=$e}return S.substring(0,fe)}function _(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function $(S){return S.replace(/\*/g,"")}function o(S,V,Z={}){if(!S)throw new Error("Cannot create regex from empty string");V||(S=c(S)),Z.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let te="";return Z.global&&(te+="g"),Z.matchCase||(te+="i"),Z.multiline&&(te+="m"),Z.unicode&&(te+="u"),new RegExp(S,te)}function s(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}function f(S){return S.split(/\r\n|\r|\n/)}function v(S){const V=[],Z=S.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(Z.length/2);te++)V.push(Z[2*te]+(Z[2*te+1]??""));return V}function k(S){for(let V=0,Z=S.length;V<Z;V++){const te=S.charCodeAt(V);if(te!==i.CharCode.Space&&te!==i.CharCode.Tab)return V}return-1}function R(S,V=0,Z=S.length){for(let te=V;te<Z;te++){const fe=S.charCodeAt(te);if(fe!==i.CharCode.Space&&fe!==i.CharCode.Tab)return S.substring(V,te)}return S.substring(V,Z)}function j(S,V=S.length-1){for(let Z=V;Z>=0;Z--){const te=S.charCodeAt(Z);if(te!==i.CharCode.Space&&te!==i.CharCode.Tab)return Z}return-1}function M(S,V,Z){const te=[];let fe=0;for(const $e of S.matchAll(V)){if(te.push(S.slice(fe,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");fe=$e.index+$e[0].length,te.push(Z($e[0],...$e.slice(1),$e.index,S,$e.groups))}return te.push(S.slice(fe)),Promise.all(te).then($e=>$e.join(""))}function p(S,V){return S<V?-1:S>V?1:0}function D(S,V,Z=0,te=S.length,fe=0,$e=V.length){for(;Z<te&&fe<$e;Z++,fe++){const Ie=S.charCodeAt(Z),ye=V.charCodeAt(fe);if(Ie<ye)return-1;if(Ie>ye)return 1}const Me=te-Z,Oe=$e-fe;return Me<Oe?-1:Me>Oe?1:0}function I(S,V){return F(S,V,0,S.length,0,V.length)}function F(S,V,Z=0,te=S.length,fe=0,$e=V.length){for(;Z<te&&fe<$e;Z++,fe++){let Ie=S.charCodeAt(Z),ye=V.charCodeAt(fe);if(Ie===ye)continue;if(Ie>=128||ye>=128)return D(S.toLowerCase(),V.toLowerCase(),Z,te,fe,$e);z(Ie)&&(Ie-=32),z(ye)&&(ye-=32);const De=Ie-ye;if(De!==0)return De}const Me=te-Z,Oe=$e-fe;return Me<Oe?-1:Me>Oe?1:0}function q(S){return S>=i.CharCode.Digit0&&S<=i.CharCode.Digit9}function z(S){return S>=i.CharCode.a&&S<=i.CharCode.z}function H(S){return S>=i.CharCode.A&&S<=i.CharCode.Z}function U(S,V){return S.length===V.length&&F(S,V)===0}function C(S,V){const Z=V.length;return V.length>S.length?!1:F(S,V,0,Z)===0}function ee(S,V){const Z=Math.min(S.length,V.length);let te;for(te=0;te<Z;te++)if(S.charCodeAt(te)!==V.charCodeAt(te))return te;return Z}function J(S,V){const Z=Math.min(S.length,V.length);let te;const fe=S.length-1,$e=V.length-1;for(te=0;te<Z;te++)if(S.charCodeAt(fe-te)!==V.charCodeAt($e-te))return te;return Z}function K(S){return 55296<=S&&S<=56319}function ne(S){return 56320<=S&&S<=57343}function P(S,V){return(S-55296<<10)+(V-56320)+65536}function X(S,V,Z){const te=S.charCodeAt(Z);if(K(te)&&Z+1<V){const fe=S.charCodeAt(Z+1);if(ne(fe))return P(te,fe)}return te}function he(S,V){const Z=S.charCodeAt(V-1);if(ne(Z)&&V>1){const te=S.charCodeAt(V-2);if(K(te))return P(te,Z)}return Z}class ge{get offset(){return this.e}constructor(V,Z=0){this.c=V,this.d=V.length,this.e=Z}setOffset(V){this.e=V}prevCodePoint(){const V=he(this.c,this.e);return this.e-=V>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,V}nextCodePoint(){const V=X(this.c,this.d,this.e);return this.e+=V>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,V}eol(){return this.e>=this.d}}t.$Qf=ge;class Ee{get offset(){return this.c.offset}constructor(V,Z=0){this.c=new ge(V,Z)}nextGraphemeLength(){const V=Fe.getInstance(),Z=this.c,te=Z.offset;let fe=V.getGraphemeBreakType(Z.nextCodePoint());for(;!Z.eol();){const $e=Z.offset,Me=V.getGraphemeBreakType(Z.nextCodePoint());if(pe(fe,Me)){Z.setOffset($e);break}fe=Me}return Z.offset-te}prevGraphemeLength(){const V=Fe.getInstance(),Z=this.c,te=Z.offset;let fe=V.getGraphemeBreakType(Z.prevCodePoint());for(;Z.offset>0;){const $e=Z.offset,Me=V.getGraphemeBreakType(Z.prevCodePoint());if(pe(Me,fe)){Z.setOffset($e);break}fe=Me}return te-Z.offset}eol(){return this.c.eol()}}t.$Rf=Ee;function r(S,V){return new Ee(S,V).nextGraphemeLength()}function je(S,V){return new Ee(S,V).prevGraphemeLength()}function Pe(S,V){V>0&&ne(S.charCodeAt(V))&&V--;const Z=V+r(S,V);return[Z-je(S,Z),Z]}function Ue(S){const V=new Ee(S);let Z=0;for(;!V.eol();)Z++,V.nextGraphemeLength();return Z}let Ae;function Ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function qe(S){return Ae||(Ae=Ne()),Ae.test(S)}const x=/^[\t\n\r\x20-\x7E]*$/;function G(S){return x.test(S)}t.$Yf=/[\u2028\u2029]/;function O(S){return t.$Yf.test(S)}function y(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}function B(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}function Y(S,V,Z=""){const te=S.trimStart();if(te.length<V)return te;const fe=/\b/g;let $e=0;for(;fe.test(te)&&!(te.length-fe.lastIndex<V);)$e=fe.lastIndex,fe.lastIndex+=1;return $e===0?te:Z+te.substring($e).trimStart()}const Q=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ae(S){let V=0;for(const Z of S.matchAll(Q))V!==Z.index&&(yield{isCode:!1,str:S.substring(V,Z.index)}),yield{isCode:!0,str:Z[0]},V=Z.index+Z[0].length;V!==S.length&&(yield{isCode:!1,str:S.substring(V)})}function we(S){return S&&(S=S.replace(Q,"")),S}const Le=/\\\[.*?\\\]/g;function Re(S){return we(S).replace(Le,"")}t.$7f=String.fromCharCode(i.CharCode.UTF8_BOM);function oe(S){return!!(S&&S.length>0&&S.charCodeAt(0)===i.CharCode.UTF8_BOM)}function re(S){return oe(S)?S.substr(1):S}function ce(S,V){if(!S||!V||S.length<V.length)return!1;const Z=V.length,te=S.toLowerCase();let fe=0,$e=-1;for(;fe<Z;){const Me=te.indexOf(V[fe],$e+1);if(Me<0)return!1;$e=Me,fe++}return!0}function le(S,V=!1){return S?(V&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}function me(S){return S.charAt(0).toUpperCase()+S.slice(1)}function be(S,V=1){if(V===0)return"";let Z=-1;do Z=S.indexOf(`
`,Z+1),V--;while(V>0&&Z>=0);return Z===-1?S:(S[Z-1]==="\r"&&Z--,S.substr(0,Z))}function ve(S){const V=i.CharCode.Z-i.CharCode.A+1;return S=S%(2*V),S<V?String.fromCharCode(i.CharCode.a+S):String.fromCharCode(i.CharCode.A+S-V)}function Te(S){return Fe.getInstance().getGraphemeBreakType(S)}function pe(S,V){return S===de.Other?V!==de.Extend&&V!==de.SpacingMark:S===de.CR&&V===de.LF?!1:S===de.Control||S===de.CR||S===de.LF||V===de.Control||V===de.CR||V===de.LF?!0:!(S===de.L&&(V===de.L||V===de.V||V===de.LV||V===de.LVT)||(S===de.LV||S===de.V)&&(V===de.V||V===de.T)||(S===de.LVT||S===de.T)&&V===de.T||V===de.Extend||V===de.ZWJ||V===de.SpacingMark||S===de.Prepend||S===de.ZWJ&&V===de.Extended_Pictographic||S===de.Regional_Indicator&&V===de.Regional_Indicator)}var de;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(de||(t.GraphemeBreakType=de={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=We()}getGraphemeBreakType(V){if(V<32)return V===i.CharCode.LineFeed?de.LF:V===i.CharCode.CarriageReturn?de.CR:de.Control;if(V<127)return de.Other;const Z=this.d,te=Z.length/3;let fe=1;for(;fe<=te;)if(V<Z[3*fe])fe=2*fe;else if(V>Z[3*fe+1])fe=2*fe+1;else return Z[3*fe+2];return de.Other}}function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(S,V){if(S===0)return 0;const Z=He(S,V);if(Z!==void 0)return Z;const te=new ge(V,S);return te.prevCodePoint(),te.offset}function He(S,V){const Z=new ge(V,S);let te=Z.prevCodePoint();for(;Ye(te)||te===Ve.emojiVariantSelector||te===Ve.enclosingKeyCap;){if(Z.offset===0)return;te=Z.prevCodePoint()}if(!B(te))return;let fe=Z.offset;return fe>0&&Z.prevCodePoint()===Ve.zwj&&(fe=Z.offset),fe}function Ye(S){return 127995<=S&&S<=127999}var Ve;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),t.$eg="\xA0";class xe{static{this.c=new T.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$bf({getCacheKey:JSON.stringify},V=>{function Z(De){const Be=new Map;for(let Se=0;Se<De.length;Se+=2)Be.set(De[Se],De[Se+1]);return Be}function te(De,Be){const Se=new Map(De);for(const[Xe,Ze]of Be)Se.set(Xe,Ze);return Se}function fe(De,Be){if(!De)return Be;const Se=new Map;for(const[Xe,Ze]of De)Be.has(Xe)&&Se.set(Xe,Ze);return Se}const $e=this.c.value;let Me=V.filter(De=>!De.startsWith("_")&&De in $e);Me.length===0&&(Me=["_default"]);let Oe;for(const De of Me){const Be=Z($e[De]);Oe=fe(Oe,Be)}const Ie=Z($e._common),ye=te(Ie,Oe);return new xe(ye)})}static getInstance(V){return xe.d.get(Array.from(V))}static{this.e=new T.$W(()=>Object.keys(xe.c.value).filter(V=>!V.startsWith("_")))}static getLocales(){return xe.e.value}constructor(V){this.f=V}isAmbiguous(V){return this.f.has(V)}containsAmbiguousCharacter(V){for(let Z=0;Z<V.length;Z++){const te=V.codePointAt(Z);if(typeof te=="number"&&this.isAmbiguous(te))return!0}return!1}getPrimaryConfusable(V){return this.f.get(V)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$fg=xe;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(V){return Ge.e().has(V)}static containsInvisibleCharacter(V){for(let Z=0;Z<V.length;Z++){const te=V.codePointAt(Z);if(typeof te=="number"&&Ge.isInvisibleCharacter(te))return!0}return!1}static get codePoints(){return Ge.e()}}t.$gg=Ge}),ie(se[50],ue([0,1,3,16,8,6,21]),function(W,t,n,i,T,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ag=b,t.$Bg=a,t.$Cg=u,t.$Dg=g,t.$Eg=E,t.$Fg=l,t.$Gg=h,t.$Hg=w,t.$Ig=L,t.$Jg=N,t.$Kg=_,t.$Lg=$,t.$Mg=o,t.$Ng=s,t.$Og=f,t.$Pg=v,t.$Qg=j;function b(M){return M===n.CharCode.Slash||M===n.CharCode.Backslash}function a(M){return M.replace(/[\\/]/g,i.$jc.sep)}function u(M){return M.indexOf("/")===-1&&(M=a(M)),/^[a-zA-Z]:(\/|$)/.test(M)&&(M="/"+M),M}function g(M,p=i.$jc.sep){if(!M)return"";const D=M.length,I=M.charCodeAt(0);if(b(I)){if(b(M.charCodeAt(1))&&!b(M.charCodeAt(2))){let q=3;const z=q;for(;q<D&&!b(M.charCodeAt(q));q++);if(z!==q&&!b(M.charCodeAt(q+1))){for(q+=1;q<D;q++)if(b(M.charCodeAt(q)))return M.slice(0,q+1).replace(/[\\/]/g,p)}}return p}else if(L(I)&&M.charCodeAt(1)===n.CharCode.Colon)return b(M.charCodeAt(2))?M.slice(0,2)+p:M.slice(0,2);let F=M.indexOf("://");if(F!==-1){for(F+=3;F<D;F++)if(b(M.charCodeAt(F)))return M.slice(0,F+1)}return""}function E(M){if(!T.$j||!M||M.length<5)return!1;let p=M.charCodeAt(0);if(p!==n.CharCode.Backslash||(p=M.charCodeAt(1),p!==n.CharCode.Backslash))return!1;let D=2;const I=D;for(;D<M.length&&(p=M.charCodeAt(D),p!==n.CharCode.Backslash);D++);return!(I===D||(p=M.charCodeAt(D+1),isNaN(p)||p===n.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,c=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(M,p=T.$j){const D=p?d:c;return!(!M||M.length===0||/^\s+$/.test(M)||(D.lastIndex=0,D.test(M))||p&&e.test(M)||M==="."||M===".."||p&&M[M.length-1]==="."||p&&M.length!==M.trim().length||M.length>255)}function h(M,p,D){const I=M===p;return!D||I?I:!M||!p?!1:(0,m.$If)(M,p)}function w(M,p,D,I=i.sep){if(M===p)return!0;if(!M||!p||p.length>M.length)return!1;if(D){if(!(0,m.$Jf)(M,p))return!1;if(p.length===M.length)return!0;let q=p.length;return p.charAt(p.length-1)===I&&q--,M.charAt(q)===I}return p.charAt(p.length-1)!==I&&(p+=I),M.indexOf(p)===0}function L(M){return M>=n.CharCode.A&&M<=n.CharCode.Z||M>=n.CharCode.a&&M<=n.CharCode.z}function N(M,p){return T.$j&&M.endsWith(":")&&(M+=i.sep),(0,i.$lc)(M)||(M=(0,i.$mc)(p,M)),M=(0,i.$kc)(M),_(M)}function _(M){return T.$j?(M=(0,m.$qf)(M,i.sep),M.endsWith(":")&&(M+=i.sep)):(M=(0,m.$qf)(M,i.sep),M||(M=i.sep)),M}function $(M){const p=(0,i.$kc)(M);return T.$j?M.length>3?!1:o(p)&&(M.length===2||p.charCodeAt(2)===n.CharCode.Backslash):p===i.$jc.sep}function o(M,p=T.$j){return p?L(M.charCodeAt(0))&&M.charCodeAt(1)===n.CharCode.Colon:!1}function s(M,p=T.$j){return o(M,p)?M[0]:void 0}function f(M,p,D){return p.length>M.length?-1:M===p?0:(D&&(M=M.toLowerCase(),p=p.toLowerCase()),M.indexOf(p))}function v(M){const p=M.split(":");let D,I,F;for(const q of p){const z=Number(q);(0,A.$lg)(z)?I===void 0?I=z:F===void 0&&(F=z):D=D?[D,q].join(":"):q}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:F!==void 0?F:I!==void 0?1:void 0}}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function j(M,p,D=8){let I="";for(let q=0;q<D;q++){let z;q===0&&T.$j&&!p&&(D===3||D===4)?z=R:z=k,I+=z.charAt(Math.floor(Math.random()*z.length))}let F;return p?F=`${p}-${I}`:F=I,M?(0,i.$mc)(M,F):F}}),ie(se[51],ue([0,1,6]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=t.$Aj=void 0,t.$wj=i,t.$xj=T,t.$yj=m,t.$zj=b,t.$Bj=l,n=ke(n);function i(w){return T(w,0)}function T(w,L){switch(typeof w){case"object":return w===null?m(349,L):Array.isArray(w)?a(w,L):u(w,L);case"string":return b(w,L);case"boolean":return A(w,L);case"number":return m(w,L);case"undefined":return m(937,L);default:return m(617,L)}}function m(w,L){return(L<<5)-L+w|0}function A(w,L){return m(w?433:863,L)}function b(w,L){L=m(149417,L);for(let N=0,_=w.length;N<_;N++)L=m(w.charCodeAt(N),L);return L}function a(w,L){return L=m(104579,L),w.reduce((N,_)=>T(_,N),L)}function u(w,L){return L=m(181387,L),Object.keys(w).sort().reduce((N,_)=>(N=b(_,N),T(w[_],N)),L)}class g{constructor(){this.g=0}get value(){return this.g}hash(L){return this.g=T(L,this.g),this.g}}t.$Aj=g;var E;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(w,L,N=32){const _=N-L,$=~((1<<_)-1);return(w<<L|($&w)>>>_)>>>0}function c(w,L=0,N=w.byteLength,_=0){for(let $=0;$<N;$++)w[L+$]=_}function e(w,L,N="0"){for(;w.length<L;)w=N+w;return w}function l(w,L=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(N=>N.toString(16).padStart(2,"0")).join(""):e((w>>>0).toString(16),L/4)}class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(L){const N=L.length;if(N===0)return;const _=this.p;let $=this.r,o=this.u,s,f;for(o!==0?(s=o,f=-1,o=0):(s=L.charCodeAt(0),f=0);;){let v=s;if(n.$Mf(s))if(f+1<N){const k=L.charCodeAt(f+1);n.$Nf(k)?(f++,v=n.$Of(s,k)):v=E.UNICODE_REPLACEMENT}else{o=s;break}else n.$Nf(s)&&(v=E.UNICODE_REPLACEMENT);if($=this.w(_,$,v),f++,f<N)s=L.charCodeAt(f);else break}this.r=$,this.u=o}w(L,N,_){return _<128?L[N++]=_:_<2048?(L[N++]=192|(_&1984)>>>6,L[N++]=128|(_&63)>>>0):_<65536?(L[N++]=224|(_&61440)>>>12,L[N++]=128|(_&4032)>>>6,L[N++]=128|(_&63)>>>0):(L[N++]=240|(_&1835008)>>>18,L[N++]=128|(_&258048)>>>12,L[N++]=128|(_&4032)>>>6,L[N++]=128|(_&63)>>>0),N>=E.BLOCK_SIZE&&(this.y(),N-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,L[0]=L[E.BLOCK_SIZE+0],L[1]=L[E.BLOCK_SIZE+1],L[2]=L[E.BLOCK_SIZE+2]),N}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const L=8*this.t;this.q.setUint32(56,Math.floor(L/4294967296),!1),this.q.setUint32(60,L%4294967296,!1),this.y()}y(){const L=h.g,N=this.q;for(let j=0;j<64;j+=4)L.setUint32(j,N.getUint32(j,!1),!1);for(let j=64;j<320;j+=4)L.setUint32(j,d(L.getUint32(j-12,!1)^L.getUint32(j-32,!1)^L.getUint32(j-56,!1)^L.getUint32(j-64,!1),1),!1);let _=this.h,$=this.l,o=this.m,s=this.n,f=this.o,v,k,R;for(let j=0;j<80;j++)j<20?(v=$&o|~$&s,k=1518500249):j<40?(v=$^o^s,k=1859775393):j<60?(v=$&o|$&s|o&s,k=2400959708):(v=$^o^s,k=3395469782),R=d(_,5)+v+f+k+L.getUint32(j*4,!1)&4294967295,f=s,s=o,o=d($,30),$=_,_=R;this.h=this.h+_&4294967295,this.l=this.l+$&4294967295,this.m=this.m+o&4294967295,this.n=this.n+s&4294967295,this.o=this.o+f&4294967295}}t.$Cj=h}),ie(se[32],ue([0,1,42,51,17]),function(W,t,n,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1t=t.$Yt=void 0,t.$Zt=A;class m{constructor(c){this.a=c}getElements(){const c=this.a,e=new Int32Array(c.length);for(let l=0,h=c.length;l<h;l++)e[l]=c.charCodeAt(l);return e}}t.$Yt=m;function A(d,c,e){return new E(new m(d),new m(c)).ComputeDiff(e).changes}class b{static Assert(c,e){if(!c)throw new Error(e)}}class a{static Copy(c,e,l,h,w){for(let L=0;L<w;L++)l[h+L]=c[e+L]}static Copy2(c,e,l,h,w){for(let L=0;L<w;L++)l[h+L]=c[e+L]}}var u;(function(d){d[d.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class g{constructor(){this.a=[],this.b=T.Constants.MAX_SAFE_SMALL_INTEGER,this.c=T.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new n.$Xt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=T.Constants.MAX_SAFE_SMALL_INTEGER,this.c=T.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(c,e){this.b=Math.min(this.b,c),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(c,e){this.b=Math.min(this.b,c),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class E{constructor(c,e,l=null){this.a=l,this.b=c,this.c=e;const[h,w,L]=E.o(c),[N,_,$]=E.o(e);this.d=L&&$,this.e=h,this.f=w,this.g=N,this.h=_,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const e=c.getElements();if(E.n(e)){const l=new Int32Array(e.length);for(let h=0,w=e.length;h<w;h++)l[h]=(0,i.$zj)(e[h],0);return[e,l,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(c,e){return this.f[c]!==this.h[e]?!1:this.d?this.e[c]===this.g[e]:!0}q(c,e){if(!this.p(c,e))return!1;const l=E.r(this.b,c),h=E.r(this.c,e);return l===h}static r(c,e){return typeof c.getStrictElement=="function"?c.getStrictElement(e):null}s(c,e){return this.f[c]!==this.f[e]?!1:this.d?this.e[c]===this.e[e]:!0}u(c,e){return this.h[c]!==this.h[e]?!1:this.d?this.g[c]===this.g[e]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,e,l,h,w){const L=[!1];let N=this.w(c,e,l,h,L);return w&&(N=this.z(N)),{quitEarly:L[0],changes:N}}w(c,e,l,h,w){for(w[0]=!1;c<=e&&l<=h&&this.p(c,l);)c++,l++;for(;e>=c&&h>=l&&this.p(e,h);)e--,h--;if(c>e||l>h){let s;return l<=h?(b.Assert(c===e+1,"originalStart should only be one more than originalEnd"),s=[new n.$Xt(c,0,l,h-l+1)]):c<=e?(b.Assert(l===h+1,"modifiedStart should only be one more than modifiedEnd"),s=[new n.$Xt(c,e-c+1,l,0)]):(b.Assert(c===e+1,"originalStart should only be one more than originalEnd"),b.Assert(l===h+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const L=[0],N=[0],_=this.y(c,e,l,h,L,N,w),$=L[0],o=N[0];if(_!==null)return _;if(!w[0]){const s=this.w(c,$,l,o,w);let f=[];return w[0]?f=[new n.$Xt($+1,e-($+1)+1,o+1,h-(o+1)+1)]:f=this.w($+1,e,o+1,h,w),this.H(s,f)}return[new n.$Xt(c,e-c+1,l,h-l+1)]}x(c,e,l,h,w,L,N,_,$,o,s,f,v,k,R,j,M,p){let D=null,I=null,F=new g,q=e,z=l,H=v[0]-j[0]-h,U=T.Constants.MIN_SAFE_SMALL_INTEGER,C=this.k.length-1;do{const ee=H+c;ee===q||ee<z&&$[ee-1]<$[ee+1]?(s=$[ee+1],k=s-H-h,s<U&&F.MarkNextChange(),U=s,F.AddModifiedElement(s+1,k),H=ee+1-c):(s=$[ee-1]+1,k=s-H-h,s<U&&F.MarkNextChange(),U=s-1,F.AddOriginalElement(s,k+1),H=ee-1-c),C>=0&&($=this.k[C],c=$[0],q=1,z=$.length-1)}while(--C>=-1);if(D=F.getReverseChanges(),p[0]){let ee=v[0]+1,J=j[0]+1;if(D!==null&&D.length>0){const K=D[D.length-1];ee=Math.max(ee,K.getOriginalEnd()),J=Math.max(J,K.getModifiedEnd())}I=[new n.$Xt(ee,f-ee+1,J,R-J+1)]}else{F=new g,q=L,z=N,H=v[0]-j[0]-_,U=T.Constants.MAX_SAFE_SMALL_INTEGER,C=M?this.m.length-1:this.m.length-2;do{const ee=H+w;ee===q||ee<z&&o[ee-1]>=o[ee+1]?(s=o[ee+1]-1,k=s-H-_,s>U&&F.MarkNextChange(),U=s+1,F.AddOriginalElement(s+1,k+1),H=ee+1-w):(s=o[ee-1],k=s-H-_,s>U&&F.MarkNextChange(),U=s,F.AddModifiedElement(s+1,k+1),H=ee-1-w),C>=0&&(o=this.m[C],w=o[0],q=1,z=o.length-1)}while(--C>=-1);I=F.getChanges()}return this.H(D,I)}y(c,e,l,h,w,L,N){let _=0,$=0,o=0,s=0,f=0,v=0;c--,l--,w[0]=0,L[0]=0,this.k=[],this.m=[];const k=e-c+(h-l),R=k+1,j=new Int32Array(R),M=new Int32Array(R),p=h-l,D=e-c,I=c-l,F=e-h,z=(D-p)%2===0;j[p]=c,M[D]=e,N[0]=!1;for(let H=1;H<=k/2+1;H++){let U=0,C=0;o=this.J(p-H,H,p,R),s=this.J(p+H,H,p,R);for(let J=o;J<=s;J+=2){J===o||J<s&&j[J-1]<j[J+1]?_=j[J+1]:_=j[J-1]+1,$=_-(J-p)-I;const K=_;for(;_<e&&$<h&&this.p(_+1,$+1);)_++,$++;if(j[J]=_,_+$>U+C&&(U=_,C=$),!z&&Math.abs(J-D)<=H-1&&_>=M[J])return w[0]=_,L[0]=$,K<=M[J]&&u.MaxDifferencesHistory>0&&H<=u.MaxDifferencesHistory+1?this.x(p,o,s,I,D,f,v,F,j,M,_,e,w,$,h,L,z,N):null}const ee=(U-c+(C-l)-H)/2;if(this.a!==null&&!this.a(U,ee))return N[0]=!0,w[0]=U,L[0]=C,ee>0&&u.MaxDifferencesHistory>0&&H<=u.MaxDifferencesHistory+1?this.x(p,o,s,I,D,f,v,F,j,M,_,e,w,$,h,L,z,N):(c++,l++,[new n.$Xt(c,e-c+1,l,h-l+1)]);f=this.J(D-H,H,D,R),v=this.J(D+H,H,D,R);for(let J=f;J<=v;J+=2){J===f||J<v&&M[J-1]>=M[J+1]?_=M[J+1]-1:_=M[J-1],$=_-(J-D)-F;const K=_;for(;_>c&&$>l&&this.p(_,$);)_--,$--;if(M[J]=_,z&&Math.abs(J-p)<=H&&_<=j[J])return w[0]=_,L[0]=$,K>=j[J]&&u.MaxDifferencesHistory>0&&H<=u.MaxDifferencesHistory+1?this.x(p,o,s,I,D,f,v,F,j,M,_,e,w,$,h,L,z,N):null}if(H<=u.MaxDifferencesHistory){let J=new Int32Array(s-o+2);J[0]=p-o+1,a.Copy2(j,o,J,1,s-o+1),this.k.push(J),J=new Int32Array(v-f+2),J[0]=D-f+1,a.Copy2(M,f,J,1,v-f+1),this.m.push(J)}}return this.x(p,o,s,I,D,f,v,F,j,M,_,e,w,$,h,L,z,N)}z(c){for(let e=0;e<c.length;e++){const l=c[e],h=e<c.length-1?c[e+1].originalStart:this.f.length,w=e<c.length-1?c[e+1].modifiedStart:this.h.length,L=l.originalLength>0,N=l.modifiedLength>0;for(;l.originalStart+l.originalLength<h&&l.modifiedStart+l.modifiedLength<w&&(!L||this.s(l.originalStart,l.originalStart+l.originalLength))&&(!N||this.u(l.modifiedStart,l.modifiedStart+l.modifiedLength));){const $=this.q(l.originalStart,l.modifiedStart);if(this.q(l.originalStart+l.originalLength,l.modifiedStart+l.modifiedLength)&&!$)break;l.originalStart++,l.modifiedStart++}const _=[null];if(e<c.length-1&&this.I(c[e],c[e+1],_)){c[e]=_[0],c.splice(e+1,1),e--;continue}}for(let e=c.length-1;e>=0;e--){const l=c[e];let h=0,w=0;if(e>0){const s=c[e-1];h=s.originalStart+s.originalLength,w=s.modifiedStart+s.modifiedLength}const L=l.originalLength>0,N=l.modifiedLength>0;let _=0,$=this.G(l.originalStart,l.originalLength,l.modifiedStart,l.modifiedLength);for(let s=1;;s++){const f=l.originalStart-s,v=l.modifiedStart-s;if(f<h||v<w||L&&!this.s(f,f+l.originalLength)||N&&!this.u(v,v+l.modifiedLength))break;const R=(f===h&&v===w?5:0)+this.G(f,l.originalLength,v,l.modifiedLength);R>$&&($=R,_=s)}l.originalStart-=_,l.modifiedStart-=_;const o=[null];if(e>0&&this.I(c[e-1],c[e],o)){c[e-1]=o[0],c.splice(e,1),e++;continue}}if(this.d)for(let e=1,l=c.length;e<l;e++){const h=c[e-1],w=c[e],L=w.originalStart-h.originalStart-h.originalLength,N=h.originalStart,_=w.originalStart+w.originalLength,$=_-N,o=h.modifiedStart,s=w.modifiedStart+w.modifiedLength,f=s-o;if(L<5&&$<20&&f<20){const v=this.A(N,$,o,f,L);if(v){const[k,R]=v;(k!==h.originalStart+h.originalLength||R!==h.modifiedStart+h.modifiedLength)&&(h.originalLength=k-h.originalStart,h.modifiedLength=R-h.modifiedStart,w.originalStart=k+L,w.modifiedStart=R+L,w.originalLength=_-w.originalStart,w.modifiedLength=s-w.modifiedStart)}}}return c}A(c,e,l,h,w){if(e<w||h<w)return null;const L=c+e-w+1,N=l+h-w+1;let _=0,$=0,o=0;for(let s=c;s<L;s++)for(let f=l;f<N;f++){const v=this.B(s,f,w);v>0&&v>_&&(_=v,$=s,o=f)}return _>0?[$,o]:null}B(c,e,l){let h=0;for(let w=0;w<l;w++){if(!this.p(c+w,e+w))return 0;h+=this.e[c+w].length}return h}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,e){if(this.C(c)||this.C(c-1))return!0;if(e>0){const l=c+e;if(this.C(l-1)||this.C(l))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,e){if(this.E(c)||this.E(c-1))return!0;if(e>0){const l=c+e;if(this.E(l-1)||this.E(l))return!0}return!1}G(c,e,l,h){const w=this.D(c,e)?1:0,L=this.F(l,h)?1:0;return w+L}H(c,e){const l=[];if(c.length===0||e.length===0)return e.length>0?e:c;if(this.I(c[c.length-1],e[0],l)){const h=new Array(c.length+e.length-1);return a.Copy(c,0,h,0,c.length-1),h[c.length-1]=l[0],a.Copy(e,1,h,c.length,e.length-1),h}else{const h=new Array(c.length+e.length);return a.Copy(c,0,h,0,c.length),a.Copy(e,0,h,c.length,e.length),h}}I(c,e,l){if(b.Assert(c.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),b.Assert(c.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=e.originalStart||c.modifiedStart+c.modifiedLength>=e.modifiedStart){const h=c.originalStart;let w=c.originalLength;const L=c.modifiedStart;let N=c.modifiedLength;return c.originalStart+c.originalLength>=e.originalStart&&(w=e.originalStart+e.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=e.modifiedStart&&(N=e.modifiedStart+e.modifiedLength-c.modifiedStart),l[0]=new n.$Xt(h,w,L,N),!0}else return l[0]=null,!1}J(c,e,l,h){if(c>=0&&c<h)return c;const w=l,L=h-l-1,N=e%2===0;if(c<0){const _=w%2===0;return N===_?0:1}else{const _=L%2===0;return N===_?h-1:h-2}}}t.$1t=E}),ie(se[13],ue([0,1,3,44,16,8]),function(W,t,n,i,T,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$yc=h,t.$zc=o,T=ke(T);const A=/^\w[\w\d+.-]*$/,b=/^\//,a=/^\/\//;function u(R,j){if(!R.scheme&&j)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!A.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!b.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(R,j){return!R&&!j?"file":R}function E(R,j){switch(R){case"https":case"http":case"file":j?j[0]!==c&&(j=c+j):j=c;break}return j}const d="",c="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(j){return j instanceof l?!0:j?typeof j.authority=="string"&&typeof j.fragment=="string"&&typeof j.path=="string"&&typeof j.query=="string"&&typeof j.scheme=="string"&&typeof j.fsPath=="string"&&typeof j.with=="function"&&typeof j.toString=="function":!1}constructor(j,M,p,D,I,F=!1){typeof j=="object"?(this.scheme=j.scheme||d,this.authority=j.authority||d,this.path=j.path||d,this.query=j.query||d,this.fragment=j.fragment||d):(this.scheme=g(j,F),this.authority=M||d,this.path=E(this.scheme,p||d),this.query=D||d,this.fragment=I||d,u(this,F))}get fsPath(){return o(this,!1)}with(j){if(!j)return this;let{scheme:M,authority:p,path:D,query:I,fragment:F}=j;return M===void 0?M=this.scheme:M===null&&(M=d),p===void 0?p=this.authority:p===null&&(p=d),D===void 0?D=this.path:D===null&&(D=d),I===void 0?I=this.query:I===null&&(I=d),F===void 0?F=this.fragment:F===null&&(F=d),M===this.scheme&&p===this.authority&&D===this.path&&I===this.query&&F===this.fragment?this:new L(M,p,D,I,F)}static parse(j,M=!1){const p=e.exec(j);return p?new L(p[2]||d,k(p[4]||d),k(p[5]||d),k(p[7]||d),k(p[9]||d),M):new L(d,d,d,d,d)}static file(j){let M=d;if(m.$j&&(j=j.replace(/\\/g,c)),j[0]===c&&j[1]===c){const p=j.indexOf(c,2);p===-1?(M=j.substring(2),j=c):(M=j.substring(2,p),j=j.substring(p)||c)}return new L("file",M,j,d,d)}static from(j,M){return new L(j.scheme,j.authority,j.path,j.query,j.fragment,M)}static joinPath(j,...M){if(!j.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return m.$j&&j.scheme==="file"?p=l.file(T.$ic.join(o(j,!0),...M)).path:p=T.$jc.join(j.path,...M),j.with({path:p})}toString(j=!1){return s(this,j)}toJSON(){return this}static revive(j){if(j){if(j instanceof l)return j;{const M=new L(j);return M._formatted=j.external??null,M._fsPath=j._sep===w?j.fsPath??null:null,M}}else return j}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=l;function h(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const w=m.$j?1:void 0;class L extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(j=!1){return j?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const j={$mid:i.MarshalledId.Uri};return this._fsPath&&(j.fsPath=this._fsPath,j._sep=w),this._formatted&&(j.external=this._formatted),this.path&&(j.path=this.path),this.scheme&&(j.scheme=this.scheme),this.authority&&(j.authority=this.authority),this.query&&(j.query=this.query),this.fragment&&(j.fragment=this.fragment),j}}const N={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function _(R,j,M){let p,D=-1;for(let I=0;I<R.length;I++){const F=R.charCodeAt(I);if(F>=n.CharCode.a&&F<=n.CharCode.z||F>=n.CharCode.A&&F<=n.CharCode.Z||F>=n.CharCode.Digit0&&F<=n.CharCode.Digit9||F===n.CharCode.Dash||F===n.CharCode.Period||F===n.CharCode.Underline||F===n.CharCode.Tilde||j&&F===n.CharCode.Slash||M&&F===n.CharCode.OpenSquareBracket||M&&F===n.CharCode.CloseSquareBracket||M&&F===n.CharCode.Colon)D!==-1&&(p+=encodeURIComponent(R.substring(D,I)),D=-1),p!==void 0&&(p+=R.charAt(I));else{p===void 0&&(p=R.substr(0,I));const q=N[F];q!==void 0?(D!==-1&&(p+=encodeURIComponent(R.substring(D,I)),D=-1),p+=q):D===-1&&(D=I)}}return D!==-1&&(p+=encodeURIComponent(R.substring(D))),p!==void 0?p:R}function $(R){let j;for(let M=0;M<R.length;M++){const p=R.charCodeAt(M);p===n.CharCode.Hash||p===n.CharCode.QuestionMark?(j===void 0&&(j=R.substr(0,M)),j+=N[p]):j!==void 0&&(j+=R[M])}return j!==void 0?j:R}function o(R,j){let M;return R.authority&&R.path.length>1&&R.scheme==="file"?M=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===n.CharCode.Slash&&(R.path.charCodeAt(1)>=n.CharCode.A&&R.path.charCodeAt(1)<=n.CharCode.Z||R.path.charCodeAt(1)>=n.CharCode.a&&R.path.charCodeAt(1)<=n.CharCode.z)&&R.path.charCodeAt(2)===n.CharCode.Colon?j?M=R.path.substr(1):M=R.path[1].toLowerCase()+R.path.substr(2):M=R.path,m.$j&&(M=M.replace(/\//g,"\\")),M}function s(R,j){const M=j?$:_;let p="",{scheme:D,authority:I,path:F,query:q,fragment:z}=R;if(D&&(p+=D,p+=":"),(I||D==="file")&&(p+=c,p+=c),I){let H=I.indexOf("@");if(H!==-1){const U=I.substr(0,H);I=I.substr(H+1),H=U.lastIndexOf(":"),H===-1?p+=M(U,!1,!1):(p+=M(U.substr(0,H),!1,!1),p+=":",p+=M(U.substr(H+1),!1,!0)),p+="@"}I=I.toLowerCase(),H=I.lastIndexOf(":"),H===-1?p+=M(I,!1,!0):(p+=M(I.substr(0,H),!1,!0),p+=I.substr(H))}if(F){if(F.length>=3&&F.charCodeAt(0)===n.CharCode.Slash&&F.charCodeAt(2)===n.CharCode.Colon){const H=F.charCodeAt(1);H>=n.CharCode.A&&H<=n.CharCode.Z&&(F=`/${String.fromCharCode(H+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===n.CharCode.Colon){const H=F.charCodeAt(0);H>=n.CharCode.A&&H<=n.CharCode.Z&&(F=`${String.fromCharCode(H+32)}:${F.substr(2)}`)}p+=M(F,!0,!1)}return q&&(p+="?",p+=M(q,!1,!1)),z&&(p+="#",p+=j?z:_(z,!1,!1)),p}function f(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+f(R.substr(3)):R}}const v=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function k(R){return R.match(v)?R.replace(v,j=>f(j)):R}}),ie(se[22],ue([0,1,4,8,6,13,16]),function(W,t,n,i,T,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Vg=t.$Ug=t.$Tg=t.Schemas=void 0,t.$Rg=a,t.$Sg=u,t.$Wg=E,n=ke(n),i=ke(i),A=ke(A);var b;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting",e.outputChannel="output"})(b||(t.Schemas=b={}));function a(e,l){return m.URI.isUri(e)?(0,T.$If)(e.scheme,l):(0,T.$Jf)(e,l+":")}function u(e,...l){return l.some(h=>a(e,h))}t.$Tg="vscode-tkn",t.$Ug="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l,h){this.f=E(l,h)}getServerRootPath(){return this.f}get g(){return A.$jc.join(this.f,b.vscodeRemoteResource)}set(l,h,w){this.a[l]=h,this.b[l]=w}setConnectionToken(l,h){this.c[l]=h}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch($){return n.$2($),l}const h=l.authority;let w=this.a[h];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const L=this.b[h],N=this.c[h];let _=`path=${encodeURIComponent(l.path)}`;return typeof N=="string"&&(_+=`&${t.$Ug}=${encodeURIComponent(N)}`),m.URI.from({scheme:i.$p?this.d:b.vscodeRemoteResource,authority:`${w}:${L}`,path:this.g,query:_})}}t.$Vg=new g;function E(e,l){return A.$jc.join(l??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Xg="vs/../../extensions",t.$Yg="vs/../../node_modules",t.$Zg="vs/../../node_modules.asar",t.$1g="vs/../../node_modules.asar.unpacked",t.$2g="vscode-app";class d{static{this.a=t.$2g}asBrowserUri(l){const h=this.b(l,W);return this.uriToBrowserUri(h)}uriToBrowserUri(l){return l.scheme===b.vscodeRemote?t.$Vg.rewrite(l):l.scheme===b.file&&(i.$n||i.$r===`${b.vscodeFileResource}://${d.a}`)?l.with({scheme:b.vscodeFileResource,authority:l.authority||d.a,query:null,fragment:null}):l}asFileUri(l){const h=this.b(l,W);return this.uriToFileUri(h)}uriToFileUri(l){return l.scheme===b.vscodeFileResource?l.with({scheme:b.file,authority:l.authority!==d.a?l.authority:null,query:null,fragment:null}):l}b(l,h){if(m.URI.isUri(l))return l;if(globalThis._VSCODE_FILE_ROOT){const w=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(w))return m.URI.joinPath(m.URI.parse(w,!0),l);const L=A.$mc(w,l);return m.URI.file(L)}return m.URI.parse(h.toUrl(l))}}t.$3g=new d;var c;(function(e){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(l.get("3"));const h="vscode-coi";function w(N){let _;typeof N=="string"?_=new URL(N).searchParams:N instanceof URL?_=N.searchParams:m.URI.isUri(N)&&(_=new URL(N.toString(!0)).searchParams);const $=_?.get(h);if($)return l.get($)}e.getHeadersFromQuery=w;function L(N,_,$){if(!globalThis.crossOriginIsolated)return;const o=_&&$?"3":$?"2":"1";N instanceof URLSearchParams?N.set(h,o):N[h]=o}e.addSearchParam=L})(c||(t.COI=c={}))}),ie(se[52],ue([0,1,3,50,22,16,8,6,13]),function(W,t,n,i,T,m,A,b,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=void 0,t.$0g=u,t.$sh=E,t.$th=c,i=ke(i),m=ke(m);function u(e){return(0,a.$zc)(e,!0)}class g{constructor(l){this.a=l}compare(l,h,w=!1){return l===h?0:(0,b.$Bf)(this.getComparisonKey(l,w),this.getComparisonKey(h,w))}isEqual(l,h,w=!1){return l===h?!0:!l||!h?!1:this.getComparisonKey(l,w)===this.getComparisonKey(h,w)}getComparisonKey(l,h=!1){return l.with({path:this.a(l)?l.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(l){return this.a(l)}isEqualOrParent(l,h,w=!1){if(l.scheme===h.scheme){if(l.scheme===T.Schemas.file)return i.$Hg(u(l),u(h),this.a(l))&&l.query===h.query&&(w||l.fragment===h.fragment);if((0,t.$oh)(l.authority,h.authority))return i.$Hg(l.path,h.path,this.a(l),"/")&&l.query===h.query&&(w||l.fragment===h.fragment)}return!1}joinPath(l,...h){return a.URI.joinPath(l,...h)}basenameOrAuthority(l){return(0,t.$gh)(l)||l.authority}basename(l){return m.$jc.basename(l.path)}extname(l){return m.$jc.extname(l.path)}dirname(l){if(l.path.length===0)return l;let h;return l.scheme===T.Schemas.file?h=a.URI.file(m.$pc(u(l))).path:(h=m.$jc.dirname(l.path),l.authority&&h.length&&h.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${l.toString})) resulted in a relative path`),h="/")),l.with({path:h})}normalizePath(l){if(!l.path.length)return l;let h;return l.scheme===T.Schemas.file?h=a.URI.file(m.$kc(u(l))).path:h=m.$jc.normalize(l.path),l.with({path:h})}relativePath(l,h){if(l.scheme!==h.scheme||!(0,t.$oh)(l.authority,h.authority))return;if(l.scheme===T.Schemas.file){const N=m.$oc(u(l),u(h));return A.$j?i.$Bg(N):N}let w=l.path||"/";const L=h.path||"/";if(this.a(l)){let N=0;for(const _=Math.min(w.length,L.length);N<_&&!(w.charCodeAt(N)!==L.charCodeAt(N)&&w.charAt(N).toLowerCase()!==L.charAt(N).toLowerCase());N++);w=L.substr(0,N)+w.substr(N)}return m.$jc.relative(w,L)}resolvePath(l,h){if(l.scheme===T.Schemas.file){const w=a.URI.file(m.$nc(u(l),h));return l.with({authority:w.authority,path:w.path})}return h=i.$Cg(h),l.with({path:m.$jc.resolve(l.path,h)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,h){return l===h||l!==void 0&&h!==void 0&&(0,b.$If)(l,h)}hasTrailingPathSeparator(l,h=m.sep){if(l.scheme===T.Schemas.file){const w=u(l);return w.length>i.$Dg(w).length&&w[w.length-1]===h}else{const w=l.path;return w.length>1&&w.charCodeAt(w.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,h=m.sep){return(0,t.$ph)(l,h)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,h=m.sep){let w=!1;if(l.scheme===T.Schemas.file){const L=u(l);w=L!==void 0&&L.length===i.$Dg(L).length&&L[L.length-1]===h}else{h="/";const L=l.path;w=L.length===1&&L.charCodeAt(L.length-1)===n.CharCode.Slash}return!w&&!(0,t.$ph)(l,h)?l.with({path:l.path+"/"}):l}}t.$$g=g,t.$_g=new g(()=>!1),t.$ah=new g(e=>e.scheme===T.Schemas.file?!A.$l:!0),t.$bh=new g(e=>!0),t.$ch=t.$_g.isEqual.bind(t.$_g),t.$dh=t.$_g.isEqualOrParent.bind(t.$_g),t.$eh=t.$_g.getComparisonKey.bind(t.$_g),t.$fh=t.$_g.basenameOrAuthority.bind(t.$_g),t.$gh=t.$_g.basename.bind(t.$_g),t.$hh=t.$_g.extname.bind(t.$_g),t.$ih=t.$_g.dirname.bind(t.$_g),t.$jh=t.$_g.joinPath.bind(t.$_g),t.$kh=t.$_g.normalizePath.bind(t.$_g),t.$lh=t.$_g.relativePath.bind(t.$_g),t.$mh=t.$_g.resolvePath.bind(t.$_g),t.$nh=t.$_g.isAbsolutePath.bind(t.$_g),t.$oh=t.$_g.isEqualAuthority.bind(t.$_g),t.$ph=t.$_g.hasTrailingPathSeparator.bind(t.$_g),t.$qh=t.$_g.removeTrailingPathSeparator.bind(t.$_g),t.$rh=t.$_g.addTrailingPathSeparator.bind(t.$_g);function E(e,l){const h=[];for(let w=0;w<e.length;w++){const L=l(e[w]);e.some((N,_)=>_===w?!1:(0,t.$dh)(L,l(N)))||h.push(e[w])}return h}var d;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function l(h){const w=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(_=>{const[$,o]=_.split(":");$&&o&&w.set($,o)});const N=h.path.substring(0,h.path.indexOf(";"));return N&&w.set(e.META_DATA_MIME,N),w}e.parseMetaData=l})(d||(t.DataUri=d={}));function c(e,l,h){if(l){let w=e.path;return w&&w[0]!==m.$jc.sep&&(w=m.$jc.sep+w),e.with({scheme:h,authority:l,path:w})}return e.with({scheme:h})}}),ie(se[53],ue([0,1,20,4,12,10,52,8,47,27]),function(W,t,n,i,T,m,A,b,a,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_h=t.$0h=t.$9h=t.$8h=t.$7h=t.Promises=t.$6h=t.$5h=t.$4h=t.$2h=t.$1h=t.$Zh=t.$Yh=t.$Xh=t.$Wh=t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=void 0,t.$uh=g,t.$vh=E,t.$wh=d,t.$xh=c,t.$yh=e,t.$zh=l,t.$Ah=h,t.$Bh=w,t.$Jh=R,t.$Kh=j,t.$Lh=M,t.$Mh=p,t.$Nh=D,t.$3h=X,t.$$h=x;function g(O){return!!O&&typeof O.then=="function"}function E(O){const y=new n.$ze,B=O(y.token),Y=new Promise((Q,ae)=>{const we=y.token.onCancellationRequested(()=>{we.dispose(),ae(new i.$7)});Promise.resolve(B).then(Le=>{we.dispose(),y.dispose(),Q(Le)},Le=>{we.dispose(),y.dispose(),ae(Le)})});return new class{cancel(){y.cancel(),y.dispose()}then(Q,ae){return Y.then(Q,ae)}catch(Q){return this.then(void 0,Q)}finally(Q){return Y.finally(Q)}}}function d(O,y,B){return new Promise((Y,Q)=>{const ae=y.onCancellationRequested(()=>{ae.dispose(),Y(B)});O.then(Y,Q).finally(()=>ae.dispose())})}function c(O,y){return new Promise((B,Y)=>{const Q=y.onCancellationRequested(()=>{Q.dispose(),Y(new i.$7)});O.then(B,Y).finally(()=>Q.dispose())})}async function e(O){let y=-1;const B=O.map((Y,Q)=>Y.then(ae=>(y=Q,ae)));try{return await Promise.race(B)}finally{O.forEach((Y,Q)=>{Q!==y&&Y.cancel()})}}function l(O,y,B){let Y;const Q=setTimeout(()=>{Y?.(void 0),B?.()},y);return Promise.race([O.finally(()=>clearTimeout(Q)),new Promise(ae=>Y=ae)])}function h(O){return new Promise((y,B)=>{const Y=O();g(Y)?Y.then(y,B):y(Y)})}function w(){let O,y;return{promise:new Promise((Y,Q)=>{O=Y,y=Q}),resolve:O,reject:y}}class L{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=y,!this.b){const B=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(B,B).then(Y)})}return new Promise((B,Y)=>{this.b.then(B,Y)})}return this.a=y(),new Promise((B,Y)=>{this.a.then(Q=>{this.a=null,B(Q)},Q=>{this.a=null,Y(Q)})})}dispose(){this.f=!0}}t.$Ch=L;class N{constructor(){this.a=Promise.resolve(null)}queue(y){return this.a=this.a.then(()=>y(),()=>y())}}t.$Dh=N;class _{constructor(){this.a=new Map}queue(y,B){const Q=(this.a.get(y)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(y)===Q&&this.a.delete(y)});return this.a.set(y,Q),Q}}t.$Eh=_;const $=(O,y)=>{let B=!0;const Y=setTimeout(()=>{B=!1,y()},O);return{isTriggered:()=>B,dispose:()=>{clearTimeout(Y),B=!1}}},o=O=>{let y=!0;return queueMicrotask(()=>{y&&(y=!1,O())}),{isTriggered:()=>y,dispose:()=>{y=!1}}};class s{constructor(y){this.defaultDelay=y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(y,B=this.defaultDelay){this.g=y,this.h(),this.b||(this.b=new Promise((Q,ae)=>{this.d=Q,this.f=ae}).then(()=>{if(this.b=null,this.d=null,this.g){const Q=this.g;return this.g=null,Q()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=B===a.$je?o(Y):$(B,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Fh=s;class f{constructor(y){this.a=new s(y),this.b=new L}trigger(y,B){return this.a.trigger(()=>this.b.queue(y),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Gh=f;class v{constructor(){this.a=!1,this.b=new Promise((y,B)=>{this.d=y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Hh=v;class k extends v{constructor(y){super(),this.f=setTimeout(()=>this.open(),y)}open(){clearTimeout(this.f),super.open()}}t.$Ih=k;function R(O,y){return y?new Promise((B,Y)=>{const Q=setTimeout(()=>{ae.dispose(),B()},O),ae=y.onCancellationRequested(()=>{clearTimeout(Q),ae.dispose(),Y(new i.$7)})}):E(B=>R(O,B))}function j(O,y=0,B){const Y=setTimeout(()=>{O(),B&&Q.dispose()},y),Q=(0,m.$Vc)(()=>{clearTimeout(Y),B?.deleteAndLeak(Q)});return B?.add(Q),Q}function M(O){const y=[];let B=0;const Y=O.length;function Q(){return B<Y?O[B++]():null}function ae(we){we!=null&&y.push(we);const Le=Q();return Le?Le.then(ae):Promise.resolve(y)}return Promise.resolve(null).then(ae)}function p(O,y=Y=>!!Y,B=null){let Y=0;const Q=O.length,ae=()=>{if(Y>=Q)return Promise.resolve(B);const we=O[Y++];return Promise.resolve(we()).then(Re=>y(Re)?Promise.resolve(Re):ae())};return ae()}function D(O,y=Y=>!!Y,B=null){if(O.length===0)return Promise.resolve(B);let Y=O.length;const Q=()=>{Y=-1;for(const ae of O)ae.cancel?.()};return new Promise((ae,we)=>{for(const Le of O)Le.then(Re=>{--Y>=0&&y(Re)?(Q(),ae(Re)):Y===0&&ae(B)}).catch(Re=>{--Y>=0&&(Q(),we(Re))})})}class I{constructor(y){this.a=0,this.b=!1,this.f=y,this.g=[],this.d=0,this.h=new T.$oe}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((B,Y)=>{this.g.push({factory:y,c:B,e:Y}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const y=this.g.shift();this.d++;const B=y.factory();B.then(y.c,y.e),B.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Oh=I;class F extends I{constructor(){super(1)}}t.$Ph=F;class q{constructor(){this.a=new he,this.b=0}queue(y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,y())):this.a.run(this.b++,y())}}t.$Qh=q;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const y=new r;return this.b.add(y),y.p}g(){for(const[,y]of this.a)if(y.size>0)return!1;return!0}queueSize(y,B=A.$_g){const Y=B.getComparisonKey(y);return this.a.get(Y)?.size??0}queueFor(y,B,Y=A.$_g){const Q=Y.getComparisonKey(y);let ae=this.a.get(Q);if(!ae){ae=new F;const we=this.f++,Le=T.Event.once(ae.onDrained)(()=>{ae?.dispose(),this.a.delete(Q),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new m.$7c),this.d.set(we,Le),this.a.set(Q,ae)}return ae.queue(B)}h(){this.g()&&this.j()}j(){for(const y of this.b)y.complete();this.b.clear()}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Rh=z;class H{constructor(y,B){this.b=!1,this.a=-1,typeof y=="function"&&typeof B=="number"&&this.setIfNotSet(y,B)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(y,B){if(this.b)throw new i.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,y()},B)}setIfNotSet(y,B){if(this.b)throw new i.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,y()},B))}}t.$Sh=H;class U{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(y,B,Y=globalThis){if(this.f)throw new i.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Q=Y.setInterval(()=>{y()},B);this.d=(0,m.$Vc)(()=>{Y.clearInterval(Q),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}t.$Th=U;class C{constructor(y,B){this.b=-1,this.a=y,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(y=this.d){this.cancel(),this.b=setTimeout(this.f,y)}get delay(){return this.d}set delay(y){this.d=y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Uh=C;class ee{constructor(y,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=y,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(y=this.b){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Vh=ee;class J extends C{constructor(y,B){super(y,B),this.j=[]}work(y){this.j.push(y),this.isScheduled()||this.schedule()}h(){const y=this.j;this.j=[],this.a?.(y)}dispose(){this.j=[],super.dispose()}}t.$Wh=J;class K extends m.$Xc{constructor(y,B){super(),this.g=y,this.h=B,this.a=[],this.b=this.B(new m.$Yc),this.f=!1}get pending(){return this.a.length}work(y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+y.length>this.g.maxBufferedWork)return!1}else if(this.pending+y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of y)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Xh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Zh=(O,y)=>{(0,b.$C)(()=>{if(B)return;const Y=Date.now()+15;y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:t.$Zh=(O,y,B)=>{const Y=O.requestIdleCallback(y,typeof B=="number"?{timeout:B}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,O.cancelIdleCallback(Y))}}},t.$Yh=O=>(0,t.$Zh)(globalThis,O)}();class ne{constructor(y,B){this.g=!1,this.d=()=>{try{this.j=B()}catch(Y){this.l=Y}finally{this.g=!0}},this.f=(0,t.$Zh)(y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$1h=ne;class P extends ne{constructor(y){super(globalThis,y)}}t.$2h=P;async function X(O,y,B){let Y;for(let Q=0;Q<B;Q++)try{return await O()}catch(ae){Y=ae,await R(y)}throw Y}class he{isRunning(y){return typeof y=="number"?this.a?.taskId===y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(y,B,Y){return this.a={taskId:y,cancel:()=>Y?.(),promise:B},B.then(()=>this.d(y),()=>this.d(y)),B}d(y){this.a&&y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const y=this.b;this.b=void 0,y.run().then(y.promiseResolve,y.promiseReject)}}queue(y){if(this.b)this.b.run=y;else{const{promise:B,resolve:Y,reject:Q}=w();this.b={run:y,promise:B,promiseResolve:Y,promiseReject:Q}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$4h=he;class ge{constructor(y,B=()=>Date.now()){this.d=y,this.f=B,this.a=0,this.b=0}increment(){const y=this.f();return y-this.a>this.d&&(this.a=y,this.b=0),this.b++,this.b}}t.$5h=ge;var Ee;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Ee||(Ee={}));class r{get isRejected(){return this.d?.outcome===Ee.Rejected}get isResolved(){return this.d?.outcome===Ee.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Ee.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((y,B)=>{this.a=y,this.b=B})}complete(y){return new Promise(B=>{this.a(y),this.d={outcome:Ee.Resolved,value:y},B()})}error(y){return new Promise(B=>{this.b(y),this.d={outcome:Ee.Rejected,value:y},B()})}cancel(){return this.error(new i.$7)}}t.$6h=r;var je;(function(O){async function y(Y){let Q;const ae=await Promise.all(Y.map(we=>we.then(Le=>Le,Le=>{Q||(Q=Le)})));if(typeof Q<"u")throw Q;return ae}O.settled=y;function B(Y){return new Promise(async(Q,ae)=>{try{await Y(Q,ae)}catch(we){ae(we)}})}O.withAsyncBody=B})(je||(t.Promises=je={}));class Pe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=y.then(B=>(this.a=B,this.d=!0,B),B=>{throw this.b=B,this.d=!0,B})}requireValue(){if(!this.d)throw new i.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$7h=Pe;class Ue{constructor(y){this.b=y,this.a=new u.$W(()=>new Pe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$8h=Ue;var Ae;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Ae||(Ae={}));class Ne{static fromArray(y){return new Ne(B=>{B.emitMany(y)})}static fromPromise(y){return new Ne(async B=>{B.emitMany(await y)})}static fromPromises(y){return new Ne(async B=>{await Promise.all(y.map(async Y=>B.emitOne(await Y)))})}static merge(y){return new Ne(async B=>{await Promise.all(y.map(async Y=>{for await(const Q of Y)B.emitOne(Q)}))})}static{this.EMPTY=Ne.fromArray([])}constructor(y,B){this.a=Ae.Initial,this.b=[],this.d=null,this.f=B,this.g=new T.$oe,queueMicrotask(async()=>{const Y={emitOne:Q=>this.h(Q),emitMany:Q=>this.j(Q),reject:Q=>this.l(Q)};try{await Promise.resolve(y(Y)),this.k()}catch(Q){this.l(Q)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let y=0;return{next:async()=>{do{if(this.a===Ae.DoneError)throw this.d;if(y<this.b.length)return{done:!1,value:this.b[y++]};if(this.a===Ae.DoneOK)return{done:!0,value:void 0};await T.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(y,B){return new Ne(async Y=>{for await(const Q of y)Y.emitOne(B(Q))})}map(y){return Ne.map(this,y)}static filter(y,B){return new Ne(async Y=>{for await(const Q of y)B(Q)&&Y.emitOne(Q)})}filter(y){return Ne.filter(this,y)}static coalesce(y){return Ne.filter(y,B=>!!B)}coalesce(){return Ne.coalesce(this)}static async toPromise(y){const B=[];for await(const Y of y)B.push(Y);return B}toPromise(){return Ne.toPromise(this)}h(y){this.a===Ae.Initial&&(this.b.push(y),this.g.fire())}j(y){this.a===Ae.Initial&&(this.b=this.b.concat(y),this.g.fire())}k(){this.a===Ae.Initial&&(this.a=Ae.DoneOK,this.g.fire())}l(y){this.a===Ae.Initial&&(this.a=Ae.DoneError,this.d=y,this.g.fire())}}t.$9h=Ne;class qe extends Ne{constructor(y,B){super(B),this.m=y}cancel(){this.m.cancel()}}t.$0h=qe;function x(O){const y=new n.$ze,B=O(y.token);return new qe(y,async Y=>{const Q=y.token.onCancellationRequested(()=>{Q.dispose(),y.dispose(),Y.reject(new i.$7)});try{for await(const ae of B){if(y.token.isCancellationRequested)return;Y.emitOne(ae)}Q.dispose(),y.dispose()}catch(ae){Q.dispose(),y.dispose(),Y.reject(ae)}})}class G{constructor(y){this.a=new r,this.b=new Ne(Q=>{if(B){Q.reject(B);return}return Y&&Q.emitMany(Y),this.d=ae=>Q.reject(ae),this.f=ae=>Q.emitOne(ae),this.a.p},y);let B,Y;this.f=Q=>{Y||(Y=[]),Y.push(Q)},this.d=Q=>{B||(B=Q)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(y){this.d(y),this.a.complete()}emitOne(y){this.f(y)}}t.$_h=G}),ie(se[83],ue([0,1,3,4,12,10,22,8,6]),function(W,t,n,i,T,m,A,b,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=v,a=ke(a);const u=!1,g="default",E="$initialize";let d=!1;function c(k){b.$p&&(d||(d=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(k.message))}var e;(function(k){k[k.Request=0]="Request",k[k.Reply=1]="Reply",k[k.SubscribeEvent=2]="SubscribeEvent",k[k.Event=3]="Event",k[k.UnsubscribeEvent=4]="UnsubscribeEvent"})(e||(e={}));class l{constructor(R,j,M,p,D){this.vsWorker=R,this.req=j,this.channel=M,this.method=p,this.args=D,this.type=e.Request}}class h{constructor(R,j,M,p){this.vsWorker=R,this.seq=j,this.res=M,this.err=p,this.type=e.Reply}}class w{constructor(R,j,M,p,D){this.vsWorker=R,this.req=j,this.channel=M,this.eventName=p,this.arg=D,this.type=e.SubscribeEvent}}class L{constructor(R,j,M){this.vsWorker=R,this.req=j,this.event=M,this.type=e.Event}}class N{constructor(R,j){this.vsWorker=R,this.req=j,this.type=e.UnsubscribeEvent}}class _{constructor(R){this.a=-1,this.g=R,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(R){this.a=R}sendMessage(R,j,M){const p=String(++this.b);return new Promise((D,I)=>{this.c[p]={resolve:D,reject:I},this.o(new l(this.a,p,R,j,M))})}listen(R,j,M){let p=null;const D=new T.$oe({onWillAddFirstListener:()=>{p=String(++this.b),this.d.set(p,D),this.o(new w(this.a,p,R,j,M))},onDidRemoveLastListener:()=>{this.d.delete(p),this.o(new N(this.a,p)),p=null}});return D.event}handleMessage(R){!R||!R.vsWorker||this.a!==-1&&R.vsWorker!==this.a||this.h(R)}createProxyToRemoteChannel(R,j){const M={get:(p,D)=>(typeof D=="string"&&!p[D]&&(s(D)?p[D]=I=>this.listen(R,D,I):o(D)?p[D]=this.listen(R,D,void 0):D.charCodeAt(0)===n.CharCode.DollarSign&&(p[D]=async(...I)=>(await j?.(),this.sendMessage(R,D,I)))),p[D])};return new Proxy(Object.create(null),M)}h(R){switch(R.type){case e.Reply:return this.j(R);case e.Request:return this.k(R);case e.SubscribeEvent:return this.l(R);case e.Event:return this.m(R);case e.UnsubscribeEvent:return this.n(R)}}j(R){if(!this.c[R.seq]){console.warn("Got reply to unknown seq");return}const j=this.c[R.seq];if(delete this.c[R.seq],R.err){let M=R.err;R.err.$isError&&(M=new Error,M.name=R.err.name,M.message=R.err.message,M.stack=R.err.stack),j.reject(M);return}j.resolve(R.res)}k(R){const j=R.req;this.g.handleMessage(R.channel,R.method,R.args).then(p=>{this.o(new h(this.a,j,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,i.$4)(p.detail)),this.o(new h(this.a,j,void 0,(0,i.$4)(p)))})}l(R){const j=R.req,M=this.g.handleEvent(R.channel,R.eventName,R.arg)(p=>{this.o(new L(this.a,j,p))});this.f.set(j,M)}m(R){if(!this.d.has(R.req)){console.warn("Got event for unknown req");return}this.d.get(R.req).fire(R.event)}n(R){if(!this.f.has(R.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(R.req).dispose(),this.f.delete(R.req)}o(R){const j=[];if(R.type===e.Request)for(let M=0;M<R.args.length;M++)R.args[M]instanceof ArrayBuffer&&j.push(R.args[M]);else R.type===e.Reply&&R.res instanceof ArrayBuffer&&j.push(R.res);this.g.sendMessage(R,j)}}class $ extends m.$Xc{constructor(R,j){super(),this.f=new Map,this.g=new Map,this.a=this.B(R.create({amdModuleId:"vs/base/common/worker/simpleWorker",esmModuleLocation:j.esmModuleLocation,label:j.label},D=>{this.c.handleMessage(D)},D=>{(0,i.$2)(D)})),this.c=new _({sendMessage:(D,I)=>{this.a.postMessage(D,I)},handleMessage:(D,I,F)=>this.h(D,I,F),handleEvent:(D,I,F)=>this.j(D,I,F)}),this.c.setWorkerId(this.a.getId());let M=null;const p=globalThis.require;typeof p<"u"&&typeof p.getConfig=="function"?M=p.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config),this.b=this.c.sendMessage(g,E,[this.a.getId(),JSON.parse(JSON.stringify(M)),j.amdModuleId]),this.proxy=this.c.createProxyToRemoteChannel(g,async()=>{await this.b}),this.b.catch(D=>{this.m("Worker failed to load "+j.amdModuleId,D)})}h(R,j,M){const p=this.f.get(R);if(!p)return Promise.reject(new Error(`Missing channel ${R} on main thread`));if(typeof p[j]!="function")return Promise.reject(new Error(`Missing method ${j} on main thread channel ${R}`));try{return Promise.resolve(p[j].apply(p,M))}catch(D){return Promise.reject(D)}}j(R,j,M){const p=this.f.get(R);if(!p)throw new Error(`Missing channel ${R} on main thread`);if(s(j)){const D=p[j].call(p,M);if(typeof D!="function")throw new Error(`Missing dynamic event ${j} on main thread channel ${R}.`);return D}if(o(j)){const D=p[j];if(typeof D!="function")throw new Error(`Missing event ${j} on main thread channel ${R}.`);return D}throw new Error(`Malformed event name ${j}`)}setChannel(R,j){this.f.set(R,j)}getChannel(R){if(!this.g.has(R)){const j=this.c.createProxyToRemoteChannel(R,async()=>{await this.b});this.g.set(R,j)}return this.g.get(R)}m(R,j){console.error(R),console.info(j)}}t.SimpleWorkerClient=$;function o(k){return k[0]==="o"&&k[1]==="n"&&a.$Hf(k.charCodeAt(2))}function s(k){return/^onDynamic/.test(k)&&a.$Hf(k.charCodeAt(9))}class f{constructor(R,j){this.d=new Map,this.f=new Map,this.a=j,this.b=null,this.c=new _({sendMessage:(M,p)=>{R(M,p)},handleMessage:(M,p,D)=>this.g(M,p,D),handleEvent:(M,p,D)=>this.h(M,p,D)})}onmessage(R){this.c.handleMessage(R)}g(R,j,M){if(R===g&&j===E)return this.j(M[0],M[1],M[2]);const p=R===g?this.b:this.d.get(R);if(!p)return Promise.reject(new Error(`Missing channel ${R} on worker thread`));if(typeof p[j]!="function")return Promise.reject(new Error(`Missing method ${j} on worker thread channel ${R}`));try{return Promise.resolve(p[j].apply(p,M))}catch(D){return Promise.reject(D)}}h(R,j,M){const p=R===g?this.b:this.d.get(R);if(!p)throw new Error(`Missing channel ${R} on worker thread`);if(s(j)){const D=p[j].call(p,M);if(typeof D!="function")throw new Error(`Missing dynamic event ${j} on request handler.`);return D}if(o(j)){const D=p[j];if(typeof D!="function")throw new Error(`Missing event ${j} on request handler.`);return D}throw new Error(`Malformed event name ${j}`)}setChannel(R,j){this.d.set(R,j)}getChannel(R){if(!this.f.has(R)){const j=this.c.createProxyToRemoteChannel(R);this.f.set(R,j)}return this.f.get(R)}async j(R,j,M){if(this.c.setWorkerId(R),this.a){this.b=this.a(this);return}if(j&&(typeof j.baseUrl<"u"&&delete j.baseUrl,typeof j.paths<"u"&&typeof j.paths.vs<"u"&&delete j.paths.vs,typeof j.trustedTypesPolicy<"u"&&delete j.trustedTypesPolicy,j.catchError=!0,globalThis.require.config(j)),u){const p=A.$3g.asBrowserUri(`${M}.js`).toString(!0);return new Promise((D,I)=>{W([`${p}`],D,I)}).then(ke).then(D=>{if(this.b=D.create(this),!this.b)throw new Error("No RequestHandler!")})}return new Promise((p,D)=>{(globalThis.require||W)([M],F=>{if(this.b=F.create(this),!this.b){D(new Error("No RequestHandler!"));return}p()},D)})}}t.SimpleWorkerServer=f;function v(k){return new f(k,null)}}),ie(se[33],ue([0,1,17]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ou=t.$nu=void 0;class i{constructor(b){const a=(0,n.$df)(b);this.c=a,this.a=i.d(a),this.b=new Map}static d(b){const a=new Uint8Array(256);return a.fill(b),a}set(b,a){const u=(0,n.$df)(a);b>=0&&b<256?this.a[b]=u:this.b.set(b,u)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$nu=i;var T;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(T||(T={}));class m{constructor(){this.a=new i(T.False)}add(b){this.a.set(b,T.True)}has(b){return this.a.get(b)===T.True}clear(){return this.a.clear()}}t.$ou=m}),ie(se[7],ue([0,1,4]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3t=t.$2t=void 0;class i{static addRange(A,b){let a=0;for(;a<b.length&&b[a].endExclusive<A.start;)a++;let u=a;for(;u<b.length&&b[u].start<=A.endExclusive;)u++;if(a===u)b.splice(a,0,A);else{const g=Math.min(A.start,b[a].start),E=Math.max(A.endExclusive,b[u-1].endExclusive);b.splice(a,u-a,new i(g,E))}}static tryCreate(A,b){if(!(A>b))return new i(A,b)}static ofLength(A){return new i(0,A)}static ofStartAndLength(A,b){return new i(A,A+b)}constructor(A,b){if(this.start=A,this.endExclusive=b,A>b)throw new n.$eb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(A){return new i(this.start+A,this.endExclusive+A)}deltaStart(A){return new i(this.start+A,this.endExclusive)}deltaEnd(A){return new i(this.start,this.endExclusive+A)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(A){return this.start===A.start&&this.endExclusive===A.endExclusive}containsRange(A){return this.start<=A.start&&A.endExclusive<=this.endExclusive}contains(A){return this.start<=A&&A<this.endExclusive}join(A){return new i(Math.min(this.start,A.start),Math.max(this.endExclusive,A.endExclusive))}intersect(A){const b=Math.max(this.start,A.start),a=Math.min(this.endExclusive,A.endExclusive);if(b<=a)return new i(b,a)}intersects(A){const b=Math.max(this.start,A.start),a=Math.min(this.endExclusive,A.endExclusive);return b<a}intersectsOrTouches(A){const b=Math.max(this.start,A.start),a=Math.min(this.endExclusive,A.endExclusive);return b<=a}isBefore(A){return this.endExclusive<=A.start}isAfter(A){return this.start>=A.endExclusive}slice(A){return A.slice(this.start,this.endExclusive)}substring(A){return A.substring(this.start,this.endExclusive)}clip(A){if(this.isEmpty)throw new n.$eb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,A))}clipCyclic(A){if(this.isEmpty)throw new n.$eb(`Invalid clipping range: ${this.toString()}`);return A<this.start?this.endExclusive-(this.start-A)%this.length:A>=this.endExclusive?this.start+(A-this.start)%this.length:A}map(A){const b=[];for(let a=this.start;a<this.endExclusive;a++)b.push(A(a));return b}forEach(A){for(let b=this.start;b<this.endExclusive;b++)A(b)}}t.$2t=i;class T{constructor(){this.a=[]}addRange(A){let b=0;for(;b<this.a.length&&this.a[b].endExclusive<A.start;)b++;let a=b;for(;a<this.a.length&&this.a[a].start<=A.endExclusive;)a++;if(b===a)this.a.splice(b,0,A);else{const u=Math.min(A.start,this.a[b].start),g=Math.max(A.endExclusive,this.a[a-1].endExclusive);this.a.splice(b,a-b,new i(u,g))}}toString(){return this.a.map(A=>A.toString()).join(", ")}intersectsStrict(A){let b=0;for(;b<this.a.length&&this.a[b].endExclusive<=A.start;)b++;return b<this.a.length&&this.a[b].start<A.endExclusive}intersectWithRange(A){const b=new T;for(const a of this.a){const u=a.intersect(A);u&&b.addRange(u)}return b}intersectWithRangeLength(A){return this.intersectWithRange(A).length}get length(){return this.a.reduce((A,b)=>A+b.length,0)}}t.$3t=T}),ie(se[5],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tt=void 0;class n{constructor(T,m){this.lineNumber=T,this.column=m}with(T=this.lineNumber,m=this.column){return T===this.lineNumber&&m===this.column?this:new n(T,m)}delta(T=0,m=0){return this.with(this.lineNumber+T,this.column+m)}equals(T){return n.equals(this,T)}static equals(T,m){return!T&&!m?!0:!!T&&!!m&&T.lineNumber===m.lineNumber&&T.column===m.column}isBefore(T){return n.isBefore(this,T)}static isBefore(T,m){return T.lineNumber<m.lineNumber?!0:m.lineNumber<T.lineNumber?!1:T.column<m.column}isBeforeOrEqual(T){return n.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,m){return T.lineNumber<m.lineNumber?!0:m.lineNumber<T.lineNumber?!1:T.column<=m.column}static compare(T,m){const A=T.lineNumber|0,b=m.lineNumber|0;if(A===b){const a=T.column|0,u=m.column|0;return a-u}return A-b}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new n(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$Tt=n}),ie(se[2],ue([0,1,5]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ut=void 0;class i{constructor(m,A,b,a){m>b||m===b&&A>a?(this.startLineNumber=b,this.startColumn=a,this.endLineNumber=m,this.endColumn=A):(this.startLineNumber=m,this.startColumn=A,this.endLineNumber=b,this.endColumn=a)}isEmpty(){return i.isEmpty(this)}static isEmpty(m){return m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn}containsPosition(m){return i.containsPosition(this,m)}static containsPosition(m,A){return!(A.lineNumber<m.startLineNumber||A.lineNumber>m.endLineNumber||A.lineNumber===m.startLineNumber&&A.column<m.startColumn||A.lineNumber===m.endLineNumber&&A.column>m.endColumn)}static strictContainsPosition(m,A){return!(A.lineNumber<m.startLineNumber||A.lineNumber>m.endLineNumber||A.lineNumber===m.startLineNumber&&A.column<=m.startColumn||A.lineNumber===m.endLineNumber&&A.column>=m.endColumn)}containsRange(m){return i.containsRange(this,m)}static containsRange(m,A){return!(A.startLineNumber<m.startLineNumber||A.endLineNumber<m.startLineNumber||A.startLineNumber>m.endLineNumber||A.endLineNumber>m.endLineNumber||A.startLineNumber===m.startLineNumber&&A.startColumn<m.startColumn||A.endLineNumber===m.endLineNumber&&A.endColumn>m.endColumn)}strictContainsRange(m){return i.strictContainsRange(this,m)}static strictContainsRange(m,A){return!(A.startLineNumber<m.startLineNumber||A.endLineNumber<m.startLineNumber||A.startLineNumber>m.endLineNumber||A.endLineNumber>m.endLineNumber||A.startLineNumber===m.startLineNumber&&A.startColumn<=m.startColumn||A.endLineNumber===m.endLineNumber&&A.endColumn>=m.endColumn)}plusRange(m){return i.plusRange(this,m)}static plusRange(m,A){let b,a,u,g;return A.startLineNumber<m.startLineNumber?(b=A.startLineNumber,a=A.startColumn):A.startLineNumber===m.startLineNumber?(b=A.startLineNumber,a=Math.min(A.startColumn,m.startColumn)):(b=m.startLineNumber,a=m.startColumn),A.endLineNumber>m.endLineNumber?(u=A.endLineNumber,g=A.endColumn):A.endLineNumber===m.endLineNumber?(u=A.endLineNumber,g=Math.max(A.endColumn,m.endColumn)):(u=m.endLineNumber,g=m.endColumn),new i(b,a,u,g)}intersectRanges(m){return i.intersectRanges(this,m)}static intersectRanges(m,A){let b=m.startLineNumber,a=m.startColumn,u=m.endLineNumber,g=m.endColumn;const E=A.startLineNumber,d=A.startColumn,c=A.endLineNumber,e=A.endColumn;return b<E?(b=E,a=d):b===E&&(a=Math.max(a,d)),u>c?(u=c,g=e):u===c&&(g=Math.min(g,e)),b>u||b===u&&a>g?null:new i(b,a,u,g)}equalsRange(m){return i.equalsRange(this,m)}static equalsRange(m,A){return!m&&!A?!0:!!m&&!!A&&m.startLineNumber===A.startLineNumber&&m.startColumn===A.startColumn&&m.endLineNumber===A.endLineNumber&&m.endColumn===A.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(m){return new n.$Tt(m.endLineNumber,m.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(m){return new n.$Tt(m.startLineNumber,m.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(m,A){return new i(this.startLineNumber,this.startColumn,m,A)}setStartPosition(m,A){return new i(m,A,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(m){return new i(m.startLineNumber,m.startColumn,m.startLineNumber,m.startColumn)}collapseToEnd(){return i.collapseToEnd(this)}static collapseToEnd(m){return new i(m.endLineNumber,m.endColumn,m.endLineNumber,m.endColumn)}delta(m){return new i(this.startLineNumber+m,this.startColumn,this.endLineNumber+m,this.endColumn)}static fromPositions(m,A=m){return new i(m.lineNumber,m.column,A.lineNumber,A.column)}static lift(m){return m?new i(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):null}static isIRange(m){return m&&typeof m.startLineNumber=="number"&&typeof m.startColumn=="number"&&typeof m.endLineNumber=="number"&&typeof m.endColumn=="number"}static areIntersectingOrTouching(m,A){return!(m.endLineNumber<A.startLineNumber||m.endLineNumber===A.startLineNumber&&m.endColumn<A.startColumn||A.endLineNumber<m.startLineNumber||A.endLineNumber===m.startLineNumber&&A.endColumn<m.startColumn)}static areIntersecting(m,A){return!(m.endLineNumber<A.startLineNumber||m.endLineNumber===A.startLineNumber&&m.endColumn<=A.startColumn||A.endLineNumber<m.startLineNumber||A.endLineNumber===m.startLineNumber&&A.endColumn<=m.startColumn)}static compareRangesUsingStarts(m,A){if(m&&A){const u=m.startLineNumber|0,g=A.startLineNumber|0;if(u===g){const E=m.startColumn|0,d=A.startColumn|0;if(E===d){const c=m.endLineNumber|0,e=A.endLineNumber|0;if(c===e){const l=m.endColumn|0,h=A.endColumn|0;return l-h}return c-e}return E-d}return u-g}return(m?1:0)-(A?1:0)}static compareRangesUsingEnds(m,A){return m.endLineNumber===A.endLineNumber?m.endColumn===A.endColumn?m.startLineNumber===A.startLineNumber?m.startColumn-A.startColumn:m.startLineNumber-A.startLineNumber:m.endColumn-A.endColumn:m.endLineNumber-A.endLineNumber}static spansMultipleLines(m){return m.endLineNumber>m.startLineNumber}toJSON(){return this}}t.$Ut=i}),ie(se[54],ue([0,1,2]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vt=void 0;class i{static insert(m,A){return{range:new n.$Ut(m.lineNumber,m.column,m.lineNumber,m.column),text:A,forceMoveMarkers:!0}}static delete(m){return{range:m,text:null}}static replace(m,A){return{range:m,text:A}}static replaceMove(m,A){return{range:m,text:A,forceMoveMarkers:!0}}}t.$Vt=i}),ie(se[18],ue([0,1,4,7,2,11]),function(W,t,n,i,T,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5t=t.$4t=void 0;class A{static fromRange(u){return new A(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new A(u.startLineNumber,u.endLineNumber+1)}static subtract(u,g){return g?u.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<u.endLineNumberExclusive?[new A(u.startLineNumber,g.startLineNumber),new A(g.endLineNumberExclusive,u.endLineNumberExclusive)]:g.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<u.endLineNumberExclusive?[new A(Math.max(g.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new A(u.startLineNumber,Math.min(g.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let g=new b(u[0].slice());for(let E=1;E<u.length;E++)g=g.getUnion(new b(u[E].slice()));return g.ranges}static join(u){if(u.length===0)throw new n.$eb("lineRanges cannot be empty");let g=u[0].startLineNumber,E=u[0].endLineNumberExclusive;for(let d=1;d<u.length;d++)g=Math.min(g,u[d].startLineNumber),E=Math.max(E,u[d].endLineNumberExclusive);return new A(g,E)}static ofLength(u,g){return new A(u,u+g)}static deserialize(u){return new A(u[0],u[1])}constructor(u,g){if(u>g)throw new n.$eb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=u,this.endLineNumberExclusive=g}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new A(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new A(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new A(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const g=Math.max(this.startLineNumber,u.startLineNumber),E=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(g<=E)return new A(g,E)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new T.$Ut(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new T.$Ut(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const g=[];for(let E=this.startLineNumber;E<this.endLineNumberExclusive;E++)g.push(u(E));return g}forEach(u){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)u(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new i.$2t(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$4t=A;class b{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const g=(0,m.$mb)(this.c,d=>d.endLineNumberExclusive>=u.startLineNumber),E=(0,m.$kb)(this.c,d=>d.startLineNumber<=u.endLineNumberExclusive)+1;if(g===E)this.c.splice(g,0,u);else if(g===E-1){const d=this.c[g];this.c[g]=d.join(u)}else{const d=this.c[g].join(this.c[E-1]).join(u);this.c.splice(g,E-g,d)}}contains(u){const g=(0,m.$jb)(this.c,E=>E.startLineNumber<=u);return!!g&&g.endLineNumberExclusive>u}intersects(u){const g=(0,m.$jb)(this.c,E=>E.startLineNumber<u.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const g=[];let E=0,d=0,c=null;for(;E<this.c.length||d<u.c.length;){let e=null;if(E<this.c.length&&d<u.c.length){const l=this.c[E],h=u.c[d];l.startLineNumber<h.startLineNumber?(e=l,E++):(e=h,d++)}else E<this.c.length?(e=this.c[E],E++):(e=u.c[d],d++);c===null?c=e:c.endLineNumberExclusive>=e.startLineNumber?c=new A(c.startLineNumber,Math.max(c.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push(c),c=e)}return c!==null&&g.push(c),new b(g)}subtractFrom(u){const g=(0,m.$mb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),E=(0,m.$kb)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(g===E)return new b([u]);const d=[];let c=u.startLineNumber;for(let e=g;e<E;e++){const l=this.c[e];l.startLineNumber>c&&d.push(new A(c,l.startLineNumber)),c=l.endLineNumberExclusive}return c<u.endLineNumberExclusive&&d.push(new A(c,u.endLineNumberExclusive)),new b(d)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const g=[];let E=0,d=0;for(;E<this.c.length&&d<u.c.length;){const c=this.c[E],e=u.c[d],l=c.intersect(e);l&&!l.isEmpty&&g.push(l),c.endLineNumberExclusive<e.endLineNumberExclusive?E++:d++}return new b(g)}getWithDelta(u){return new b(this.c.map(g=>g.delta(u)))}}t.$5t=b}),ie(se[55],ue([0,1,5,2]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wt=t.SelectionDirection=void 0;var T;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(T||(t.SelectionDirection=T={}));class m extends i.$Ut{constructor(b,a,u,g){super(b,a,u,g),this.selectionStartLineNumber=b,this.selectionStartColumn=a,this.positionLineNumber=u,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return m.selectionsEqual(this,b)}static selectionsEqual(b,a){return b.selectionStartLineNumber===a.selectionStartLineNumber&&b.selectionStartColumn===a.selectionStartColumn&&b.positionLineNumber===a.positionLineNumber&&b.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?T.LTR:T.RTL}setEndPosition(b,a){return this.getDirection()===T.LTR?new m(this.startLineNumber,this.startColumn,b,a):new m(b,a,this.startLineNumber,this.startColumn)}getPosition(){return new n.$Tt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new n.$Tt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,a){return this.getDirection()===T.LTR?new m(b,a,this.endLineNumber,this.endColumn):new m(this.endLineNumber,this.endColumn,b,a)}static fromPositions(b,a=b){return new m(b.lineNumber,b.column,a.lineNumber,a.column)}static fromRange(b,a){return a===T.LTR?new m(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new m(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new m(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,a){if(b&&!a||!b&&a)return!1;if(!b&&!a)return!0;if(b.length!==a.length)return!1;for(let u=0,g=b.length;u<g;u++)if(!this.selectionsEqual(b[u],a[u]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,a,u,g,E){return E===T.LTR?new m(b,a,u,g):new m(u,g,b,a)}}t.$Wt=m}),ie(se[34],ue([0,1,5,2]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6t=void 0;class T{static{this.zero=new T(0,0)}static lengthDiffNonNegative(A,b){return b.isLessThan(A)?T.zero:A.lineCount===b.lineCount?new T(0,b.columnCount-A.columnCount):new T(b.lineCount-A.lineCount,b.columnCount)}static betweenPositions(A,b){return A.lineNumber===b.lineNumber?new T(0,b.column-A.column):new T(b.lineNumber-A.lineNumber,b.column-1)}static ofRange(A){return T.betweenPositions(A.getStartPosition(),A.getEndPosition())}static ofText(A){let b=0,a=0;for(const u of A)u===`
`?(b++,a=0):a++;return new T(b,a)}constructor(A,b){this.lineCount=A,this.columnCount=b}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(A){return this.lineCount!==A.lineCount?this.lineCount<A.lineCount:this.columnCount<A.columnCount}isGreaterThan(A){return this.lineCount!==A.lineCount?this.lineCount>A.lineCount:this.columnCount>A.columnCount}isGreaterThanOrEqualTo(A){return this.lineCount!==A.lineCount?this.lineCount>A.lineCount:this.columnCount>=A.columnCount}equals(A){return this.lineCount===A.lineCount&&this.columnCount===A.columnCount}compare(A){return this.lineCount!==A.lineCount?this.lineCount-A.lineCount:this.columnCount-A.columnCount}add(A){return A.lineCount===0?new T(this.lineCount,this.columnCount+A.columnCount):new T(this.lineCount+A.lineCount,A.columnCount)}createRange(A){return this.lineCount===0?new i.$Ut(A.lineNumber,A.column,A.lineNumber,A.column+this.columnCount):new i.$Ut(A.lineNumber,A.column,A.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new i.$Ut(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(A){return this.lineCount===0?new n.$Tt(A.lineNumber,A.column+this.columnCount):new n.$Tt(A.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}t.$6t=T}),ie(se[56],ue([0,1,11,7,5,2,34]),function(W,t,n,i,T,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7t=void 0;class b{constructor(u){this.text=u,this.a=[],this.a.push(0);for(let g=0;g<u.length;g++)u.charAt(g)===`
`&&this.a.push(g+1)}getOffset(u){return this.a[u.lineNumber-1]+u.column-1}getOffsetRange(u){return new i.$2t(this.getOffset(u.getStartPosition()),this.getOffset(u.getEndPosition()))}getPosition(u){const g=(0,n.$kb)(this.a,c=>c<=u),E=g+1,d=u-this.a[g]+1;return new T.$Tt(E,d)}getRange(u){return m.$Ut.fromPositions(this.getPosition(u.start),this.getPosition(u.endExclusive))}getTextLength(u){return A.$6t.ofRange(this.getRange(u))}get textLength(){const u=this.a.length-1;return new A.$6t(u,this.text.length-this.a[u])}}t.$7t=b}),ie(se[57],ue([0,1,15,4,5,56,2,34]),function(W,t,n,i,T,m,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$au=t.$_t=t.$$t=t.$0t=t.$9t=t.$8t=void 0;class a{static single(h,w){return new a([new u(h,w)])}constructor(h){this.edits=h,(0,n.$kd)(()=>(0,n.$ld)(h,(w,L)=>w.range.getEndPosition().isBeforeOrEqual(L.range.getStartPosition())))}normalize(){const h=[];for(const w of this.edits)if(h.length>0&&h[h.length-1].range.getEndPosition().equals(w.range.getStartPosition())){const L=h[h.length-1];h[h.length-1]=new u(L.range.plusRange(w.range),L.text+w.text)}else w.isEmpty||h.push(w);return new a(h)}mapPosition(h){let w=0,L=0,N=0;for(const _ of this.edits){const $=_.range.getStartPosition(),o=_.range.getEndPosition();if(h.isBeforeOrEqual($))break;const s=b.$6t.ofText(_.text);if(h.isBefore(o)){const f=new T.$Tt($.lineNumber+w,$.column+($.lineNumber+w===L?N:0)),v=s.addToPosition(f);return g(f,v)}w+=s.lineCount-(_.range.endLineNumber-_.range.startLineNumber),s.lineCount===0?o.lineNumber!==$.lineNumber?N+=s.columnCount-(o.column-1):N+=s.columnCount-(o.column-$.column):N=s.columnCount,L=o.lineNumber+w}return new T.$Tt(h.lineNumber+w,h.column+(h.lineNumber+w===L?N:0))}mapRange(h){function w($){return $ instanceof T.$Tt?$:$.getStartPosition()}function L($){return $ instanceof T.$Tt?$:$.getEndPosition()}const N=w(this.mapPosition(h.getStartPosition())),_=L(this.mapPosition(h.getEndPosition()));return g(N,_)}inverseMapPosition(h,w){return this.inverse(w).mapPosition(h)}inverseMapRange(h,w){return this.inverse(w).mapRange(h)}apply(h){let w="",L=new T.$Tt(1,1);for(const _ of this.edits){const $=_.range,o=$.getStartPosition(),s=$.getEndPosition(),f=g(L,o);f.isEmpty()||(w+=h.getValueOfRange(f)),w+=_.text,L=s}const N=g(L,h.endPositionExclusive);return N.isEmpty()||(w+=h.getValueOfRange(N)),w}applyToString(h){const w=new e(h);return this.apply(w)}inverse(h){const w=this.getNewRanges();return new a(this.edits.map((L,N)=>new u(w[N],h.getValueOfRange(L.range))))}getNewRanges(){const h=[];let w=0,L=0,N=0;for(const _ of this.edits){const $=b.$6t.ofText(_.text),o=T.$Tt.lift({lineNumber:_.range.startLineNumber+L,column:_.range.startColumn+(_.range.startLineNumber===w?N:0)}),s=$.createRange(o);h.push(s),L=s.endLineNumber-_.range.endLineNumber,N=s.endColumn-_.range.endColumn,w=_.range.endLineNumber}return h}}t.$8t=a;class u{constructor(h,w){this.range=h,this.text=w}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(h,w){return h.range.equalsRange(w.range)&&h.text===w.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}t.$9t=u;function g(l,h){if(l.lineNumber===h.lineNumber&&l.column===Number.MAX_SAFE_INTEGER)return A.$Ut.fromPositions(h,h);if(!l.isBeforeOrEqual(h))throw new i.$eb("start must be before end");return new A.$Ut(l.lineNumber,l.column,h.lineNumber,h.column)}class E{get endPositionExclusive(){return this.length.addToPosition(new T.$Tt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}t.$0t=E;class d extends E{constructor(h,w){(0,n.$id)(w>=1),super(),this.c=h,this.d=w}getValueOfRange(h){if(h.startLineNumber===h.endLineNumber)return this.c(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);let w=this.c(h.startLineNumber).substring(h.startColumn-1);for(let L=h.startLineNumber+1;L<h.endLineNumber;L++)w+=`
`+this.c(L);return w+=`
`+this.c(h.endLineNumber).substring(0,h.endColumn-1),w}get length(){const h=this.c(this.d);return new b.$6t(this.d-1,h.length)}}t.$$t=d;class c extends d{constructor(h){super(w=>h[w-1],h.length)}}t.$_t=c;class e extends E{constructor(h){super(),this.value=h,this.c=new m.$7t(this.value)}getValueOfRange(h){return this.c.getOffsetRange(h).substring(this.value)}get length(){return this.c.textLength}}t.$au=e}),ie(se[58],ue([0,1,3,19,33]),function(W,t,n,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pu=t.WordCharacterClass=void 0,t.$qu=a;var m;(function(u){u[u.Regular=0]="Regular",u[u.Whitespace=1]="Whitespace",u[u.WordSeparator=2]="WordSeparator"})(m||(t.WordCharacterClass=m={}));class A extends T.$nu{constructor(g,E){super(m.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let d=0,c=g.length;d<c;d++)this.set(g.charCodeAt(d),m.WordSeparator);this.set(n.CharCode.Space,m.Whitespace),this.set(n.CharCode.Tab,m.Whitespace)}findPrevIntlWordBeforeOrAtOffset(g,E){let d=null;for(const c of this.h(g)){if(c.index>E)break;d=c}return d}findNextIntlWordAtOrAfterOffset(g,E){for(const d of this.h(g))if(!(d.index<E))return d;return null}h(g){return this.e?this.f===g?this.g:(this.f=g,this.g=this.j(this.e.segment(g)),this.g):[]}j(g){const E=[];for(const d of g)this.k(d)&&E.push(d);return E}k(g){return!!g.isWordLike}}t.$pu=A;const b=new i.$Gc(10);function a(u,g){const E=`${u}/${g.join(",")}`;let d=b.get(E);return d||(d=new A(u,g),b.set(E,d)),d}}),ie(se[35],ue([0,1,26,10,28]),function(W,t,n,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tt=t.$st=void 0,t.$ut=A,t.$vt=a,t.$wt=u,t.$st="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(E=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const c of t.$st)E.indexOf(c)>=0||(d+="\\"+c);return d+="\\s]+)",new RegExp(d,"g")}t.$tt=m();function A(E){let d=t.$tt;if(E&&E instanceof RegExp)if(E.global)d=E;else{let c="g";E.ignoreCase&&(c+="i"),E.multiline&&(c+="m"),E.unicode&&(c+="u"),d=new RegExp(E.source,c)}return d.lastIndex=0,d}const b=new T.$8c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(E){const d=b.unshift(E);return(0,i.$Vc)(d)}function u(E,d,c,e,l){if(d=A(d),l||(l=n.Iterable.first(b)),c.length>l.maxLen){let _=E-l.maxLen/2;return _<0?_=0:e+=_,c=c.substring(_,E+l.maxLen/2),u(E,d,c,e,l)}const h=Date.now(),w=E-1-e;let L=-1,N=null;for(let _=1;!(Date.now()-h>=l.timeBudget);_++){const $=w-l.windowSize*_;d.lastIndex=Math.max(0,$);const o=g(d,c,w,L);if(!o&&N||(N=o,$<=0))break;L=$}if(N){const _={word:N[0],startColumn:e+1+N.index,endColumn:e+1+N.index+N[0].length};return d.lastIndex=0,_}return null}function g(E,d,c,e){let l;for(;l=E.exec(d);){const h=l.index||0;if(h<=c&&E.lastIndex>=c)return l;if(e>0&&h>e)return null}return null}}),ie(se[14],ue([0,1,9,4,7]),function(W,t,n,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$b5=t.$a5=t.$_4=t.$$4=t.$04=void 0;class m{static trivial(E,d){return new m([new A(T.$2t.ofLength(E.length),T.$2t.ofLength(d.length))],!1)}static trivialTimedOut(E,d){return new m([new A(T.$2t.ofLength(E.length),T.$2t.ofLength(d.length))],!0)}constructor(E,d){this.diffs=E,this.hitTimeout=d}}t.$04=m;class A{static invert(E,d){const c=[];return(0,n.$Db)(E,(e,l)=>{c.push(A.fromOffsetPairs(e?e.getEndExclusives():b.zero,l?l.getStarts():new b(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),c}static fromOffsetPairs(E,d){return new A(new T.$2t(E.offset1,d.offset1),new T.$2t(E.offset2,d.offset2))}static assertSorted(E){let d;for(const c of E){if(d&&!(d.seq1Range.endExclusive<=c.seq1Range.start&&d.seq2Range.endExclusive<=c.seq2Range.start))throw new i.$eb("Sequence diffs must be sorted");d=c}}constructor(E,d){this.seq1Range=E,this.seq2Range=d}swap(){return new A(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(E){return new A(this.seq1Range.join(E.seq1Range),this.seq2Range.join(E.seq2Range))}delta(E){return E===0?this:new A(this.seq1Range.delta(E),this.seq2Range.delta(E))}deltaStart(E){return E===0?this:new A(this.seq1Range.deltaStart(E),this.seq2Range.deltaStart(E))}deltaEnd(E){return E===0?this:new A(this.seq1Range.deltaEnd(E),this.seq2Range.deltaEnd(E))}intersectsOrTouches(E){return this.seq1Range.intersectsOrTouches(E.seq1Range)||this.seq2Range.intersectsOrTouches(E.seq2Range)}intersect(E){const d=this.seq1Range.intersect(E.seq1Range),c=this.seq2Range.intersect(E.seq2Range);if(!(!d||!c))return new A(d,c)}getStarts(){return new b(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new b(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$$4=A;class b{static{this.zero=new b(0,0)}static{this.max=new b(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(E,d){this.offset1=E,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(E){return E===0?this:new b(this.offset1+E,this.offset2+E)}equals(E){return this.offset1===E.offset1&&this.offset2===E.offset2}}t.$_4=b;class a{static{this.instance=new a}isValid(){return!0}}t.$a5=a;class u{constructor(E){if(this.e=E,this.c=Date.now(),this.d=!0,E<=0)throw new i.$eb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$b5=u}),ie(se[36],ue([0,1,7,14]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$g5=void 0;class T{compute(u,g,E=i.$a5.instance){if(u.length===0||g.length===0)return i.$04.trivial(u,g);const d=u,c=g;function e(s,f){for(;s<d.length&&f<c.length&&d.getElement(s)===c.getElement(f);)s++,f++;return s}let l=0;const h=new A;h.set(0,e(0,0));const w=new b;w.set(0,h.get(0)===0?null:new m(null,0,0,h.get(0)));let L=0;e:for(;;){if(l++,!E.isValid())return i.$04.trivialTimedOut(d,c);const s=-Math.min(l,c.length+l%2),f=Math.min(l,d.length+l%2);for(L=s;L<=f;L+=2){let v=0;const k=L===f?-1:h.get(L+1),R=L===s?-1:h.get(L-1)+1;v++;const j=Math.min(Math.max(k,R),d.length),M=j-L;if(v++,j>d.length||M>c.length)continue;const p=e(j,M);h.set(L,p);const D=j===k?w.get(L+1):w.get(L-1);if(w.set(L,p!==j?new m(D,j,M,p-j):D),h.get(L)===d.length&&h.get(L)-L===c.length)break e}}let N=w.get(L);const _=[];let $=d.length,o=c.length;for(;;){const s=N?N.x+N.length:0,f=N?N.y+N.length:0;if((s!==$||f!==o)&&_.push(new i.$$4(new n.$2t(s,$),new n.$2t(f,o))),!N)break;$=N.x,o=N.y,N=N.prev}return _.reverse(),new i.$04(_,!1)}}t.$g5=T;class m{constructor(u,g,E,d){this.prev=u,this.x=g,this.y=E,this.length=d}}class A{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,g){if(u<0){if(u=-u-1,u>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[u]=g}else{if(u>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[u]=g}}}class b{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,g){u<0?(u=-u-1,this.b[u]=g):this.a[u]=g}}}),ie(se[59],ue([0,1,9,7,14]),function(W,t,n,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$k5=m,t.$l5=u,t.$m5=g,t.$n5=d,t.$o5=c;function m(e,l,h){let w=h;return w=A(e,l,w),w=A(e,l,w),w=b(e,l,w),w}function A(e,l,h){if(h.length===0)return h;const w=[];w.push(h[0]);for(let N=1;N<h.length;N++){const _=w[w.length-1];let $=h[N];if($.seq1Range.isEmpty||$.seq2Range.isEmpty){const o=$.seq1Range.start-_.seq1Range.endExclusive;let s;for(s=1;s<=o&&!(e.getElement($.seq1Range.start-s)!==e.getElement($.seq1Range.endExclusive-s)||l.getElement($.seq2Range.start-s)!==l.getElement($.seq2Range.endExclusive-s));s++);if(s--,s===o){w[w.length-1]=new T.$$4(new i.$2t(_.seq1Range.start,$.seq1Range.endExclusive-o),new i.$2t(_.seq2Range.start,$.seq2Range.endExclusive-o));continue}$=$.delta(-s)}w.push($)}const L=[];for(let N=0;N<w.length-1;N++){const _=w[N+1];let $=w[N];if($.seq1Range.isEmpty||$.seq2Range.isEmpty){const o=_.seq1Range.start-$.seq1Range.endExclusive;let s;for(s=0;s<o&&!(!e.isStronglyEqual($.seq1Range.start+s,$.seq1Range.endExclusive+s)||!l.isStronglyEqual($.seq2Range.start+s,$.seq2Range.endExclusive+s));s++);if(s===o){w[N+1]=new T.$$4(new i.$2t($.seq1Range.start+o,_.seq1Range.endExclusive),new i.$2t($.seq2Range.start+o,_.seq2Range.endExclusive));continue}s>0&&($=$.delta(s))}L.push($)}return w.length>0&&L.push(w[w.length-1]),L}function b(e,l,h){if(!e.getBoundaryScore||!l.getBoundaryScore)return h;for(let w=0;w<h.length;w++){const L=w>0?h[w-1]:void 0,N=h[w],_=w+1<h.length?h[w+1]:void 0,$=new i.$2t(L?L.seq1Range.endExclusive+1:0,_?_.seq1Range.start-1:e.length),o=new i.$2t(L?L.seq2Range.endExclusive+1:0,_?_.seq2Range.start-1:l.length);N.seq1Range.isEmpty?h[w]=a(N,e,l,$,o):N.seq2Range.isEmpty&&(h[w]=a(N.swap(),l,e,o,$).swap())}return h}function a(e,l,h,w,L){let _=1;for(;e.seq1Range.start-_>=w.start&&e.seq2Range.start-_>=L.start&&h.isStronglyEqual(e.seq2Range.start-_,e.seq2Range.endExclusive-_)&&_<100;)_++;_--;let $=0;for(;e.seq1Range.start+$<w.endExclusive&&e.seq2Range.endExclusive+$<L.endExclusive&&h.isStronglyEqual(e.seq2Range.start+$,e.seq2Range.endExclusive+$)&&$<100;)$++;if(_===0&&$===0)return e;let o=0,s=-1;for(let f=-_;f<=$;f++){const v=e.seq2Range.start+f,k=e.seq2Range.endExclusive+f,R=e.seq1Range.start+f,j=l.getBoundaryScore(R)+h.getBoundaryScore(v)+h.getBoundaryScore(k);j>s&&(s=j,o=f)}return e.delta(o)}function u(e,l,h){const w=[];for(const L of h){const N=w[w.length-1];if(!N){w.push(L);continue}L.seq1Range.start-N.seq1Range.endExclusive<=2||L.seq2Range.start-N.seq2Range.endExclusive<=2?w[w.length-1]=new T.$$4(N.seq1Range.join(L.seq1Range),N.seq2Range.join(L.seq2Range)):w.push(L)}return w}function g(e,l,h){const w=T.$$4.invert(h,e.length),L=[];let N=new T.$_4(0,0);function _(o,s){if(o.offset1<N.offset1||o.offset2<N.offset2)return;const f=e.findWordContaining(o.offset1),v=l.findWordContaining(o.offset2);if(!f||!v)return;let k=new T.$$4(f,v);const R=k.intersect(s);let j=R.seq1Range.length,M=R.seq2Range.length;for(;w.length>0;){const p=w[0];if(!(p.seq1Range.intersects(k.seq1Range)||p.seq2Range.intersects(k.seq2Range)))break;const I=e.findWordContaining(p.seq1Range.start),F=l.findWordContaining(p.seq2Range.start),q=new T.$$4(I,F),z=q.intersect(p);if(j+=z.seq1Range.length,M+=z.seq2Range.length,k=k.join(q),k.seq1Range.endExclusive>=p.seq1Range.endExclusive)w.shift();else break}j+M<(k.seq1Range.length+k.seq2Range.length)*2/3&&L.push(k),N=k.getEndExclusives()}for(;w.length>0;){const o=w.shift();o.seq1Range.isEmpty||(_(o.getStarts(),o),_(o.getEndExclusives().delta(-1),o))}return E(h,L)}function E(e,l){const h=[];for(;e.length>0||l.length>0;){const w=e[0],L=l[0];let N;w&&(!L||w.seq1Range.start<L.seq1Range.start)?N=e.shift():N=l.shift(),h.length>0&&h[h.length-1].seq1Range.endExclusive>=N.seq1Range.start?h[h.length-1]=h[h.length-1].join(N):h.push(N)}return h}function d(e,l,h){let w=h;if(w.length===0)return w;let L=0,N;do{N=!1;const _=[w[0]];for(let $=1;$<w.length;$++){let f=function(k,R){const j=new i.$2t(s.seq1Range.endExclusive,o.seq1Range.start);return e.getText(j).replace(/\s/g,"").length<=4&&(k.seq1Range.length+k.seq2Range.length>5||R.seq1Range.length+R.seq2Range.length>5)};const o=w[$],s=_[_.length-1];f(s,o)?(N=!0,_[_.length-1]=_[_.length-1].join(o)):_.push(o)}w=_}while(L++<10&&N);return w}function c(e,l,h){let w=h;if(w.length===0)return w;let L=0,N;do{N=!1;const $=[w[0]];for(let o=1;o<w.length;o++){let v=function(R,j){const M=new i.$2t(f.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(M)>5||M.length>500)return!1;const D=e.getText(M).trim();if(D.length>20||D.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(R.seq1Range),F=R.seq1Range.length,q=l.countLinesIn(R.seq2Range),z=R.seq2Range.length,H=e.countLinesIn(j.seq1Range),U=j.seq1Range.length,C=l.countLinesIn(j.seq2Range),ee=j.seq2Range.length,J=2*40+50;function K(ne){return Math.min(ne,J)}return Math.pow(Math.pow(K(I*40+F),1.5)+Math.pow(K(q*40+z),1.5),1.5)+Math.pow(Math.pow(K(H*40+U),1.5)+Math.pow(K(C*40+ee),1.5),1.5)>(J**1.5)**1.5*1.3};const s=w[o],f=$[$.length-1];v(f,s)?(N=!0,$[$.length-1]=$[$.length-1].join(s)):$.push(s)}w=$}while(L++<10&&N);const _=[];return(0,n.$Eb)(w,($,o,s)=>{let f=o;function v(D){return D.length>0&&D.trim().length<=3&&o.seq1Range.length+o.seq2Range.length>100}const k=e.extendToFullLines(o.seq1Range),R=e.getText(new i.$2t(k.start,o.seq1Range.start));v(R)&&(f=f.deltaStart(-R.length));const j=e.getText(new i.$2t(o.seq1Range.endExclusive,k.endExclusive));v(j)&&(f=f.deltaEnd(j.length));const M=T.$$4.fromOffsetPairs($?$.getEndExclusives():T.$_4.zero,s?s.getStarts():T.$_4.max),p=f.intersect(M);_.length>0&&p.getStarts().equals(_[_.length-1].getEndExclusives())?_[_.length-1]=_[_.length-1].join(p):_.push(p)}),_}}),ie(se[60],ue([0,1,3]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$j5=void 0;class i{constructor(A,b){this.a=A,this.b=b}getElement(A){return this.a[A]}get length(){return this.a.length}getBoundaryScore(A){const b=A===0?0:T(this.b[A-1]),a=A===this.b.length?0:T(this.b[A]);return 1e3-(b+a)}getText(A){return this.b.slice(A.start,A.endExclusive).join(`
`)}isStronglyEqual(A,b){return this.b[A]===this.b[b]}}t.$j5=i;function T(m){let A=0;for(;A<m.length&&(m.charCodeAt(A)===n.CharCode.Space||m.charCodeAt(A)===n.CharCode.Tab);)A++;return A}}),ie(se[23],ue([0,1,3]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$e5=t.$c5=void 0,t.$d5=T;class i{constructor(b,a){this.width=b,this.height=a,this.a=[],this.a=new Array(b*a)}get(b,a){return this.a[b+a*this.width]}set(b,a,u){this.a[b+a*this.width]=u}}t.$c5=i;function T(A){return A===n.CharCode.Space||A===n.CharCode.Tab}class m{static{this.a=new Map}static b(b){let a=this.a.get(b);return a===void 0&&(a=this.a.size,this.a.set(b,a)),a}constructor(b,a,u){this.range=b,this.lines=a,this.source=u,this.d=[];let g=0;for(let E=b.startLineNumber-1;E<b.endLineNumberExclusive-1;E++){const d=a[E];for(let e=0;e<d.length;e++){g++;const l=d[e],h=m.b(l);this.d[h]=(this.d[h]||0)+1}g++;const c=m.b(`
`);this.d[c]=(this.d[c]||0)+1}this.c=g}computeSimilarity(b){let a=0;const u=Math.max(this.d.length,b.d.length);for(let g=0;g<u;g++)a+=Math.abs((this.d[g]??0)-(b.d[g]??0));return 1-a/(this.c+b.c)}}t.$e5=m}),ie(se[61],ue([0,1,7,14,23]),function(W,t,n,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$f5=void 0;class m{compute(b,a,u=i.$a5.instance,g){if(b.length===0||a.length===0)return i.$04.trivial(b,a);const E=new T.$c5(b.length,a.length),d=new T.$c5(b.length,a.length),c=new T.$c5(b.length,a.length);for(let _=0;_<b.length;_++)for(let $=0;$<a.length;$++){if(!u.isValid())return i.$04.trivialTimedOut(b,a);const o=_===0?0:E.get(_-1,$),s=$===0?0:E.get(_,$-1);let f;b.getElement(_)===a.getElement($)?(_===0||$===0?f=0:f=E.get(_-1,$-1),_>0&&$>0&&d.get(_-1,$-1)===3&&(f+=c.get(_-1,$-1)),f+=g?g(_,$):1):f=-1;const v=Math.max(o,s,f);if(v===f){const k=_>0&&$>0?c.get(_-1,$-1):0;c.set(_,$,k+1),d.set(_,$,3)}else v===o?(c.set(_,$,0),d.set(_,$,1)):v===s&&(c.set(_,$,0),d.set(_,$,2));E.set(_,$,v)}const e=[];let l=b.length,h=a.length;function w(_,$){(_+1!==l||$+1!==h)&&e.push(new i.$$4(new n.$2t(_+1,l),new n.$2t($+1,h))),l=_,h=$}let L=b.length-1,N=a.length-1;for(;L>=0&&N>=0;)d.get(L,N)===3?(w(L,N),L--,N--):d.get(L,N)===1?L--:N--;return w(-1,-1),e.reverse(),new i.$04(e,!1)}}t.$f5=m}),ie(se[37],ue([0,1,11,3,7,5,2,23]),function(W,t,n,i,T,m,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$h5=void 0;class a{constructor(l,h,w){this.lines=l,this.g=h,this.considerWhitespaceChanges=w,this.b=[],this.c=[],this.d=[],this.f=[],this.c.push(0);for(let L=this.g.startLineNumber;L<=this.g.endLineNumber;L++){let N=l[L-1],_=0;L===this.g.startLineNumber&&this.g.startColumn>1&&(_=this.g.startColumn-1,N=N.substring(_)),this.d.push(_);let $=0;if(!w){const s=N.trimStart();$=N.length-s.length,N=s.trimEnd()}this.f.push($);const o=L===this.g.endLineNumber?Math.min(this.g.endColumn-1-_-$,N.length):N.length;for(let s=0;s<o;s++)this.b.push(N.charCodeAt(s));L<this.g.endLineNumber&&(this.b.push(10),this.c.push(this.b.length))}}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new T.$2t(0,this.length))}getText(l){return this.b.slice(l.start,l.endExclusive).map(h=>String.fromCharCode(h)).join("")}getElement(l){return this.b[l]}get length(){return this.b.length}getBoundaryScore(l){const h=c(l>0?this.b[l-1]:-1),w=c(l<this.b.length?this.b[l]:-1);if(h===g.LineBreakCR&&w===g.LineBreakLF)return 0;if(h===g.LineBreakLF)return 150;let L=0;return h!==w&&(L+=10,h===g.WordLower&&w===g.WordUpper&&(L+=1)),L+=d(h),L+=d(w),L}translateOffset(l,h="right"){const w=(0,n.$kb)(this.c,N=>N<=l),L=l-this.c[w];return new m.$Tt(this.g.startLineNumber+w,1+this.d[w]+L+(L===0&&h==="left"?0:this.f[w]))}translateRange(l){const h=this.translateOffset(l.start,"right"),w=this.translateOffset(l.endExclusive,"left");return w.isBefore(h)?A.$Ut.fromPositions(w,w):A.$Ut.fromPositions(h,w)}findWordContaining(l){if(l<0||l>=this.b.length||!u(this.b[l]))return;let h=l;for(;h>0&&u(this.b[h-1]);)h--;let w=l;for(;w<this.b.length&&u(this.b[w]);)w++;return new T.$2t(h,w)}countLinesIn(l){return this.translateOffset(l.endExclusive).lineNumber-this.translateOffset(l.start).lineNumber}isStronglyEqual(l,h){return this.b[l]===this.b[h]}extendToFullLines(l){const h=(0,n.$jb)(this.c,L=>L<=l.start)??0,w=(0,n.$lb)(this.c,L=>l.endExclusive<=L)??this.b.length;return new T.$2t(h,w)}}t.$h5=a;function u(e){return e>=i.CharCode.a&&e<=i.CharCode.z||e>=i.CharCode.A&&e<=i.CharCode.Z||e>=i.CharCode.Digit0&&e<=i.CharCode.Digit9}var g;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(g||(g={}));const E={[g.WordLower]:0,[g.WordUpper]:0,[g.WordNumber]:0,[g.End]:10,[g.Other]:2,[g.Separator]:30,[g.Space]:3,[g.LineBreakCR]:10,[g.LineBreakLF]:10};function d(e){return E[e]}function c(e){return e===i.CharCode.LineFeed?g.LineBreakLF:e===i.CharCode.CarriageReturn?g.LineBreakCR:(0,b.$d5)(e)?g.Space:e>=i.CharCode.a&&e<=i.CharCode.z?g.WordLower:e>=i.CharCode.A&&e<=i.CharCode.Z?g.WordUpper:e>=i.CharCode.Digit0&&e<=i.CharCode.Digit9?g.WordNumber:e===-1?g.End:e===i.CharCode.Comma||e===i.CharCode.Semicolon?g.Separator:g.Other}}),ie(se[38],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fu=t.$eu=void 0;class n{constructor(m,A,b){this.changes=m,this.moves=A,this.hitTimeout=b}}t.$eu=n;class i{constructor(m,A){this.lineRangeMapping=m,this.changes=A}flip(){return new i(this.lineRangeMapping.flip(),this.changes.map(m=>m.flip()))}}t.$fu=i}),ie(se[24],ue([0,1,4,18,5,2,57]),function(W,t,n,i,T,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$du=t.$cu=t.$bu=void 0;class b{static inverse(c,e,l){const h=[];let w=1,L=1;for(const _ of c){const $=new b(new i.$4t(w,_.original.startLineNumber),new i.$4t(L,_.modified.startLineNumber));$.modified.isEmpty||h.push($),w=_.original.endLineNumberExclusive,L=_.modified.endLineNumberExclusive}const N=new b(new i.$4t(w,e+1),new i.$4t(L,l+1));return N.modified.isEmpty||h.push(N),h}static clip(c,e,l){const h=[];for(const w of c){const L=w.original.intersect(e),N=w.modified.intersect(l);L&&!L.isEmpty&&N&&!N.isEmpty&&h.push(new b(L,N))}return h}constructor(c,e){this.original=c,this.modified=e}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new b(this.modified,this.original)}join(c){return new b(this.original.join(c.original),this.modified.join(c.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const c=this.original.toInclusiveRange(),e=this.modified.toInclusiveRange();if(c&&e)return new E(c,e);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new n.$eb("not a valid diff");return new E(new m.$Ut(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new m.$Ut(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new E(new m.$Ut(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new m.$Ut(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}toRangeMapping2(c,e){if(u(this.original.endLineNumberExclusive,c)&&u(this.modified.endLineNumberExclusive,e))return new E(new m.$Ut(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new m.$Ut(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1));if(!this.original.isEmpty&&!this.modified.isEmpty)return new E(m.$Ut.fromPositions(new T.$Tt(this.original.startLineNumber,1),a(new T.$Tt(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),c)),m.$Ut.fromPositions(new T.$Tt(this.modified.startLineNumber,1),a(new T.$Tt(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));if(this.original.startLineNumber>1&&this.modified.startLineNumber>1)return new E(m.$Ut.fromPositions(a(new T.$Tt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER),c),a(new T.$Tt(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),c)),m.$Ut.fromPositions(a(new T.$Tt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER),e),a(new T.$Tt(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));throw new n.$eb}}t.$bu=b;function a(d,c){if(d.lineNumber<1)return new T.$Tt(1,1);if(d.lineNumber>c.length)return new T.$Tt(c.length,c[c.length-1].length+1);const e=c[d.lineNumber-1];return d.column>e.length+1?new T.$Tt(d.lineNumber,e.length+1):d}function u(d,c){return d>=1&&d<=c.length}class g extends b{static fromRangeMappings(c){const e=i.$4t.join(c.map(h=>i.$4t.fromRangeInclusive(h.originalRange))),l=i.$4t.join(c.map(h=>i.$4t.fromRangeInclusive(h.modifiedRange)));return new g(e,l,c)}constructor(c,e,l){super(c,e),this.innerChanges=l}flip(){return new g(this.modified,this.original,this.innerChanges?.map(c=>c.flip()))}withInnerChangesFromLineRanges(){return new g(this.original,this.modified,[this.toRangeMapping()])}}t.$cu=g;class E{static assertSorted(c){for(let e=1;e<c.length;e++){const l=c[e-1],h=c[e];if(!(l.originalRange.getEndPosition().isBeforeOrEqual(h.originalRange.getStartPosition())&&l.modifiedRange.getEndPosition().isBeforeOrEqual(h.modifiedRange.getStartPosition())))throw new n.$eb("Range mappings must be sorted")}}constructor(c,e){this.originalRange=c,this.modifiedRange=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new E(this.modifiedRange,this.originalRange)}toTextEdit(c){const e=c.getValueOfRange(this.modifiedRange);return new A.$9t(this.originalRange,e)}}t.$du=E}),ie(se[62],ue([0,1,14,24,9,11,19,18,37,23,36,2]),function(W,t,n,i,T,m,A,b,a,u,g,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$i5=d;function d(N,_,$,o,s,f){let{moves:v,excludedChanges:k}=e(N,_,$,f);if(!f.isValid())return[];const R=N.filter(M=>!k.has(M)),j=l(R,o,s,_,$,f);return(0,T.$2b)(v,j),v=w(v),v=v.filter(M=>{const p=M.original.toOffsetRange().slice(_).map(I=>I.trim());return p.join(`
`).length>=15&&c(p,I=>I.length>=2)>=2}),v=L(N,v),v}function c(N,_){let $=0;for(const o of N)_(o)&&$++;return $}function e(N,_,$,o){const s=[],f=N.filter(R=>R.modified.isEmpty&&R.original.length>=3).map(R=>new u.$e5(R.original,_,R)),v=new Set(N.filter(R=>R.original.isEmpty&&R.modified.length>=3).map(R=>new u.$e5(R.modified,$,R))),k=new Set;for(const R of f){let j=-1,M;for(const p of v){const D=R.computeSimilarity(p);D>j&&(j=D,M=p)}if(j>.9&&M&&(v.delete(M),s.push(new i.$bu(R.range,M.range)),k.add(R.source),k.add(M.source)),!o.isValid())return{moves:s,excludedChanges:k}}return{moves:s,excludedChanges:k}}function l(N,_,$,o,s,f){const v=[],k=new A.$Kc;for(const D of N)for(let I=D.original.startLineNumber;I<D.original.endLineNumberExclusive-2;I++){const F=`${_[I-1]}:${_[I+1-1]}:${_[I+2-1]}`;k.add(F,{range:new b.$4t(I,I+3)})}const R=[];N.sort((0,T.$8b)(D=>D.modified.startLineNumber,T.$0b));for(const D of N){let I=[];for(let F=D.modified.startLineNumber;F<D.modified.endLineNumberExclusive-2;F++){const q=`${$[F-1]}:${$[F+1-1]}:${$[F+2-1]}`,z=new b.$4t(F,F+3),H=[];k.forEach(q,({range:U})=>{for(const ee of I)if(ee.originalLineRange.endLineNumberExclusive+1===U.endLineNumberExclusive&&ee.modifiedLineRange.endLineNumberExclusive+1===z.endLineNumberExclusive){ee.originalLineRange=new b.$4t(ee.originalLineRange.startLineNumber,U.endLineNumberExclusive),ee.modifiedLineRange=new b.$4t(ee.modifiedLineRange.startLineNumber,z.endLineNumberExclusive),H.push(ee);return}const C={modifiedLineRange:z,originalLineRange:U};R.push(C),H.push(C)}),I=H}if(!f.isValid())return[]}R.sort((0,T.$_b)((0,T.$8b)(D=>D.modifiedLineRange.length,T.$0b)));const j=new b.$5t,M=new b.$5t;for(const D of R){const I=D.modifiedLineRange.startLineNumber-D.originalLineRange.startLineNumber,F=j.subtractFrom(D.modifiedLineRange),q=M.subtractFrom(D.originalLineRange).getWithDelta(I),z=F.getIntersection(q);for(const H of z.ranges){if(H.length<3)continue;const U=H,C=H.delta(-I);v.push(new i.$bu(C,U)),j.addRange(U),M.addRange(C)}}v.sort((0,T.$8b)(D=>D.original.startLineNumber,T.$0b));const p=new m.$ob(N);for(let D=0;D<v.length;D++){const I=v[D],F=p.findLastMonotonous(K=>K.original.startLineNumber<=I.original.startLineNumber),q=(0,m.$jb)(N,K=>K.modified.startLineNumber<=I.modified.startLineNumber),z=Math.max(I.original.startLineNumber-F.original.startLineNumber,I.modified.startLineNumber-q.modified.startLineNumber),H=p.findLastMonotonous(K=>K.original.startLineNumber<I.original.endLineNumberExclusive),U=(0,m.$jb)(N,K=>K.modified.startLineNumber<I.modified.endLineNumberExclusive),C=Math.max(H.original.endLineNumberExclusive-I.original.endLineNumberExclusive,U.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let ee;for(ee=0;ee<z;ee++){const K=I.original.startLineNumber-ee-1,ne=I.modified.startLineNumber-ee-1;if(K>o.length||ne>s.length||j.contains(ne)||M.contains(K)||!h(o[K-1],s[ne-1],f))break}ee>0&&(M.addRange(new b.$4t(I.original.startLineNumber-ee,I.original.startLineNumber)),j.addRange(new b.$4t(I.modified.startLineNumber-ee,I.modified.startLineNumber)));let J;for(J=0;J<C;J++){const K=I.original.endLineNumberExclusive+J,ne=I.modified.endLineNumberExclusive+J;if(K>o.length||ne>s.length||j.contains(ne)||M.contains(K)||!h(o[K-1],s[ne-1],f))break}J>0&&(M.addRange(new b.$4t(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+J)),j.addRange(new b.$4t(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+J))),(ee>0||J>0)&&(v[D]=new i.$bu(new b.$4t(I.original.startLineNumber-ee,I.original.endLineNumberExclusive+J),new b.$4t(I.modified.startLineNumber-ee,I.modified.endLineNumberExclusive+J)))}return v}function h(N,_,$){if(N.trim()===_.trim())return!0;if(N.length>300&&_.length>300)return!1;const s=new g.$g5().compute(new a.$h5([N],new E.$Ut(1,1,1,N.length),!1),new a.$h5([_],new E.$Ut(1,1,1,_.length),!1),$);let f=0;const v=n.$$4.invert(s.diffs,N.length);for(const M of v)M.seq1Range.forEach(p=>{(0,u.$d5)(N.charCodeAt(p))||f++});function k(M){let p=0;for(let D=0;D<N.length;D++)(0,u.$d5)(M.charCodeAt(D))||p++;return p}const R=k(N.length>_.length?N:_);return f/R>.6&&R>10}function w(N){if(N.length===0)return N;N.sort((0,T.$8b)($=>$.original.startLineNumber,T.$0b));const _=[N[0]];for(let $=1;$<N.length;$++){const o=_[_.length-1],s=N[$],f=s.original.startLineNumber-o.original.endLineNumberExclusive,v=s.modified.startLineNumber-o.modified.endLineNumberExclusive;if(f>=0&&v>=0&&f+v<=2){_[_.length-1]=o.join(s);continue}_.push(s)}return _}function L(N,_){const $=new m.$ob(N);return _=_.filter(o=>{const s=$.findLastMonotonous(k=>k.original.startLineNumber<o.original.endLineNumberExclusive)||new i.$bu(new b.$4t(1,1),new b.$4t(1,1)),f=(0,m.$jb)(N,k=>k.modified.startLineNumber<o.modified.endLineNumberExclusive);return s!==f}),_}}),ie(se[63],ue([0,1,9,15,18,7,2,14,61,36,62,59,60,37,38,24]),function(W,t,n,i,T,m,A,b,a,u,g,E,d,c,e,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p5=void 0,t.$q5=w,t.$r5=L;class h{constructor(){this.e=new a.$f5,this.f=new u.$g5}computeDiff($,o,s){if($.length<=1&&(0,n.$wb)($,o,(K,ne)=>K===ne))return new e.$eu([],[],!1);if($.length===1&&$[0].length===0||o.length===1&&o[0].length===0)return new e.$eu([new l.$cu(new T.$4t(1,$.length+1),new T.$4t(1,o.length+1),[new l.$du(new A.$Ut(1,1,$.length,$[$.length-1].length+1),new A.$Ut(1,1,o.length,o[o.length-1].length+1))])],[],!1);const f=s.maxComputationTimeMs===0?b.$a5.instance:new b.$b5(s.maxComputationTimeMs),v=!s.ignoreTrimWhitespace,k=new Map;function R(K){let ne=k.get(K);return ne===void 0&&(ne=k.size,k.set(K,ne)),ne}const j=$.map(K=>R(K.trim())),M=o.map(K=>R(K.trim())),p=new d.$j5(j,$),D=new d.$j5(M,o),I=p.length+D.length<1700?this.e.compute(p,D,f,(K,ne)=>$[K]===o[ne]?o[ne].length===0?.1:1+Math.log(1+o[ne].length):.99):this.f.compute(p,D,f);let F=I.diffs,q=I.hitTimeout;F=(0,E.$k5)(p,D,F),F=(0,E.$n5)(p,D,F);const z=[],H=K=>{if(v)for(let ne=0;ne<K;ne++){const P=U+ne,X=C+ne;if($[P]!==o[X]){const he=this.j($,o,new b.$$4(new m.$2t(P,P+1),new m.$2t(X,X+1)),f,v);for(const ge of he.mappings)z.push(ge);he.hitTimeout&&(q=!0)}}};let U=0,C=0;for(const K of F){(0,i.$kd)(()=>K.seq1Range.start-U===K.seq2Range.start-C);const ne=K.seq1Range.start-U;H(ne),U=K.seq1Range.endExclusive,C=K.seq2Range.endExclusive;const P=this.j($,o,K,f,v);P.hitTimeout&&(q=!0);for(const X of P.mappings)z.push(X)}H($.length-U);const ee=w(z,$,o);let J=[];return s.computeMoves&&(J=this.h(ee,$,o,j,M,f,v)),(0,i.$kd)(()=>{function K(P,X){if(P.lineNumber<1||P.lineNumber>X.length)return!1;const he=X[P.lineNumber-1];return!(P.column<1||P.column>he.length+1)}function ne(P,X){return!(P.startLineNumber<1||P.startLineNumber>X.length+1||P.endLineNumberExclusive<1||P.endLineNumberExclusive>X.length+1)}for(const P of ee){if(!P.innerChanges)return!1;for(const X of P.innerChanges)if(!(K(X.modifiedRange.getStartPosition(),o)&&K(X.modifiedRange.getEndPosition(),o)&&K(X.originalRange.getStartPosition(),$)&&K(X.originalRange.getEndPosition(),$)))return!1;if(!ne(P.modified,o)||!ne(P.original,$))return!1}return!0}),new e.$eu(ee,J,q)}h($,o,s,f,v,k,R){return(0,g.$i5)($,o,s,f,v,k).map(p=>{const D=this.j(o,s,new b.$$4(p.original.toOffsetRange(),p.modified.toOffsetRange()),k,R),I=w(D.mappings,o,s,!0);return new e.$fu(p,I)})}j($,o,s,f,v){const R=N(s).toRangeMapping2($,o),j=new c.$h5($,R.originalRange,v),M=new c.$h5(o,R.modifiedRange,v),p=j.length+M.length<500?this.e.compute(j,M,f):this.f.compute(j,M,f),D=!1;let I=p.diffs;D&&b.$$4.assertSorted(I),I=(0,E.$k5)(j,M,I),D&&b.$$4.assertSorted(I),I=(0,E.$m5)(j,M,I),D&&b.$$4.assertSorted(I),I=(0,E.$l5)(j,M,I),D&&b.$$4.assertSorted(I),I=(0,E.$o5)(j,M,I),D&&b.$$4.assertSorted(I);const F=I.map(q=>new l.$du(j.translateRange(q.seq1Range),M.translateRange(q.seq2Range)));return D&&l.$du.assertSorted(F),{mappings:F,hitTimeout:p.hitTimeout}}}t.$p5=h;function w(_,$,o,s=!1){const f=[];for(const v of(0,n.$Cb)(_.map(k=>L(k,$,o)),(k,R)=>k.original.overlapOrTouch(R.original)||k.modified.overlapOrTouch(R.modified))){const k=v[0],R=v[v.length-1];f.push(new l.$cu(k.original.join(R.original),k.modified.join(R.modified),v.map(j=>j.innerChanges[0])))}return(0,i.$kd)(()=>!s&&f.length>0&&(f[0].modified.startLineNumber!==f[0].original.startLineNumber||o.length-f[f.length-1].modified.endLineNumberExclusive!==$.length-f[f.length-1].original.endLineNumberExclusive)?!1:(0,i.$ld)(f,(v,k)=>k.original.startLineNumber-v.original.endLineNumberExclusive===k.modified.startLineNumber-v.modified.endLineNumberExclusive&&v.original.endLineNumberExclusive<k.original.startLineNumber&&v.modified.endLineNumberExclusive<k.modified.startLineNumber)),f}function L(_,$,o){let s=0,f=0;_.modifiedRange.endColumn===1&&_.originalRange.endColumn===1&&_.originalRange.startLineNumber+s<=_.originalRange.endLineNumber&&_.modifiedRange.startLineNumber+s<=_.modifiedRange.endLineNumber&&(f=-1),_.modifiedRange.startColumn-1>=o[_.modifiedRange.startLineNumber-1].length&&_.originalRange.startColumn-1>=$[_.originalRange.startLineNumber-1].length&&_.originalRange.startLineNumber<=_.originalRange.endLineNumber+f&&_.modifiedRange.startLineNumber<=_.modifiedRange.endLineNumber+f&&(s=1);const v=new T.$4t(_.originalRange.startLineNumber+s,_.originalRange.endLineNumber+1+f),k=new T.$4t(_.modifiedRange.startLineNumber+s,_.modifiedRange.endLineNumber+1+f);return new l.$cu(v,k,[_])}function N(_){return new l.$bu(new T.$4t(_.seq1Range.start+1,_.seq1Range.endExclusive+1),new T.$4t(_.seq2Range.start+1,_.seq2Range.endExclusive+1))}}),ie(se[39],ue([0,1,3,32,38,24,6,2,15,18]),function(W,t,n,i,T,m,A,b,a,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hu=t.$gu=void 0,A=ke(A);const g=3;class E{computeDiff(s,f,v){const R=new L(s,f,{maxComputationTime:v.maxComputationTimeMs,shouldIgnoreTrimWhitespace:v.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),j=[];let M=null;for(const p of R.changes){let D;p.originalEndLineNumber===0?D=new u.$4t(p.originalStartLineNumber+1,p.originalStartLineNumber+1):D=new u.$4t(p.originalStartLineNumber,p.originalEndLineNumber+1);let I;p.modifiedEndLineNumber===0?I=new u.$4t(p.modifiedStartLineNumber+1,p.modifiedStartLineNumber+1):I=new u.$4t(p.modifiedStartLineNumber,p.modifiedEndLineNumber+1);let F=new m.$cu(D,I,p.charChanges?.map(q=>new m.$du(new b.$Ut(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new b.$Ut(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===F.modified.startLineNumber||M.original.endLineNumberExclusive===F.original.startLineNumber)&&(F=new m.$cu(M.original.join(F.original),M.modified.join(F.modified),M.innerChanges&&F.innerChanges?M.innerChanges.concat(F.innerChanges):void 0),j.pop()),j.push(F),M=F}return(0,a.$kd)(()=>(0,a.$ld)(j,(p,D)=>D.original.startLineNumber-p.original.endLineNumberExclusive===D.modified.startLineNumber-p.modified.endLineNumberExclusive&&p.original.endLineNumberExclusive<D.original.startLineNumber&&p.modified.endLineNumberExclusive<D.modified.startLineNumber)),new T.$eu(j,[],R.quitEarly)}}t.$gu=E;function d(o,s,f,v){return new i.$1t(o,s,f).ComputeDiff(v)}class c{constructor(s){const f=[],v=[];for(let k=0,R=s.length;k<R;k++)f[k]=N(s[k],1),v[k]=_(s[k],1);this.lines=s,this.a=f,this.b=v}getElements(){const s=[];for(let f=0,v=this.lines.length;f<v;f++)s[f]=this.lines[f].substring(this.a[f]-1,this.b[f]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,f,v){const k=[],R=[],j=[];let M=0;for(let p=f;p<=v;p++){const D=this.lines[p],I=s?this.a[p]:1,F=s?this.b[p]:D.length+1;for(let q=I;q<F;q++)k[M]=D.charCodeAt(q-1),R[M]=p+1,j[M]=q,M++;!s&&p<v&&(k[M]=n.CharCode.LineFeed,R[M]=p+1,j[M]=D.length+1,M++)}return new e(k,R,j)}}class e{constructor(s,f,v){this.a=s,this.b=f,this.d=v}toString(){return"["+this.a.map((s,f)=>(s===n.CharCode.LineFeed?"\\n":String.fromCharCode(s))+`-(${this.b[f]},${this.d[f]})`).join(", ")+"]"}e(s,f){if(s<0||s>=f.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(s){return s>0&&s===this.b.length?this.getEndLineNumber(s-1):(this.e(s,this.b),this.b[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this.e(s,this.b),this.a[s]===n.CharCode.LineFeed?this.b[s]+1:this.b[s])}getStartColumn(s){return s>0&&s===this.d.length?this.getEndColumn(s-1):(this.e(s,this.d),this.d[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this.e(s,this.d),this.a[s]===n.CharCode.LineFeed?1:this.d[s]+1)}}class l{constructor(s,f,v,k,R,j,M,p){this.originalStartLineNumber=s,this.originalStartColumn=f,this.originalEndLineNumber=v,this.originalEndColumn=k,this.modifiedStartLineNumber=R,this.modifiedStartColumn=j,this.modifiedEndLineNumber=M,this.modifiedEndColumn=p}static createFromDiffChange(s,f,v){const k=f.getStartLineNumber(s.originalStart),R=f.getStartColumn(s.originalStart),j=f.getEndLineNumber(s.originalStart+s.originalLength-1),M=f.getEndColumn(s.originalStart+s.originalLength-1),p=v.getStartLineNumber(s.modifiedStart),D=v.getStartColumn(s.modifiedStart),I=v.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),F=v.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new l(k,R,j,M,p,D,I,F)}}function h(o){if(o.length<=1)return o;const s=[o[0]];let f=s[0];for(let v=1,k=o.length;v<k;v++){const R=o[v],j=R.originalStart-(f.originalStart+f.originalLength),M=R.modifiedStart-(f.modifiedStart+f.modifiedLength);Math.min(j,M)<g?(f.originalLength=R.originalStart+R.originalLength-f.originalStart,f.modifiedLength=R.modifiedStart+R.modifiedLength-f.modifiedStart):(s.push(R),f=R)}return s}class w{constructor(s,f,v,k,R){this.originalStartLineNumber=s,this.originalEndLineNumber=f,this.modifiedStartLineNumber=v,this.modifiedEndLineNumber=k,this.charChanges=R}static createFromDiffResult(s,f,v,k,R,j,M){let p,D,I,F,q;if(f.originalLength===0?(p=v.getStartLineNumber(f.originalStart)-1,D=0):(p=v.getStartLineNumber(f.originalStart),D=v.getEndLineNumber(f.originalStart+f.originalLength-1)),f.modifiedLength===0?(I=k.getStartLineNumber(f.modifiedStart)-1,F=0):(I=k.getStartLineNumber(f.modifiedStart),F=k.getEndLineNumber(f.modifiedStart+f.modifiedLength-1)),j&&f.originalLength>0&&f.originalLength<20&&f.modifiedLength>0&&f.modifiedLength<20&&R()){const z=v.createCharSequence(s,f.originalStart,f.originalStart+f.originalLength-1),H=k.createCharSequence(s,f.modifiedStart,f.modifiedStart+f.modifiedLength-1);if(z.getElements().length>0&&H.getElements().length>0){let U=d(z,H,R,!0).changes;M&&(U=h(U)),q=[];for(let C=0,ee=U.length;C<ee;C++)q.push(l.createFromDiffChange(U[C],z,H))}}return new w(p,D,I,F,q)}}class L{constructor(s,f,v){this.a=v.shouldComputeCharChanges,this.b=v.shouldPostProcessCharChanges,this.d=v.shouldIgnoreTrimWhitespace,this.e=v.shouldMakePrettyDiff,this.f=s,this.g=f,this.h=new c(s),this.j=new c(f),this.k=$(v.maxComputationTime),this.l=$(v.maxComputationTime===0?0:Math.min(v.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=d(this.h,this.j,this.k,this.e),f=s.changes,v=s.quitEarly;if(this.d){const M=[];for(let p=0,D=f.length;p<D;p++)M.push(w.createFromDiffResult(this.d,f[p],this.h,this.j,this.l,this.a,this.b));return{quitEarly:v,changes:M}}const k=[];let R=0,j=0;for(let M=-1,p=f.length;M<p;M++){const D=M+1<p?f[M+1]:null,I=D?D.originalStart:this.f.length,F=D?D.modifiedStart:this.g.length;for(;R<I&&j<F;){const q=this.f[R],z=this.g[j];if(q!==z){{let H=N(q,1),U=N(z,1);for(;H>1&&U>1;){const C=q.charCodeAt(H-2),ee=z.charCodeAt(U-2);if(C!==ee)break;H--,U--}(H>1||U>1)&&this.m(k,R+1,1,H,j+1,1,U)}{let H=_(q,1),U=_(z,1);const C=q.length+1,ee=z.length+1;for(;H<C&&U<ee;){const J=q.charCodeAt(H-1),K=q.charCodeAt(U-1);if(J!==K)break;H++,U++}(H<C||U<ee)&&this.m(k,R+1,H,C,j+1,U,ee)}}R++,j++}D&&(k.push(w.createFromDiffResult(this.d,D,this.h,this.j,this.l,this.a,this.b)),R+=D.originalLength,j+=D.modifiedLength)}return{quitEarly:v,changes:k}}m(s,f,v,k,R,j,M){if(this.n(s,f,v,k,R,j,M))return;let p;this.a&&(p=[new l(f,v,f,k,R,j,R,M)]),s.push(new w(f,f,R,R,p))}n(s,f,v,k,R,j,M){const p=s.length;if(p===0)return!1;const D=s[p-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===f&&D.modifiedEndLineNumber===R?(this.a&&D.charChanges&&D.charChanges.push(new l(f,v,f,k,R,j,R,M)),!0):D.originalEndLineNumber+1===f&&D.modifiedEndLineNumber+1===R?(D.originalEndLineNumber=f,D.modifiedEndLineNumber=R,this.a&&D.charChanges&&D.charChanges.push(new l(f,v,f,k,R,j,R,M)),!0):!1}}t.$hu=L;function N(o,s){const f=A.$xf(o);return f===-1?s:f+1}function _(o,s){const f=A.$zf(o);return f===-1?s:f+2}function $(o){if(o===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<o}}),ie(se[64],ue([0,1,39,63]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$s5=void 0,t.$s5={getLegacy:()=>new n.$gu,getDefault:()=>new i.$p5}}),ie(se[65],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bu=t.MetadataConsts=t.StandardTokenType=t.ColorId=t.FontStyle=t.LanguageId=void 0;var n;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(n||(t.LanguageId=n={}));var i;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(i||(t.FontStyle=i={}));var T;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(T||(t.ColorId=T={}));var m;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(m||(t.StandardTokenType=m={}));var A;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",a[a.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(A||(t.MetadataConsts=A={}));class b{static getLanguageId(u){return(u&A.LANGUAGEID_MASK)>>>A.LANGUAGEID_OFFSET}static getTokenType(u){return(u&A.TOKEN_TYPE_MASK)>>>A.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(u){return(u&A.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(u){return(u&A.FONT_STYLE_MASK)>>>A.FONT_STYLE_OFFSET}static getForeground(u){return(u&A.FOREGROUND_MASK)>>>A.FOREGROUND_OFFSET}static getBackground(u){return(u&A.BACKGROUND_MASK)>>>A.BACKGROUND_OFFSET}static getClassNameFromMetadata(u){let E="mtk"+this.getForeground(u);const d=this.getFontStyle(u);return d&i.Italic&&(E+=" mtki"),d&i.Bold&&(E+=" mtkb"),d&i.Underline&&(E+=" mtku"),d&i.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(u,g){const E=this.getForeground(u),d=this.getFontStyle(u);let c=`color: ${g[E]};`;d&i.Italic&&(c+="font-style: italic;"),d&i.Bold&&(c+="font-weight: bold;");let e="";return d&i.Underline&&(e+=" underline"),d&i.Strikethrough&&(e+=" line-through"),e&&(c+=`text-decoration:${e};`),c}static getPresentationFromMetadata(u){const g=this.getForeground(u),E=this.getFontStyle(u);return{foreground:g,italic:!!(E&i.Italic),bold:!!(E&i.Bold),underline:!!(E&i.Underline),strikethrough:!!(E&i.Strikethrough)}}}t.$Bu=b}),ie(se[66],ue([0,1,41]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$t5=E;function i(d){const c=[];for(const e of d){const l=Number(e);(l||l===0&&e.replace(/\s/g,"")!=="")&&c.push(l)}return c}function T(d,c,e,l){return{red:d/255,blue:e/255,green:c/255,alpha:l}}function m(d,c){const e=c.index,l=c[0].length;if(!e)return;const h=d.positionAt(e);return{startLineNumber:h.lineNumber,startColumn:h.column,endLineNumber:h.lineNumber,endColumn:h.column+l}}function A(d,c){if(!d)return;const e=n.$uu.Format.CSS.parseHex(c);if(e)return{range:d,color:T(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function b(d,c,e){if(!d||c.length!==1)return;const h=c[0].values(),w=i(h);return{range:d,color:T(w[0],w[1],w[2],e?w[3]:1)}}function a(d,c,e){if(!d||c.length!==1)return;const h=c[0].values(),w=i(h),L=new n.$uu(new n.$su(w[0],w[1]/100,w[2]/100,e?w[3]:1));return{range:d,color:T(L.rgba.r,L.rgba.g,L.rgba.b,L.rgba.a)}}function u(d,c){return typeof d=="string"?[...d.matchAll(c)]:d.findMatches(c)}function g(d){const c=[],l=u(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(l.length>0)for(const h of l){const w=h.filter($=>$!==void 0),L=w[1],N=w[2];if(!N)continue;let _;if(L==="rgb"){const $=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;_=b(m(d,h),u(N,$),!1)}else if(L==="rgba"){const $=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;_=b(m(d,h),u(N,$),!0)}else if(L==="hsl"){const $=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;_=a(m(d,h),u(N,$),!1)}else if(L==="hsla"){const $=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;_=a(m(d,h),u(N,$),!0)}else L==="#"&&(_=A(m(d,h),L+N));_&&c.push(_)}return c}function E(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:g(d)}}),ie(se[67],ue([0,1,3,33]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$44=t.$34=t.State=void 0,t.$54=c;var T;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(T||(t.State=T={}));class m{constructor(l,h,w){const L=new Uint8Array(l*h);for(let N=0,_=l*h;N<_;N++)L[N]=w;this.a=L,this.rows=l,this.cols=h}get(l,h){return this.a[l*this.cols+h]}set(l,h,w){this.a[l*this.cols+h]=w}}class A{constructor(l){let h=0,w=T.Invalid;for(let N=0,_=l.length;N<_;N++){const[$,o,s]=l[N];o>h&&(h=o),$>w&&(w=$),s>w&&(w=s)}h++,w++;const L=new m(w,h,T.Invalid);for(let N=0,_=l.length;N<_;N++){const[$,o,s]=l[N];L.set($,o,s)}this.a=L,this.b=h}nextState(l,h){return h<0||h>=this.b?T.Invalid:this.a.get(l,h)}}t.$34=A;let b=null;function a(){return b===null&&(b=new A([[T.Start,n.CharCode.h,T.H],[T.Start,n.CharCode.H,T.H],[T.Start,n.CharCode.f,T.F],[T.Start,n.CharCode.F,T.F],[T.H,n.CharCode.t,T.HT],[T.H,n.CharCode.T,T.HT],[T.HT,n.CharCode.t,T.HTT],[T.HT,n.CharCode.T,T.HTT],[T.HTT,n.CharCode.p,T.HTTP],[T.HTT,n.CharCode.P,T.HTTP],[T.HTTP,n.CharCode.s,T.BeforeColon],[T.HTTP,n.CharCode.S,T.BeforeColon],[T.HTTP,n.CharCode.Colon,T.AfterColon],[T.F,n.CharCode.i,T.FI],[T.F,n.CharCode.I,T.FI],[T.FI,n.CharCode.l,T.FIL],[T.FI,n.CharCode.L,T.FIL],[T.FIL,n.CharCode.e,T.BeforeColon],[T.FIL,n.CharCode.E,T.BeforeColon],[T.BeforeColon,n.CharCode.Colon,T.AfterColon],[T.AfterColon,n.CharCode.Slash,T.AlmostThere],[T.AlmostThere,n.CharCode.Slash,T.End]])),b}var u;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let g=null;function E(){if(g===null){g=new i.$nu(u.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)g.set(e.charCodeAt(h),u.ForceTermination);const l=".,;:";for(let h=0;h<l.length;h++)g.set(l.charCodeAt(h),u.CannotEndIn)}return g}class d{static a(l,h,w,L,N){let _=N-1;do{const $=h.charCodeAt(_);if(l.get($)!==u.CannotEndIn)break;_--}while(_>L);if(L>0){const $=h.charCodeAt(L-1),o=h.charCodeAt(_);($===n.CharCode.OpenParen&&o===n.CharCode.CloseParen||$===n.CharCode.OpenSquareBracket&&o===n.CharCode.CloseSquareBracket||$===n.CharCode.OpenCurlyBrace&&o===n.CharCode.CloseCurlyBrace)&&_--}return{range:{startLineNumber:w,startColumn:L+1,endLineNumber:w,endColumn:_+2},url:h.substring(L,_+1)}}static computeLinks(l,h=a()){const w=E(),L=[];for(let N=1,_=l.getLineCount();N<=_;N++){const $=l.getLineContent(N),o=$.length;let s=0,f=0,v=0,k=T.Start,R=!1,j=!1,M=!1,p=!1;for(;s<o;){let D=!1;const I=$.charCodeAt(s);if(k===T.Accept){let F;switch(I){case n.CharCode.OpenParen:R=!0,F=u.None;break;case n.CharCode.CloseParen:F=R?u.None:u.ForceTermination;break;case n.CharCode.OpenSquareBracket:M=!0,j=!0,F=u.None;break;case n.CharCode.CloseSquareBracket:M=!1,F=j?u.None:u.ForceTermination;break;case n.CharCode.OpenCurlyBrace:p=!0,F=u.None;break;case n.CharCode.CloseCurlyBrace:F=p?u.None:u.ForceTermination;break;case n.CharCode.SingleQuote:case n.CharCode.DoubleQuote:case n.CharCode.BackTick:v===I?F=u.ForceTermination:v===n.CharCode.SingleQuote||v===n.CharCode.DoubleQuote||v===n.CharCode.BackTick?F=u.None:F=u.ForceTermination;break;case n.CharCode.Asterisk:F=v===n.CharCode.Asterisk?u.ForceTermination:u.None;break;case n.CharCode.Pipe:F=v===n.CharCode.Pipe?u.ForceTermination:u.None;break;case n.CharCode.Space:F=M?u.None:u.ForceTermination;break;default:F=w.get(I)}F===u.ForceTermination&&(L.push(d.a(w,$,N,f,s)),D=!0)}else if(k===T.End){let F;I===n.CharCode.OpenSquareBracket?(j=!0,F=u.None):F=w.get(I),F===u.ForceTermination?D=!0:k=T.Accept}else k=h.nextState(k,I),k===T.Invalid&&(D=!0);D&&(k=T.Start,R=!1,j=!1,p=!1,f=s+1,v=I),s++}k===T.Accept&&L.push(d.a(w,$,N,f,o))}return L}}t.$44=d;function c(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:d.computeLinks(e)}}),ie(se[68],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$64=void 0;class n{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new n}navigateValueSet(T,m,A,b,a){if(T&&m){const u=this.a(m,a);if(u)return{range:T,value:u}}if(A&&b){const u=this.a(b,a);if(u)return{range:A,value:u}}return null}a(T,m){const A=this.b(T,m);return A!==null?A:this.d(T,m)}b(T,m){const A=Math.pow(10,T.length-(T.lastIndexOf(".")+1));let b=Number(T);const a=parseFloat(T);return!isNaN(b)&&!isNaN(a)&&b===a?b===0&&!m?null:(b=Math.floor(b*A),b+=m?A:-A,String(b/A)):null}d(T,m){return this.e(this.c,T,m)}e(T,m,A){let b=null;for(let a=0,u=T.length;b===null&&a<u;a++)b=this.f(T[a],m,A);return b}f(T,m,A){let b=T.indexOf(m);return b>=0?(b+=A?1:-1,b<0?b=T.length-1:b%=T.length,T[b]):null}}t.$64=n}),ie(se[69],ue([0,1,31]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pw=t.$ow=t.$nw=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$lw=t.$kw=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$mw=e,t.$qw=_;var i;(function($){$[$.Left=1]="Left",$[$.Center=2]="Center",$[$.Right=4]="Right",$[$.Full=7]="Full"})(i||(t.OverviewRulerLane=i={}));var T;(function($){$[$.Left=1]="Left",$[$.Center=2]="Center",$[$.Right=3]="Right"})(T||(t.GlyphMarginLane=T={}));var m;(function($){$[$.Inline=1]="Inline",$[$.Gutter=2]="Gutter"})(m||(t.MinimapPosition=m={}));var A;(function($){$[$.Normal=1]="Normal",$[$.Underlined=2]="Underlined"})(A||(t.MinimapSectionHeaderStyle=A={}));var b;(function($){$[$.Both=0]="Both",$[$.Right=1]="Right",$[$.Left=2]="Left",$[$.None=3]="None"})(b||(t.InjectedTextCursorStops=b={}));var a;(function($){$[$.TextDefined=0]="TextDefined",$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(a||(t.EndOfLinePreference=a={}));var u;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var g;(function($){$[$.LF=0]="LF",$[$.CRLF=1]="CRLF"})(g||(t.EndOfLineSequence=g={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,n.$mo)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}t.$kw=E;class d{constructor(o,s){this._findMatchBrand=void 0,this.range=o,this.matches=s}}t.$lw=d;var c;(function($){$[$.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",$[$.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",$[$.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",$[$.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(c||(t.TrackedRangeStickiness=c={}));function e($){return $&&typeof $.read=="function"}var l;(function($){$[$.Left=0]="Left",$[$.Right=1]="Right",$[$.None=2]="None",$[$.LeftOfInjectedText=3]="LeftOfInjectedText",$[$.RightOfInjectedText=4]="RightOfInjectedText"})(l||(t.PositionAffinity=l={}));var h;(function($){$[$.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(h||(t.ModelConstants=h={}));class w{constructor(o,s,f,v,k,R){this.identifier=o,this.range=s,this.text=f,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=k,this._isTracked=R}}t.$nw=w;class L{constructor(o,s,f){this.regex=o,this.wordSeparators=s,this.simpleSearch=f}}t.$ow=L;class N{constructor(o,s,f){this.reverseEdits=o,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}t.$pw=N;function _($){return!$.isTooLargeForSyncing()&&!$.isForSimpleWidget}}),ie(se[70],ue([0,1,9,17]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vw=t.$uw=t.$tw=void 0;class T{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,u){a=(0,i.$ef)(a);const g=this.a,E=this.b,d=u.length;return d===0?!1:(this.a=new Uint32Array(g.length+d),this.a.set(g.subarray(0,a),0),this.a.set(g.subarray(a),a+d),this.a.set(u,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(a,u){return a=(0,i.$ef)(a),u=(0,i.$ef)(u),this.a[a]===u?!1:(this.a[a]=u,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,u){a=(0,i.$ef)(a),u=(0,i.$ef)(u);const g=this.a,E=this.b;if(a>=g.length)return!1;const d=g.length-a;return u>=d&&(u=d),u===0?!1:(this.a=new Uint32Array(g.length-u),this.a.set(g.subarray(0,a),0),this.a.set(g.subarray(a+u),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,i.$ef)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),a>=this.a.length&&(a=this.a.length-1);for(let g=u;g<=a;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let u=0,g=this.a.length-1,E=0,d=0,c=0;for(;u<=g;)if(E=u+(g-u)/2|0,d=this.b[E],c=d-this.a[E],a<c)g=E-1;else if(a>=d)u=E+1;else break;return new A(E,a-c)}}t.$tw=T;class m{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const u=this.e[a],g=u>0?this.d[u-1]:0;return new A(u,a-g)}removeValues(a,u){this.a.splice(a,u),this.f(a)}insertValues(a,u){this.a=(0,n.$Xb)(this.a,a,u),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,u=this.a.length;a<u;a++){const g=this.a[a],E=a>0?this.d[a-1]:0;this.d[a]=E+g;for(let d=0;d<g;d++)this.e[E+d]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,u){this.a[a]!==u&&(this.a[a]=u,this.f(a))}}t.$uw=m;class A{constructor(a,u){this.index=a,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=u}}t.$vw=A}),ie(se[71],ue([0,1,6,5,70]),function(W,t,n,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ww=void 0;class m{constructor(b,a,u,g){this.a=b,this.b=a,this.c=u,this.d=g,this.f=null,this.g=null}dispose(){this.b.length=0}get version(){return this.d}getText(){return this.g===null&&(this.g=this.b.join(this.c)),this.g}onEvents(b){b.eol&&b.eol!==this.c&&(this.c=b.eol,this.f=null);const a=b.changes;for(const u of a)this.k(u.range),this.l(new i.$Tt(u.range.startLineNumber,u.range.startColumn),u.text);this.d=b.versionId,this.g=null}h(){if(!this.f){const b=this.c.length,a=this.b.length,u=new Uint32Array(a);for(let g=0;g<a;g++)u[g]=this.b[g].length+b;this.f=new T.$tw(u)}}j(b,a){this.b[b]=a,this.f&&this.f.setValue(b,this.b[b].length+this.c.length)}k(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.j(b.startLineNumber-1,this.b[b.startLineNumber-1].substring(0,b.startColumn-1)+this.b[b.startLineNumber-1].substring(b.endColumn-1));return}this.j(b.startLineNumber-1,this.b[b.startLineNumber-1].substring(0,b.startColumn-1)+this.b[b.endLineNumber-1].substring(b.endColumn-1)),this.b.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.f&&this.f.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}l(b,a){if(a.length===0)return;const u=(0,n.$vf)(a);if(u.length===1){this.j(b.lineNumber-1,this.b[b.lineNumber-1].substring(0,b.column-1)+u[0]+this.b[b.lineNumber-1].substring(b.column-1));return}u[u.length-1]+=this.b[b.lineNumber-1].substring(b.column-1),this.j(b.lineNumber-1,this.b[b.lineNumber-1].substring(0,b.column-1)+u[0]);const g=new Uint32Array(u.length-1);for(let E=1;E<u.length;E++)this.b.splice(b.lineNumber+E-1,0,u[E]),g[E-1]=u[E].length+this.c.length;this.f&&this.f.insertValues(b.lineNumber,g)}}t.$ww=m}),ie(se[72],ue([0,1,3,6,58,5,2,69]),function(W,t,n,i,T,m,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AD=t.$yD=t.$vD=void 0,t.$wD=g,t.$xD=E,t.$zD=h,i=ke(i);const a=999;class u{constructor(N,_,$,o){this.searchString=N,this.isRegex=_,this.matchCase=$,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let N;this.isRegex?N=g(this.searchString):N=this.searchString.indexOf(`
`)>=0;let _=null;try{_=i.$tf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:N,global:!0,unicode:!0})}catch{return null}if(!_)return null;let $=!this.isRegex&&!N;return $&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&($=this.matchCase),new b.$ow(_,this.wordSeparators?(0,T.$qu)(this.wordSeparators,[]):null,$?this.searchString:null)}}t.$vD=u;function g(L){if(!L||L.length===0)return!1;for(let N=0,_=L.length;N<_;N++){const $=L.charCodeAt(N);if($===n.CharCode.LineFeed)return!0;if($===n.CharCode.Backslash){if(N++,N>=_)break;const o=L.charCodeAt(N);if(o===n.CharCode.n||o===n.CharCode.r||o===n.CharCode.W)return!0}}return!1}function E(L,N,_){if(!_)return new b.$lw(L,null);const $=[];for(let o=0,s=N.length;o<s;o++)$[o]=N[o];return new b.$lw(L,$)}class d{constructor(N){const _=[];let $=0;for(let o=0,s=N.length;o<s;o++)N.charCodeAt(o)===n.CharCode.LineFeed&&(_[$++]=o);this.a=_}findLineFeedCountBeforeOffset(N){const _=this.a;let $=0,o=_.length-1;if(o===-1||N<=_[0])return 0;for(;$<o;){const s=$+((o-$)/2>>0);_[s]>=N?o=s-1:_[s+1]>=N?($=s,o=s):$=s+1}return $+1}}class c{static findMatches(N,_,$,o,s){const f=_.parseSearchRequest();return f?f.regex.multiline?this.b(N,$,new w(f.wordSeparators,f.regex),o,s):this.c(N,$,f,o,s):[]}static a(N,_,$,o,s,f){let v,k=0;o?(k=o.findLineFeedCountBeforeOffset(s),v=_+s+k):v=_+s;let R;if(o){const D=o.findLineFeedCountBeforeOffset(s+f.length)-k;R=v+f.length+D}else R=v+f.length;const j=N.getPositionAt(v),M=N.getPositionAt(R);return new A.$Ut(j.lineNumber,j.column,M.lineNumber,M.column)}static b(N,_,$,o,s){const f=N.getOffsetAt(_.getStartPosition()),v=N.getValueInRange(_,b.EndOfLinePreference.LF),k=N.getEOL()===`\r
`?new d(v):null,R=[];let j=0,M;for($.reset(0);M=$.next(v);)if(R[j++]=E(this.a(N,f,v,k,M.index,M[0]),M,o),j>=s)return R;return R}static c(N,_,$,o,s){const f=[];let v=0;if(_.startLineNumber===_.endLineNumber){const R=N.getLineContent(_.startLineNumber).substring(_.startColumn-1,_.endColumn-1);return v=this.d($,R,_.startLineNumber,_.startColumn-1,v,f,o,s),f}const k=N.getLineContent(_.startLineNumber).substring(_.startColumn-1);v=this.d($,k,_.startLineNumber,_.startColumn-1,v,f,o,s);for(let R=_.startLineNumber+1;R<_.endLineNumber&&v<s;R++)v=this.d($,N.getLineContent(R),R,0,v,f,o,s);if(v<s){const R=N.getLineContent(_.endLineNumber).substring(0,_.endColumn-1);v=this.d($,R,_.endLineNumber,0,v,f,o,s)}return f}static d(N,_,$,o,s,f,v,k){const R=N.wordSeparators;if(!v&&N.simpleSearch){const p=N.simpleSearch,D=p.length,I=_.length;let F=-D;for(;(F=_.indexOf(p,F+D))!==-1;)if((!R||h(R,_,I,F,D))&&(f[s++]=new b.$lw(new A.$Ut($,F+1+o,$,F+1+D+o),null),s>=k))return s;return s}const j=new w(N.wordSeparators,N.regex);let M;j.reset(0);do if(M=j.next(_),M&&(f[s++]=E(new A.$Ut($,M.index+1+o,$,M.index+1+M[0].length+o),M,v),s>=k))return s;while(M);return s}static findNextMatch(N,_,$,o){const s=_.parseSearchRequest();if(!s)return null;const f=new w(s.wordSeparators,s.regex);return s.regex.multiline?this.e(N,$,f,o):this.f(N,$,f,o)}static e(N,_,$,o){const s=new m.$Tt(_.lineNumber,1),f=N.getOffsetAt(s),v=N.getLineCount(),k=N.getValueInRange(new A.$Ut(s.lineNumber,s.column,v,N.getLineMaxColumn(v)),b.EndOfLinePreference.LF),R=N.getEOL()===`\r
`?new d(k):null;$.reset(_.column-1);const j=$.next(k);return j?E(this.a(N,f,k,R,j.index,j[0]),j,o):_.lineNumber!==1||_.column!==1?this.e(N,new m.$Tt(1,1),$,o):null}static f(N,_,$,o){const s=N.getLineCount(),f=_.lineNumber,v=N.getLineContent(f),k=this.g($,v,f,_.column,o);if(k)return k;for(let R=1;R<=s;R++){const j=(f+R-1)%s,M=N.getLineContent(j+1),p=this.g($,M,j+1,1,o);if(p)return p}return null}static g(N,_,$,o,s){N.reset(o-1);const f=N.next(_);return f?E(new A.$Ut($,f.index+1,$,f.index+1+f[0].length),f,s):null}static findPreviousMatch(N,_,$,o){const s=_.parseSearchRequest();if(!s)return null;const f=new w(s.wordSeparators,s.regex);return s.regex.multiline?this.h(N,$,f,o):this.j(N,$,f,o)}static h(N,_,$,o){const s=this.b(N,new A.$Ut(1,1,_.lineNumber,_.column),$,o,10*a);if(s.length>0)return s[s.length-1];const f=N.getLineCount();return _.lineNumber!==f||_.column!==N.getLineMaxColumn(f)?this.h(N,new m.$Tt(f,N.getLineMaxColumn(f)),$,o):null}static j(N,_,$,o){const s=N.getLineCount(),f=_.lineNumber,v=N.getLineContent(f).substring(0,_.column-1),k=this.k($,v,f,o);if(k)return k;for(let R=1;R<=s;R++){const j=(s+f-R-1)%s,M=N.getLineContent(j+1),p=this.k($,M,j+1,o);if(p)return p}return null}static k(N,_,$,o){let s=null,f;for(N.reset(0);f=N.next(_);)s=E(new A.$Ut($,f.index+1,$,f.index+1+f[0].length),f,o);return s}}t.$yD=c;function e(L,N,_,$,o){if($===0)return!0;const s=N.charCodeAt($-1);if(L.get(s)!==T.WordCharacterClass.Regular||s===n.CharCode.CarriageReturn||s===n.CharCode.LineFeed)return!0;if(o>0){const f=N.charCodeAt($);if(L.get(f)!==T.WordCharacterClass.Regular)return!0}return!1}function l(L,N,_,$,o){if($+o===_)return!0;const s=N.charCodeAt($+o);if(L.get(s)!==T.WordCharacterClass.Regular||s===n.CharCode.CarriageReturn||s===n.CharCode.LineFeed)return!0;if(o>0){const f=N.charCodeAt($+o-1);if(L.get(f)!==T.WordCharacterClass.Regular)return!0}return!1}function h(L,N,_,$,o){return e(L,N,_,$,o)&&l(L,N,_,$,o)}class w{constructor(N,_){this._wordSeparators=N,this.a=_,this.b=-1,this.c=0}reset(N){this.a.lastIndex=N,this.b=-1,this.c=0}next(N){const _=N.length;let $;do{if(this.b+this.c===_||($=this.a.exec(N),!$))return null;const o=$.index,s=$[0].length;if(o===this.b&&s===this.c){if(s===0){i.$Pf(N,_,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=s,!this._wordSeparators||h(this._wordSeparators,N,_,o,s))return $}while($);return null}}t.$AD=w}),ie(se[73],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$94=void 0;class n{static{this.CHANNEL_NAME="editorWorkerHost"}static getChannel(T){return T.getChannel(n.CHANNEL_NAME)}static setChannel(T,m){T.setChannel(n.CHANNEL_NAME,m)}}t.$94=n}),ie(se[74],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$u5=T;const n=new RegExp("\\bMARK:\\s*(.*)$","d"),i=/^-+|-+$/g;function T(u,g){let E=[];if(g.findRegionSectionHeaders&&g.foldingRules?.markers){const d=m(u,g);E=E.concat(d)}if(g.findMarkSectionHeaders){const d=A(u);E=E.concat(d)}return E}function m(u,g){const E=[],d=u.getLineCount();for(let c=1;c<=d;c++){const e=u.getLineContent(c),l=e.match(g.foldingRules.markers.start);if(l){const h={startLineNumber:c,startColumn:l[0].length+1,endLineNumber:c,endColumn:e.length+1};if(h.endColumn>h.startColumn){const w={range:h,...a(e.substring(l[0].length)),shouldBeInComments:!1};(w.text||w.hasSeparatorLine)&&E.push(w)}}}return E}function A(u){const g=[],E=u.getLineCount();for(let d=1;d<=E;d++){const c=u.getLineContent(d);b(c,d,g)}return g}function b(u,g,E){n.lastIndex=0;const d=n.exec(u);if(d){const c=d.indices[1][0]+1,e=d.indices[1][1]+1,l={startLineNumber:g,startColumn:c,endLineNumber:g,endColumn:e};if(l.endColumn>l.startColumn){const h={range:l,...a(d[1]),shouldBeInComments:!0};(h.text||h.hasSeparatorLine)&&E.push(h)}}}function a(u){u=u.trim();const g=u.startsWith("-");return u=u.replace(i,""),{text:u,hasSeparatorLine:g}}}),ie(se[75],ue([0,1,53,10,13,5,2,35,71]),function(W,t,n,i,T,m,A,b,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z5=t.$y5=t.$x5=t.$w5=t.$v5=void 0,t.$v5=60*1e3,t.$w5="workerTextModelSync";class u extends i.$Xc{static create(c,e){return new u(c.getChannel(t.$w5),e)}constructor(c,e,l=!1){if(super(),this.c=Object.create(null),this.f=Object.create(null),this.a=c,this.b=e,!l){const h=new n.$Th;h.cancelAndSet(()=>this.g(),Math.round(t.$v5/2)),this.B(h)}}dispose(){for(const c in this.c)(0,i.$Sc)(this.c[c]);this.c=Object.create(null),this.f=Object.create(null),super.dispose()}ensureSyncedResources(c,e=!1){for(const l of c){const h=l.toString();this.c[h]||this.h(l,e),this.c[h]&&(this.f[h]=new Date().getTime())}}g(){const c=new Date().getTime(),e=[];for(const l in this.f)c-this.f[l]>t.$v5&&e.push(l);for(const l of e)this.j(l)}h(c,e){const l=this.b.getModel(c);if(!l||!e&&l.isTooLargeForSyncing())return;const h=c.toString();this.a.$acceptNewModel({url:l.uri.toString(),lines:l.getLinesContent(),EOL:l.getEOL(),versionId:l.getVersionId()});const w=new i.$Wc;w.add(l.onDidChangeContent(L=>{this.a.$acceptModelChanged(h.toString(),L)})),w.add(l.onWillDispose(()=>{this.j(h)})),w.add((0,i.$Vc)(()=>{this.a.$acceptRemovedModel(h)})),this.c[h]=w}j(c){const e=this.c[c];delete this.c[c],delete this.f[c],(0,i.$Sc)(e)}}t.$x5=u;class g{constructor(){this.a=Object.create(null)}bindToServer(c){c.setChannel(t.$w5,this)}getModel(c){return this.a[c]}getModels(){const c=[];return Object.keys(this.a).forEach(e=>c.push(this.a[e])),c}$acceptNewModel(c){this.a[c.url]=new E(T.URI.parse(c.url),c.lines,c.EOL,c.versionId)}$acceptModelChanged(c,e){if(!this.a[c])return;this.a[c].onEvents(e)}$acceptRemovedModel(c){this.a[c]&&delete this.a[c]}}t.$y5=g;class E extends a.$ww{get uri(){return this.a}get eol(){return this.c}getValue(){return this.getText()}findMatches(c){const e=[];for(let l=0;l<this.b.length;l++){const h=this.b[l],w=this.offsetAt(new m.$Tt(l+1,1)),L=h.matchAll(c);for(const N of L)(N.index||N.index===0)&&(N.index=N.index+w),e.push(N)}return e}getLinesContent(){return this.b.slice(0)}getLineCount(){return this.b.length}getLineContent(c){return this.b[c-1]}getWordAtPosition(c,e){const l=(0,b.$wt)(c.column,(0,b.$ut)(e),this.b[c.lineNumber-1],0);return l?new A.$Ut(c.lineNumber,l.startColumn,c.lineNumber,l.endColumn):null}getWordUntilPosition(c,e){const l=this.getWordAtPosition(c,e);return l?{word:this.b[c.lineNumber-1].substring(l.startColumn-1,c.column-1),startColumn:l.startColumn,endColumn:c.column}:{word:"",startColumn:c.column,endColumn:c.column}}words(c){const e=this.b,l=this.m.bind(this);let h=0,w="",L=0,N=[];return{*[Symbol.iterator](){for(;;)if(L<N.length){const _=w.substring(N[L].start,N[L].end);L+=1,yield _}else if(h<e.length)w=e[h],N=l(w,c),L=0,h+=1;else break}}}getLineWords(c,e){const l=this.b[c-1],h=this.m(l,e),w=[];for(const L of h)w.push({word:l.substring(L.start,L.end),startColumn:L.start+1,endColumn:L.end+1});return w}m(c,e){const l=[];let h;for(e.lastIndex=0;(h=e.exec(c))&&h[0].length!==0;)l.push({start:h.index,end:h.index+h[0].length});return l}getValueInRange(c){if(c=this.n(c),c.startLineNumber===c.endLineNumber)return this.b[c.startLineNumber-1].substring(c.startColumn-1,c.endColumn-1);const e=this.c,l=c.startLineNumber-1,h=c.endLineNumber-1,w=[];w.push(this.b[l].substring(c.startColumn-1));for(let L=l+1;L<h;L++)w.push(this.b[L]);return w.push(this.b[h].substring(0,c.endColumn-1)),w.join(e)}offsetAt(c){return c=this.o(c),this.h(),this.f.getPrefixSum(c.lineNumber-2)+(c.column-1)}positionAt(c){c=Math.floor(c),c=Math.max(0,c),this.h();const e=this.f.getIndexOf(c),l=this.b[e.index].length;return{lineNumber:1+e.index,column:1+Math.min(e.remainder,l)}}n(c){const e=this.o({lineNumber:c.startLineNumber,column:c.startColumn}),l=this.o({lineNumber:c.endLineNumber,column:c.endColumn});return e.lineNumber!==c.startLineNumber||e.column!==c.startColumn||l.lineNumber!==c.endLineNumber||l.column!==c.endColumn?{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:l.lineNumber,endColumn:l.column}:c}o(c){if(!m.$Tt.isIPosition(c))throw new Error("bad position");let{lineNumber:e,column:l}=c,h=!1;if(e<1)e=1,l=1,h=!0;else if(e>this.b.length)e=this.b.length,l=this.b[e-1].length+1,h=!0;else{const w=this.b[e-1].length+1;l<1?(l=1,h=!0):l>w&&(l=w,h=!0)}return h?{lineNumber:e,column:l}:c}}t.$z5=E}),ie(se[76],ue([0,1,2,72,6,15,35]),function(W,t,n,i,T,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$24=void 0,T=ke(T);class b{static computeUnicodeHighlights(e,l,h){const w=h?h.startLineNumber:1,L=h?h.endLineNumber:e.getLineCount(),N=new g(l),_=N.getCandidateCodePoints();let $;_==="allNonBasicAscii"?$=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):$=new RegExp(`${a(Array.from(_))}`,"g");const o=new i.$AD(null,$),s=[];let f=!1,v,k=0,R=0,j=0;e:for(let M=w,p=L;M<=p;M++){const D=e.getLineContent(M),I=D.length;o.reset(0);do if(v=o.next(D),v){let F=v.index,q=v.index+v[0].length;if(F>0){const C=D.charCodeAt(F-1);T.$Mf(C)&&F--}if(q+1<I){const C=D.charCodeAt(q-1);T.$Mf(C)&&q++}const z=D.substring(F,q);let H=(0,A.$wt)(F+1,A.$tt,D,0);H&&H.endColumn<=F+1&&(H=null);const U=N.shouldHighlightNonBasicASCII(z,H?H.word:null);if(U!==d.None){if(U===d.Ambiguous?k++:U===d.Invisible?R++:U===d.NonBasicASCII?j++:(0,m.$hd)(U),s.length>=1e3){f=!0;break e}s.push(new n.$Ut(M,F+1,M,q+1))}}while(v)}return{ranges:s,hasMore:f,ambiguousCharacterCount:k,invisibleCharacterCount:R,nonBasicAsciiCharacterCount:j}}static computeUnicodeHighlightReason(e,l){const h=new g(l);switch(h.shouldHighlightNonBasicASCII(e,null)){case d.None:return null;case d.Invisible:return{kind:u.Invisible};case d.Ambiguous:{const L=e.codePointAt(0),N=h.ambiguousCharacters.getPrimaryConfusable(L),_=T.$fg.getLocales().filter($=>!T.$fg.getInstance(new Set([...l.allowedLocales,$])).isAmbiguous(L));return{kind:u.Ambiguous,confusableWith:String.fromCodePoint(N),notAmbiguousInLocales:_}}case d.NonBasicASCII:return{kind:u.NonBasicAscii}}}}t.$24=b;function a(c,e){return`[${T.$kf(c.map(h=>String.fromCodePoint(h)).join(""))}]`}var u;(function(c){c[c.Ambiguous=0]="Ambiguous",c[c.Invisible=1]="Invisible",c[c.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=T.$fg.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const l of T.$gg.codePoints)E(String.fromCodePoint(l))||e.add(l);if(this.b.ambiguousCharacters)for(const l of this.ambiguousCharacters.getConfusableCodePoints())e.add(l);for(const l of this.a)e.delete(l);return e}shouldHighlightNonBasicASCII(e,l){const h=e.codePointAt(0);if(this.a.has(h))return d.None;if(this.b.nonBasicASCII)return d.NonBasicASCII;let w=!1,L=!1;if(l)for(const N of l){const _=N.codePointAt(0),$=T.$Xf(N);w=w||$,!$&&!this.ambiguousCharacters.isAmbiguous(_)&&!T.$gg.isInvisibleCharacter(_)&&(L=!0)}return!w&&L?d.None:this.b.invisibleCharacters&&!E(e)&&T.$gg.isInvisibleCharacter(h)?d.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(h)?d.Ambiguous:d.None}}function E(c){return c===" "||c===`
`||c==="	"}var d;(function(c){c[c.None=0]="None",c[c.NonBasicASCII=1]="NonBasicASCII",c[c.Invisible=2]="Invisible",c[c.Ambiguous=3]="Ambiguous"})(d||(d={}))}),ie(se[77],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.HoverVerbosityAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var n;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(n||(t.AccessibilitySupport=n={}));var i;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(i||(t.CodeActionTriggerType=i={}));var T;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(T||(t.CompletionItemInsertTextRule=T={}));var m;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(m||(t.CompletionItemKind=m={}));var A;(function(r){r[r.Deprecated=1]="Deprecated"})(A||(t.CompletionItemTag=A={}));var b;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b||(t.CompletionTriggerKind=b={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var g;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var E;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var d;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(d||(t.EditorAutoIndentStrategy=d={}));var c;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.placeholder=88]="placeholder",r[r.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",r[r.quickSuggestions=90]="quickSuggestions",r[r.quickSuggestionsDelay=91]="quickSuggestionsDelay",r[r.readOnly=92]="readOnly",r[r.readOnlyMessage=93]="readOnlyMessage",r[r.renameOnType=94]="renameOnType",r[r.renderControlCharacters=95]="renderControlCharacters",r[r.renderFinalNewline=96]="renderFinalNewline",r[r.renderLineHighlight=97]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=99]="renderValidationDecorations",r[r.renderWhitespace=100]="renderWhitespace",r[r.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",r[r.roundedSelection=102]="roundedSelection",r[r.rulers=103]="rulers",r[r.scrollbar=104]="scrollbar",r[r.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=106]="scrollBeyondLastLine",r[r.scrollPredominantAxis=107]="scrollPredominantAxis",r[r.selectionClipboard=108]="selectionClipboard",r[r.selectionHighlight=109]="selectionHighlight",r[r.selectOnLineNumbers=110]="selectOnLineNumbers",r[r.showFoldingControls=111]="showFoldingControls",r[r.showUnused=112]="showUnused",r[r.snippetSuggestions=113]="snippetSuggestions",r[r.smartSelect=114]="smartSelect",r[r.smoothScrolling=115]="smoothScrolling",r[r.stickyScroll=116]="stickyScroll",r[r.stickyTabStops=117]="stickyTabStops",r[r.stopRenderingLineAfter=118]="stopRenderingLineAfter",r[r.suggest=119]="suggest",r[r.suggestFontSize=120]="suggestFontSize",r[r.suggestLineHeight=121]="suggestLineHeight",r[r.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",r[r.suggestSelection=123]="suggestSelection",r[r.tabCompletion=124]="tabCompletion",r[r.tabIndex=125]="tabIndex",r[r.unicodeHighlighting=126]="unicodeHighlighting",r[r.unusualLineTerminators=127]="unusualLineTerminators",r[r.useShadowDOM=128]="useShadowDOM",r[r.useTabStops=129]="useTabStops",r[r.wordBreak=130]="wordBreak",r[r.wordSegmenterLocales=131]="wordSegmenterLocales",r[r.wordSeparators=132]="wordSeparators",r[r.wordWrap=133]="wordWrap",r[r.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=136]="wordWrapColumn",r[r.wordWrapOverride1=137]="wordWrapOverride1",r[r.wordWrapOverride2=138]="wordWrapOverride2",r[r.wrappingIndent=139]="wrappingIndent",r[r.wrappingStrategy=140]="wrappingStrategy",r[r.showDeprecated=141]="showDeprecated",r[r.inlayHints=142]="inlayHints",r[r.editorClassName=143]="editorClassName",r[r.pixelRatio=144]="pixelRatio",r[r.tabFocusMode=145]="tabFocusMode",r[r.layoutInfo=146]="layoutInfo",r[r.wrappingInfo=147]="wrappingInfo",r[r.defaultColorDecorators=148]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(c||(t.EditorOption=c={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var l;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));var h;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(h||(t.GlyphMarginLane=h={}));var w;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(w||(t.HoverVerbosityAction=w={}));var L;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var N;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var _;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(_||(t.InlayHintKind=_={}));var $;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})($||(t.InlineCompletionTriggerKind=$={}));var o;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(o||(t.InlineEditTriggerKind=o={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var f;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(f||(t.MarkerSeverity=f={}));var v;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(v||(t.MarkerTag=v={}));var k;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(k||(t.MinimapPosition=k={}));var R;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(R||(t.MinimapSectionHeaderStyle=R={}));var j;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(j||(t.MouseTargetType=j={}));var M;(function(r){r[r.AIGenerated=1]="AIGenerated"})(M||(t.NewSymbolNameTag=M={}));var p;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(p||(t.NewSymbolNameTriggerKind=p={}));var D;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(D||(t.OverlayWidgetPositionPreference=D={}));var I;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(I||(t.OverviewRulerLane=I={}));var F;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(F||(t.PartialAcceptTriggerKind=F={}));var q;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(q||(t.PositionAffinity=q={}));var z;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(z||(t.RenderLineNumbersType=z={}));var H;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(H||(t.RenderMinimap=H={}));var U;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(U||(t.ScrollType=U={}));var C;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(C||(t.ScrollbarVisibility=C={}));var ee;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(ee||(t.SelectionDirection=ee={}));var J;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(J||(t.ShowLightbulbIconMode=J={}));var K;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(K||(t.SignatureHelpTriggerKind=K={}));var ne;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(ne||(t.SymbolKind=ne={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P||(t.SymbolTag=P={}));var X;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(X||(t.TextEditorCursorBlinkingStyle=X={}));var he;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(he||(t.TextEditorCursorStyle=he={}));var ge;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ge||(t.TrackedRangeStickiness=ge={}));var Ee;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(Ee||(t.WrappingIndent=Ee={}))}),ie(se[78],ue([0,1,12,10,65]),function(W,t,n,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eu=void 0;class m{constructor(){this.a=new Map,this.b=new Map,this.c=new n.$oe,this.onDidChange=this.c.event,this.d=null}handleChange(a){this.c.fire({changedLanguages:a,changedColorMap:!1})}register(a,u){return this.a.set(a,u),this.handleChange([a]),(0,i.$Vc)(()=>{this.a.get(a)===u&&(this.a.delete(a),this.handleChange([a]))})}get(a){return this.a.get(a)||null}registerFactory(a,u){this.b.get(a)?.dispose();const g=new A(this,a,u);return this.b.set(a,g),(0,i.$Vc)(()=>{const E=this.b.get(a);!E||E!==g||(this.b.delete(a),E.dispose())})}async getOrCreate(a){const u=this.get(a);if(u)return u;const g=this.b.get(a);return!g||g.isResolved?null:(await g.resolve(),this.get(a))}isResolved(a){if(this.get(a))return!0;const g=this.b.get(a);return!!(!g||g.isResolved)}setColorMap(a){this.d=a,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>T.ColorId.DefaultBackground?this.d[T.ColorId.DefaultBackground]:null}}t.$Eu=m;class A extends i.$Xc{get isResolved(){return this.c}constructor(a,u,g){super(),this.f=a,this.g=u,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const a=await this.h.tokenizationSupport;this.c=!0,a&&!this.a&&this.B(this.f.register(this.g,a))}}}),ie(se[79],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=T,t.localize2=A;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function i(b,a){let u;return a.length===0?u=b:u=b.replace(/\{(\d+)\}/g,(g,E)=>{const d=E[0],c=a[d];let e=g;return typeof c=="string"?e=c:(typeof c=="number"||typeof c=="boolean"||c===void 0||c===null)&&(e=String(c)),e}),n&&(u="\uFF3B"+u.replace(/[aouei]/g,"$&$&")+"\uFF3D"),u}function T(b,a,...u){return i(typeof b=="number"?m(b,a):a,u)}function m(b,a){const u=globalThis._VSCODE_NLS_MESSAGES?.[b];if(typeof u!="string"){if(typeof a=="string")return a;throw new Error(`!!! NLS MISSING: ${b} !!!`)}return u}function A(b,a,...u){let g;typeof b=="number"?g=m(b,a):g=a;const E=i(g,u);return{value:E,original:a===g?E:i(a,u)}}}),ie(se[80],ue([0,1,49,13,54,2,78,79]),function(W,t,n,i,T,m,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$Yu=t.$Xu=t.$Wu=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.$Vu=t.$Uu=t.SymbolKinds=t.SymbolTag=t.$Su=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$Qu=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.HoverVerbosityAction=t.$Pu=t.$Ou=t.$Nu=void 0,t.$Ru=f,t.$Tu=k;class a{constructor(X,he,ge){this.offset=X,this.type=he,this.language=ge,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Nu=a;class u{constructor(X,he){this.tokens=X,this.endState=he,this._tokenizationResultBrand=void 0}}t.$Ou=u;class g{constructor(X,he){this.tokens=X,this.endState=he,this._encodedTokenizationResultBrand=void 0}}t.$Pu=g;var E;(function(P){P[P.Increase=0]="Increase",P[P.Decrease=1]="Decrease"})(E||(t.HoverVerbosityAction=E={}));var d;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(d||(t.CompletionItemKind=d={}));var c;(function(P){const X=new Map;X.set(d.Method,n.$8j.symbolMethod),X.set(d.Function,n.$8j.symbolFunction),X.set(d.Constructor,n.$8j.symbolConstructor),X.set(d.Field,n.$8j.symbolField),X.set(d.Variable,n.$8j.symbolVariable),X.set(d.Class,n.$8j.symbolClass),X.set(d.Struct,n.$8j.symbolStruct),X.set(d.Interface,n.$8j.symbolInterface),X.set(d.Module,n.$8j.symbolModule),X.set(d.Property,n.$8j.symbolProperty),X.set(d.Event,n.$8j.symbolEvent),X.set(d.Operator,n.$8j.symbolOperator),X.set(d.Unit,n.$8j.symbolUnit),X.set(d.Value,n.$8j.symbolValue),X.set(d.Enum,n.$8j.symbolEnum),X.set(d.Constant,n.$8j.symbolConstant),X.set(d.Enum,n.$8j.symbolEnum),X.set(d.EnumMember,n.$8j.symbolEnumMember),X.set(d.Keyword,n.$8j.symbolKeyword),X.set(d.Snippet,n.$8j.symbolSnippet),X.set(d.Text,n.$8j.symbolText),X.set(d.Color,n.$8j.symbolColor),X.set(d.File,n.$8j.symbolFile),X.set(d.Reference,n.$8j.symbolReference),X.set(d.Customcolor,n.$8j.symbolCustomColor),X.set(d.Folder,n.$8j.symbolFolder),X.set(d.TypeParameter,n.$8j.symbolTypeParameter),X.set(d.User,n.$8j.account),X.set(d.Issue,n.$8j.issues);function he(r){let je=X.get(r);return je||(console.info("No codicon found for CompletionItemKind "+r),je=n.$8j.symbolProperty),je}P.toIcon=he;const ge=new Map;ge.set("method",d.Method),ge.set("function",d.Function),ge.set("constructor",d.Constructor),ge.set("field",d.Field),ge.set("variable",d.Variable),ge.set("class",d.Class),ge.set("struct",d.Struct),ge.set("interface",d.Interface),ge.set("module",d.Module),ge.set("property",d.Property),ge.set("event",d.Event),ge.set("operator",d.Operator),ge.set("unit",d.Unit),ge.set("value",d.Value),ge.set("constant",d.Constant),ge.set("enum",d.Enum),ge.set("enum-member",d.EnumMember),ge.set("enumMember",d.EnumMember),ge.set("keyword",d.Keyword),ge.set("snippet",d.Snippet),ge.set("text",d.Text),ge.set("color",d.Color),ge.set("file",d.File),ge.set("reference",d.Reference),ge.set("customcolor",d.Customcolor),ge.set("folder",d.Folder),ge.set("type-parameter",d.TypeParameter),ge.set("typeParameter",d.TypeParameter),ge.set("account",d.User),ge.set("issue",d.Issue);function Ee(r,je){let Pe=ge.get(r);return typeof Pe>"u"&&!je&&(Pe=d.Property),Pe}P.fromString=Ee})(c||(t.CompletionItemKinds=c={}));var e;(function(P){P[P.Deprecated=1]="Deprecated"})(e||(t.CompletionItemTag=e={}));var l;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(l||(t.CompletionItemInsertTextRule=l={}));var h;(function(P){P[P.Word=0]="Word",P[P.Line=1]="Line",P[P.Suggest=2]="Suggest"})(h||(t.PartialAcceptTriggerKind=h={}));var w;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(t.CompletionTriggerKind=w={}));var L;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(L||(t.InlineCompletionTriggerKind=L={}));class N{constructor(X,he,ge,Ee){this.range=X,this.text=he,this.completionKind=ge,this.isSnippetText=Ee}equals(X){return m.$Ut.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}t.$Qu=N;var _;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(_||(t.CodeActionTriggerType=_={}));var $;(function(P){P[P.Automatic=0]="Automatic",P[P.PasteAs=1]="PasteAs"})($||(t.DocumentPasteTriggerKind=$={}));var o;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(o||(t.SignatureHelpTriggerKind=o={}));var s;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(s||(t.DocumentHighlightKind=s={}));function f(P){return P&&i.URI.isUri(P.uri)&&m.$Ut.isIRange(P.range)&&(m.$Ut.isIRange(P.originSelectionRange)||m.$Ut.isIRange(P.targetSelectionRange))}var v;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(v||(t.SymbolKind=v={})),t.$Su={[v.Array]:(0,b.localize)(788,null),[v.Boolean]:(0,b.localize)(789,null),[v.Class]:(0,b.localize)(790,null),[v.Constant]:(0,b.localize)(791,null),[v.Constructor]:(0,b.localize)(792,null),[v.Enum]:(0,b.localize)(793,null),[v.EnumMember]:(0,b.localize)(794,null),[v.Event]:(0,b.localize)(795,null),[v.Field]:(0,b.localize)(796,null),[v.File]:(0,b.localize)(797,null),[v.Function]:(0,b.localize)(798,null),[v.Interface]:(0,b.localize)(799,null),[v.Key]:(0,b.localize)(800,null),[v.Method]:(0,b.localize)(801,null),[v.Module]:(0,b.localize)(802,null),[v.Namespace]:(0,b.localize)(803,null),[v.Null]:(0,b.localize)(804,null),[v.Number]:(0,b.localize)(805,null),[v.Object]:(0,b.localize)(806,null),[v.Operator]:(0,b.localize)(807,null),[v.Package]:(0,b.localize)(808,null),[v.Property]:(0,b.localize)(809,null),[v.String]:(0,b.localize)(810,null),[v.Struct]:(0,b.localize)(811,null),[v.TypeParameter]:(0,b.localize)(812,null),[v.Variable]:(0,b.localize)(813,null)};function k(P,X){return(0,b.localize)(814,null,P,t.$Su[X])}var R;(function(P){P[P.Deprecated=1]="Deprecated"})(R||(t.SymbolTag=R={}));var j;(function(P){const X=new Map;X.set(v.File,n.$8j.symbolFile),X.set(v.Module,n.$8j.symbolModule),X.set(v.Namespace,n.$8j.symbolNamespace),X.set(v.Package,n.$8j.symbolPackage),X.set(v.Class,n.$8j.symbolClass),X.set(v.Method,n.$8j.symbolMethod),X.set(v.Property,n.$8j.symbolProperty),X.set(v.Field,n.$8j.symbolField),X.set(v.Constructor,n.$8j.symbolConstructor),X.set(v.Enum,n.$8j.symbolEnum),X.set(v.Interface,n.$8j.symbolInterface),X.set(v.Function,n.$8j.symbolFunction),X.set(v.Variable,n.$8j.symbolVariable),X.set(v.Constant,n.$8j.symbolConstant),X.set(v.String,n.$8j.symbolString),X.set(v.Number,n.$8j.symbolNumber),X.set(v.Boolean,n.$8j.symbolBoolean),X.set(v.Array,n.$8j.symbolArray),X.set(v.Object,n.$8j.symbolObject),X.set(v.Key,n.$8j.symbolKey),X.set(v.Null,n.$8j.symbolNull),X.set(v.EnumMember,n.$8j.symbolEnumMember),X.set(v.Struct,n.$8j.symbolStruct),X.set(v.Event,n.$8j.symbolEvent),X.set(v.Operator,n.$8j.symbolOperator),X.set(v.TypeParameter,n.$8j.symbolTypeParameter);function he(ge){let Ee=X.get(ge);return Ee||(console.info("No codicon found for SymbolKind "+ge),Ee=n.$8j.symbolProperty),Ee}P.toIcon=he})(j||(t.SymbolKinds=j={}));class M{static asEditOperation(X){return T.$Vt.replace(m.$Ut.lift(X.range),X.text)}}t.$Uu=M;class p{static{this.Comment=new p("comment")}static{this.Imports=new p("imports")}static{this.Region=new p("region")}static fromValue(X){switch(X){case"comment":return p.Comment;case"imports":return p.Imports;case"region":return p.Region}return new p(X)}constructor(X){this.value=X}}t.$Vu=p;var D;(function(P){P[P.AIGenerated=1]="AIGenerated"})(D||(t.NewSymbolNameTag=D={}));var I;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(I||(t.NewSymbolNameTriggerKind=I={}));var F;(function(P){function X(he){return!he||typeof he!="object"?!1:typeof he.id=="string"&&typeof he.title=="string"}P.is=X})(F||(t.Command=F={}));var q;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(q||(t.CommentThreadCollapsibleState=q={}));var z;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(z||(t.CommentThreadState=z={}));var H;(function(P){P[P.Current=0]="Current",P[P.Outdated=1]="Outdated"})(H||(t.CommentThreadApplicability=H={}));var U;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(U||(t.CommentMode=U={}));var C;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(C||(t.CommentState=C={}));var ee;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(ee||(t.InlayHintKind=ee={}));class J{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Wu=J,t.$Xu=new A.$Eu,t.$Yu=new A.$Eu;var K;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(K||(t.ExternalUriOpenerPriority=K={}));var ne;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(ne||(t.InlineEditTriggerKind=ne={}))}),ie(se[81],ue([0,1,20,12,43,13,5,2,55,80,77]),function(W,t,n,i,T,m,A,b,a,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$74=void 0,t.$84=d,g=ke(g);class E{static{this.CtrlCmd=T.KeyMod.CtrlCmd}static{this.Shift=T.KeyMod.Shift}static{this.Alt=T.KeyMod.Alt}static{this.WinCtrl=T.KeyMod.WinCtrl}static chord(e,l){return(0,T.$5r)(e,l)}}t.$74=E;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:n.$ze,Emitter:i.$oe,KeyCode:g.KeyCode,KeyMod:E,Position:A.$Tt,Range:b.$Ut,Selection:a.$Wt,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:m.URI,Token:u.$Nu}}}),ie(se[84],ue([0,1,32,5,2,67,68,81,73,29,76,39,64,31,22,4,66,74,75]),function(W,t,n,i,T,m,A,b,a,u,g,E,d,c,e,l,h,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=t.BaseEditorSimpleWorker=void 0,t.create=o;const N=!1;class _{constructor(){this.d=new L.$y5}dispose(){}f(f){return this.d.getModel(f)}g(){return this.d.getModels()}$acceptNewModel(f){this.d.$acceptNewModel(f)}$acceptModelChanged(f,v){this.d.$acceptModelChanged(f,v)}$acceptRemovedModel(f){this.d.$acceptRemovedModel(f)}async $computeUnicodeHighlights(f,v,k){const R=this.f(f);return R?g.$24.computeUnicodeHighlights(R,v,k):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async $findSectionHeaders(f,v){const k=this.f(f);return k?(0,w.$u5)(k,v):[]}async $computeDiff(f,v,k,R){const j=this.f(f),M=this.f(v);return!j||!M?null:$.h(j,M,k,R)}static h(f,v,k,R){const j=R==="advanced"?d.$s5.getDefault():d.$s5.getLegacy(),M=f.getLinesContent(),p=v.getLinesContent(),D=j.computeDiff(M,p,k),I=D.changes.length>0?!1:this.j(f,v);function F(q){return q.map(z=>[z.original.startLineNumber,z.original.endLineNumberExclusive,z.modified.startLineNumber,z.modified.endLineNumberExclusive,z.innerChanges?.map(H=>[H.originalRange.startLineNumber,H.originalRange.startColumn,H.originalRange.endLineNumber,H.originalRange.endColumn,H.modifiedRange.startLineNumber,H.modifiedRange.startColumn,H.modifiedRange.endLineNumber,H.modifiedRange.endColumn])])}return{identical:I,quitEarly:D.hitTimeout,changes:F(D.changes),moves:D.moves.map(q=>[q.lineRangeMapping.original.startLineNumber,q.lineRangeMapping.original.endLineNumberExclusive,q.lineRangeMapping.modified.startLineNumber,q.lineRangeMapping.modified.endLineNumberExclusive,F(q.changes)])}}static j(f,v){const k=f.getLineCount(),R=v.getLineCount();if(k!==R)return!1;for(let j=1;j<=k;j++){const M=f.getLineContent(j),p=v.getLineContent(j);if(M!==p)return!1}return!0}async $computeDirtyDiff(f,v,k){const R=this.f(f),j=this.f(v);if(!R||!j)return null;const M=R.getLinesContent(),p=j.getLinesContent();return new E.$hu(M,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:k,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.k=1e5}async $computeMoreMinimalEdits(f,v,k){const R=this.f(f);if(!R)return v;const j=[];let M;v=v.slice(0).sort((D,I)=>{if(D.range&&I.range)return T.$Ut.compareRangesUsingStarts(D.range,I.range);const F=D.range?0:1,q=I.range?0:1;return F-q});let p=0;for(let D=1;D<v.length;D++)T.$Ut.getEndPosition(v[p].range).equals(T.$Ut.getStartPosition(v[D].range))?(v[p].range=T.$Ut.fromPositions(T.$Ut.getStartPosition(v[p].range),T.$Ut.getEndPosition(v[D].range)),v[p].text+=v[D].text):(p++,v[p]=v[D]);v.length=p+1;for(let{range:D,text:I,eol:F}of v){if(typeof F=="number"&&(M=F),T.$Ut.isEmpty(D)&&!I)continue;const q=R.getValueInRange(D);if(I=I.replace(/\r\n|\n|\r/g,R.eol),q===I)continue;if(Math.max(I.length,q.length)>$.k){j.push({range:D,text:I});continue}const z=(0,n.$Zt)(q,I,k),H=R.offsetAt(T.$Ut.lift(D).getStartPosition());for(const U of z){const C=R.positionAt(H+U.originalStart),ee=R.positionAt(H+U.originalStart+U.originalLength),J={text:I.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:ee.lineNumber,endColumn:ee.column}};R.getValueInRange(J.range)!==J.text&&j.push(J)}}return typeof M=="number"&&j.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),j}$computeHumanReadableDiff(f,v,k){const R=this.f(f);if(!R)return v;const j=[];let M;v=v.slice(0).sort((p,D)=>{if(p.range&&D.range)return T.$Ut.compareRangesUsingStarts(p.range,D.range);const I=p.range?0:1,F=D.range?0:1;return I-F});for(let{range:p,text:D,eol:I}of v){let C=function(J,K){return new i.$Tt(J.lineNumber+K.lineNumber-1,K.lineNumber===1?J.column+K.column-1:K.column)},ee=function(J,K){const ne=[];for(let P=K.startLineNumber;P<=K.endLineNumber;P++){const X=J[P-1];P===K.startLineNumber&&P===K.endLineNumber?ne.push(X.substring(K.startColumn-1,K.endColumn-1)):P===K.startLineNumber?ne.push(X.substring(K.startColumn-1)):P===K.endLineNumber?ne.push(X.substring(0,K.endColumn-1)):ne.push(X)}return ne};if(typeof I=="number"&&(M=I),T.$Ut.isEmpty(p)&&!D)continue;const F=R.getValueInRange(p);if(D=D.replace(/\r\n|\n|\r/g,R.eol),F===D)continue;if(Math.max(D.length,F.length)>$.k){j.push({range:p,text:D});continue}const q=F.split(/\r\n|\n|\r/),z=D.split(/\r\n|\n|\r/),H=d.$s5.getDefault().computeDiff(q,z,k),U=T.$Ut.lift(p).getStartPosition();for(const J of H.changes)if(J.innerChanges)for(const K of J.innerChanges)j.push({range:T.$Ut.fromPositions(C(U,K.originalRange.getStartPosition()),C(U,K.originalRange.getEndPosition())),text:ee(z,K.modifiedRange).join(R.eol)});else throw new l.$eb("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&j.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),j}async $computeLinks(f){const v=this.f(f);return v?(0,m.$54)(v):null}async $computeDefaultDocumentColors(f){const v=this.f(f);return v?(0,h.$t5)(v):null}static{this.l=1e4}async $textualSuggest(f,v,k,R){const j=new u.$ie,M=new RegExp(k,R),p=new Set;e:for(const D of f){const I=this.f(D);if(I){for(const F of I.words(M))if(!(F===v||!isNaN(Number(F)))&&(p.add(F),p.size>$.l))break e}}return{words:Array.from(p),duration:j.elapsed()}}async $computeWordRanges(f,v,k,R){const j=this.f(f);if(!j)return Object.create(null);const M=new RegExp(k,R),p=Object.create(null);for(let D=v.startLineNumber;D<v.endLineNumber;D++){const I=j.getLineWords(D,M);for(const F of I){if(!isNaN(Number(F.word)))continue;let q=p[F.word];q||(q=[],p[F.word]=q),q.push({startLineNumber:D,startColumn:F.startColumn,endLineNumber:D,endColumn:F.endColumn})}}return p}async $navigateValueSet(f,v,k,R,j){const M=this.f(f);if(!M)return null;const p=new RegExp(R,j);v.startColumn===v.endColumn&&(v={startLineNumber:v.startLineNumber,startColumn:v.startColumn,endLineNumber:v.endLineNumber,endColumn:v.endColumn+1});const D=M.getValueInRange(v),I=M.getWordAtPosition({lineNumber:v.startLineNumber,column:v.startColumn},p);if(!I)return null;const F=M.getValueInRange(I);return A.$64.INSTANCE.navigateValueSet(v,D,I,F,k)}}t.BaseEditorSimpleWorker=_;class $ extends _{constructor(f,v){super(),this.o=f,this.p=v,this.n=null}async $ping(){return"pong"}$loadForeignModule(f,v,k){const R=(p,D)=>this.o.$fhr(p,D),M={host:(0,c.$to)(k,R),getMirrorModels:()=>this.g()};return this.p?(this.n=this.p(M,v),Promise.resolve((0,c.$so)(this.n))):new Promise((p,D)=>{const I=F=>{this.n=F.create(M,v),p((0,c.$so)(this.n))};if(!N)W([`${f}`],I,D);else{const F=e.$3g.asBrowserUri(`${f}.js`).toString(!0);new Promise((q,z)=>{W([`${F}`],q,z)}).then(ke).then(I).catch(D)}})}$fmr(f,v){if(!this.n||typeof this.n[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.n[f].apply(this.n,v))}catch(k){return Promise.reject(k)}}}t.EditorSimpleWorker=$;function o(s){return new $(a.$94.getChannel(s),null)}typeof importScripts=="function"&&(globalThis.monaco=(0,b.$84)())})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2aa3c4625ed4b46448fa546ac5f2e93b0757718/core/vs/base/worker/workerMain.js.map
