/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/uri","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/amd","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/amdX","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/request/common/request","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],he=function(Z){for(var e=[],P=0,I=Z.length;P<I;P++)e[P]=le[Z[P]];return e};define(le[55],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=e.$T=void 0,e.$T=!1,e.$U=!0;var P;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class I{static get(){const k=new Map,C=new Map,O=new Map,g=new Map;function l(p,S){p.has(S.detail)||p.set(S.detail,-S.timestamp)}function d(p,S){const b=p.get(S.detail);b&&(b>=0||p.set(S.detail,b+S.timestamp))}let h=[];typeof Z=="function"&&typeof Z.getStats=="function"&&(h=Z.getStats().slice(0).sort((p,S)=>p.timestamp-S.timestamp));for(const p of h)switch(p.type){case P.BeginLoadingScript:l(k,p);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:d(k,p);break;case P.BeginInvokeFactory:l(C,p);break;case P.EndInvokeFactory:d(C,p);break;case P.NodeBeginNativeRequire:l(O,p);break;case P.NodeEndNativeRequire:d(O,p);break;case P.NodeBeginEvaluatingScript:l(g,p);break;case P.NodeEndEvaluatingScript:d(g,p);break}let w=0;O.forEach(p=>w+=p);function f(p){const S=[];return p.forEach((b,y)=>S.push([y,b])),S}return{amdLoad:f(k),amdInvoke:f(C),nodeRequire:f(O),nodeEval:f(g),nodeRequireTotal:w}}static toMarkdownTable(k,C){let O="";const g=[];return k.forEach((l,d)=>{g[d]=l.length}),C.forEach(l=>{l.forEach((d,h)=>{typeof d>"u"&&(d=l[h]="-");const w=d.toString().length;g[h]=Math.max(w,g[h])})}),k.forEach((l,d)=>{O+=`| ${l+" ".repeat(g[d]-l.toString().length)} `}),O+=`|
`,k.forEach((l,d)=>{O+=`| ${"-".repeat(g[d])} `}),O+=`|
`,C.forEach(l=>{l.forEach((d,h)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(g[h]-d.toString().length)} `)}),O+=`|
`}),O}}e.$V=I}),define(le[56],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=I,e.$bi=v,e.$ci=k;function P(C){return(O,g,l)=>{let d=null,h=null;if(typeof l.value=="function"?(d="value",h=l.value):typeof l.get=="function"&&(d="get",h=l.get),!h)throw new Error("not supported");l[d]=C(h,g)}}function I(C,O,g){let l=null,d=null;if(typeof g.value=="function"?(l="value",d=g.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",d=g.get),!d)throw new Error("not supported");const h=`$memoize$${O}`;g[l]=function(...w){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,w)}),this[h]}}function v(C,O,g){return P((l,d)=>{const h=`$debounce$${d}`,w=`$debounce$result$${d}`;return function(...f){this[w]||(this[w]=g?g():void 0),clearTimeout(this[h]),O&&(this[w]=O(this[w],...f),f=[this[w]]),this[h]=setTimeout(()=>{l.apply(this,f),this[w]=g?g():void 0},C)}})}function k(C,O,g){return P((l,d)=>{const h=`$throttle$timer$${d}`,w=`$throttle$result$${d}`,f=`$throttle$lastRun$${d}`,p=`$throttle$pending$${d}`;return function(...S){if(this[w]||(this[w]=g?g():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),O&&(this[w]=O(this[w],...S)),this[p])return;const b=this[f]+C;b<=Date.now()?(this[f]=Date.now(),l.apply(this,[this[w]]),this[w]=g?g():void 0):(this[p]=!0,this[h]=setTimeout(()=>{this[p]=!1,this[f]=Date.now(),l.apply(this,[this[w]]),this[w]=g?g():void 0},b-Date.now()))}})}}),define(le[76],he([0,1,7]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=I,e.$hd=v,e.$id=k,e.$jd=C,e.$kd=O,e.$ld=g;function I(l,d){if(!l)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function v(l,d="Unreachable"){throw new Error(d)}function k(l,d="unexpected state"){if(!l)throw new P.$eb(`Assertion Failed: ${d}`)}function C(l){l||(0,P.$2)(new P.$eb("Soft Assertion Failed"))}function O(l){if(!l()){debugger;l(),(0,P.$2)(new P.$eb("Assertion Failed"))}}function g(l,d){let h=0;for(;h<l.length-1;){const w=l[h],f=l[h+1];if(!d(w,f))return!1;h++}return!0}}),define(le[34],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$1n=C,e.$2n=h,e.$3n=w,e.$4n=f,e.$5n=p,e.$6n=S,e.$7n=b,e.$8n=y,e.$9n=u,e.$0n=R,e.$$n=$;var P;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var I;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(I||(e.SyntaxKind=I={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v||(e.ParseErrorCode=v={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function C(i,a=!1){let n=0;const r=i.length;let t="",s=0,o=I.Unknown,c=P.None;function m(Y){let ne=0,ae=0;for(;ne<Y;){const ue=i.charCodeAt(n);if(ue>=d._0&&ue<=d._9)ae=ae*16+ue-d._0;else if(ue>=d.A&&ue<=d.F)ae=ae*16+ue-d.A+10;else if(ue>=d.a&&ue<=d.f)ae=ae*16+ue-d.a+10;else break;n++,ne++}return ne<Y&&(ae=-1),ae}function N(Y){n=Y,t="",s=0,o=I.Unknown,c=P.None}function T(){const Y=n;if(i.charCodeAt(n)===d._0)n++;else for(n++;n<i.length&&l(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===d.dot)if(n++,n<i.length&&l(i.charCodeAt(n)))for(n++;n<i.length&&l(i.charCodeAt(n));)n++;else return c=P.UnexpectedEndOfNumber,i.substring(Y,n);let ne=n;if(n<i.length&&(i.charCodeAt(n)===d.E||i.charCodeAt(n)===d.e))if(n++,(n<i.length&&i.charCodeAt(n)===d.plus||i.charCodeAt(n)===d.minus)&&n++,n<i.length&&l(i.charCodeAt(n))){for(n++;n<i.length&&l(i.charCodeAt(n));)n++;ne=n}else c=P.UnexpectedEndOfNumber;return i.substring(Y,ne)}function D(){let Y="",ne=n;for(;;){if(n>=r){Y+=i.substring(ne,n),c=P.UnexpectedEndOfString;break}const ae=i.charCodeAt(n);if(ae===d.doubleQuote){Y+=i.substring(ne,n),n++;break}if(ae===d.backslash){if(Y+=i.substring(ne,n),n++,n>=r){c=P.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case d.doubleQuote:Y+='"';break;case d.backslash:Y+="\\";break;case d.slash:Y+="/";break;case d.b:Y+="\b";break;case d.f:Y+="\f";break;case d.n:Y+=`
`;break;case d.r:Y+="\r";break;case d.t:Y+="	";break;case d.u:{const me=m(4);me>=0?Y+=String.fromCharCode(me):c=P.InvalidUnicode;break}default:c=P.InvalidEscapeCharacter}ne=n;continue}if(ae>=0&&ae<=31)if(g(ae)){Y+=i.substring(ne,n),c=P.UnexpectedEndOfString;break}else c=P.InvalidCharacter;n++}return Y}function A(){if(t="",c=P.None,s=n,n>=r)return s=r,o=I.EOF;let Y=i.charCodeAt(n);if(O(Y)){do n++,t+=String.fromCharCode(Y),Y=i.charCodeAt(n);while(O(Y));return o=I.Trivia}if(g(Y))return n++,t+=String.fromCharCode(Y),Y===d.carriageReturn&&i.charCodeAt(n)===d.lineFeed&&(n++,t+=`
`),o=I.LineBreakTrivia;switch(Y){case d.openBrace:return n++,o=I.OpenBraceToken;case d.closeBrace:return n++,o=I.CloseBraceToken;case d.openBracket:return n++,o=I.OpenBracketToken;case d.closeBracket:return n++,o=I.CloseBracketToken;case d.colon:return n++,o=I.ColonToken;case d.comma:return n++,o=I.CommaToken;case d.doubleQuote:return n++,t=D(),o=I.StringLiteral;case d.slash:{const ne=n-1;if(i.charCodeAt(n+1)===d.slash){for(n+=2;n<r&&!g(i.charCodeAt(n));)n++;return t=i.substring(ne,n),o=I.LineCommentTrivia}if(i.charCodeAt(n+1)===d.asterisk){n+=2;const ae=r-1;let ue=!1;for(;n<ae;){if(i.charCodeAt(n)===d.asterisk&&i.charCodeAt(n+1)===d.slash){n+=2,ue=!0;break}n++}return ue||(n++,c=P.UnexpectedEndOfComment),t=i.substring(ne,n),o=I.BlockCommentTrivia}return t+=String.fromCharCode(Y),n++,o=I.Unknown}case d.minus:if(t+=String.fromCharCode(Y),n++,n===r||!l(i.charCodeAt(n)))return o=I.Unknown;case d._0:case d._1:case d._2:case d._3:case d._4:case d._5:case d._6:case d._7:case d._8:case d._9:return t+=T(),o=I.NumericLiteral;default:for(;n<r&&F(Y);)n++,Y=i.charCodeAt(n);if(s!==n){switch(t=i.substring(s,n),t){case"true":return o=I.TrueKeyword;case"false":return o=I.FalseKeyword;case"null":return o=I.NullKeyword}return o=I.Unknown}return t+=String.fromCharCode(Y),n++,o=I.Unknown}}function F(Y){if(O(Y)||g(Y))return!1;switch(Y){case d.closeBrace:case d.closeBracket:case d.openBrace:case d.openBracket:case d.doubleQuote:case d.colon:case d.comma:case d.slash:return!1}return!0}function H(){let Y;do Y=A();while(Y>=I.LineCommentTrivia&&Y<=I.Trivia);return Y}return{setPosition:N,getPosition:()=>n,scan:a?H:A,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>c}}function O(i){return i===d.space||i===d.tab||i===d.verticalTab||i===d.formFeed||i===d.nonBreakingSpace||i===d.ogham||i>=d.enQuad&&i<=d.zeroWidthSpace||i===d.narrowNoBreakSpace||i===d.mathematicalSpace||i===d.ideographicSpace||i===d.byteOrderMark}function g(i){return i===d.lineFeed||i===d.carriageReturn||i===d.lineSeparator||i===d.paragraphSeparator}function l(i){return i>=d._0&&i<=d._9}var d;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(d||(d={}));function h(i,a){const n=[],r=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function c(m,N,T,D){s.value=m,s.offset=N,s.length=T,s.type=D,s.colonOffset=void 0,t=s}try{R(i,{onObjectBegin:(m,N)=>{if(a<=m)throw r;t=void 0,o=a>m,n.push("")},onObjectProperty:(m,N,T)=>{if(a<N||(c(m,N,T,"property"),n[n.length-1]=m,a<=N+T))throw r},onObjectEnd:(m,N)=>{if(a<=m)throw r;t=void 0,n.pop()},onArrayBegin:(m,N)=>{if(a<=m)throw r;t=void 0,n.push(0)},onArrayEnd:(m,N)=>{if(a<=m)throw r;t=void 0,n.pop()},onLiteralValue:(m,N,T)=>{if(a<N||(c(m,N,T,$(m)),a<=N+T))throw r},onSeparator:(m,N,T)=>{if(a<=N)throw r;if(m===":"&&t&&t.type==="property")t.colonOffset=N,o=!1,t=void 0;else if(m===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(m){if(m!==r)throw m}return{path:n,previousNode:t,isAtPropertyKey:o,matches:m=>{let N=0;for(let T=0;N<m.length&&T<n.length;T++)if(m[N]===n[T]||m[N]==="*")N++;else if(m[N]!=="**")return!1;return N===m.length}}}function w(i,a=[],n=k.DEFAULT){let r=null,t=[];const s=[];function o(m){Array.isArray(t)?t.push(m):r!==null&&(t[r]=m)}return R(i,{onObjectBegin:()=>{const m={};o(m),s.push(t),t=m,r=null},onObjectProperty:m=>{r=m},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const m=[];o(m),s.push(t),t=m,r=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:o,onError:(m,N,T)=>{a.push({error:m,offset:N,length:T})}},n),t[0]}function f(i,a=[],n=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(m){r.type==="property"&&(r.length=m-r.offset,r=r.parent)}function s(m){return r.children.push(m),m}R(i,{onObjectBegin:m=>{r=s({type:"object",offset:m,length:-1,parent:r,children:[]})},onObjectProperty:(m,N,T)=>{r=s({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:m,offset:N,length:T,parent:r})},onObjectEnd:(m,N)=>{r.length=m+N-r.offset,r=r.parent,t(m+N)},onArrayBegin:(m,N)=>{r=s({type:"array",offset:m,length:-1,parent:r,children:[]})},onArrayEnd:(m,N)=>{r.length=m+N-r.offset,r=r.parent,t(m+N)},onLiteralValue:(m,N,T)=>{s({type:$(m),offset:N,length:T,parent:r,value:m}),t(N+T)},onSeparator:(m,N,T)=>{r.type==="property"&&(m===":"?r.colonOffset=N:m===","&&t(N))},onError:(m,N,T)=>{a.push({error:m,offset:N,length:T})}},n);const c=r.children[0];return c&&delete c.parent,c}function p(i,a){if(!i)return;let n=i;for(const r of a)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],t=!0;break}if(!t)return}else{const t=r;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function S(i){if(!i.parent||!i.parent.children)return[];const a=S(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;a.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&a.push(n)}return a}function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const a=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(a[n.children[0].value]=b(r))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function y(i,a,n=!1){return a>=i.offset&&a<i.offset+i.length||n&&a===i.offset+i.length}function u(i,a,n=!1){if(y(i,a,n)){const r=i.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=a;t++){const s=u(r[t],a,n);if(s)return s}return i}}function R(i,a,n=k.DEFAULT){const r=C(i,!1);function t(Q){return Q?()=>Q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(Q){return Q?ie=>Q(ie,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),c=s(a.onObjectProperty),m=t(a.onObjectEnd),N=t(a.onArrayBegin),T=t(a.onArrayEnd),D=s(a.onLiteralValue),A=s(a.onSeparator),F=t(a.onComment),H=s(a.onError),Y=n&&n.disallowComments,ne=n&&n.allowTrailingComma;function ae(){for(;;){const Q=r.scan();switch(r.getTokenError()){case P.InvalidUnicode:ue(v.InvalidUnicode);break;case P.InvalidEscapeCharacter:ue(v.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:ue(v.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:Y||ue(v.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:ue(v.UnexpectedEndOfString);break;case P.InvalidCharacter:ue(v.InvalidCharacter);break}switch(Q){case I.LineCommentTrivia:case I.BlockCommentTrivia:Y?ue(v.InvalidCommentToken):F();break;case I.Unknown:ue(v.InvalidSymbol);break;case I.Trivia:case I.LineBreakTrivia:break;default:return Q}}}function ue(Q,ie=[],se=[]){if(H(Q),ie.length+se.length>0){let L=r.getToken();for(;L!==I.EOF;){if(ie.indexOf(L)!==-1){ae();break}else if(se.indexOf(L)!==-1)break;L=ae()}}}function me(Q){const ie=r.getTokenValue();return Q?D(ie):c(ie),ae(),!0}function W(){switch(r.getToken()){case I.NumericLiteral:{let Q=0;try{Q=JSON.parse(r.getTokenValue()),typeof Q!="number"&&(ue(v.InvalidNumberFormat),Q=0)}catch{ue(v.InvalidNumberFormat)}D(Q);break}case I.NullKeyword:D(null);break;case I.TrueKeyword:D(!0);break;case I.FalseKeyword:D(!1);break;default:return!1}return ae(),!0}function _(){return r.getToken()!==I.StringLiteral?(ue(v.PropertyNameExpected,[],[I.CloseBraceToken,I.CommaToken]),!1):(me(!1),r.getToken()===I.ColonToken?(A(":"),ae(),x()||ue(v.ValueExpected,[],[I.CloseBraceToken,I.CommaToken])):ue(v.ColonExpected,[],[I.CloseBraceToken,I.CommaToken]),!0)}function M(){o(),ae();let Q=!1;for(;r.getToken()!==I.CloseBraceToken&&r.getToken()!==I.EOF;){if(r.getToken()===I.CommaToken){if(Q||ue(v.ValueExpected,[],[]),A(","),ae(),r.getToken()===I.CloseBraceToken&&ne)break}else Q&&ue(v.CommaExpected,[],[]);_()||ue(v.ValueExpected,[],[I.CloseBraceToken,I.CommaToken]),Q=!0}return m(),r.getToken()!==I.CloseBraceToken?ue(v.CloseBraceExpected,[I.CloseBraceToken],[]):ae(),!0}function q(){N(),ae();let Q=!1;for(;r.getToken()!==I.CloseBracketToken&&r.getToken()!==I.EOF;){if(r.getToken()===I.CommaToken){if(Q||ue(v.ValueExpected,[],[]),A(","),ae(),r.getToken()===I.CloseBracketToken&&ne)break}else Q&&ue(v.CommaExpected,[],[]);x()||ue(v.ValueExpected,[],[I.CloseBracketToken,I.CommaToken]),Q=!0}return T(),r.getToken()!==I.CloseBracketToken?ue(v.CloseBracketExpected,[I.CloseBracketToken],[]):ae(),!0}function x(){switch(r.getToken()){case I.OpenBracketToken:return q();case I.OpenBraceToken:return M();case I.StringLiteral:return me(!0);default:return W()}}return ae(),r.getToken()===I.EOF?n.allowEmptyContent?!0:(ue(v.ValueExpected,[],[]),!1):x()?(r.getToken()!==I.EOF&&ue(v.EndOfFileExpected,[],[]),!0):(ue(v.ValueExpected,[],[]),!1)}function $(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[77],he([0,1,34]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=I,e.$ao=v,e.$bo=O,e.$co=g;function I(l,d,h){let w,f,p,S,b;if(d){for(S=d.offset,b=S+d.length,p=S;p>0&&!g(l,p-1);)p--;let c=b;for(;c<l.length&&!g(l,c);)c++;f=l.substring(p,c),w=C(f,h)}else f=l,w=0,p=0,S=0,b=l.length;const y=O(h,l);let u=!1,R=0,$;h.insertSpaces?$=k(" ",h.tabSize||4):$="	";const i=(0,P.$1n)(f,!1);let a=!1;function n(){return y+k($,w+R)}function r(){let c=i.scan();for(u=!1;c===P.SyntaxKind.Trivia||c===P.SyntaxKind.LineBreakTrivia;)u=u||c===P.SyntaxKind.LineBreakTrivia,c=i.scan();return a=c===P.SyntaxKind.Unknown||i.getTokenError()!==P.ScanError.None,c}const t=[];function s(c,m,N){!a&&m<b&&N>S&&l.substring(m,N)!==c&&t.push({offset:m,length:N-m,content:c})}let o=r();if(o!==P.SyntaxKind.EOF){const c=i.getTokenOffset()+p,m=k($,w);s(m,p,c)}for(;o!==P.SyntaxKind.EOF;){let c=i.getTokenOffset()+i.getTokenLength()+p,m=r(),N="";for(;!u&&(m===P.SyntaxKind.LineCommentTrivia||m===P.SyntaxKind.BlockCommentTrivia);){const D=i.getTokenOffset()+p;s(" ",c,D),c=i.getTokenOffset()+i.getTokenLength()+p,N=m===P.SyntaxKind.LineCommentTrivia?n():"",m=r()}if(m===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(R--,N=n());else if(m===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(R--,N=n());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:R++,N=n();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:N=n();break;case P.SyntaxKind.BlockCommentTrivia:u?N=n():N=" ";break;case P.SyntaxKind.ColonToken:N=" ";break;case P.SyntaxKind.StringLiteral:if(m===P.SyntaxKind.ColonToken){N="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:m===P.SyntaxKind.LineCommentTrivia||m===P.SyntaxKind.BlockCommentTrivia?N=" ":m!==P.SyntaxKind.CommaToken&&m!==P.SyntaxKind.EOF&&(a=!0);break;case P.SyntaxKind.Unknown:a=!0;break}u&&(m===P.SyntaxKind.LineCommentTrivia||m===P.SyntaxKind.BlockCommentTrivia)&&(N=n())}const T=i.getTokenOffset()+p;s(N,c,T),o=m}return t}function v(l,d){const h=JSON.stringify(l,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?h.replace(/\r\n|\r|\n/g,d.eol):h}function k(l,d){let h="";for(let w=0;w<d;w++)h+=l;return h}function C(l,d){let h=0,w=0;const f=d.tabSize||4;for(;h<l.length;){const p=l.charAt(h);if(p===" ")w++;else if(p==="	")w+=f;else break;h++}return Math.floor(w/f)}function O(l,d){for(let h=0;h<d.length;h++){const w=d.charAt(h);if(w==="\r")return h+1<d.length&&d.charAt(h+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return l&&l.eol||`
`}function g(l,d){return`\r
`.indexOf(l.charAt(d))!==-1}}),define(le[78],he([0,1,34,77]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=v,e.$eo=k,e.$fo=C,e.$go=O,e.$ho=g;function v(l,d,h){return k(l,d,void 0,h)}function k(l,d,h,w,f){const p=d.slice(),S=[],b=(0,P.$4n)(l,S);let y,u;for(;p.length>0&&(u=p.pop(),y=(0,P.$5n)(b,p),y===void 0&&h!==void 0);)typeof u=="string"?h={[u]:h}:h=[h];if(y)if(y.type==="object"&&typeof u=="string"&&Array.isArray(y.children)){const R=(0,P.$5n)(y,[u]);if(R!==void 0)if(h===void 0){if(!R.parent)throw new Error("Malformed AST");const $=y.children.indexOf(R.parent);let i,a=R.parent.offset+R.parent.length;if($>0){const n=y.children[$-1];i=n.offset+n.length}else i=y.offset+1,y.children.length>1&&(a=y.children[1].offset);return C(l,{offset:i,length:a-i,content:""},w)}else return C(l,{offset:R.offset,length:R.length,content:JSON.stringify(h)},w);else{if(h===void 0)return[];const $=`${JSON.stringify(u)}: ${JSON.stringify(h)}`,i=f?f(y.children.map(n=>n.children[0].value)):y.children.length;let a;if(i>0){const n=y.children[i-1];a={offset:n.offset+n.length,length:0,content:","+$}}else y.children.length===0?a={offset:y.offset+1,length:0,content:$}:a={offset:y.offset+1,length:0,content:$+","};return C(l,a,w)}}else if(y.type==="array"&&typeof u=="number"&&Array.isArray(y.children))if(h!==void 0){const R=`${JSON.stringify(h)}`;let $;if(y.children.length===0||u===0)$={offset:y.offset+1,length:0,content:y.children.length===0?R:R+","};else{const i=u===-1||u>y.children.length?y.children.length:u,a=y.children[i-1];$={offset:a.offset+a.length,length:0,content:","+R}}return C(l,$,w)}else{const R=u,$=y.children[R];let i;if(y.children.length===1)i={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===R){const a=y.children[R-1],n=a.offset+a.length,r=y.offset+y.length;i={offset:n,length:r-2-n,content:""}}else i={offset:$.offset,length:y.children[R+1].offset-$.offset,content:""};return C(l,i,w)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${y.type}`);else return h===void 0?[]:C(l,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(h)},w)}function C(l,d,h){let w=O(l,d),f=d.offset,p=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;f>0&&!(0,I.$co)(w,f-1);)f--;for(;p<w.length&&!(0,I.$co)(w,p);)p++}const S=(0,I.$_n)(w,{offset:f,length:p-f},h);for(let y=S.length-1;y>=0;y--){const u=S[y];w=O(w,u),f=Math.min(f,u.offset),p=Math.max(p,u.offset+u.length),p+=u.content.length-u.length}const b=l.length-(w.length-p)-f;return[{offset:f,length:b,content:w.substring(f,p)}]}function O(l,d){return l.substring(0,d.offset)+d.content+l.substring(d.offset+d.length)}function g(l,d){const h=d.slice(0).sort((f,p)=>{const S=f.offset-p.offset;return S===0?f.length-p.length:S});let w=l.length;for(let f=h.length-1;f>=0;f--){const p=h[f];if(p.offset+p.length<=w)l=O(l,p);else throw new Error("Overlapping edit");w=p.offset}return l}}),define(le[79],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=P;function P(k){let C=!1;const O=new Map,g=new Map;if(v(k,S=>{if(k===S)return!0;const b=JSON.stringify(S);if(b.length<30)return!0;const y=O.get(b);if(!y){const u={schemas:[S]};return O.set(b,u),g.set(S,u),!0}return y.schemas.push(S),g.set(S,y),C=!0,!1}),O.clear(),!C)return JSON.stringify(k);let d="$defs";for(;k.hasOwnProperty(d);)d+="_";const h=[];function w(S){return JSON.stringify(S,(b,y)=>{if(y!==S){const u=g.get(y);if(u&&u.schemas.length>1)return u.id||(u.id=`_${h.length}`,h.push(u.schemas[0])),{$ref:`#/${d}/${u.id}`}}return y})}const f=w(k),p=[];for(let S=0;S<h.length;S++)p.push(`"_${S}":${w(h[S])}`);return p.length?`${f.substring(0,f.length-1)},"${d}":{${p.join(",")}}}`:f}function I(k){return typeof k=="object"&&k!==null}function v(k,C){if(!k||typeof k!="object")return;const O=(...f)=>{for(const p of f)I(p)&&h.push(p)},g=(...f)=>{for(const p of f)if(I(p))for(const S in p){const b=p[S];I(b)&&h.push(b)}},l=(...f)=>{for(const p of f)if(Array.isArray(p))for(const S of p)I(S)&&h.push(S)},d=f=>{if(Array.isArray(f))for(const p of f)I(p)&&h.push(p);else I(f)&&h.push(f)},h=[k];let w=h.pop();for(;w;)C(w)&&(O(w.additionalItems,w.additionalProperties,w.not,w.contains,w.propertyNames,w.if,w.then,w.else,w.unevaluatedItems,w.unevaluatedProperties),g(w.definitions,w.$defs,w.properties,w.patternProperties,w.dependencies,w.dependentSchemas),l(w.anyOf,w.allOf,w.oneOf,w.prefixItems),d(w.items)),w=h.pop()}}),define(le[80],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0,e.$Om=P,e.rot=I,e.$Tm=O;function P(g,l,d){return Math.min(Math.max(g,l),d)}function I(g,l){return(l+g%l)%l}class v{constructor(){this.a=0}getNext(){return this.a++}}e.$Qm=v;class k{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rm=k;class C{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const d=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sm=C;function O(g,l,d,h,w,f,p,S){const b=p-d,y=S-h,u=w-d,R=f-h,$=g-d,i=l-h,a=b*b+y*y,n=b*u+y*R,r=b*$+y*i,t=u*u+R*R,s=u*$+R*i,o=1/(a*t-n*n),c=(t*r-n*s)*o,m=(a*s-n*r)*o;return c>=0&&m>=0&&c+m<1}}),function(){function Z(v){const k=[];typeof v=="number"&&k.push("code/timeOrigin",v);function C(g){k.push(g,Date.now())}function O(){const g=[];for(let l=0;l<k.length;l+=2)g.push({name:k[l],startTime:k[l+1]});return g}return{mark:C,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const C of performance.getEntriesByType("mark"))k.push({name:C.name,startTime:Math.round(v+C.startTime)});return k}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function P(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=P(I))}(),define(le[57],he([0,1,11]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=k,e.$pm=C;var I;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(I||(e.Source=I={}));var v;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(v||(e.TerminateResponseCode=v={}));function k(O,...g){const l=g.reduce((w,f)=>(w[f]=!0,w),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(w=>!l[w]).forEach(w=>{for(let f=0;f<d.length;f++)if(w.search(d[f])!==-1){delete O[w];break}})}function C(O){O&&(delete O.DEBUG,P.$l&&delete O.LD_PRELOAD)}}),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var I in P)(typeof exports=="object"?exports:Z)[I]=P[I]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function P(I){if(e[I])return e[I].exports;var v=e[I]={i:I,l:!1,exports:{}};return Z[I].call(v.exports,v,v.exports,P),v.l=!0,v.exports}return P.m=Z,P.c=e,P.d=function(I,v,k){P.o(I,v)||Object.defineProperty(I,v,{enumerable:!0,get:k})},P.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},P.t=function(I,v){if(1&v&&(I=P(I)),8&v||4&v&&typeof I=="object"&&I&&I.__esModule)return I;var k=Object.create(null);if(P.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:I}),2&v&&typeof I!="string")for(var C in I)P.d(k,C,function(O){return I[O]}.bind(null,C));return k},P.n=function(I){var v=I&&I.__esModule?function(){return I.default}:function(){return I};return P.d(v,"a",v),v},P.o=function(I,v){return Object.prototype.hasOwnProperty.call(I,v)},P.p="",P(P.s=0)}([function(Z,e,P){(function(I){var v;e=Z.exports=L,v=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],g=e.src=[],l=0,d=l++;g[d]="0|[1-9]\\d*";var h=l++;g[h]="[0-9]+";var w=l++;g[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=l++;g[f]="("+g[d]+")\\.("+g[d]+")\\.("+g[d]+")";var p=l++;g[p]="("+g[h]+")\\.("+g[h]+")\\.("+g[h]+")";var S=l++;g[S]="(?:"+g[d]+"|"+g[w]+")";var b=l++;g[b]="(?:"+g[h]+"|"+g[w]+")";var y=l++;g[y]="(?:-("+g[S]+"(?:\\."+g[S]+")*))";var u=l++;g[u]="(?:-?("+g[b]+"(?:\\."+g[b]+")*))";var R=l++;g[R]="[0-9A-Za-z-]+";var $=l++;g[$]="(?:\\+("+g[R]+"(?:\\."+g[R]+")*))";var i=l++,a="v?"+g[f]+g[y]+"?"+g[$]+"?";g[i]="^"+a+"$";var n="[v=\\s]*"+g[p]+g[u]+"?"+g[$]+"?",r=l++;g[r]="^"+n+"$";var t=l++;g[t]="((?:<|>)?=?)";var s=l++;g[s]=g[h]+"|x|X|\\*";var o=l++;g[o]=g[d]+"|x|X|\\*";var c=l++;g[c]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[y]+")?"+g[$]+"?)?)?";var m=l++;g[m]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[u]+")?"+g[$]+"?)?)?";var N=l++;g[N]="^"+g[t]+"\\s*"+g[c]+"$";var T=l++;g[T]="^"+g[t]+"\\s*"+g[m]+"$";var D=l++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=l++;g[A]="(?:~>?)";var F=l++;g[F]="(\\s*)"+g[A]+"\\s+",O[F]=new RegExp(g[F],"g");var H=l++;g[H]="^"+g[A]+g[c]+"$";var Y=l++;g[Y]="^"+g[A]+g[m]+"$";var ne=l++;g[ne]="(?:\\^)";var ae=l++;g[ae]="(\\s*)"+g[ne]+"\\s+",O[ae]=new RegExp(g[ae],"g");var ue=l++;g[ue]="^"+g[ne]+g[c]+"$";var me=l++;g[me]="^"+g[ne]+g[m]+"$";var W=l++;g[W]="^"+g[t]+"\\s*("+n+")$|^$";var _=l++;g[_]="^"+g[t]+"\\s*("+a+")$|^$";var M=l++;g[M]="(\\s*)"+g[t]+"\\s*("+n+"|"+g[c]+")",O[M]=new RegExp(g[M],"g");var q=l++;g[q]="^\\s*("+g[c]+")\\s+-\\s+("+g[c]+")\\s*$";var x=l++;g[x]="^\\s*("+g[m]+")\\s+-\\s+("+g[m]+")\\s*$";var Q=l++;g[Q]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)v(ie,g[ie]),O[ie]||(O[ie]=new RegExp(g[ie]));function se(B,ee){if(B instanceof L)return B;if(typeof B!="string"||B.length>k||!(ee?O[r]:O[i]).test(B))return null;try{return new L(B,ee)}catch{return null}}function L(B,ee){if(B instanceof L){if(B.loose===ee)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof L))return new L(B,ee);v("SemVer",B,ee),this.loose=ee;var te=B.trim().match(ee?O[r]:O[i]);if(!te)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var Se=+ge;if(Se>=0&&Se<C)return Se}return ge}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=se,e.valid=function(B,ee){var te=se(B,ee);return te?te.version:null},e.clean=function(B,ee){var te=se(B.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(B){return v("SemVer.compare",this.version,this.loose,B),B instanceof L||(B=new L(B,this.loose)),this.compareMain(B)||this.comparePre(B)},L.prototype.compareMain=function(B){return B instanceof L||(B=new L(B,this.loose)),z(this.major,B.major)||z(this.minor,B.minor)||z(this.patch,B.patch)},L.prototype.comparePre=function(B){if(B instanceof L||(B=new L(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],ge=B.prerelease[ee];if(v("prerelease compare",ee,te,ge),te===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(te===void 0)return-1;if(te!==ge)return z(te,ge)}while(++ee)},L.prototype.inc=function(B,ee){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,ee,te,ge){typeof te=="string"&&(ge=te,te=void 0);try{return new L(B,te).inc(ee,ge).version}catch{return null}},e.diff=function(B,ee){if(J(B,ee))return null;var te=se(B),ge=se(ee);if(te.prerelease.length||ge.prerelease.length){for(var Se in te)if((Se==="major"||Se==="minor"||Se==="patch")&&te[Se]!==ge[Se])return"pre"+Se;return"prerelease"}for(var Se in te)if((Se==="major"||Se==="minor"||Se==="patch")&&te[Se]!==ge[Se])return Se},e.compareIdentifiers=z;var V=/^[0-9]+$/;function z(B,ee){var te=V.test(B),ge=V.test(ee);return te&&ge&&(B=+B,ee=+ee),te&&!ge?-1:ge&&!te?1:B<ee?-1:B>ee?1:0}function E(B,ee,te){return new L(B,te).compare(new L(ee,te))}function j(B,ee,te){return E(B,ee,te)>0}function X(B,ee,te){return E(B,ee,te)<0}function J(B,ee,te){return E(B,ee,te)===0}function G(B,ee,te){return E(B,ee,te)!==0}function U(B,ee,te){return E(B,ee,te)>=0}function K(B,ee,te){return E(B,ee,te)<=0}function re(B,ee,te,ge){var Se;switch(ee){case"===":typeof B=="object"&&(B=B.version),typeof te=="object"&&(te=te.version),Se=B===te;break;case"!==":typeof B=="object"&&(B=B.version),typeof te=="object"&&(te=te.version),Se=B!==te;break;case"":case"=":case"==":Se=J(B,te,ge);break;case"!=":Se=G(B,te,ge);break;case">":Se=j(B,te,ge);break;case">=":Se=U(B,te,ge);break;case"<":Se=X(B,te,ge);break;case"<=":Se=K(B,te,ge);break;default:throw new TypeError("Invalid operator: "+ee)}return Se}function ce(B,ee){if(B instanceof ce){if(B.loose===ee)return B;B=B.value}if(!(this instanceof ce))return new ce(B,ee);v("comparator",B,ee),this.loose=ee,this.parse(B),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(B,ee){return z(ee,B)},e.major=function(B,ee){return new L(B,ee).major},e.minor=function(B,ee){return new L(B,ee).minor},e.patch=function(B,ee){return new L(B,ee).patch},e.compare=E,e.compareLoose=function(B,ee){return E(B,ee,!0)},e.rcompare=function(B,ee,te){return E(ee,B,te)},e.sort=function(B,ee){return B.sort(function(te,ge){return e.compare(te,ge,ee)})},e.rsort=function(B,ee){return B.sort(function(te,ge){return e.rcompare(te,ge,ee)})},e.gt=j,e.lt=X,e.eq=J,e.neq=G,e.gte=U,e.lte=K,e.cmp=re,e.Comparator=ce;var fe={};function we(B,ee){if(B instanceof we)return B.loose===ee?B:new we(B.raw,ee);if(B instanceof ce)return new we(B.value,ee);if(!(this instanceof we))return new we(B,ee);if(this.loose=ee,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function de(B){return!B||B.toLowerCase()==="x"||B==="*"}function pe(B,ee,te,ge,Se,De,ke,Te,Re,Ce,qe,Ae,Le){return((ee=de(te)?"":de(ge)?">="+te+".0.0":de(Se)?">="+te+"."+ge+".0":">="+ee)+" "+(Te=de(Re)?"":de(Ce)?"<"+(+Re+1)+".0.0":de(qe)?"<"+Re+"."+(+Ce+1)+".0":Ae?"<="+Re+"."+Ce+"."+qe+"-"+Ae:"<="+Te)).trim()}function ye(B,ee){for(var te=0;te<B.length;te++)if(!B[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<B.length;te++)if(v(B[te].semver),B[te].semver!==fe&&B[te].semver.prerelease.length>0){var ge=B[te].semver;if(ge.major===ee.major&&ge.minor===ee.minor&&ge.patch===ee.patch)return!0}return!1}return!0}function $e(B,ee,te){try{ee=new we(ee,te)}catch{return!1}return ee.test(B)}function ve(B,ee,te,ge){var Se,De,ke,Te,Re;switch(B=new L(B,ge),ee=new we(ee,ge),te){case">":Se=j,De=K,ke=X,Te=">",Re=">=";break;case"<":Se=X,De=U,ke=j,Te="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(B,ee,ge))return!1;for(var Ce=0;Ce<ee.set.length;++Ce){var qe=ee.set[Ce],Ae=null,Le=null;if(qe.forEach(function(je){je.semver===fe&&(je=new ce(">=0.0.0")),Ae=Ae||je,Le=Le||je,Se(je.semver,Ae.semver,ge)?Ae=je:ke(je.semver,Le.semver,ge)&&(Le=je)}),Ae.operator===Te||Ae.operator===Re||(!Le.operator||Le.operator===Te)&&De(B,Le.semver)||Le.operator===Re&&ke(B,Le.semver))return!1}return!0}ce.prototype.parse=function(B){var ee=this.loose?O[W]:O[_],te=B.match(ee);if(!te)throw new TypeError("Invalid comparator: "+B);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new L(te[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(B){return v("Comparator.test",B,this.loose),this.semver===fe||(typeof B=="string"&&(B=new L(B,this.loose)),re(B,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(B,ee){if(!(B instanceof ce))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new we(B.value,ee),$e(this.value,te,ee);if(B.operator==="")return te=new we(this.value,ee),$e(B.semver,te,ee);var ge=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),De=this.semver.version===B.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Te=re(this.semver,"<",B.semver,ee)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Re=re(this.semver,">",B.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ge||Se||De&&ke||Te||Re},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(B){var ee=this.loose;B=B.trim(),v("range",B,ee);var te=ee?O[x]:O[q];B=B.replace(te,pe),v("hyphen replace",B),B=B.replace(O[M],"$1$2$3"),v("comparator trim",B,O[M]),B=(B=(B=B.replace(O[F],"$1~")).replace(O[ae],"$1^")).split(/\s+/).join(" ");var ge=ee?O[W]:O[_],Se=B.split(" ").map(function(De){return function(ke,Te){return v("comp",ke),ke=function(Re,Ce){return Re.trim().split(/\s+/).map(function(qe){return function(Ae,Le){v("caret",Ae,Le);var je=Le?O[me]:O[ue];return Ae.replace(je,function(Ue,Pe,Ie,Oe,Ne){var Fe;return v("caret",Ae,Ue,Pe,Ie,Oe,Ne),de(Pe)?Fe="":de(Ie)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de(Oe)?Fe=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":Ne?(v("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Fe=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+Ne+" <"+(+Pe+1)+".0.0"):(v("no pr"),Fe=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+" <"+(+Pe+1)+".0.0"),v("caret return",Fe),Fe})}(qe,Ce)}).join(" ")}(ke,Te),v("caret",ke),ke=function(Re,Ce){return Re.trim().split(/\s+/).map(function(qe){return function(Ae,Le){var je=Le?O[Y]:O[H];return Ae.replace(je,function(Ue,Pe,Ie,Oe,Ne){var Fe;return v("tilde",Ae,Ue,Pe,Ie,Oe,Ne),de(Pe)?Fe="":de(Ie)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de(Oe)?Fe=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":Ne?(v("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Fe=">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+(+Ie+1)+".0"):Fe=">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0",v("tilde return",Fe),Fe})}(qe,Ce)}).join(" ")}(ke,Te),v("tildes",ke),ke=function(Re,Ce){return v("replaceXRanges",Re,Ce),Re.split(/\s+/).map(function(qe){return function(Ae,Le){Ae=Ae.trim();var je=Le?O[T]:O[N];return Ae.replace(je,function(Ue,Pe,Ie,Oe,Ne,Fe){v("xRange",Ae,Ue,Pe,Ie,Oe,Ne,Fe);var Ve=de(Ie),Me=Ve||de(Oe),Be=Me||de(Ne);return Pe==="="&&Be&&(Pe=""),Ve?Ue=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(Me&&(Oe=0),Be&&(Ne=0),Pe===">"?(Pe=">=",Me?(Ie=+Ie+1,Oe=0,Ne=0):Be&&(Oe=+Oe+1,Ne=0)):Pe==="<="&&(Pe="<",Me?Ie=+Ie+1:Oe=+Oe+1),Ue=Pe+Ie+"."+Oe+"."+Ne):Me?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),v("xRange return",Ue),Ue})}(qe,Ce)}).join(" ")}(ke,Te),v("xrange",ke),ke=function(Re,Ce){return v("replaceStars",Re,Ce),Re.trim().replace(O[Q],"")}(ke,Te),v("stars",ke),ke}(De,ee)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(De){return!!De.match(ge)})),Se=Se.map(function(De){return new ce(De,ee)})},we.prototype.intersects=function(B,ee){if(!(B instanceof we))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(ge){return B.set.some(function(Se){return Se.every(function(De){return ge.intersects(De,ee)})})})})},e.toComparators=function(B,ee){return new we(B,ee).set.map(function(te){return te.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},we.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new L(B,this.loose));for(var ee=0;ee<this.set.length;ee++)if(ye(this.set[ee],B))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(B,ee,te){var ge=null,Se=null;try{var De=new we(ee,te)}catch{return null}return B.forEach(function(ke){De.test(ke)&&(ge&&Se.compare(ke)!==-1||(Se=new L(ge=ke,te)))}),ge},e.minSatisfying=function(B,ee,te){var ge=null,Se=null;try{var De=new we(ee,te)}catch{return null}return B.forEach(function(ke){De.test(ke)&&(ge&&Se.compare(ke)!==1||(Se=new L(ge=ke,te)))}),ge},e.validRange=function(B,ee){try{return new we(B,ee).range||"*"}catch{return null}},e.ltr=function(B,ee,te){return ve(B,ee,"<",te)},e.gtr=function(B,ee,te){return ve(B,ee,">",te)},e.outside=ve,e.prerelease=function(B,ee){var te=se(B,ee);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(B,ee,te){return B=new we(B,te),ee=new we(ee,te),B.intersects(ee)},e.coerce=function(B){if(B instanceof L)return B;if(typeof B!="string")return null;var ee=B.match(O[D]);return ee==null?null:se((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,P(1))},function(Z,e){var P,I,v=Z.exports={};function k(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function O(b){if(P===setTimeout)return setTimeout(b,0);if((P===k||!P)&&setTimeout)return P=setTimeout,setTimeout(b,0);try{return P(b,0)}catch{try{return P.call(null,b,0)}catch{return P.call(this,b,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:k}catch{P=k}try{I=typeof clearTimeout=="function"?clearTimeout:C}catch{I=C}})();var g,l=[],d=!1,h=-1;function w(){d&&g&&(d=!1,g.length?l=g.concat(l):h=-1,l.length&&f())}function f(){if(!d){var b=O(w);d=!0;for(var y=l.length;y;){for(g=l,l=[];++h<y;)g&&g[h].run();h=-1,y=l.length}g=null,d=!1,function(u){if(I===clearTimeout)return clearTimeout(u);if((I===C||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(u);try{I(u)}catch{try{return I.call(null,u)}catch{return I.call(this,u)}}}(b)}}function p(b,y){this.fun=b,this.array=y}function S(){}v.nextTick=function(b){var y=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)y[u-1]=arguments[u];l.push(new p(b,y)),l.length!==1||d||O(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=S,v.addListener=S,v.once=S,v.off=S,v.removeListener=S,v.removeAllListeners=S,v.emit=S,v.prependListener=S,v.prependOnceListener=S,v.listeners=function(b){return[]},v.binding=function(b){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(b){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(le[81],he([0,1]),function(Z,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class I{constructor(O,g,l){this.level=O,this.key=g,this.value=l,this.forward=[]}}const v=void 0;class k{constructor(O,g=2**16){this.comparator=O,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new I(this.c,v,v)}get size(){return this.f}clear(){this.e=new I(this.c,v,v),this.f=0}has(O){return!!k.g(this,O,this.comparator)}get(O){return k.g(this,O,this.comparator)?.value}set(O,g){return k.h(this,O,g,this.comparator)&&(this.f+=1),this}delete(O){const g=k.k(this,O,this.comparator);return g&&(this.f-=1),g}forEach(O,g){let l=this.e.forward[0];for(;l;)O.call(g,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",g=this.e.forward[0];for(;g;)O+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return O}static g(O,g,l){let d=O.e;for(let h=O.d-1;h>=0;h--)for(;d.forward[h]&&l(d.forward[h].key,g)<0;)d=d.forward[h];if(d=d.forward[0],d&&l(d.key,g)===0)return d}static h(O,g,l,d){const h=[];let w=O.e;for(let f=O.d-1;f>=0;f--){for(;w.forward[f]&&d(w.forward[f].key,g)<0;)w=w.forward[f];h[f]=w}if(w=w.forward[0],w&&d(w.key,g)===0)return w.value=l,!1;{const f=k.j(O);if(f>O.d){for(let p=O.d;p<f;p++)h[p]=O.e;O.d=f}w=new I(f,g,l);for(let p=0;p<f;p++)w.forward[p]=h[p].forward[p],h[p].forward[p]=w;return!0}}static j(O,g=.5){let l=1;for(;Math.random()<g&&l<O.c;)l+=1;return l}static k(O,g,l){const d=[];let h=O.e;for(let w=O.d-1;w>=0;w--){for(;h.forward[w]&&l(h.forward[w].key,g)<0;)h=h.forward[w];d[w]=h}if(h=h.forward[0],!h||l(h.key,g)!==0)return!1;for(let w=0;w<O.d&&d[w].forward[w]===h;w++)d[w].forward[w]=h.forward[w];for(;O.d>0&&O.e.forward[O.d-1]===v;)O.d-=1;return!0}}e.$Zs=k}),define(le[47],he([0,1,7,2]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=v,e.$Ce=k,e.$De=C,e.$Ee=O,e.$Fe=l,e.$Ge=d,e.$He=h,e.$Ie=w,e.$Je=f,e.$Ke=p,e.$Le=S,e.$Me=b,e.$Ne=y,e.$Oe=u,e.$Pe=R;function v($){const i=$;return i?typeof i.read=="function":!1}function k($){const i=$;return i?[i.on,i.pause,i.resume,i.destroy].every(a=>typeof a=="function"):!1}function C($){const i=$;return i?k(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function O($,i){return new g($,i)}class g{constructor(i,a){this.e=i,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(a=>a(i))}h(i){this.c.error.length===0?(0,P.$2)(i):this.c.error.slice(0).forEach(a=>a(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,a){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(i,a){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(a);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l($,i){const a=[];let n;for(;(n=$.read())!==null;)a.push(n);return i(a)}function d($,i,a){const n=[];let r;for(;(r=$.read())!==null&&n.length<a;)n.push(r);return r===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return $.read()}}}function h($,i){return new Promise((a,n)=>{const r=[];w($,{onData:t=>{i&&r.push(t)},onError:t=>{i?n(t):a(void 0)},onEnd:()=>{a(i?i(r):void 0)}})})}function w($,i,a){$.on("error",n=>{a?.isCancellationRequested||i.onError(n)}),$.on("end",()=>{a?.isCancellationRequested||i.onEnd()}),$.on("data",n=>{a?.isCancellationRequested||i.onData(n)})}function f($,i){return new Promise((a,n)=>{const r=new I.$Wc,t=[],s=m=>{if(t.push(m),t.length>i)return r.dispose(),$.pause(),a({stream:$,buffer:t,ended:!1})},o=m=>(r.dispose(),n(m)),c=()=>(r.dispose(),a({stream:$,buffer:t,ended:!0}));r.add((0,I.$Vc)(()=>$.removeListener("error",o))),$.on("error",o),r.add((0,I.$Vc)(()=>$.removeListener("end",c))),$.on("end",c),r.add((0,I.$Vc)(()=>$.removeListener("data",s))),$.on("data",s)})}function p($,i){const a=O(i);return a.end($),a}function S(){const $=O(()=>{throw new Error("not supported")});return $.end(),$}function b($){let i=!1;return{read:()=>i?null:(i=!0,$)}}function y($,i,a){const n=O(a);return w($,{onData:r=>n.write(i.data(r)),onError:r=>n.error(i.error?i.error(r):r),onEnd:()=>n.end()}),n}function u($,i,a){let n=!1;return{read:()=>{const r=i.read();return n?r:(n=!0,r!==null?a([$,r]):$)}}}function R($,i,a){let n=!1;const r=O(a);return w(i,{onData:t=>n?r.write(t):(n=!0,r.write(a([$,t]))),onError:t=>r.error(t),onEnd:()=>{n||(n=!0,r.write($)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(Z,e,P,I){I===void 0&&(I=P);var v=Object.getOwnPropertyDescriptor(e,P);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(Z,I,v)}:function(Z,e,P,I){I===void 0&&(I=P),Z[I]=e[P]}),He=this&&this.__setModuleDefault||(Object.create?function(Z,e){Object.defineProperty(Z,"default",{enumerable:!0,value:e})}:function(Z,e){Z.default=e}),be=this&&this.__importStar||function(Z){if(Z&&Z.__esModule)return Z;var e={};if(Z!=null)for(var P in Z)P!=="default"&&Object.prototype.hasOwnProperty.call(Z,P)&&We(e,Z,P);return He(e,Z),e};define(le[13],he([0,1,147,47]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=l,e.$Se=d,e.$Te=h,e.$Ue=w,e.$Ve=f,e.$We=p,e.$Xe=S,e.$Ye=b,e.$Ze=y,e.$1e=u,e.$2e=R,e.$3e=$,e.$4e=i,e.$5e=a,e.$6e=n,e.$7e=r,e.$8e=t,e.$9e=s,e.$0e=o,e.$$e=N,I=be(I);const v=typeof Buffer<"u",k=new P.$W(()=>new Uint8Array(256));let C,O;class g{static alloc(D){return v?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return v&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,A){return!(A?.dontUseNodeBuffer||!1)&&v?new g(Buffer.from(D)):(C||(C=new TextEncoder),new g(C.encode(D)))}static fromByteArray(D){const A=g.alloc(D.length);for(let F=0,H=D.length;F<H;F++)A.buffer[F]=D[F];return A}static concat(D,A){if(typeof A>"u"){A=0;for(let Y=0,ne=D.length;Y<ne;Y++)A+=D[Y].byteLength}const F=g.alloc(A);let H=0;for(let Y=0,ne=D.length;Y<ne;Y++){const ae=D[Y];F.set(ae,H),H+=ae.byteLength}return F}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return v?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(D,A){return new g(this.buffer.subarray(D,A))}set(D,A){if(D instanceof g)this.buffer.set(D.buffer,A);else if(D instanceof Uint8Array)this.buffer.set(D,A);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),A);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return w(this.buffer,D)}writeUInt32BE(D,A){f(this.buffer,D,A)}readUInt32LE(D){return p(this.buffer,D)}writeUInt32LE(D,A){S(this.buffer,D,A)}readUInt8(D){return b(this.buffer,D)}writeUInt8(D,A){y(this.buffer,D,A)}indexOf(D,A=0){return l(this.buffer,D instanceof g?D.buffer:D,A)}}e.$Qe=g;function l(T,D,A=0){const F=D.byteLength,H=T.byteLength;if(F===0)return 0;if(F===1)return T.indexOf(D[0]);if(F>H-A)return-1;const Y=k.value;Y.fill(D.length);for(let me=0;me<D.length;me++)Y[D[me]]=D.length-me-1;let ne=A+D.length-1,ae=ne,ue=-1;for(;ne<H;)if(T[ne]===D[ae]){if(ae===0){ue=ne;break}ne--,ae--}else ne+=Math.max(D.length-ae,Y[T[ne]]),ae=D.length-1;return ue}function d(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0}function h(T,D,A){T[A+0]=D&255,D=D>>>8,T[A+1]=D&255}function w(T,D){return T[D]*2**24+T[D+1]*2**16+T[D+2]*2**8+T[D+3]}function f(T,D,A){T[A+3]=D,D=D>>>8,T[A+2]=D,D=D>>>8,T[A+1]=D,D=D>>>8,T[A]=D}function p(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0|T[D+2]<<16>>>0|T[D+3]<<24>>>0}function S(T,D,A){T[A+0]=D&255,D=D>>>8,T[A+1]=D&255,D=D>>>8,T[A+2]=D&255,D=D>>>8,T[A+3]=D&255}function b(T,D){return T[D]}function y(T,D,A){T[A]=D}function u(T){return I.$Fe(T,D=>g.concat(D))}function R(T){return I.$Me(T)}function $(T){return I.$He(T,D=>g.concat(D))}async function i(T){return T.ended?g.concat(T.buffer):g.concat([...T.buffer,await $(T.stream)])}function a(T){return I.$Ke(T,D=>g.concat(D))}function n(T){return I.$Ne(T,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}function r(T){return I.$Ee(D=>g.concat(D),T)}function t(T,D){return I.$Oe(T,D,A=>g.concat(A))}function s(T,D){return I.$Pe(T,D,A=>g.concat(A))}function o(T){let D=0,A=0,F=0;const H=new Uint8Array(Math.floor(T.length/4*3)),Y=ae=>{switch(A){case 3:H[F++]=D|ae,A=0;break;case 2:H[F++]=D|ae>>>2,D=ae<<6,A=3;break;case 1:H[F++]=D|ae>>>4,D=ae<<4,A=2;break;default:D=ae<<2,A=1}};for(let ae=0;ae<T.length;ae++){const ue=T.charCodeAt(ae);if(ue>=65&&ue<=90)Y(ue-65);else if(ue>=97&&ue<=122)Y(ue-97+26);else if(ue>=48&&ue<=57)Y(ue-48+52);else if(ue===43||ue===45)Y(62);else if(ue===47||ue===95)Y(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ae]}`)}}const ne=F;for(;A>0;)Y(0);return g.wrap(H).slice(0,ne)}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:T},D=!0,A=!1){const F=A?m:c;let H="";const Y=T.byteLength%3;let ne=0;for(;ne<T.byteLength-Y;ne+=3){const ae=T[ne+0],ue=T[ne+1],me=T[ne+2];H+=F[ae>>>2],H+=F[(ae<<4|ue>>>4)&63],H+=F[(ue<<2|me>>>6)&63],H+=F[me&63]}if(Y===1){const ae=T[ne+0];H+=F[ae>>>2],H+=F[ae<<4&63],D&&(H+="==")}else if(Y===2){const ae=T[ne+0],ue=T[ne+1];H+=F[ae>>>2],H+=F[(ae<<4|ue>>>4)&63],H+=F[ue<<2&63],D&&(H+="=")}return H}}),define(le[27],he([0,1,3]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=I,e.$jo=v,e.$ko=C,e.$lo=g,e.$mo=l,e.$no=d,e.$oo=h,e.$po=w,e.$qo=f,e.$ro=p,e.$so=S,e.$to=b,e.$uo=y;function I(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const R=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([$,i])=>{R[$]=i&&typeof i=="object"?I(i):i}),R}function v(u){if(!u||typeof u!="object")return u;const R=[u];for(;R.length>0;){const $=R.shift();Object.freeze($);for(const i in $)if(k.call($,i)){const a=$[i];typeof a=="object"&&!Object.isFrozen(a)&&!(0,P.$kg)(a)&&R.push(a)}}return u}const k=Object.prototype.hasOwnProperty;function C(u,R){return O(u,R,new Set)}function O(u,R,$){if((0,P.$qg)(u))return u;const i=R(u);if(typeof i<"u")return i;if(Array.isArray(u)){const a=[];for(const n of u)a.push(O(n,R,$));return a}if((0,P.$jg)(u)){if($.has(u))throw new Error("Cannot clone recursive data-structure");$.add(u);const a={};for(const n in u)k.call(u,n)&&(a[n]=O(u[n],R,$));return $.delete(u),a}return u}function g(u,R,$=!0){return(0,P.$jg)(u)?((0,P.$jg)(R)&&Object.keys(R).forEach(i=>{i in u?$&&((0,P.$jg)(u[i])&&(0,P.$jg)(R[i])?g(u[i],R[i],$):u[i]=R[i]):u[i]=R[i]}),u):R}function l(u,R){if(u===R)return!0;if(u==null||R===null||R===void 0||typeof u!=typeof R||typeof u!="object"||Array.isArray(u)!==Array.isArray(R))return!1;let $,i;if(Array.isArray(u)){if(u.length!==R.length)return!1;for($=0;$<u.length;$++)if(!l(u[$],R[$]))return!1}else{const a=[];for(i in u)a.push(i);a.sort();const n=[];for(i in R)n.push(i);if(n.sort(),!l(a,n))return!1;for($=0;$<a.length;$++)if(!l(u[a[$]],R[a[$]]))return!1}return!0}function d(u){const R=new Set;return JSON.stringify(u,($,i)=>{if((0,P.$jg)(i)||Array.isArray(i)){if(R.has(i))return"[Circular]";R.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function h(u,R){const $=Object.create(null);return!u||!R||Object.keys(R).forEach(a=>{const n=u[a],r=R[a];l(n,r)||($[a]=r)}),$}function w(u,R){const $=R.toLowerCase(),i=Object.keys(u).find(a=>a.toLowerCase()===$);return i?u[i]:u[R]}function f(u,R){const $=Object.create(null);for(const[i,a]of Object.entries(u))R(i,a)&&($[i]=a);return $}function p(u){let R=[];for(;Object.prototype!==u;)R=R.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return R}function S(u){const R=[];for(const $ of p(u))typeof u[$]=="function"&&R.push($);return R}function b(u,R){const $=a=>function(){const n=Array.prototype.slice.call(arguments,0);return R(a,n)},i={};for(const a of u)i[a]=$(a);return i}function y(u,R){const $={};for(const[i,a]of Object.entries(u))$[i]=R(a,i);return $}}),define(le[43],he([0,1,31]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Aj=void 0,e.$wj=I,e.$xj=v,e.$yj=k,e.$zj=O,e.$Bj=S,P=be(P);function I(y){return v(y,0)}function v(y,u){switch(typeof y){case"object":return y===null?k(349,u):Array.isArray(y)?g(y,u):l(y,u);case"string":return O(y,u);case"boolean":return C(y,u);case"number":return k(y,u);case"undefined":return k(937,u);default:return k(617,u)}}function k(y,u){return(u<<5)-u+y|0}function C(y,u){return k(y?433:863,u)}function O(y,u){u=k(149417,u);for(let R=0,$=y.length;R<$;R++)u=k(y.charCodeAt(R),u);return u}function g(y,u){return u=k(104579,u),y.reduce((R,$)=>v($,R),u)}function l(y,u){return u=k(181387,u),Object.keys(y).sort().reduce((R,$)=>(R=O($,R),v(y[$],R)),u)}class d{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=v(u,this.g),this.g}}e.$Aj=d;var h;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function w(y,u,R=32){const $=R-u,i=~((1<<$)-1);return(y<<u|(i&y)>>>$)>>>0}function f(y,u=0,R=y.byteLength,$=0){for(let i=0;i<R;i++)y[u+i]=$}function p(y,u,R="0"){for(;y.length<u;)y=R+y;return y}function S(y,u=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(R=>R.toString(16).padStart(2,"0")).join(""):p((y>>>0).toString(16),u/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(h.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const R=u.length;if(R===0)return;const $=this.p;let i=this.r,a=this.u,n,r;for(a!==0?(n=a,r=-1,a=0):(n=u.charCodeAt(0),r=0);;){let t=n;if(P.$Mf(n))if(r+1<R){const s=u.charCodeAt(r+1);P.$Nf(s)?(r++,t=P.$Of(n,s)):t=h.UNICODE_REPLACEMENT}else{a=n;break}else P.$Nf(n)&&(t=h.UNICODE_REPLACEMENT);if(i=this.w($,i,t),r++,r<R)n=u.charCodeAt(r);else break}this.r=i,this.u=a}w(u,R,$){return $<128?u[R++]=$:$<2048?(u[R++]=192|($&1984)>>>6,u[R++]=128|($&63)>>>0):$<65536?(u[R++]=224|($&61440)>>>12,u[R++]=128|($&4032)>>>6,u[R++]=128|($&63)>>>0):(u[R++]=240|($&1835008)>>>18,u[R++]=128|($&258048)>>>12,u[R++]=128|($&4032)>>>6,u[R++]=128|($&63)>>>0),R>=h.BLOCK_SIZE&&(this.y(),R-=h.BLOCK_SIZE,this.t+=h.BLOCK_SIZE,u[0]=u[h.BLOCK_SIZE+0],u[1]=u[h.BLOCK_SIZE+1],u[2]=u[h.BLOCK_SIZE+2]),R}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,h.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=b.g,R=this.q;for(let c=0;c<64;c+=4)u.setUint32(c,R.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)u.setUint32(c,w(u.getUint32(c-12,!1)^u.getUint32(c-32,!1)^u.getUint32(c-56,!1)^u.getUint32(c-64,!1),1),!1);let $=this.h,i=this.l,a=this.m,n=this.n,r=this.o,t,s,o;for(let c=0;c<80;c++)c<20?(t=i&a|~i&n,s=1518500249):c<40?(t=i^a^n,s=1859775393):c<60?(t=i&a|i&n|a&n,s=2400959708):(t=i^a^n,s=3395469782),o=w($,5)+t+r+s+u.getUint32(c*4,!1)&4294967295,r=n,n=a,a=w(i,30),i=$,$=o;this.h=this.h+$&4294967295,this.l=this.l+i&4294967295,this.m=this.m+a&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.$Cj=b}),define(le[58],he([0,1,31]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=be(P);var I;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(I||(I={})),function(v){const k="error",C="warning",O="warn",g="info",l="ignore";function d(w){return w?P.$If(k,w)?v.Error:P.$If(C,w)||P.$If(O,w)?v.Warning:P.$If(g,w)?v.Info:v.Ignore:v.Ignore}v.fromValue=d;function h(w){switch(w){case v.Error:return k;case v.Warning:return C;case v.Info:return g;default:return l}}v.toString=h}(I||(I={})),e.default=I}),define(le[82],he([0,1,12]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=I,e.$kr=v,e.$lr=k,e.log=O;function I(l){const d=l;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function v(l){const d=[];let h;try{const w=JSON.parse(l.arguments),f=w[w.length-1];f&&f.__$stack&&(w.pop(),h=f.__$stack),d.push(...w)}catch{d.push("Unable to log remote console arguments",l.arguments)}return{args:d,stack:h}}function k(l){if(typeof l!="string")return k(v(l).stack);const d=l;if(d){const h=C(d),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(w&&w.length===4)return{uri:P.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function C(l){if(!l)return l;const d=l.indexOf(`
`);return d===-1?l:l.substring(0,d)}function O(l,d){const{args:h,stack:w}=v(l),f=typeof h[0]=="string"&&h.length===1;let p=C(w);p&&(p=`(${p.trim()})`);let S=[];if(typeof h[0]=="string"?p&&f?S=[`%c[${d}] %c${h[0]} %c${p}`,g("blue"),g(""),g("grey")]:S=[`%c[${d}] %c${h[0]}`,g("blue"),g(""),...h.slice(1)]:S=[`%c[${d}]%`,g("blue"),...h],p&&!f&&S.push(p),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,S)}function g(l){return`color: ${l}`}}),define(le[48],he([0,1,13,12,148]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=k,e.$ei=C,e.$fi=g;function k(l){return JSON.stringify(l,O)}function C(l){let d=JSON.parse(l);return d=g(d),d}function O(l,d){return d instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:d.source,flags:d.flags}:d}function g(l,d=0){if(!l||d>200)return l;if(typeof l=="object"){switch(l.$mid){case v.MarshalledId.Uri:return I.URI.revive(l);case v.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case v.MarshalledId.Date:return new Date(l.source)}if(l instanceof P.$Qe||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let h=0;h<l.length;++h)l[h]=g(l[h],d+1);else for(const h in l)Object.hasOwnProperty.call(l,h)&&(l[h]=g(l[h],d+1))}return l}}),define(le[59],he([0,1,55,14,11,3,12]),function(Z,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=h,e.$yq=w,v=be(v);class O{constructor(p,S,b){this.id=p,this.dependencies=S,this.callback=b}}class g{static{this.INSTANCE=new g}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){if(!this.d){this.d=!0,globalThis.define=(p,S,b)=>{typeof p!="string"&&(b=S,S=p,p=null),(typeof S!="object"||!Array.isArray(S))&&(b=S,S=null),this.c.push(new O(p,S,b))},globalThis.define.amd=!0;try{this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}}))}catch(p){console.warn(p)}}}async load(p){this.g();const S=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!S){console.warn(`Did not receive a define call from script ${p}`);return}if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(p){return new Promise((S,b)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const u=()=>{y.removeEventListener("load",R),y.removeEventListener("error",$)},R=i=>{u(),S(this.c.pop())},$=i=>{u(),b(i)};y.addEventListener("load",R),y.addEventListener("error",$),this.f&&(p=this.f.createScriptURL(p)),y.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(y)})}async i(p){return this.f&&(p=this.f.createScriptURL(p)),P.$T?await new Promise((S,b)=>{Z([p],S,b)}).then(be):importScripts(p),this.c.pop()}async j(p){try{const S=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,u=C.URI.parse(p).fsPath,R=S.readFileSync(u).toString(),$=y.wrap(R.replace(/^#!.*/,""));return new b.Script($).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const l=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function h(f,p,S){if(P.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[f]&&(f=d[f]);const b=p?`${f}/${p}`:f;if(l.has(b))return l.get(b);let y;if(/^\w[\w\d+.-]*:\/\//.test(b))y=b;else{const i=`${P.$U&&S&&!v.$p?I.$Zg:I.$Yg}/${b}`;y=I.$3g.asBrowserUri(i).toString(!0)}const u=g.INSTANCE.load(y);return l.set(b,u),u}else return await new Promise((b,y)=>{Z([f],b,y)}).then(be)}function w(f,p){(0,k.$rg)(P.$T);const b=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,y=P.$U&&b&&!v.$p,u=`${f}/${p}`,$=`${y?I.$Zg:I.$Yg}/${u}`;return I.$3g.asBrowserUri($).toString(!0)}}),define(le[28],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=I;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(v){return P.test(v)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(O){for(let g=0;g<O.length;g++)O[g]=Math.floor(Math.random()*256);return O};const k=new Uint8Array(16),C=[];for(let O=0;O<256;O++)C.push(O.toString(16).padStart(2,"0"));return function(){v(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,l="";return l+=C[k[g++]],l+=C[k[g++]],l+=C[k[g++]],l+=C[k[g++]],l+="-",l+=C[k[g++]],l+=C[k[g++]],l+="-",l+=C[k[g++]],l+=C[k[g++]],l+="-",l+=C[k[g++]],l+=C[k[g++]],l+="-",l+=C[k[g++]],l+=C[k[g++]],l+=C[k[g++]],l+=C[k[g++]],l+=C[k[g++]],l+=C[k[g++]],l}}()}),define(le[83],he([0,1,35]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=k;const I=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(C){const O=C.replace(/\-/g,":").toLowerCase();return!I.has(O)}function k(){const C=(0,P.networkInterfaces)();for(const O in C){const g=C[O];if(g){for(const{mac:l}of g)if(v(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[84],he([0,1,35,49,28,83,11]),function(Z,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0,e.$Xn=g,e.$Yn=h,e.$Zn=w,v=be(v),e.$Wn=new class{c(f){return this.a||(this.a=I.$Oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(f)}value(){if(this.b===void 0){let f=0,p=0;const S=(0,P.networkInterfaces)();for(const b in S){const y=S[b];if(y)for(const{mac:u,internal:R}of y)R||(p+=1,this.c(u.toUpperCase())&&(f+=1))}this.b=p>0?f/p:0}return this.b}};let O;async function g(f){return O||(O=(async()=>await l(f)||v.$5g())()),O}async function l(f){try{const p=await new Promise((b,y)=>{Z(["crypto"],b,y)}).then(be),S=(0,k.$Vn)();return p.createHash("sha256").update(S,"utf8").digest("hex")}catch(p){f(p);return}}const d="Software\\Microsoft\\SQMClient";async function h(f){if(C.$j){const p=await new Promise((S,b)=>{Z(["@vscode/windows-registry"],S,b)}).then(be);try{return p.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(S){return f(S),""}}return""}async function w(f){try{return await(await new Promise((b,y)=>{Z(["@vscode/deviceid"],b,y)}).then(be)).getDeviceId()}catch(p){return f(p),""}}}),define(le[85],he([0,1,35,15,29]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=u,e.$Am=R,P=be(P),I=be(I),v=be(v);const k=/^\d+$/,C=/^Microsoft.PowerShell_.*/,O=/^Microsoft.PowerShellPreview_.*/;var g;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(g||(g={}));let l;switch(process.arch){case"ia32":l=g.x86;break;case"arm":case"arm64":l=g.ARM;break;default:l=g.x64;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=g.x86:d=g.x64;class h{constructor(i,a,n){this.exePath=i,this.displayName=a,this.a=n}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:$=!1}={}){return $?l===g.x64?process.env["ProgramFiles(x86)"]||null:d===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:$=!1,findPreview:i=!1}={}){const a=w({useAlternateBitness:$});if(!a)return null;const n=I.$mc(a,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(n))return null;let r=-1,t=null;for(const c of await v.Promises.readdir(n)){let m=-1;if(i){const T=c.indexOf("-");if(T<0)continue;const D=c.substring(0,T);if(!k.test(D)||c.substring(T+1)!=="preview")continue;m=parseInt(D,10)}else{if(!k.test(c))continue;m=parseInt(c,10)}if(m<=r)continue;const N=I.$mc(n,c,"pwsh.exe");await v.SymlinkSupport.existsFile(N)&&(t=N,r=m)}if(!t)return null;const s=a.includes("x86")?" (x86)":"",o=i?" Preview":"";return new h(t,`PowerShell${o}${s}`,!0)}async function p({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const i=I.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:a,pwshMsixName:n}=$?{pwshMsixDirRegex:O,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await v.Promises.readdir(i))if(a.test(r)){const t=I.$mc(i,r,"pwsh.exe");return new h(t,n)}return null}function S(){const $=I.$mc(P.homedir(),".dotnet","tools","pwsh.exe");return new h($,".NET Core PowerShell Global Tool")}function b(){const $=I.$mc(process.env.windir,l===g.x86&&d!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h($,"Windows PowerShell",!0)}async function*y(){let $=await f();$&&(yield $),$=await f({useAlternateBitness:!0}),$&&(yield $),$=await p(),$&&(yield $),$=S(),$&&(yield $),$=await f({findPreview:!0}),$&&(yield $),$=await p({findPreview:!0}),$&&(yield $),$=await f({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=b(),$&&(yield $)}async function*u(){for await(const $ of y())await $.exists()&&(yield $)}async function R(){for await(const $ of u())return $;return null}}),define(le[60],he([0,1,32,15,11,36,57,3,29]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Bm=l,e.$Cm=d,I=be(I),v=be(v),k=be(k),O=be(O),g=be(g),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function l(w=k.env){return w.comspec||"cmd.exe"}function d(w){let f=[],p=!1;const S=function(b){if(p){f.push(b);return}(!w.send(b,u=>{if(u&&console.error(u),p=!1,f.length>0){const R=f.slice(0);f=[],R.forEach($=>S($))}})||v.$j)&&(p=!0)};return{send:S}}var h;(function(w){async function f(p,S,b){if(I.$lc(p))return p;if(S===void 0&&(S=k.cwd()),I.$pc(p)!=="."||(b===void 0&&O.$hg(k.env.PATH)&&(b=k.env.PATH.split(I.$wc)),b===void 0||b.length===0))return I.$mc(S,p);async function u(R){if(await g.Promises.exists(R)){let $;try{$=await P.promises.stat(R)}catch(i){i.message.startsWith("EACCES")&&($=await P.promises.lstat(R))}return $?!$.isDirectory():!1}return!1}for(const R of b){let $;if(I.$lc(R)?$=I.$mc(R,p):$=I.$mc(S,R,p),await u($))return $;let i=$+".com";if(await u(i)||(i=$+".exe",await u(i)))return i}return I.$mc(S,p)}w.findExecutable=f})(h||(e.win32=h={}))}),define(le[86],he([0,1,35,11,85,60]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=C,I=be(I),k=be(k);async function C(h,w){return h===I.OperatingSystem.Windows?I.$j?d():k.$Bm(w):g(h,w)}let O=null;function g(h,w){if(I.$l&&h===I.OperatingSystem.Macintosh||I.$k&&h===I.OperatingSystem.Linux)return"/bin/bash";if(!O){let f;if(I.$j)f="/bin/bash";else{if(f=w.SHELL,!f)try{f=(0,P.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}O=f}return O}let l=null;async function d(){return l||(l=(await(0,v.$Am)()).exePath),l}});var Ee=this&&this.__decorate||function(Z,e,P,I){var v=arguments.length,k=v<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,P):I,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Z,e,P,I);else for(var O=Z.length-1;O>=0;O--)(C=Z[O])&&(k=(v<3?C(k):v>3?C(e,P,k):C(e,P))||k);return v>3&&k&&Object.defineProperty(e,P,k),k};define(le[61],he([0,1,19,8,13,21,56,7,4,2,48,31,3]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.ProxyChannel=e.$qi=e.$ni=e.$mi=e.$li=e.RequestInitiator=e.$ki=e.$hi=e.$gi=void 0,e.$ii=o,e.$ji=c,e.$oi=F,e.$pi=H,h=be(h);var f;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(f||(f={}));function p(M){switch(M){case f.Promise:return"req";case f.PromiseCancel:return"cancel";case f.EventListen:return"subscribe";case f.EventDispose:return"unsubscribe"}}var S;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(S||(S={}));function b(M){switch(M){case S.Initialize:return"init";case S.PromiseSuccess:return"reply:";case S.PromiseError:case S.PromiseErrorObj:return"replyErr:";case S.EventFire:return"event:"}}var y;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(y||(y={}));function u(M){let q=0;for(let x=0;;x+=7){const Q=M.read(1);if(q|=(Q.buffer[0]&127)<<x,!(Q.buffer[0]&128))return q}}const R=r(0);function $(M,q){if(q===0){M.write(R);return}let x=0;for(let ie=q;ie!==0;ie=ie>>>7)x++;const Q=v.$Qe.alloc(x);for(let ie=0;q!==0;ie++)Q.buffer[ie]=q&127,q=q>>>7,q>0&&(Q.buffer[ie]|=128);M.write(Q)}class i{constructor(q){this.b=q,this.a=0}read(q){const x=this.b.slice(this.a,this.a+q);return this.a+=x.byteLength,x}}e.$gi=i;class a{constructor(){this.a=[]}get buffer(){return v.$Qe.concat(this.a)}write(q){this.a.push(q)}}e.$hi=a;var n;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(n||(n={}));function r(M){const q=v.$Qe.alloc(1);return q.writeUInt8(M,0),q}const t={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(M,q){if(typeof q>"u")M.write(t.Undefined);else if(typeof q=="string"){const x=v.$Qe.fromString(q);M.write(t.String),$(M,x.byteLength),M.write(x)}else if(s&&Buffer.isBuffer(q)){const x=v.$Qe.wrap(q);M.write(t.Buffer),$(M,x.byteLength),M.write(x)}else if(q instanceof v.$Qe)M.write(t.VSBuffer),$(M,q.byteLength),M.write(q);else if(Array.isArray(q)){M.write(t.Array),$(M,q.length);for(const x of q)o(M,x)}else if(typeof q=="number"&&(q|0)===q)M.write(t.Uint),$(M,q);else{const x=v.$Qe.fromString(JSON.stringify(q));M.write(t.Object),$(M,x.byteLength),M.write(x)}}function c(M){switch(M.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return M.read(u(M)).toString();case n.Buffer:return M.read(u(M)).buffer;case n.VSBuffer:return M.read(u(M));case n.Array:{const x=u(M),Q=[];for(let ie=0;ie<x;ie++)Q.push(c(M));return Q}case n.Object:return JSON.parse(M.read(u(M)).toString());case n.Int:return u(M)}}class m{constructor(q,x,Q=null,ie=1e3){this.h=q,this.j=x,this.k=Q,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:S.Initialize})}registerChannel(q,x){this.b.set(q,x),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case S.Initialize:{const x=this.o([q.type]);this.k?.logOutgoing(x,0,N.OtherSide,b(q.type));return}case S.PromiseSuccess:case S.PromiseError:case S.EventFire:case S.PromiseErrorObj:{const x=this.o([q.type,q.id],q.data);this.k?.logOutgoing(x,q.id,N.OtherSide,b(q.type),q.data);return}}}o(q,x=void 0){const Q=new a;return o(Q,q),o(Q,x),this.p(Q.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const x=new i(q),Q=c(x),ie=c(x),se=Q[0];switch(se){case f.Promise:return this.k?.logIncoming(q.byteLength,Q[1],N.OtherSide,`${p(se)}: ${Q[2]}.${Q[3]}`,ie),this.s({type:se,id:Q[1],channelName:Q[2],name:Q[3],arg:ie});case f.EventListen:return this.k?.logIncoming(q.byteLength,Q[1],N.OtherSide,`${p(se)}: ${Q[2]}.${Q[3]}`,ie),this.t({type:se,id:Q[1],channelName:Q[2],name:Q[3],arg:ie});case f.PromiseCancel:return this.k?.logIncoming(q.byteLength,Q[1],N.OtherSide,`${p(se)}`),this.u({type:se,id:Q[1]});case f.EventDispose:return this.k?.logIncoming(q.byteLength,Q[1],N.OtherSide,`${p(se)}`),this.u({type:se,id:Q[1]})}}s(q){const x=this.b.get(q.channelName);if(!x){this.v(q);return}const Q=new k.$ze;let ie;try{ie=x.call(this.j,q.name,q.arg,Q.token)}catch(V){ie=Promise.reject(V)}const se=q.id;ie.then(V=>{this.m({id:se,data:V,type:S.PromiseSuccess})},V=>{V instanceof Error?this.m({id:se,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split(`
`):void 0},type:S.PromiseError}):this.m({id:se,data:V,type:S.PromiseErrorObj})}).finally(()=>{L.dispose(),this.d.delete(q.id)});const L=(0,l.$Vc)(()=>Q.cancel());this.d.set(q.id,L)}t(q){const x=this.b.get(q.channelName);if(!x){this.v(q);return}const Q=q.id,se=x.listen(this.j,q.name,q.arg)(L=>this.m({id:Q,data:L,type:S.EventFire}));this.d.set(q.id,se)}u(q){const x=this.d.get(q.id);x&&(x.dispose(),this.d.delete(q.id))}v(q){let x=this.g.get(q.channelName);x||(x=[],this.g.set(q.channelName,x));const Q=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===f.Promise&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:S.PromiseError})},this.l);x.push({request:q,timeoutTimer:Q})}w(q){const x=this.g.get(q);if(x){for(const Q of x)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case f.Promise:this.s(Q.request);break;case f.EventListen:this.t(Q.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}e.$ki=m;var N;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(N||(e.RequestInitiator=N={}));class T{constructor(q,x=null){this.l=q,this.a=!1,this.b=y.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$oe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=x}getChannel(q){const x=this;return{call(Q,ie,se){return x.a?Promise.reject(new O.$7):x.m(q,Q,ie,se)},listen(Q,ie){return x.a?g.Event.None:x.o(q,Q,ie)}}}m(q,x,Q,ie=k.CancellationToken.None){const se=this.g++,L=f.Promise,V={id:se,type:L,channelName:q,name:x,arg:Q};if(ie.isCancellationRequested)return Promise.reject(new O.$7);let z;return new Promise((j,X)=>{if(ie.isCancellationRequested)return X(new O.$7);const J=()=>{const re=ce=>{switch(ce.type){case S.PromiseSuccess:this.f.delete(se),j(ce.data);break;case S.PromiseError:{this.f.delete(se);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,X(fe);break}case S.PromiseErrorObj:this.f.delete(se),X(ce.data);break}};this.f.set(se,re),this.p(V)};let G=null;this.b===y.Idle?J():(G=(0,I.$vh)(re=>this.u()),G.then(()=>{G=null,J()}));const U=()=>{G?(G.cancel(),G=null):this.p({id:se,type:f.PromiseCancel}),X(new O.$7)},K=ie.onCancellationRequested(U);z=(0,l.$Uc)((0,l.$Vc)(U),K),this.d.add(z)}).finally(()=>{z.dispose(),this.d.delete(z)})}o(q,x,Q){const ie=this.g++,se=f.EventListen,L={id:ie,type:se,channelName:q,name:x,arg:Q};let V=null;const z=new g.$oe({onWillAddFirstListener:()=>{V=(0,I.$vh)(j=>this.u()),V.then(()=>{V=null,this.d.add(z),this.p(L)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(z),this.p({id:ie,type:f.EventDispose}))}}),E=j=>z.fire(j.data);return this.f.set(ie,E),z.event}p(q){switch(q.type){case f.Promise:case f.EventListen:{const x=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(x,q.id,N.LocalSide,`${p(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case f.PromiseCancel:case f.EventDispose:{const x=this.q([q.type,q.id]);this.j?.logOutgoing(x,q.id,N.LocalSide,p(q.type));return}}}q(q,x=void 0){const Q=new a;return o(Q,q),o(Q,x),this.r(Q.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const x=new i(q),Q=c(x),ie=c(x),se=Q[0];switch(se){case S.Initialize:return this.j?.logIncoming(q.byteLength,0,N.LocalSide,b(se)),this.t({type:Q[0]});case S.PromiseSuccess:case S.PromiseError:case S.EventFire:case S.PromiseErrorObj:return this.j?.logIncoming(q.byteLength,Q[1],N.LocalSide,b(se),ie),this.t({type:Q[0],id:Q[1],data:ie})}}t(q){if(q.type===S.Initialize){this.b=y.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}e.$li=T,Ee([C.$ai],T.prototype,"onDidInitializePromise",null);class D{get connections(){const q=[];return this.f.forEach(x=>q.push(x)),q}constructor(q,x,Q){this.a=new Map,this.f=new Set,this.g=new g.$oe,this.onDidAddConnection=this.g.event,this.h=new g.$oe,this.onDidRemoveConnection=this.h.event,this.j=new l.$Wc,this.j.add(q(({protocol:ie,onDidClientDisconnect:se})=>{const L=g.Event.once(ie.onMessage);this.j.add(L(V=>{const z=new i(V),E=c(z),j=new m(ie,E,x,Q),X=new T(ie,x);this.a.forEach((G,U)=>j.registerChannel(U,G));const J={channelServer:j,channelClient:X,ctx:E};this.f.add(J),this.g.fire(J),this.j.add(se(()=>{j.dispose(),X.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(q,x){const Q=this;return{call(ie,se,L){let V;if((0,w.$vg)(x)){const E=(0,P.$5b)(Q.connections.filter(x));V=E?Promise.resolve(E):g.Event.toPromise(g.Event.filter(Q.onDidAddConnection,x))}else V=x.routeCall(Q,ie,se);const z=V.then(E=>E.channelClient.getChannel(q));return F(z).call(ie,se,L)},listen(ie,se){if((0,w.$vg)(x))return Q.k(q,x,ie,se);const L=x.routeEvent(Q,ie,se).then(V=>V.channelClient.getChannel(q));return F(L).listen(ie,se)}}}k(q,x,Q,ie){const se=this;let L;const V=new g.$oe({onWillAddFirstListener:()=>{L=new l.$Wc;const z=new g.$ue,E=new Map,j=J=>{const U=J.channelClient.getChannel(q).listen(Q,ie),K=z.add(U);E.set(J,K)},X=J=>{const G=E.get(J);G&&(G.dispose(),E.delete(J))};se.connections.filter(x).forEach(j),g.Event.filter(se.onDidAddConnection,x)(j,void 0,L),se.onDidRemoveConnection(X,void 0,L),z.event(V.fire,V,L),L.add(z)},onDidRemoveLastListener:()=>{L?.dispose(),L=void 0}});return V.event}registerChannel(q,x){this.a.set(q,x);for(const Q of this.f)Q.channelServer.registerChannel(q,x)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$mi=D;class A{constructor(q,x,Q=null){const ie=new a;o(ie,x),q.send(ie.buffer),this.a=new T(q,Q),this.d=new m(q,x,Q)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,x){this.d.registerChannel(q,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ni=A;function F(M){return{call(q,x,Q){return M.then(ie=>ie.call(q,x,Q))},listen(q,x){const Q=new g.$xe;return M.then(ie=>Q.input=ie.listen(q,x)),Q.event}}}function H(M){let q=!1;return{call(x,Q,ie){return q?M.call(x,Q,ie):(0,I.$Jh)(0).then(()=>q=!0).then(()=>M.call(x,Q,ie))},listen(x,Q){if(q)return M.listen(x,Q);const ie=new g.$xe;return(0,I.$Jh)(0).then(()=>q=!0).then(()=>ie.input=M.listen(x,Q)),ie.event}}}class Y{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const x of q.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await g.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$qi=Y;var ne;(function(M){function q(se,L,V){const z=se,E=V&&V.disableMarshalling,j=new Map;for(const X in z)Q(X)&&j.set(X,g.Event.buffer(z[X],!0,void 0,L));return new class{listen(X,J,G){const U=j.get(J);if(U)return U;const K=z[J];if(typeof K=="function"){if(ie(J))return K.call(z,G);if(Q(J))return j.set(J,g.Event.buffer(z[J],!0,void 0,L)),j.get(J)}throw new O.$db(`Event not found: ${J}`)}call(X,J,G){const U=z[J];if(typeof U=="function"){if(!E&&Array.isArray(G))for(let re=0;re<G.length;re++)G[re]=(0,d.$fi)(G[re]);let K=U.apply(z,G);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new O.$db(`Method not found: ${J}`)}}}M.fromService=q;function x(se,L){const V=L&&L.disableMarshalling;return new Proxy({},{get(z,E){if(typeof E=="string")return L?.properties?.has(E)?L.properties.get(E):ie(E)?function(j){return se.listen(E,j)}:Q(E)?se.listen(E):async function(...j){let X;L&&!(0,w.$qg)(L.context)?X=[L.context,...j]:X=j;const J=await se.call(E,X);return V?J:(0,d.$fi)(J)};throw new O.$db(`Property not found: ${String(E)}`)}})}M.toService=x;function Q(se){return se[0]==="o"&&se[1]==="n"&&h.$Hf(se.charCodeAt(2))}function ie(se){return/^onDynamic/.test(se)&&h.$Hf(se.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const q=M.toString();if(q!=="[object Object]")return q}return M}function me(M){return Array.isArray(M)?M.map(ue):ue(M)}function W(M,q,x,Q,ie,se,L){L=me(L);const V=ae[ie],z=V[Q%V.length];let E=[`%c[${M}]%c[${String(q).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(se)?(E=E.concat(L),E.push(")")):E.push(L),console.log.apply(console,E)}class _{constructor(q,x){this.d=q,this.f=x,this.a=0,this.b=0}logOutgoing(q,x,Q,ie,se){this.b+=q,W(this.d,this.b,q,x,Q,ie,se)}logIncoming(q,x,Q,ie,se){this.a+=q,W(this.f,this.a,q,x,Q,ie,se)}}e.$ri=_}),define(le[87],he([0,1,62,8,13,21,82,7,4,2,27,60,57,61]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0,O=be(O);class p extends f.$ki{constructor(y){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",u=>v.$Qe.wrap(Buffer.from(u,"base64")))},y),process.once("disconnect",()=>this.dispose())}}e.$nr=p;class S{constructor(y,u){this.i=y,this.j=u,this.c=new Set,this.g=new Map,this.h=new g.$oe,this.onDidProcessExit=this.h.event;const R=u&&u.timeout?u.timeout:6e4;this.b=new I.$Fh(R),this.d=null,this.f=null}getChannel(y){const u=this;return{call(R,$,i){return u.k(y,R,$,i)},listen(R,$){return u.l(y,R,$)}}}k(y,u,R,$=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(O.$8());this.b.cancel();const i=this.n(y),a=(0,I.$vh)(t=>i.call(u,R,t)),n=$.onCancellationRequested(()=>a.cancel()),r=(0,l.$Vc)(()=>a.cancel());return this.c.add(r),a.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(y,u,R){if(!this.b)return g.Event.None;this.b.cancel();let $;const i=new g.$oe({onWillAddFirstListener:()=>{$=this.n(y).listen(u,R)(i.fire,i),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const y=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,d.$io)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,w.$pm)(u.env),this.d=(0,P.fork)(this.i,y,u);const R=new g.$oe,i=g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,C.$jr)(o)){(0,C.log)(o,`IPC Library: ${this.j.serverName}`);return}R.fire(v.$Qe.wrap(Buffer.from(o,"base64")))}),a=this.j.useQueue?(0,h.$Cm)(this.d):this.d,n=o=>this.d&&this.d.connected&&a.send(o.buffer.toString("base64")),r=R.event,t={send:n,onMessage:r};this.f=new f.$li(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",s),i.dispose(),this.c.forEach(m=>(0,l.$Sc)(m)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(y){let u=this.g.get(y);return u||(u=this.m.getChannel(y),this.g.set(y,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$or=S}),define(le[88],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0,e.$ap=I;const P="Offline";function I(k){return k instanceof v?!0:k instanceof Error&&k.name===P&&k.message===P}class v extends Error{constructor(){super(P),this.name=this.message}}e.$bp=v}),define(le[89],he([0,1,8,4,2,48,3]),function(Z,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.StorageState=e.StorageHint=void 0,e.$hq=g;var O;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function g(w){const f=w;return f?.changed instanceof Map||f?.deleted instanceof Set}var l;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(l||(e.StorageState=l={}));class d extends v.$Xc{static{this.a=100}constructor(f,p=Object.create(null)){super(),this.r=f,this.s=p,this.b=this.B(new I.$re),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$Gh(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((p,S)=>this.w(S,p)),f.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(f,p){if(this.c===l.Closed)return;let S=!1;(0,C.$qg)(p)?S=this.f.delete(f):this.f.get(f)!==p&&(this.f.set(f,p),S=!0),S&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,p){const S=this.f.get(f);return(0,C.$qg)(S)?p:S}getBoolean(f,p){const S=this.get(f);return(0,C.$qg)(S)?p:S==="true"}getNumber(f,p){const S=this.get(f);return(0,C.$qg)(S)?p:parseInt(S,10)}getObject(f,p){const S=this.get(f);return(0,C.$qg)(S)?p:(0,k.$ei)(S)}async set(f,p,S=!1){if(this.c===l.Closed)return;if((0,C.$qg)(p))return this.delete(f,S);const b=(0,C.$jg)(p)||Array.isArray(p)?(0,k.$di)(p):String(p);if(this.f.get(f)!==b)return this.f.set(f,b),this.j.set(f,b),this.h.delete(f),this.b.fire({key:f,external:S}),this.D()}async delete(f,p=!1){if(!(this.c===l.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:p}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(!(this.c===l.Closed||this.m))return this.D(f)}async D(f){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$iq=d;class h{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((p,S)=>this.a.set(S,p)),f.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$jq=h}),define(le[90],he([0,1,5]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=l,e.$6m=d,e.$7m=h,e.$8m=w;const I=60,v=I*60,k=v*24,C=k*7,O=k*30,g=k*365;function l(f,p,S,b){typeof f!="number"&&(f=f.getTime());const y=Math.round((new Date().getTime()-f)/1e3);if(y<-30)return(0,P.localize)(42,null,l(new Date().getTime()+y*1e3,!1));if(!b&&y<30)return(0,P.localize)(43,null);let u;return y<I?(u=y,p?u===1?S?(0,P.localize)(44,null,u):(0,P.localize)(45,null,u):S?(0,P.localize)(46,null,u):(0,P.localize)(47,null,u):u===1?S?(0,P.localize)(48,null,u):(0,P.localize)(49,null,u):S?(0,P.localize)(50,null,u):(0,P.localize)(51,null,u)):y<v?(u=Math.floor(y/I),p?u===1?S?(0,P.localize)(52,null,u):(0,P.localize)(53,null,u):S?(0,P.localize)(54,null,u):(0,P.localize)(55,null,u):u===1?S?(0,P.localize)(56,null,u):(0,P.localize)(57,null,u):S?(0,P.localize)(58,null,u):(0,P.localize)(59,null,u)):y<k?(u=Math.floor(y/v),p?u===1?S?(0,P.localize)(60,null,u):(0,P.localize)(61,null,u):S?(0,P.localize)(62,null,u):(0,P.localize)(63,null,u):u===1?S?(0,P.localize)(64,null,u):(0,P.localize)(65,null,u):S?(0,P.localize)(66,null,u):(0,P.localize)(67,null,u)):y<C?(u=Math.floor(y/k),p?u===1?(0,P.localize)(68,null,u):(0,P.localize)(69,null,u):u===1?(0,P.localize)(70,null,u):(0,P.localize)(71,null,u)):y<O?(u=Math.floor(y/C),p?u===1?S?(0,P.localize)(72,null,u):(0,P.localize)(73,null,u):S?(0,P.localize)(74,null,u):(0,P.localize)(75,null,u):u===1?S?(0,P.localize)(76,null,u):(0,P.localize)(77,null,u):S?(0,P.localize)(78,null,u):(0,P.localize)(79,null,u)):y<g?(u=Math.floor(y/O),p?u===1?S?(0,P.localize)(80,null,u):(0,P.localize)(81,null,u):S?(0,P.localize)(82,null,u):(0,P.localize)(83,null,u):u===1?S?(0,P.localize)(84,null,u):(0,P.localize)(85,null,u):S?(0,P.localize)(86,null,u):(0,P.localize)(87,null,u)):(u=Math.floor(y/g),p?u===1?S?(0,P.localize)(88,null,u):(0,P.localize)(89,null,u):S?(0,P.localize)(90,null,u):(0,P.localize)(91,null,u):u===1?S?(0,P.localize)(92,null,u):(0,P.localize)(93,null,u):S?(0,P.localize)(94,null,u):(0,P.localize)(95,null,u))}function d(f,p,S){typeof f!="number"&&(f=f.getTime());const b=new Date;b.setHours(0,0,0,0);const y=new Date(b.getTime());return y.setDate(y.getDate()-1),f>b.getTime()?(0,P.localize)(96,null):f>y.getTime()?(0,P.localize)(97,null):l(f,p,S)}function h(f,p){const S=Math.abs(f/1e3);return S<1?p?(0,P.localize)(98,null,f):(0,P.localize)(99,null,f):S<I?p?(0,P.localize)(100,null,Math.round(f)/1e3):(0,P.localize)(101,null,Math.round(f)/1e3):S<v?p?(0,P.localize)(102,null,Math.round(f/(1e3*I))):(0,P.localize)(103,null,Math.round(f/(1e3*I))):S<k?p?(0,P.localize)(104,null,Math.round(f/(1e3*v))):(0,P.localize)(105,null,Math.round(f/(1e3*v))):(0,P.localize)(106,null,Math.round(f/(1e3*k)))}function w(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[38],he([0,1,19,3,5]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=g,e.$uj=l,e.$vj=d,P=be(P),I=be(I),v=be(v);function k(h,w){return w&&(h.stack||h.stacktrace)?v.localize(107,null,O(h),C(h.stack)||C(h.stacktrace)):O(h)}function C(h){return Array.isArray(h)?h.join(`
`):h}function O(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?v.localize(108,null,h.message):h.message||v.localize(109,null)}function g(h=null,w=!1){if(!h)return v.localize(110,null);if(Array.isArray(h)){const f=P.$Jb(h),p=g(f[0],w);return f.length>1?v.localize(111,null,p,f.length):p}if(I.$hg(h))return h;if(h.detail){const f=h.detail;if(f.error)return k(f.error,w);if(f.exception)return k(f.exception,w)}return h.stack?k(h,w):h.message?h.message:v.localize(112,null)}function l(h){const w=h;return w instanceof Error&&Array.isArray(w.actions)}function d(h,w){let f;return typeof h=="string"?f=new Error(h):f=h,f.actions=w,f}}),define(le[91],he([0,1,5,34]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=v;function v(k){switch(k){case I.ParseErrorCode.InvalidSymbol:return(0,P.localize)(113,null);case I.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(114,null);case I.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(115,null);case I.ParseErrorCode.ValueExpected:return(0,P.localize)(116,null);case I.ParseErrorCode.ColonExpected:return(0,P.localize)(117,null);case I.ParseErrorCode.CommaExpected:return(0,P.localize)(118,null);case I.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(119,null);case I.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(120,null);case I.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(121,null);default:return""}}}),define(le[50],he([0,1,32,8,15,3,29,5]),function(Z,e,P,I,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0,e.zip=b,e.$Jq=y,e.$Kq=R,v=be(v),O=be(O),e.$Gq="end of central directory record signature not found";const g=new RegExp(e.$Gq);class l extends Error{constructor(i,a){let n=a.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=a}}e.$Hq=l;function d($){const i=$.externalFileAttributes>>16||33188;return[448,56,7].map(a=>i&a).reduce((a,n)=>a+n,i&61440)}function h($){if($ instanceof l)return $;let i;return g.test($.message)&&(i="CorruptZip"),new l(i,$)}function w($,i,a,n,r,t){const s=v.$pc(i),o=v.$mc(n,s);if(!o.startsWith(n))return Promise.reject(new Error(O.localize(142,null,i)));const c=v.$mc(n,i);let m;return t.onCancellationRequested(()=>{m?.destroy()}),Promise.resolve(P.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,T)=>{if(!t.isCancellationRequested)try{m=(0,P.createWriteStream)(c,{mode:a}),m.once("close",()=>N()),m.once("error",T),$.once("error",T),$.pipe(m)}catch(D){T(D)}}))}function f($,i,a,n){let r=(0,I.$vh)(()=>Promise.resolve()),t=0;const s=n.onCancellationRequested(()=>{r.cancel(),$.close()});return new Promise((o,c)=>{const m=new I.$Dh,N=T=>{T.isCancellationRequested||(t++,$.readEntry())};$.once("error",c),$.once("close",()=>r.then(()=>{n.isCancellationRequested||$.entryCount===t?o():c(new l("Incomplete",new Error(O.localize(143,null,t,$.entryCount))))},c)),$.readEntry(),$.on("entry",T=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(T.fileName)){N(n);return}const D=T.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(D)){const H=v.$mc(i,D);r=(0,I.$vh)(Y=>P.promises.mkdir(H,{recursive:!0}).then(()=>N(Y)).then(void 0,c));return}const A=S($,T),F=d(T);r=(0,I.$vh)(H=>m.queue(()=>A.then(Y=>w(Y,D,F,i,a,H).then(()=>N(H)))).then(null,c))})}).finally(()=>s.dispose())}async function p($,i=!1){const{open:a}=await new Promise((n,r)=>{Z(["yauzl"],n,r)}).then(be);return new Promise((n,r)=>{a($,i?{lazyEntries:!0}:void 0,(t,s)=>{t?r(h(t)):n((0,k.$sg)(s))})})}function S($,i){return new Promise((a,n)=>{$.openReadStream(i,(r,t)=>{r?n(h(r)):a((0,k.$sg)(t))})})}async function b($,i){const{ZipFile:a}=await new Promise((n,r)=>{Z(["yazl"],n,r)}).then(be);return new Promise((n,r)=>{const t=new a;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,P.createWriteStream)($);t.outputStream.pipe(s),t.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n($))})}function y($,i,a={},n){const r=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let t=p($,!0);return a.overwrite&&(t=t.then(s=>C.Promises.rm(i).then(()=>s))),t.then(s=>f(s,i,{sourcePathRegex:r},n))}function u($,i){return p($).then(a=>new Promise((n,r)=>{a.on("entry",t=>{t.fileName===i&&S(a,t).then(s=>n(s),s=>r(s))}),a.once("close",()=>r(new Error(O.localize(144,null,i))))}))}function R($,i){return u($,i).then(a=>new Promise((n,r)=>{const t=[];a.once("error",r),a.on("data",s=>t.push(s)),a.on("end",()=>n(Buffer.concat(t)))}))}}),define(le[92],he([0,1,93,7,5]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var k;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(k||(e.TokenType=k={}));function C(...d){switch(d.length){case 1:return(0,v.localize)(1693,null,d[0]);case 2:return(0,v.localize)(1694,null,d[0],d[1]);case 3:return(0,v.localize)(1695,null,d[0],d[1],d[2]);default:return}}const O=(0,v.localize)(1696,null),g=(0,v.localize)(1697,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return h.isTripleEq?"===":"==";case k.NotEq:return h.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return h.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return h.lexeme;case k.QuotedStr:return h.lexeme;case k.Error:return h.lexeme;case k.EOF:return"EOF";default:throw(0,I.$0)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(k.LParen);break;case P.CharCode.CloseParen:this.k(k.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const w=this.h(P.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:w})}else this.k(k.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const w=this.h(P.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:w})}else this.h(P.CharCode.Tilde)?this.k(k.RegexOp):this.l(C("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?k.LtEq:k.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?k.GtEq:k.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(k.And):this.l(C("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(k.Or):this.l(C("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const w=this.d,f=this.c.substring(this.d,this.e),p={type:k.Error,offset:this.d,lexeme:f};this.g.push({offset:w,lexeme:f,additionalInfo:h}),this.f.push(p)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const w=this.c.substring(this.d,this.e),f=l.b.get(w);f?this.k(f):this.f.push({type:k.Str,lexeme:w,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,w=!1,f=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(g);return}const S=this.c.charCodeAt(h);if(w)w=!1;else if(S===P.CharCode.Slash&&!f){h++;break}else S===P.CharCode.OpenSquareBracket?f=!0:S===P.CharCode.Backslash?w=!0:S===P.CharCode.CloseSquareBracket&&(f=!1);h++}for(;h<this.c.length&&l.a.has(this.c.charCodeAt(h));)h++;this.e=h;const p=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=l}),define(le[94],he([0,1,90,56,14,15,36,16,12]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=d,e.$_m=h,e.$9m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,k.$pc)(v.$3g.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,k.$mc)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,O.$jh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$jh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$mc)(this.userDataPath,"logs",f)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$jh)(g.URI.file((0,k.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$jh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$jh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$jh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?g.URI.file((0,k.$mc)(f,"argv.json")):(0,O.$jh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,k.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,k.$nc)(f):(0,k.$kc)((0,k.$mc)(v.$3g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?g.URI.file((0,k.$nc)(f)):g.URI.file((0,k.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,k.$nc)(f);const p=C.env.VSCODE_EXTENSIONS;if(p)return p;const S=C.env.VSCODE_PORTABLE;return S?(0,k.$mc)(S,"extensions"):(0,O.$jh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,k.$kc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?g.URI.parse(f):g.URI.file((0,k.$kc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$9m.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const S=e.$9m.exec(p);S&&S[1]&&S[2]&&f.push([S[1],S[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,O.$jh)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=C.env.VSCODE_PORTABLE;return f?g.URI.file((0,k.$mc)(f,"policy.json")):(0,O.$jh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,p,S){this.a=f,this.b=p,this.c=S,this.editSessionId=this.args.editSessionId}}e.$0m=l,Ee([I.$ai],l.prototype,"appRoot",null),Ee([I.$ai],l.prototype,"userHome",null),Ee([I.$ai],l.prototype,"userDataPath",null),Ee([I.$ai],l.prototype,"appSettingsHome",null),Ee([I.$ai],l.prototype,"tmpDir",null),Ee([I.$ai],l.prototype,"cacheHome",null),Ee([I.$ai],l.prototype,"stateResource",null),Ee([I.$ai],l.prototype,"userRoamingDataHome",null),Ee([I.$ai],l.prototype,"userDataSyncHome",null),Ee([I.$ai],l.prototype,"sync",null),Ee([I.$ai],l.prototype,"machineSettingsResource",null),Ee([I.$ai],l.prototype,"workspaceStorageHome",null),Ee([I.$ai],l.prototype,"localHistoryHome",null),Ee([I.$ai],l.prototype,"keyboardLayoutResource",null),Ee([I.$ai],l.prototype,"argvResource",null),Ee([I.$ai],l.prototype,"isExtensionDevelopment",null),Ee([I.$ai],l.prototype,"untitledWorkspacesHome",null),Ee([I.$ai],l.prototype,"builtinExtensionsPath",null),Ee([I.$ai],l.prototype,"extensionsPath",null),Ee([I.$ai],l.prototype,"extensionDevelopmentLocationURI",null),Ee([I.$ai],l.prototype,"extensionDevelopmentKind",null),Ee([I.$ai],l.prototype,"extensionTestsLocationURI",null),Ee([I.$ai],l.prototype,"debugExtensionHost",null),Ee([I.$ai],l.prototype,"logLevel",null),Ee([I.$ai],l.prototype,"extensionLogLevel",null),Ee([I.$ai],l.prototype,"serviceMachineIdResource",null),Ee([I.$ai],l.prototype,"disableTelemetry",null),Ee([I.$ai],l.prototype,"disableWorkspaceTrust",null),Ee([I.$ai],l.prototype,"useInMemorySecretStorage",null),Ee([I.$ai],l.prototype,"policyFile",null);function d(w,f){return h(w["inspect-extensions"],w["inspect-brk-extensions"],5870,f,w.debugId,w.extensionEnvironment)}function h(w,f,p,S,b,y){const R=Number(f||w)||(S?null:p),$=R?!!f:!1;let i;if(y)try{i=JSON.parse(y)}catch{}return{port:R,break:$,debugId:b,env:i}}}),function(){function Z(e,P,I){function v(C,O){const g=k(C,O),l=[g];return e.isAbsolute(g)||l.unshift(I),e.resolve(...l)}function k(C,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,O);const d=C["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(h,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,O)}return{getUserDataPath:v}}if(typeof define=="function")define(le[95],he([149,35,36]),function(e,P,I){return Z(e,P,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=Z(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[96],he([0,1,35,94,95]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=C,e.$cn=O;class k extends I.$0m{constructor(l,d){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,v.getUserDataPath)(l,d.nameShort)},d)}}e.$an=k;function C(g,l){return(0,I.$_m)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,l,g.extensionEnvironment)}function O(g,l){return(0,I.$_m)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,l,g.extensionEnvironment)}}),define(le[97],he([0,1,3,5]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=v;function v(C,O,g,l){try{k(C,O,g,l)}catch(d){C.error(d?.message??d)}return O}function k(C,O,g,l){const d=(h,w,f)=>{const p=h[w];if((0,P.$hg)(p)){const S=p,b=S.length;if(b>1&&S[0]==="%"&&S[b-1]==="%"){const y=S.substr(1,b-2);let u=g[y];u===void 0&&l&&(u=l[y]);const R=typeof u=="string"?u:u?.message,$=l?.[y],i=typeof $=="string"?$:$?.message;if(!R){i||C.warn(`[${O.name}]: ${(0,I.localize)(1814,null,y)}`);return}if(f&&(w==="title"||w==="category")&&i&&i!==R){const a={value:R,original:i};h[w]=a}else h[w]=R}}else if((0,P.$jg)(p))for(const S in p)p.hasOwnProperty(S)&&(S==="commands"?d(p,S,!0):d(p,S,f));else if(Array.isArray(p))for(let S=0;S<p.length;S++)d(p,S,f)};for(const h in O)O.hasOwnProperty(h)&&d(O,h)}}),define(le[98],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const P={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(P)}),define(le[51],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class P{constructor(v,k=[],C=!1){this.ctor=v,this.staticArguments=k,this.supportsDelayedInstantiation=C}}e.$Fi=P}),define(le[99],he([0,1,51]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Xs=k,e.$Ys=C;const I=[];var v;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(v||(e.InstantiationType=v={}));function k(O,g,l){g instanceof P.$Fi||(g=new P.$Fi(g,[],!!l)),I.push([O,g])}function C(){return I}}),define(le[100],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class P{constructor(k,C){this.key=k,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$Ar=P;class I{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const C of this.a.values())C.outgoing.size===0&&k.push(C);return k}insertEdge(k,C){const O=this.lookupOrInsertNode(k),g=this.lookupOrInsertNode(C);O.outgoing.set(g.key,g),g.incoming.set(O.key,O)}removeNode(k){const C=this.b(k);this.a.delete(C);for(const O of this.a.values())O.outgoing.delete(C),O.incoming.delete(C)}lookupOrInsertNode(k){const C=this.b(k);let O=this.a.get(C);return O||(O=new P(C,k),this.a.set(C,O)),O}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[C,O]of this.a)k.push(`${C}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,C]of this.a){const O=new Set([k]),g=this.c(C,O);if(g)return g}}c(k,C){for(const[O,g]of k.outgoing){if(C.has(O))return[...C,O].join(" -> ");C.add(O);const l=this.c(g,C);if(l)return l;C.delete(O)}}}e.$Br=I}),define(le[30],he([0,1,3,12,10]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=k,e.$ej=C,e.$fj=g,e.$gj=l,e.$hj=d,e.$ij=h,e.$jj=w,e.$kj=p,e.$lj=S,e.$mj=b,P=be(P),e.$cj=(0,v.$Ii)("configurationService");function k(y){return y&&typeof y=="object"&&(!y.overrideIdentifier||typeof y.overrideIdentifier=="string")&&(!y.resource||y.resource instanceof I.URI)}function C(y){return y&&typeof y=="object"&&(!y.overrideIdentifiers||Array.isArray(y.overrideIdentifiers))&&!y.overrideIdentifier&&(!y.resource||y.resource instanceof I.URI)}var O;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.USER=2]="USER",y[y.USER_LOCAL=3]="USER_LOCAL",y[y.USER_REMOTE=4]="USER_REMOTE",y[y.WORKSPACE=5]="WORKSPACE",y[y.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",y[y.DEFAULT=7]="DEFAULT",y[y.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function g(y){switch(y){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function l(y){return y.applicationValue!==void 0||y.userValue!==void 0||y.userLocalValue!==void 0||y.userRemoteValue!==void 0||y.workspaceValue!==void 0||y.workspaceFolderValue!==void 0}function d(y,u){const R=Object.create(null);for(const $ in y)h(R,$,y[$],u);return R}function h(y,u,R,$){const i=u.split("."),a=i.pop();let n=y;for(let r=0;r<i.length;r++){const t=i[r];let s=n[t];switch(typeof s){case"undefined":s=n[t]=Object.create(null);break;case"object":if(s===null){$(`Ignoring ${u} as ${i.slice(0,r+1).join(".")} is null`);return}break;default:$(`Ignoring ${u} as ${i.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[a]=R}catch{$(`Ignoring ${u} as ${i.join(".")} is ${JSON.stringify(n)}`)}else $(`Ignoring ${u} as ${i.join(".")} is ${JSON.stringify(n)}`)}function w(y,u){const R=u.split(".");f(y,R)}function f(y,u){const R=u.shift();if(u.length===0){delete y[R];return}if(Object.keys(y).indexOf(R)!==-1){const $=y[R];typeof $=="object"&&!Array.isArray($)&&(f($,u),Object.keys($).length===0&&delete y[R])}}function p(y,u,R){function $(n,r){let t=n;for(const s of r){if(typeof t!="object"||t===null)return;t=t[s]}return t}const i=u.split("."),a=$(y,i);return typeof a>"u"?R:a}function S(y,u,R){Object.keys(u).forEach($=>{$!=="__proto__"&&($ in y?P.$jg(y[$])&&P.$jg(u[$])?S(y[$],u[$],R):R&&(y[$]=u[$]):y[$]=u[$])})}function b(y){return y.replace(/[\[\]]/g,"")}}),define(le[101],he([0,1,93,11,31,92,10,5,7]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=d,e.$Hj=r,e.$Ij=t,e.$2j=se;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",I.$k),l.set("isLinux",I.$l),l.set("isWindows",I.$j),l.set("isWeb",I.$p),l.set("isMacNative",I.$k&&!I.$p),l.set("isEdge",I.$I),l.set("isFirefox",I.$G),l.set("isChrome",I.$F),l.set("isSafari",I.$H);function d(z,E){if(l.get(z)!==void 0)throw(0,g.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(z,E)}const h=Object.prototype.hasOwnProperty;var w;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const f={regexParsingWithErrorRecovery:!0},p=(0,O.localize)(1673,null),S=(0,O.localize)(1674,null),b=(0,O.localize)(1675,null),y=(0,O.localize)(1676,null),u=(0,O.localize)(1677,null),R=(0,O.localize)(1678,null),$=(0,O.localize)(1679,null),i=(0,O.localize)(1680,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(E=f){this.k=E,this.d=new k.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(E){if(E===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(E).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const X=this.D(),J=X.type===k.TokenType.Str?R:void 0;throw this.h.push({message:u,offset:X.offset,lexeme:k.$Dj.getLexeme(X),additionalInfo:J}),a.c}return j}catch(j){if(j!==a.c)throw j;return}}l(){return this.m()}m(){const E=[this.o()];for(;this.y(k.TokenType.Or);){const j=this.o();E.push(j)}return E.length===1?E[0]:n.or(...E)}o(){const E=[this.s()];for(;this.y(k.TokenType.And);){const j=this.s();E.push(j)}return E.length===1?E[0]:n.and(...E)}s(){if(this.y(k.TokenType.Neg)){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),c.INSTANCE;case k.TokenType.LParen:{this.z();const j=this.l();return this.A(k.TokenType.RParen,y),j?.negate()}case k.TokenType.Str:return this.z(),F.create(E.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",E)}}return this.t()}t(){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),n.true();case k.TokenType.False:return this.z(),n.false();case k.TokenType.LParen:{this.z();const j=this.l();return this.A(k.TokenType.RParen,y),j}case k.TokenType.Str:{const j=E.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const J=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),J.type!==k.TokenType.RegexStr)throw this.B("REGEX",J);const G=J.lexeme,U=G.lastIndexOf("/"),K=U===G.length-1?void 0:this.w(G.substring(U+1));let re;try{re=new RegExp(G.substring(1,U),K)}catch{throw this.B("REGEX",J)}return me.create(j,re)}switch(J.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const G=[J.lexeme];this.z();let U=this.D(),K=0;for(let de=0;de<J.lexeme.length;de++)J.lexeme.charCodeAt(de)===P.CharCode.OpenParen?K++:J.lexeme.charCodeAt(de)===P.CharCode.CloseParen&&K--;for(;!this.E()&&U.type!==k.TokenType.And&&U.type!==k.TokenType.Or;){switch(U.type){case k.TokenType.LParen:K++;break;case k.TokenType.RParen:K--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===P.CharCode.OpenParen?K++:J.lexeme.charCodeAt(de)===P.CharCode.CloseParen&&K--}if(K<0)break;G.push(k.$Dj.getLexeme(U)),this.z(),U=this.D()}const re=G.join(""),ce=re.lastIndexOf("/"),fe=ce===re.length-1?void 0:this.w(re.substring(ce+1));let we;try{we=new RegExp(re.substring(1,ce),fe)}catch{throw this.B("REGEX",J)}return n.regex(j,we)}case k.TokenType.QuotedStr:{const G=J.lexeme;this.z();let U=null;if(!(0,v.$ff)(G)){const K=G.indexOf("/"),re=G.lastIndexOf("/");if(K!==re&&K>=0){const ce=G.slice(K+1,re),fe=G[re+1]==="i"?"i":"";try{U=new RegExp(ce,fe)}catch{throw this.B("REGEX",J)}}}if(U===null)throw this.B("REGEX",J);return me.create(j,U)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,b);const J=this.u();return n.notIn(j,J)}switch(this.D().type){case k.TokenType.Eq:{this.z();const J=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.equals(j,J);switch(J){case"true":return n.has(j);case"false":return n.not(j);default:return n.equals(j,J)}}case k.TokenType.NotEq:{this.z();const J=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.notEquals(j,J);switch(J){case"true":return n.not(j);case"false":return n.has(j);default:return n.notEquals(j,J)}}case k.TokenType.Lt:return this.z(),ae.create(j,this.u());case k.TokenType.LtEq:return this.z(),ue.create(j,this.u());case k.TokenType.Gt:return this.z(),Y.create(j,this.u());case k.TokenType.GtEq:return this.z(),ne.create(j,this.u());case k.TokenType.In:return this.z(),n.in(j,this.u());default:return n.has(j)}}case k.TokenType.EOF:throw this.h.push({message:$,offset:E.offset,lexeme:"",additionalInfo:i}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const E=this.D();switch(E.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),E.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(E){return E.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(E){return this.C(E)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(E,j){if(this.C(E))return this.z();throw this.B(j,this.D())}B(E,j,X){const J=(0,O.localize)(1681,null,E,k.$Dj.getLexeme(j)),G=j.offset,U=k.$Dj.getLexeme(j);return this.h.push({message:J,offset:G,lexeme:U,additionalInfo:X}),a.c}C(E){return this.D().type===E}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Fj=a;class n{static false(){return o.INSTANCE}static true(){return c.INSTANCE}static has(E){return m.create(E)}static equals(E,j){return N.create(E,j)}static notEquals(E,j){return A.create(E,j)}static regex(E,j){return me.create(E,j)}static in(E,j){return T.create(E,j)}static notIn(E,j){return D.create(E,j)}static not(E){return F.create(E)}static and(...E){return M.create(E,null,!0)}static or(...E){return q.create(E,null,!0)}static greater(E,j){return Y.create(E,j)}static greaterEquals(E,j){return ne.create(E,j)}static smaller(E,j){return ae.create(E,j)}static smallerEquals(E,j){return ue.create(E,j)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(E){return E==null?void 0:this.c.parse(E)}}e.$Gj=n;function r(z){const E=new a({regexParsingWithErrorRecovery:!1});return z.map(j=>(E.parse(j),E.lexingErrors.length>0?E.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,O.localize)(1682,null,X.additionalInfo):(0,O.localize)(1683,null),offset:X.offset,length:X.lexeme.length})):E.parsingErrors.length>0?E.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}function t(z,E){const j=z?z.substituteConstants():void 0,X=E?E.substituteConstants():void 0;return!j&&!X?!0:!j||!X?!1:j.equals(X)}function s(z,E){return z.cmp(E)}class o{static{this.INSTANCE=new o}constructor(){this.type=w.False}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return c.INSTANCE}}e.$Jj=o;class c{static{this.INSTANCE=new c}constructor(){this.type=w.True}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return o.INSTANCE}}e.$Kj=c;class m{static create(E,j=null){const X=l.get(E);return typeof X=="boolean"?X?c.INSTANCE:o.INSTANCE:new m(E,j)}constructor(E,j){this.key=E,this.c=j,this.type=w.Defined}cmp(E){return E.type!==this.type?this.type-E.type:Q(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=l.get(this.key);return typeof E=="boolean"?E?c.INSTANCE:o.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Lj=m;class N{static create(E,j,X=null){if(typeof j=="boolean")return j?m.create(E,X):F.create(E,X);const J=l.get(E);return typeof J=="boolean"?j===(J?"true":"false")?c.INSTANCE:o.INSTANCE:new N(E,j,X)}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=w.Equals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=l.get(this.c);if(typeof E=="boolean"){const j=E?"true":"false";return this.d===j?c.INSTANCE:o.INSTANCE}return this}evaluate(E){return E.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(E){return E.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Mj=N;class T{static create(E,j){return new T(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=w.In,this.c=null}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.d,this.f,E.d,E.f)}equals(E){return E.type===this.type?this.d===E.d&&this.f===E.f:!1}substituteConstants(){return this}evaluate(E){const j=E.getValue(this.f),X=E.getValue(this.d);return Array.isArray(j)?j.includes(X):typeof X=="string"&&typeof j=="object"&&j!==null?h.call(j,X):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(E){return E.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Nj=T;class D{static create(E,j){return new D(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=w.NotIn,this.c=T.create(E,j)}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(E){return E.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=D;class A{static create(E,j,X=null){if(typeof j=="boolean")return j?F.create(E,X):m.create(E,X);const J=l.get(E);return typeof J=="boolean"?j===(J?"true":"false")?o.INSTANCE:c.INSTANCE:new A(E,j,X)}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=w.NotEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=l.get(this.c);if(typeof E=="boolean"){const j=E?"true":"false";return this.d===j?o.INSTANCE:c.INSTANCE}return this}evaluate(E){return E.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(E){return E.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Pj=A;class F{static create(E,j=null){const X=l.get(E);return typeof X=="boolean"?X?o.INSTANCE:c.INSTANCE:new F(E,j)}constructor(E,j){this.c=E,this.d=j,this.type=w.Not}cmp(E){return E.type!==this.type?this.type-E.type:Q(this.c,E.c)}equals(E){return E.type===this.type?this.c===E.c:!1}substituteConstants(){const E=l.get(this.c);return typeof E=="boolean"?E?o.INSTANCE:c.INSTANCE:this}evaluate(E){return!E.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(E){return E.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$Qj=F;function H(z,E){if(typeof z=="string"){const j=parseFloat(z);isNaN(j)||(z=j)}return typeof z=="string"||typeof z=="number"?E(z):o.INSTANCE}class Y{static create(E,j,X=null){return H(j,J=>new Y(E,J,X))}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=w.Greater}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Rj=Y;class ne{static create(E,j,X=null){return H(j,J=>new ne(E,J,X))}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=w.GreaterEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Sj=ne;class ae{static create(E,j,X=null){return H(j,J=>new ae(E,J,X))}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=w.Smaller}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Tj=ae;class ue{static create(E,j,X=null){return H(j,J=>new ue(E,J,X))}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=w.SmallerEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Uj=ue;class me{static create(E,j){return new me(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=w.Regex,this.c=null}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.d<E.d)return-1;if(this.d>E.d)return 1;const j=this.f?this.f.source:"",X=E.f?E.f.source:"";return j<X?-1:j>X?1:0}equals(E){if(E.type===this.type){const j=this.f?this.f.source:"",X=E.f?E.f.source:"";return this.d===E.d&&j===X}return!1}substituteConstants(){return this}evaluate(E){const j=E.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const E=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${E}`}keys(){return[this.d]}map(E){return E.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$Vj=me;class W{static create(E){return new W(E)}constructor(E){this.c=E,this.type=w.NotRegex}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(E){return new W(this.c.map(E))}negate(){return this.c}}e.$Wj=W;function _(z){let E=null;for(let j=0,X=z.length;j<X;j++){const J=z[j].substituteConstants();if(z[j]!==J&&E===null){E=[];for(let G=0;G<j;G++)E[G]=z[G]}E!==null&&(E[j]=J)}return E===null?z:E}class M{static create(E,j,X){return M.d(E,j,X)}constructor(E,j){this.expr=E,this.c=j,this.type=w.And}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let j=0,X=this.expr.length;j<X;j++){const J=s(this.expr[j],E.expr[j]);if(J!==0)return J}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let j=0,X=this.expr.length;j<X;j++)if(!this.expr[j].equals(E.expr[j]))return!1;return!0}return!1}substituteConstants(){const E=_(this.expr);return E===this.expr?this:M.create(E,this.c,!1)}evaluate(E){for(let j=0,X=this.expr.length;j<X;j++)if(!this.expr[j].evaluate(E))return!1;return!0}static d(E,j,X){const J=[];let G=!1;for(const U of E)if(U){if(U.type===w.True){G=!0;continue}if(U.type===w.False)return o.INSTANCE;if(U.type===w.And){J.push(...U.expr);continue}J.push(U)}if(J.length===0&&G)return c.INSTANCE;if(J.length!==0){if(J.length===1)return J[0];J.sort(s);for(let U=1;U<J.length;U++)J[U-1].equals(J[U])&&(J.splice(U,1),U--);if(J.length===1)return J[0];for(;J.length>1;){const U=J[J.length-1];if(U.type!==w.Or)break;J.pop();const K=J.pop(),re=J.length===0,ce=q.create(U.expr.map(fe=>M.create([fe,K],null,X)),null,re);ce&&(J.push(ce),J.sort(s))}if(J.length===1)return J[0];if(X){for(let U=0;U<J.length;U++)for(let K=U+1;K<J.length;K++)if(J[U].negate().equals(J[K]))return o.INSTANCE;if(J.length===1)return J[0]}return new M(J,j)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(const j of this.expr)E.push(...j.keys());return E}map(E){return new M(this.expr.map(j=>j.map(E)),null)}negate(){if(!this.c){const E=[];for(const j of this.expr)E.push(j.negate());this.c=q.create(E,this,!0)}return this.c}}e.$Xj=M;class q{static create(E,j,X){return q.d(E,j,X)}constructor(E,j){this.expr=E,this.c=j,this.type=w.Or}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let j=0,X=this.expr.length;j<X;j++){const J=s(this.expr[j],E.expr[j]);if(J!==0)return J}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let j=0,X=this.expr.length;j<X;j++)if(!this.expr[j].equals(E.expr[j]))return!1;return!0}return!1}substituteConstants(){const E=_(this.expr);return E===this.expr?this:q.create(E,this.c,!1)}evaluate(E){for(let j=0,X=this.expr.length;j<X;j++)if(this.expr[j].evaluate(E))return!0;return!1}static d(E,j,X){let J=[],G=!1;if(E){for(let U=0,K=E.length;U<K;U++){const re=E[U];if(re){if(re.type===w.False){G=!0;continue}if(re.type===w.True)return c.INSTANCE;if(re.type===w.Or){J=J.concat(re.expr);continue}J.push(re)}}if(J.length===0&&G)return o.INSTANCE;J.sort(s)}if(J.length!==0){if(J.length===1)return J[0];for(let U=1;U<J.length;U++)J[U-1].equals(J[U])&&(J.splice(U,1),U--);if(J.length===1)return J[0];if(X){for(let U=0;U<J.length;U++)for(let K=U+1;K<J.length;K++)if(J[U].negate().equals(J[K]))return c.INSTANCE;if(J.length===1)return J[0]}return new q(J,j)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(const j of this.expr)E.push(...j.keys());return E}map(E){return new q(this.expr.map(j=>j.map(E)),null)}negate(){if(!this.c){const E=[];for(const j of this.expr)E.push(j.negate());for(;E.length>1;){const j=E.shift(),X=E.shift(),J=[];for(const G of V(j))for(const U of V(X))J.push(M.create([G,U],null,!1));E.unshift(q.create(J,null,!1))}this.c=q.create(E,this,!0)}return this.c}}e.$Yj=q;class x extends m{static{this.d=[]}static all(){return x.d.values()}constructor(E,j,X){super(E,null),this.f=j,typeof X=="object"?x.d.push({...X,key:E}):X!==!0&&x.d.push({key:E,description:X,type:j!=null?typeof j:void 0})}bindTo(E){return E.createKey(this.key,this.f)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return N.create(this.key,E)}notEqualsTo(E){return A.create(this.key,E)}}e.$Zj=x,e.$1j=(0,C.$Ii)("contextKeyService");function Q(z,E){return z<E?-1:z>E?1:0}function ie(z,E,j,X){return z<j?-1:z>j?1:E<X?-1:E>X?1:0}function se(z,E){if(z.type===w.False||E.type===w.True)return!0;if(z.type===w.Or)return E.type===w.Or?L(z.expr,E.expr):!1;if(E.type===w.Or){for(const j of E.expr)if(se(z,j))return!0;return!1}if(z.type===w.And){if(E.type===w.And)return L(E.expr,z.expr);for(const j of z.expr)if(se(j,E))return!0;return!1}return z.equals(E)}function L(z,E){let j=0,X=0;for(;j<z.length&&X<E.length;){const J=z[j].cmp(E[X]);if(J<0)return!1;J===0&&j++,X++}return j===z.length}function V(z){return z.type===w.Or?z.expr:[z]}}),define(le[63],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=void 0,e.$6o=(0,P.$Ii)("downloadService")}),define(le[17],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,P.$Ii)("environmentService"),e.$Qi=(0,P.$Ji)(e.$Pi)}),define(le[64],he([0,1,13,7,5,9]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=C;async function C(d,h,w,f,p,S){let b;try{await O(d,h,w,f,p,S)}catch(y){b=y}finally{b&&p.errorTransformer&&(b=p.errorTransformer(b)),typeof b<"u"&&w.error(b),w.end()}}async function O(d,h,w,f,p,S){g(S);const b=await d.open(h,{create:!1});try{g(S);let y=0,u=0,R=p&&typeof p.length=="number"?p.length:void 0,$=P.$Qe.alloc(Math.min(p.bufferSize,typeof R=="number"?R:p.bufferSize)),i=p&&typeof p.position=="number"?p.position:0,a=0;do u=await d.read(b,i,$.buffer,a,$.byteLength-a),i+=u,a+=u,y+=u,typeof R=="number"&&(R-=u),a===$.byteLength&&(await w.write(f($)),$=P.$Qe.alloc(Math.min(p.bufferSize,typeof R=="number"?R:p.bufferSize)),a=0);while(u>0&&(typeof R!="number"||R>0)&&g(S)&&l(y,p));if(a>0){let n=a;typeof R=="number"&&(n=Math.min(a,R)),w.write(f($.slice(0,n)))}}catch(y){throw(0,k.$rl)(y)}finally{await d.close(b)}}function g(d){if(d.isCancellationRequested)throw(0,I.$8)();return!0}function l(d,h){if(typeof h?.limits?.size=="number"&&d>h.limits.size)throw(0,k.$ql)((0,v.localize)(1898,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[102],he([0,1,32,2,52,4,9,12,8]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class l extends I.$Xc{constructor(){super(),this.a=this.B(new k.$oe),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$oe),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$oe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new I.$7c),this.m=new Set,this.n=this.B(new g.$Gh(this.y())),this.r=5007,this.s=new g.$6h,this.R=!1,this.B(this.f(h=>this.t(h)))}t(h){this.u(h)&&this.z(h)}u(h){return(0,v.$0q)(h)}async watch(h){this.s.isSettled||this.s.complete(),this.s=new g.$6h;try{this.h.clear(),this.g.clear();for(const w of h)this.u(w)?this.h.set(w.correlationId,w):this.g.add(w);for(const[w]of this.j)this.h.has(w)||(this.j.deleteAndDispose(w),this.m.delete(w));return await this.w(!1)}finally{this.s.complete()}}w(h){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(w=>!this.j.has(w.correlationId))]),h?this.y():0)}y(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async z(h){if(this.j.has(h.correlationId))return;const w=new I.$Wc;this.j.set(h.correlationId,w),await this.s.p,!w.isDisposed&&(this.D(h,w),this.w(!0))}C(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.w(!1)}D(h,w){this.F(h,w)?(this.P(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.G(h,w),this.m.add(h.correlationId))}F(h,w){const f=this.O?.subscribe(h.path,(p,S)=>{w.isDisposed||(p?this.D(h,w):S?.type===C.FileChangeType.ADDED&&this.H(h))});return f?(w.add(f),!0):!1}G(h,w){let f=!1;const p=(S,b)=>{if(w.isDisposed)return;const y=this.I(S),u=this.I(b),R=f;f=y,!y&&(u||R)&&this.H(h)};this.P(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,P.watchFile)(h.path,{persistent:!1,interval:this.r},p)}catch(S){this.Q(`fs.watchFile() failed with error ${S} on path ${h.path} (correlationId: ${h.correlationId})`)}w.add((0,I.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,P.unwatchFile)(h.path,p)}catch(S){this.Q(`fs.unwatchFile() failed with error ${S} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}H(h){this.P(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const w={resource:O.URI.file(h.path),type:C.FileChangeType.ADDED,cId:h.correlationId};this.a.fire([w]),this.J(w,h),this.C(h)}I(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(h,w){if(this.R){const f=` >> normalized ${h.type===C.FileChangeType.ADDED?"[ADDED]":h.type===C.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.L(f,w)}}L(h,w){this.R&&this.P(`${h}${typeof w.correlationId=="number"?` <${w.correlationId}> `:""}`)}M(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,v.$hr)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.R=h}}e.$qr=l}),define(le[103],he([0,1,4,150,102,11,151,65]),function(Z,e,P,I,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;class g extends v.$qr{constructor(d){super(),this.O=d,this.onDidError=P.Event.None,this.watchers=new Set}async N(d){d=this.Z(d);const h=[],w=new Set(Array.from(this.watchers));for(const f of d){const p=this.W(f);p&&(0,I.$Hk)(p.request.excludes,f.excludes)&&(0,I.$Hk)(p.request.includes,f.includes)?w.delete(p):h.push(f)}h.length&&this.P(`Request to start watching: ${h.map(f=>this.M(f)).join(",")}`),w.size&&this.P(`Request to stop watching: ${Array.from(w).map(f=>this.M(f.request)).join(",")}`);for(const f of w)this.Y(f);for(const f of h)this.X(f)}W(d){for(const h of this.watchers)if(typeof d.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===d.correlationId)return h}else if((0,O.$Gg)(h.request.path,d.path,!k.$l))return h}X(d){const h=new C.$vr(d,this.O,f=>this.a.fire(f),()=>this.c.fire(d),f=>this.b.fire(f),this.R),w={request:d,instance:h};this.watchers.add(w)}async stop(){await super.stop();for(const d of this.watchers)this.Y(d)}Y(d){this.P("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}Z(d){const h=new Map;for(const w of d){const f=k.$l?w.path:w.path.toLowerCase();let p=h.get(w.correlationId);p||(p=new Map,h.set(w.correlationId,p)),p.has(f)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(w)}`),p.set(f,w)}return Array.from(h.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const h of this.watchers)h.instance.setVerboseLogging(d)}P(d,h){this.R&&this.b.fire({type:"trace",message:this.bb(d,h)})}Q(d){this.b.fire({type:"warn",message:this.bb(d)})}bb(d,h){return h?`[File Watcher (node.js)] ${d} (${this.M(h.request)})`:`[File Watcher (node.js)] ${d}`}}e.$xr=g}),define(le[104],he([0,1,52,103]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class v extends P.$ar{constructor(C,O,g){super(C,O,g),this.s()}r(C){return C.add(new I.$xr(void 0))}}e.$yr=v}),define(le[105],he([0,1,14,61,87,52]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class C extends k.$br{constructor(g,l,d){super(g,l,d),this.s()}r(g){const l=g.add(new v.$or(P.$3g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(l.onDidProcessExit(({code:d,signal:h})=>this.t(`terminated by itself with code ${d}, signal: ${h} (ETERM)`))),I.ProxyChannel.toService((0,I.$pi)(l.getChannel("watcher")))}}e.$pr=C}),define(le[66],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class P{constructor(...v){this.a=new Map;for(const[k,C]of v)this.set(k,C)}set(v,k){const C=this.a.get(v);return this.a.set(v,k),C}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}e.$Gi=P}),define(le[106],he([0,1,8,7,2,51,100,10,66,152]),function(Z,e,P,I,v,k,C,O,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;const d=!1;class h extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class w{constructor(b=new g.$Gi,y=!1,u,R=d){this.i=b,this.j=y,this.k=u,this.l=R,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Hi,this),this._globalGraph=R?u?._globalGraph??new C.$Br($=>$):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Sc)(this.h),this.h.clear();for(const b of this.g)(0,v.$Rc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,y){this.m();const u=this,R=new class extends w{dispose(){u.h.delete(R),super.dispose()}}(b,this.j,this,this.l);return this.h.add(R),y?.add(R),R}invokeFunction(b,...y){this.m();const u=p.traceInvocation(this.l,b);let R=!1;try{return b({get:i=>{if(R)throw(0,I.$0)("service accessor is only valid during the invocation of its target method");const a=this.s(i,u);if(!a)throw new Error(`[invokeFunction] unknown service '${i}'`);return a}},...y)}finally{R=!0,u.stop()}}createInstance(b,...y){this.m();let u,R;return b instanceof k.$Fi?(u=p.traceCreation(this.l,b.ctor),R=this.o(b.ctor,b.staticArguments.concat(y),u)):(u=p.traceCreation(this.l,b),R=this.o(b,y,u)),u.stop(),R}o(b,y=[],u){const R=O._util.getServiceDependencies(b).sort((a,n)=>a.index-n.index),$=[];for(const a of R){const n=this.s(a.id,u);n||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${a.id}.`,!1),$.push(n)}const i=R.length>0?R[0].index:y.length;if(y.length!==i){console.trace(`[createInstance] First service dependency of ${b.name} at position ${i+1} conflicts with ${y.length} static arguments`);const a=i-y.length;a>0?y=y.concat(new Array(a)):y=y.slice(0,i)}return Reflect.construct(b,y.concat($))}q(b,y){if(this.i.get(b)instanceof k.$Fi)this.i.set(b,y);else if(this.k)this.k.q(b,y);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const y=this.i.get(b);return!y&&this.k?this.k.r(b):y}s(b,y){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const u=this.r(b);return u instanceof k.$Fi?this.u(b,u,y.branch(b,!0)):(y.branch(b,!1),u)}u(b,y,u){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,y,u)}finally{this.t.delete(b)}}v(b,y,u){const R=new C.$Br(n=>n.id.toString());let $=0;const i=[{id:b,desc:y,_trace:u}],a=new Set;for(;i.length;){const n=i.pop();if(!a.has(String(n.id))){if(a.add(String(n.id)),R.lookupOrInsertNode(n),$++>1e3)throw new h(R);for(const r of O._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof k.$Fi){const s={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};R.insertEdge(n,s),i.push(s)}}}}for(;;){const n=R.roots();if(n.length===0){if(!R.isEmpty())throw new h(R);break}for(const{data:r}of n){if(this.r(r.id)instanceof k.$Fi){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}R.removeNode(r)}}return this.r(b)}w(b,y,u=[],R,$){if(this.i.get(b)instanceof k.$Fi)return this.x(b,y,u,R,$,this.g);if(this.k)return this.k.w(b,y,u,R,$);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}x(b,y,u=[],R,$,i){if(R){const a=new w(void 0,this.j,this,this.l);a.c=String(b);const n=new Map,r=new P.$2h(()=>{const t=a.o(y,u,$);for(const[s,o]of n){const c=t[s];if(typeof c=="function")for(const m of o)m.disposable=c.apply(t,m.listener)}return n.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let m=n.get(s);return m||(m=new l.$8c,n.set(s,m)),(T,D,A)=>{if(r.isInitialized)return r.value[s](T,D,A);{const F={listener:[T,D,A],disposable:void 0},H=m.push(F);return(0,v.$Vc)(()=>{H(),F.disposable?.dispose()})}}}if(s in t)return t[s];const o=r.value;let c=o[s];return typeof c!="function"||(c=c.bind(o),t[s]=c),c},set(t,s,o){return r.value[s]=o,!0},getPrototypeOf(t){return y.prototype}})}else{const a=this.o(y,u,$);return i.add(a),a}}y(b,y){if(y&&console.warn(b),this.j)throw new Error(b)}}e.$Cr=w;var f;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(f||(f={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(f.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,y){return b?new p(f.Invocation,y.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(b,y){return b?new p(f.Creation,y.name):p.c}static{this.f=0}constructor(b,y){this.type=b,this.name=y,this.g=Date.now(),this.h=[]}branch(b,y){const u=new p(f.Branch,b.toString());return this.h.push([b,y,u]),u}stop(){const b=Date.now()-this.g;p.f+=b;let y=!1;function u($,i){const a=[],n=new Array($+1).join("	");for(const[r,t,s]of i.h)if(t&&s){y=!0,a.push(`${n}CREATES -> ${r}`);const o=u($+1,s);o&&a.push(o)}else a.push(`${n}uses -> ${r}`);return a.join(`
`)}const R=[`${this.type===f.Creation?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(b>2||y)&&p.all.add(R.join(`
`))}}e.$Dr=p}),define(le[6],he([0,1,5,38,4,43,2,25,11,16,3,12,101,10]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=S,e.log=y,e.$rk=c,e.$sk=m,e.$tk=N,e.$uk=T,P=be(P),e.$dk=(0,f.$Ii)("logService"),e.$ek=(0,f.$Ii)("loggerService");function p(){return new Date().toISOString()}function S(D){return(0,d.$lg)(D)}var b;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$gk=b.Info;function y(D,A,F){switch(A){case b.Trace:D.trace(F);break;case b.Debug:D.debug(F);break;case b.Info:D.info(F);break;case b.Warning:D.warn(F);break;case b.Error:D.error(F);break;case b.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function u(D,A=!1){let F="";for(let H=0;H<D.length;H++){let Y=D[H];if(Y instanceof Error&&(Y=(0,I.$tj)(Y,A)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}F+=(H>0?" ":"")+Y}return F}class R extends C.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new v.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(A){this.b!==A&&(this.b=A,this.c.fire(this.b))}getLevel(){return this.b}f(A){return this.b!==b.Off&&this.b<=A}}e.$ik=R;class $ extends R{constructor(A){super(),this.h=A}f(A){return this.h||super.f(A)}trace(A,...F){this.f(b.Trace)&&this.g(b.Trace,u([A,...F],!0))}debug(A,...F){this.f(b.Debug)&&this.g(b.Debug,u([A,...F]))}info(A,...F){this.f(b.Info)&&this.g(b.Info,u([A,...F]))}warn(A,...F){this.f(b.Warning)&&this.g(b.Warning,u([A,...F]))}error(A,...F){if(this.f(b.Error))if(A instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=A.stack,this.g(b.Error,u(H))}else this.g(b.Error,u([A,...F]))}flush(){}}e.$jk=$;class i extends R{constructor(A=e.$gk){super(),this.setLevel(A),this.g=!g.$j}trace(A,...F){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,A,...F):console.log(`[main ${p()}]`,A,...F))}debug(A,...F){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,A,...F):console.log(`[main ${p()}]`,A,...F))}info(A,...F){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,A,...F):console.log(`[main ${p()}]`,A,...F))}warn(A,...F){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,A,...F):console.warn(`[main ${p()}]`,A,...F))}error(A,...F){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,A,...F):console.error(`[main ${p()}]`,A,...F))}flush(){}}e.$kk=i;class a extends R{constructor(A=e.$gk,F=!0){super(),this.g=F,this.setLevel(A)}trace(A,...F){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",A,...F):console.log(A,...F))}debug(A,...F){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",A,...F):console.log(A,...F))}info(A,...F){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",A,...F):console.log(A,...F))}warn(A,...F){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",A,...F):console.log(A,...F))}error(A,...F){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",A,...F):console.error(A,...F))}flush(){}}e.$lk=a;class n extends R{constructor(A,F=e.$gk){super(),this.g=A,this.setLevel(F)}trace(A,...F){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(A),...F])}debug(A,...F){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(A),...F])}info(A,...F){this.f(b.Info)&&this.g.log(b.Info,[this.h(A),...F])}warn(A,...F){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(A),...F])}error(A,...F){this.f(b.Error)&&this.g.log(b.Error,[this.h(A),...F])}h(A){return typeof A=="string"?A:(0,I.$tj)(A,this.f(b.Trace))}flush(){}}e.$mk=n;class r extends R{constructor(A){super(),this.g=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const F of this.g)F.setLevel(A);super.setLevel(A)}trace(A,...F){for(const H of this.g)H.trace(A,...F)}debug(A,...F){for(const H of this.g)H.debug(A,...F)}info(A,...F){for(const H of this.g)H.info(A,...F)}warn(A,...F){for(const H of this.g)H.warn(A,...F)}error(A,...F){for(const H of this.g)H.error(A,...F)}flush(){for(const A of this.g)A.flush()}dispose(){for(const A of this.g)A.dispose();super.dispose()}}e.$nk=r;class t extends C.$Xc{constructor(A,F,H){if(super(),this.h=A,this.j=F,this.b=new O.$Dc,this.c=this.B(new v.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$oe),this.onDidChangeVisibility=this.g.event,H)for(const Y of H)this.b.set(Y.resource,{logger:void 0,info:Y})}m(A){return(0,d.$hg)(A)?[...this.b.values()].find(F=>F.info.id===A):this.b.get(A)}getLogger(A){return this.m(A)?.logger}createLogger(A,F){const H=this.n(A),Y=(0,d.$hg)(A)?A:F?.id??(0,k.$wj)(H.toString()).toString(16);let ne=this.b.get(H)?.logger;const ae=F?.logLevel==="always"?b.Trace:F?.logLevel;ne||(ne=this.s(H,ae??this.getLogLevel(H)??this.h,{...F,id:Y}));const ue={logger:ne,info:{resource:H,id:Y,logLevel:ae,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(ue.info),this.b.set(H,ue),ne}n(A){return(0,d.$hg)(A)?(0,l.$jh)(this.j,`${A}.log`):A}setLogLevel(A,F){if(h.URI.isUri(A)){const H=A,Y=F,ne=this.b.get(H);ne&&Y!==ne.info.logLevel&&(ne.info.logLevel=Y===this.h?void 0:Y,ne.logger?.setLevel(Y),this.b.set(ne.info.resource,ne),this.f.fire([H,Y]))}else{this.h=A;for(const[H,Y]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(A,F){const H=this.m(A);H&&F!==!H.info.hidden&&(H.info.hidden=!F,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,F]))}getLogLevel(A){let F;return A&&(F=this.b.get(A)?.info.logLevel),F??this.h}registerLogger(A){const F=this.b.get(A.resource);F?F.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this.b.set(A.resource,{info:A,logger:void 0}),this.c.fire({added:[A],removed:[]}))}deregisterLogger(A){const F=this.b.get(A);F&&(F.logger&&F.logger.dispose(),this.b.delete(A),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const A of this.b.values())yield A.info}getRegisteredLogger(A){return this.b.get(A)?.info}dispose(){this.b.forEach(A=>A.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=t;class s{constructor(){this.onDidChangeLogLevel=new v.$oe().event}setLevel(A){}getLevel(){return b.Info}trace(A,...F){}debug(A,...F){}info(A,...F){}warn(A,...F){}error(A,...F){}critical(A,...F){}dispose(){}flush(){}}e.$pk=s;class o extends s{}e.$qk=o;function c(D){if(D.verbose)return b.Trace;if(typeof D.logLevel=="string"){const A=T(D.logLevel.toLowerCase());if(A!==void 0)return A}return e.$gk}function m(D){switch(D){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function N(D){switch(D){case b.Trace:return{original:"Trace",value:P.localize(1959,null)};case b.Debug:return{original:"Debug",value:P.localize(1960,null)};case b.Info:return{original:"Info",value:P.localize(1961,null)};case b.Warning:return{original:"Warning",value:P.localize(1962,null)};case b.Error:return{original:"Error",value:P.localize(1963,null)};case b.Off:return{original:"Off",value:P.localize(1964,null)}}}function T(D){switch(D){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$vk=new w.$Zj("logLevel",m(b.Info))}),define(le[107],he([0,1,19,8,7,4,65,2,15,52,6]),function(Z,e,P,I,v,k,C,O,g,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class h extends O.$Xc{constructor(f,p){super(),this.a=f,this.b=p,this.c=this.B(new k.$oe),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$oe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new I.$Gh(0)),this.w=[],this.y=this.B(new I.$Gh(0))}watch(f,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(f,p):this.z(f,p)}n(f,p){const S={path:this.J(f),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},b=(0,P.$Vb)(this.j,S);return this.r(),(0,O.$Vc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(f=>(0,v.$2)(f))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,l.$cr)(p)),p=>this.G(p),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const f=this.b?.watcher?.recursive?.usePolling;if(f===!0)for(const p of this.j)(0,l.$$q)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const p of this.j)(0,l.$$q)(p)&&f.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(f,p){const S={path:this.J(f),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},b=(0,P.$Vb)(this.w,S);return this.C(),(0,O.$Vc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(f=>(0,v.$2)(f))}D(){return this.u||(this.u=this.B(this.F(f=>this.c.fire((0,l.$cr)(f)),f=>this.G(f),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(f){f.type==="error"&&this.g.fire(f.message),this.H(f)}H(f){this.a[f.type](f.message)}I(f){return(0,g.$kc)(f.fsPath)}J(f){const p=this.I(f);return(0,C.$Kg)(p)}}e.$ir=h});var oe=this&&this.__param||function(Z,e){return function(P,I){e(P,I,Z)}};define(le[108],he([0,1,19,8,13,21,4,43,67,2,49,14,109,16,47,5,9,64,6,7]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u,R){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;let i=class extends l.$Xc{static{$=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new C.$oe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$oe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$oe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$oe),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$oe),this.Y=this.B(new C.$oe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$oe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new I.$Rh)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${n}`);const t=new l.$Wc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(s=>{const o=new b.$wl(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,l.$Vc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,l.$Sc)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await I.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,f.$nh)(n))throw new b.$yl((0,S.localize)(1871,null,this.sb(n)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new R.$db;throw t.message=(0,S.localize)(1872,null,n.toString()),t}return r}async m(n){const r=await this.j(n);if((0,b.$jl)(r)||(0,b.$gl)(r)||(0,b.$kl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,b.$jl)(r)||(0,b.$gl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(t){throw(0,b.$tl)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$yl((0,S.localize)(1873,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$rl)(t)}}async s(n,r){const t=await this.j(n),s=this.S(t),o=r?.resolveTo,c=r?.resolveSingleChildDescendants,m=r?.resolveMetadata,N=await t.stat(n);let T;return this.t(t,n,N,void 0,!!m,(D,A)=>(T||(T=d.$Oi.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(D.resource)||T.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&c?A===1:!1))}async t(n,r,t,s,o,c){const{providerExtUri:m}=this.R(n),N={resource:r,name:m.basename(r),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(n.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Jl)({mtime:t.mtime,size:t.size}),children:void 0};if(N.isDirectory&&c(N,s)){try{const T=await n.readdir(r),D=await I.Promises.settled(T.map(async([A,F])=>{try{const H=m.joinPath(r,A),Y=o?await n.stat(H):{type:F};return await this.t(n,H,Y,T.length,o,c)}catch(H){return this.b.trace(H),null}}));N.children=(0,P.$Jb)(D)}catch(T){this.b.trace(T),N.children=[]}return N}return N}async resolveAll(n){return I.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.t(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(t){return t}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new b.$yl((0,S.localize)(1874,null,this.sb(n)),b.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=v.$Qe.fromString(""),t){await this.u(n,t);const s=await this.writeFile(n,r);return this.r.fire(new b.$vl(n,b.FileOperation.CREATE,s)),s}async writeFile(n,r,t){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let c=t;if((0,b.$ml)(s)&&!c?.atomic){const m=s.enforceAtomicWriteFile?.(n);m&&(c={...t,atomic:m})}try{await this.w(s,n,c)||await this.U(s,o.dirname(n));let N;if((0,b.$gl)(s)&&!(r instanceof v.$Qe))if((0,p.$Ce)(r)){const T=await(0,p.$Je)(r,3);T.ended?N=v.$Qe.concat(T.buffer):N=T}else N=(0,p.$Ge)(r,T=>v.$Qe.concat(T),3);else N=r;!(0,b.$jl)(s)||(0,b.$gl)(s)&&N instanceof v.$Qe||(0,b.$gl)(s)&&(0,b.$ml)(s)&&c?.atomic?await this.hb(s,n,c,N):await this.db(s,n,c,N instanceof v.$Qe?(0,v.$2e)(N):N),this.r.fire(new b.$vl(n,b.FileOperation.WRITE))}catch(m){throw new b.$yl((0,S.localize)(1875,null,this.sb(n),(0,b.$rl)(m).toString()),(0,b.$ul)(m),c)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,t){const s=!!t?.unlock;if(s&&!(n.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,S.localize)(1876,null,this.sb(r)));if(!!t?.atomic){if(!(n.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,S.localize)(1877,null,this.sb(r)));if(!(n.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,S.localize)(1878,null,this.sb(r)));if(s)throw new Error((0,S.localize)(1879,null,this.sb(r)))}let c;try{c=await n.stat(r)}catch{return}if(c.type&b.FileType.Directory)throw new b.$yl((0,S.localize)(1880,null,this.sb(r)),b.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(r,c),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Il&&typeof c.mtime=="number"&&typeof c.size=="number"&&t.mtime<c.mtime&&t.etag!==(0,b.$Jl)({mtime:t.mtime,size:c.size}))throw new b.$yl((0,S.localize)(1881,null),b.FileOperationResult.FILE_MODIFIED_SINCE,t);return c}async readFile(n,r,t){const s=await this.m(n);return r?.atomic?this.z(s,n,r,t):this.C(s,n,r,t)}async z(n,r,t,s){return new Promise((o,c)=>{this.cb.queueFor(r,async()=>{try{const m=await this.C(n,r,t,s);o(m)}catch(m){c(m)}},this.R(n).providerExtUri)})}async C(n,r,t,s){const o=await this.D(n,r,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,v.$3e)(o.value)}}async readFileStream(n,r,t){const s=await this.m(n);return this.D(s,n,r,t)}async D(n,r,t,s){const o=new k.$ze(s);let c=t;(0,b.$ll)(n)&&n.enforceAtomicReadFile?.(r)&&(c={...t,atomic:!0});const m=this.J(r,c).then(T=>T,T=>{throw o.dispose(!0),T});let N;try{return typeof c?.etag=="string"&&c.etag!==b.$Il&&await m,c?.atomic&&(0,b.$ll)(n)||!((0,b.$jl)(n)||(0,b.$kl)(n))||(0,b.$gl)(n)&&c?.preferUnbuffered?N=this.I(n,r,c):(0,b.$kl)(n)?N=this.G(n,r,o.token,c):N=this.H(n,r,o.token,c),N.on("end",()=>o.dispose()),N.on("error",()=>o.dispose()),{...await m,value:N}}catch(T){throw N&&await(0,p.$He)(N),this.F(T,r,c)}}F(n,r,t){const s=(0,S.localize)(1882,null,this.sb(r),(0,b.$rl)(n).toString());return n instanceof b.$Al?new b.$Al(s,n.stat,t):n instanceof b.$zl?new b.$zl(s,n.fileOperationResult,n.size,n.options):new b.$yl(s,(0,b.$ul)(n),t)}G(n,r,t,s=Object.create(null)){const o=n.readFileStream(r,s,t);return(0,p.$Ne)(o,{data:c=>c instanceof v.$Qe?c:v.$Qe.wrap(c),error:c=>this.F(c,r,s)},c=>v.$Qe.concat(c))}H(n,r,t,s=Object.create(null)){const o=(0,v.$7e)();return(0,y.$8q)(n,r,o,c=>c,{...s,bufferSize:this.a,errorTransformer:c=>this.F(c,r,s)},t),o}I(n,r,t){const s=(0,p.$Ee)(o=>v.$Qe.concat(o));return(async()=>{try{let o;t?.atomic&&(0,b.$ll)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),s.end(v.$Qe.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new b.$yl((0,S.localize)(1883,null,this.sb(n)),b.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==b.$Il&&r.etag===t.etag)throw new b.$Al((0,S.localize)(1884,null),t,r);return this.L(n,t.size,r),t}L(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new b.$zl((0,S.localize)(1885,null,this.sb(n)),b.FileOperationResult.FILE_TOO_LARGE,r,t)}async canMove(n,r,t){return this.M(n,r,"move",t)}async canCopy(n,r,t){return this.M(n,r,"copy",t)}async M(n,r,t,s){if(n.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(n),n):await this.m(n),c=this.qb(await this.n(r),r);await this.Q(o,n,c,r,t,s)}catch(o){return o}return!0}async move(n,r,t){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),c=await this.N(s,n,o,r,"move",!!t),m=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$vl(n,c==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,m)),m}async copy(n,r,t){const s=await this.m(n),o=this.qb(await this.n(r),r),c=await this.N(s,n,o,r,"copy",!!t),m=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$vl(n,c==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,m)),m}async N(n,r,t,s,o,c){if(r.toString()===s.toString())return o;const{exists:m,isSameResourceWithDifferentPathCase:N}=await this.Q(n,r,t,s,o,c);if(m&&!N&&c&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),o==="copy"){if(n===t&&(0,b.$hl)(n))await n.copy(r,s,{overwrite:c});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,t,s):await this.O(n,r,t,s)}return o}else return n===t?(await n.rename(r,s,{overwrite:c}),o):(await this.N(n,r,t,s,"copy",c),await this.del(r,{recursive:!0}),"copy")}async O(n,r,t,s){if((0,b.$jl)(n)&&(0,b.$jl)(t))return this.jb(n,r,t,s);if((0,b.$jl)(n)&&(0,b.$gl)(t))return this.pb(n,r,t,s);if((0,b.$gl)(n)&&(0,b.$jl)(t))return this.nb(n,r,t,s);if((0,b.$gl)(n)&&(0,b.$gl)(t))return this.lb(n,r,t,s)}async P(n,r,t,s){await t.mkdir(s),Array.isArray(r.children)&&await I.Promises.settled(r.children.map(async o=>{const c=this.R(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),t,c):this.O(n,o.resource,t,c)}))}async Q(n,r,t,s,o,c){let m=!1;if(n===t){const{providerExtUri:T,isPathCaseSensitive:D}=this.R(n);if(D||(m=T.isEqual(r,s)),m&&o==="copy")throw new Error((0,S.localize)(1886,null,this.sb(r),this.sb(s)));if(!m&&T.isEqualOrParent(s,r))throw new Error((0,S.localize)(1887,null,this.sb(r),this.sb(s)))}const N=await this.exists(s);if(N&&!m){if(!c)throw new b.$yl((0,S.localize)(1888,null,this.sb(r),this.sb(s)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(n===t){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,S.localize)(1889,null,this.sb(r),this.sb(s)))}}return{exists:N,isSameResourceWithDifferentPathCase:m}}R(n){const r=this.S(n);return{providerExtUri:r?f.$_g:f.$bh,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$vl(n,b.FileOperation.CREATE,t)),t}async U(n,r){const t=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&b.FileType.Directory))throw new Error((0,S.localize)(1890,null,this.sb(r)));break}catch(o){if((0,b.$tl)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(r)),r=s.dirname(r)}for(let o=t.length-1;o>=0;o--){r=s.joinPath(r,t[o]);try{await n.mkdir(r)}catch(c){if((0,b.$tl)(c)!==b.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(n,r){try{await this.W(n,r)}catch(t){return t}return!0}async W(n,r){const t=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(t.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,S.localize)(1891,null,this.sb(n)));const o=r?.atomic;if(o&&!(t.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,S.localize)(1892,null,this.sb(n)));if(s&&o)throw new Error((0,S.localize)(1893,null,this.sb(n)));let c;try{c=await t.stat(n)}catch{}if(c)this.rb(n,c);else throw new b.$yl((0,S.localize)(1894,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const N=await this.resolve(n);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,S.localize)(1895,null,this.sb(n)))}return t}async del(n,r){const t=await this.W(n,r);let s=r;if((0,b.$nl)(t)&&!s?.atomic){const N=t.enforceAtomicDelete?.(n);N&&(s={...r,atomic:N})}const o=!!s?.useTrash,c=!!s?.recursive,m=s?.atomic??!1;await t.delete(n,{recursive:c,useTrash:o,atomic:m}),this.r.fire(new b.$vl(n,b.FileOperation.DELETE))}async cloneFile(n,r){const t=await this.j(n),s=this.qb(await this.n(r),r);if(!(t===s&&this.R(t).providerExtUri.isEqual(n,r)))return t===s&&(0,b.$il)(t)?t.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),t===s&&(0,b.$hl)(t)?this.cb.queueFor(n,()=>t.copy(n,r,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(n,()=>this.O(t,n,s,r),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:$.ab++})}watch(n,r={recursive:!1,excludes:[]}){const t=new l.$Wc;let s=!1,o=()=>{s=!0};t.add((0,l.$Vc)(()=>o())),(async()=>{try{const m=await this.bb(n,r);s?(0,l.$Sc)(m):o=()=>(0,l.$Sc)(m)}catch(m){this.b.error(m)}})();const c=r.correlationId;if(typeof c=="number"){const m=t.add(new C.$oe);return t.add(this.X.event(T=>{T.correlates(c)&&m.fire(T)})),{onDidChange:m.event,dispose:()=>t.dispose()}}return t}async bb(n,r){const t=await this.j(n),s=(0,O.$wj)([this.R(t).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:t.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,l.$Vc)(()=>{o&&(o.count--,o.count===0&&((0,l.$Sc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,l.$Sc)(n.disposable);this.$.clear()}async db(n,r,t,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,p.$Ce)(s)||(0,p.$De)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(c){throw(0,b.$rl)(c)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,t){let s=0,o;if((0,p.$De)(t)){if(t.buffer.length>0){const c=v.$Qe.concat(t.buffer);await this.gb(n,r,c,c.byteLength,s,0),s+=c.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((c,m)=>{(0,p.$Ie)(o,{onData:async N=>{o.pause();try{await this.gb(n,r,N,N.byteLength,s,0)}catch(T){return m(T)}s+=N.byteLength,setTimeout(()=>o.resume())},onError:N=>m(N),onEnd:()=>c()})})}async fb(n,r,t){let s=0,o;for(;(o=t.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,t,s,o,c){let m=0;for(;m<s;){const N=await n.write(r,o+m,t.buffer,c+m,s-m);m+=N}}async hb(n,r,t,s){return this.cb.queueFor(r,()=>this.ib(n,r,t,s),this.R(n).providerExtUri)}async ib(n,r,t,s){let o;s instanceof v.$Qe?o=s:(0,p.$Ce)(s)?o=await(0,v.$3e)(s):(0,p.$De)(s)?o=await(0,v.$4e)(s):o=(0,v.$1e)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(n,r,t,s){return this.cb.queueFor(s,()=>this.kb(n,r,t,s),this.R(t).providerExtUri)}async kb(n,r,t,s){let o,c;try{o=await n.open(r,{create:!1}),c=await t.open(s,{create:!0,unlock:!1});const m=v.$Qe.alloc(this.a);let N=0,T=0,D=0;do D=await n.read(o,N,m.buffer,T,m.byteLength-T),await this.gb(t,c,m,D,N,T),N+=D,T+=D,T===m.byteLength&&(T=0);while(D>0)}catch(m){throw(0,b.$rl)(m)}finally{await I.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async lb(n,r,t,s){return this.cb.queueFor(s,()=>this.mb(n,r,t,s),this.R(t).providerExtUri)}async mb(n,r,t,s){return t.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,t,s){return this.cb.queueFor(s,()=>this.ob(n,r,t,s),this.R(t).providerExtUri)}async ob(n,r,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const c=await n.readFile(r);await this.gb(t,o,v.$Qe.wrap(c),c.byteLength,0,0)}catch(c){throw(0,b.$rl)(c)}finally{await t.close(o)}}async pb(n,r,t,s){const o=await(0,v.$3e)(this.H(n,r,k.CancellationToken.None));await this.hb(t,s,void 0,o)}qb(n,r){if(n.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$yl((0,S.localize)(1896,null,this.sb(r)),b.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$yl((0,S.localize)(1897,null,this.sb(n)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===h.Schemas.file?n.fsPath:n.toString(!0)}};e.$9q=i,e.$9q=i=$=Ee([oe(0,u.$dk)],i)}),define(le[110],he([0,1,32,8,25,13,4,65,2,15,11,16,47,29,5,9,64,107,105,104]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class $ extends y.$ir{static{this.L=!1}constructor(a,n){super(a,n),this.onDidChangeCapabilities=C.Event.None,this.P=new v.$Dc(r=>h.$ah.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=S.FileSystemProviderCapabilities.FileReadWrite|S.FileSystemProviderCapabilities.FileOpenReadWriteClose|S.FileSystemProviderCapabilities.FileReadStream|S.FileSystemProviderCapabilities.FileFolderCopy|S.FileSystemProviderCapabilities.FileWriteUnlock|S.FileSystemProviderCapabilities.FileAtomicRead|S.FileSystemProviderCapabilities.FileAtomicWrite|S.FileSystemProviderCapabilities.FileAtomicDelete|S.FileSystemProviderCapabilities.FileClone,d.$l&&(this.M|=S.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:n,symbolicLink:r}=await f.SymlinkSupport.stat(this.I(a));return{type:this.O(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:S.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const n=await f.Promises.readdir(this.I(a),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,h.$jh)(a,t.name))).type:s=this.O(t),r.push([t.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.hb(n)}}O(a,n){let r;return n?.dangling?r=S.FileType.Unknown:a.isFile()?r=S.FileType.File:a.isDirectory()?r=S.FileType.Directory:r=S.FileType.Unknown,n&&(r|=S.FileType.SymbolicLink),r}async Q(a){const n=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const t=new I.$Hh;return this.P.set(a,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,g.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(a)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),t.open()})}async readFile(a,n){let r;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),r=await this.Q(a));const t=this.I(a);return await P.promises.readFile(t)}catch(t){throw this.hb(t)}finally{r?.dispose()}}R(a){$.L&&this.a.trace(a)}readFileStream(a,n,r){const t=(0,w.$Ee)(s=>k.$Qe.concat(s.map(o=>k.$Qe.wrap(o))).buffer);return(0,b.$8q)(this,a,t,s=>s.buffer,{...n,bufferSize:256*1024},r),t}async writeFile(a,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(a)?this.U(a,(0,h.$jh)((0,h.$ih)(a),`${(0,h.$gh)(a)}${r.atomic.postfix}`),n,r):this.W(a,n,r)}async S(a){try{const n=this.I(a),{symbolicLink:r}=await f.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async U(a,n,r,t){const s=new g.$Wc;try{s.add(await this.Q(a)),s.add(await this.Q(n)),await this.W(n,r,t,!0);try{await this.rename(n,a,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async W(a,n,r,t){let s;try{const o=this.I(a);if(!r.create||!r.overwrite){if(await f.Promises.exists(o)){if(!r.overwrite)throw(0,S.$ql)((0,p.localize)(1901,null),S.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,S.$ql)((0,p.localize)(1902,null),S.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(a,{create:!0,unlock:r.unlock},t),await this.write(s,0,n,0,n.byteLength)}catch(o){throw await this.ib(a,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(a){$.$=a}async open(a,n,r){const t=this.I(a);let s;(0,S.$el)(n)&&!r&&(s=await this.Q(a));let o;try{if((0,S.$el)(n)&&n.unlock)try{const{stat:m}=await f.SymlinkSupport.stat(t);m.mode&128||await P.promises.chmod(t,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let c;if((0,S.$el)(n)){if(d.$j)try{await P.promises.truncate(t,0),c="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}c||(c="w")}else c="r";o=await f.Promises.open(t,c)}catch(c){throw s?.dispose(),(0,S.$el)(n)?await this.ib(a,c):this.hb(c)}if(this.X.set(o,0),(0,S.$el)(n)&&this.Z.set(o,a),s){const c=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.Y.set(o,s),c&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),c.dispose())}return o}async close(a){const n=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&$.$)try{await f.Promises.fdatasync(a)}catch(r){$.configureFlushOnWrite(!1),this.a.error(r)}return await f.Promises.close(a)}catch(r){throw this.hb(r)}finally{n&&(this.Y.get(a)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),n.dispose())}}async read(a,n,r,t,s){const o=this.ab(a,n);let c=null;try{c=(await f.Promises.read(a,r,t,s,o)).bytesRead}catch(m){throw this.hb(m)}finally{this.bb(a,o,c)}return c}ab(a,n){return n===this.X.get(a)?null:n}bb(a,n,r){const t=this.X.get(a);typeof t=="number"&&(typeof n=="number"||(typeof r=="number"?this.X.set(a,t+r):this.X.delete(a)))}async write(a,n,r,t,s){return(0,I.$3h)(()=>this.cb(a,n,r,t,s),100,3)}async cb(a,n,r,t,s){const o=this.ab(a,n);let c=null;try{c=(await f.Promises.write(a,r,t,s,o)).bytesWritten}catch(m){throw await this.ib(this.Z.get(a),m)}finally{this.bb(a,o,c)}return c}async mkdir(a){try{await P.promises.mkdir(this.I(a))}catch(n){throw this.hb(n)}}async delete(a,n){try{const r=this.I(a);if(n.recursive){let t;n?.atomic!==!1&&n.atomic.postfix&&(t=(0,l.$mc)((0,l.$pc)(r),`${(0,l.$qc)(r)}${n.atomic.postfix}`)),await f.Promises.rm(r,f.RimRafMode.MOVE,t)}else try{await P.promises.unlink(r)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:c}=await f.SymlinkSupport.stat(r);s=o.isDirectory()&&!c}catch{}if(s)await P.promises.rmdir(r);else throw t}else throw t}}catch(r){throw this.hb(r)}}async rename(a,n,r){const t=this.I(a),s=this.I(n);if(t!==s)try{await this.db(a,n,"move",r.overwrite),await f.Promises.rename(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,p.localize)(1903,null,(0,l.$qc)(t),(0,l.$qc)((0,l.$pc)(s)),o.toString()))),this.hb(o)}}async copy(a,n,r){const t=this.I(a),s=this.I(n);if(t!==s)try{await this.db(a,n,"copy",r.overwrite),await f.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,p.localize)(1904,null,(0,l.$qc)(t),(0,l.$qc)((0,l.$pc)(s)),o.toString()))),this.hb(o)}}async db(a,n,r,t){const s=this.I(a),o=this.I(n);let c=!1;if(!!(this.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive)||(c=(0,O.$Gg)(s,o,!0)),c){if(r==="copy")throw(0,S.$ql)((0,p.localize)(1905,null),S.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const N=await this.N(a);if(!N)throw(0,S.$ql)((0,p.localize)(1906,null),S.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(n);if(T){if(!t)throw(0,S.$ql)((0,p.localize)(1907,null),S.FileSystemProviderErrorCode.FileExists);N.type&S.FileType.File&&T.type&S.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,n){return this.eb(a,n,!1)}async eb(a,n,r){const t=this.I(a),s=this.I(n),o=!!(this.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Gg)(t,s,!o))return;const c=new g.$Wc;try{c.add(await this.Q(a)),c.add(await this.Q(n)),r&&await P.promises.mkdir((0,l.$pc)(s),{recursive:!0}),await P.promises.copyFile(t,s)}catch(m){if(m.code==="ENOENT"&&!r)return this.eb(a,n,!0);throw this.hb(m)}finally{c.dispose()}}t(a,n,r){return new u.$pr(t=>a(t),t=>n(t),r)}F(a,n,r){return new R.$yr(t=>a(t),t=>n(t),r)}hb(a){if(a instanceof S.$pl)return a;let n=a,r;switch(a.code){case"ENOENT":r=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=S.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=S.FileSystemProviderErrorCode.Unknown;break;default:r=S.FileSystemProviderErrorCode.Unknown}return(0,S.$ql)(n,r)}async ib(a,n){let r=this.hb(n);if(a&&r.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await f.SymlinkSupport.stat(this.I(a));t.mode&128||(r=(0,S.$ql)(n,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return r}}e.$zr=$}),define(le[111],he([0,1,2,6]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class v extends P.$Xc{constructor(C,O=[]){super(),this.a=new I.$nk([C,...O]),this.B(C.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...O){this.a.trace(C,...O)}debug(C,...O){this.a.debug(C,...O)}info(C,...O){this.a.info(C,...O)}warn(C,...O){this.a.warn(C,...O)}error(C,...O){this.a.error(C,...O)}flush(){this.a.flush()}}e.$4R=v}),define(le[112],he([0,1,9,6]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0;var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v||(v={}));async function k(l,d,h,w,f){try{const p=await new Promise((b,y)=>{Z(["@vscode/spdlog"],b,y)}).then(be);p.setFlushOn(v.Trace);const S=await p.createAsyncRotatingLogger(l,d,h,w);return f?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(p){console.error(p)}return null}function C(l,d,h){switch(d){case I.LogLevel.Trace:l.trace(h);break;case I.LogLevel.Debug:l.debug(h);break;case I.LogLevel.Info:l.info(h);break;case I.LogLevel.Warning:l.warn(h);break;case I.LogLevel.Error:l.error(h);break;case I.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function O(l,d){switch(d){case I.LogLevel.Trace:l.setLevel(v.Trace);break;case I.LogLevel.Debug:l.setLevel(v.Debug);break;case I.LogLevel.Info:l.setLevel(v.Info);break;case I.LogLevel.Warning:l.setLevel(v.Warning);break;case I.LogLevel.Error:l.setLevel(v.Error);break;case I.LogLevel.Off:l.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class g extends I.$jk{constructor(d,h,w,f,p){super(),this.m=[],this.setLevel(p),this.n=this.s(d,h,w,f),this.B(this.onDidChangeLogLevel(S=>{this.r&&O(this.r,S)}))}async s(d,h,w,f){const p=w?6:1,S=30/p*P.$Ll.MB,b=await k(d,h,S,p,f);if(b){this.r=b,O(this.r,this.getLevel());for(const{level:y,message:u}of this.m)C(this.r,y,u);this.m=[]}}g(d,h){this.r?C(this.r,d,h):this.getLevel()<=d&&this.m.push({level:d,message:h})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$SR=g}),define(le[113],he([0,1,28,6,112]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0;class k extends I.$ok{s(O,g,l){return new v.$SR((0,P.$5g)(),O.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,g)}}e.$TR=k}),define(le[39],he([0,1,4,67,2,10]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=void 0,e.$xo=(0,k.$Ii)("policy");class C extends v.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$oe),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const d=Object.keys(this.f).length;return this.f={...l,...this.f},d!==Object.keys(this.f).length&&await this.j(l),I.Iterable.reduce(this.g.entries(),(h,[w,f])=>({...h,[w]:f}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return I.Iterable.reduce(Object.entries(this.f),(l,[d,h])=>({...l,[d]:{definition:h,value:this.g.get(d)}}),{})}}e.$yo=C;class O{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$zo=O}),define(le[114],he([0,1,8,4,67,3,9,6,39]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;function l(h,w){const f=[];for(const p of new Set(v.Iterable.concat(h.keys(),w.keys())))h.get(p)!==w.get(p)&&f.push(p);return f}let d=class extends g.$yo{constructor(w,f,p){super(),this.m=w,this.n=f,this.s=p,this.c=this.B(new P.$Gh(500));const S=I.Event.filter(f.onDidFilesChange,b=>b.affects(w));this.B(f.watch(w)),this.B(S(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const w=new Map;try{const f=await this.n.readFile(this.m),p=JSON.parse(f.value.toString());if(!(0,k.$jg)(p))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(p))this.f[S]&&w.set(S,p[S])}catch(f){f.fileOperationResult!==C.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",f)}return w}async w(){const w=await this.u(),f=l(this.g,w);this.g=w,f.length>0&&this.h.fire(f)}};e.$Yic=d,e.$Yic=d=Ee([oe(1,C.$dl),oe(2,O.$dk)],d)}),define(le[115],he([0,1,39,8,2,6]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;let C=class extends P.$yo{constructor(g,l){super(),this.m=g,this.n=l,this.a=new I.$Ch,this.b=this.B(new v.$Yc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:l}=await new Promise((d,h)=>{Z(["@vscode/policy-watcher"],d,h)}).then(be);await this.a.queue(()=>new Promise((d,h)=>{try{this.b.value=l(this.n,g,w=>{this.t(w),d()})}catch(w){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",w),h(w)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const l in g){const d=g[l];d===void 0?this.g.delete(l):this.g.set(l,d)}this.h.fire(Object.keys(g))}};e.$Xic=C,e.$Xic=C=Ee([oe(0,k.$dk)],C)}),define(le[33],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,P.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"}),define(le[37],he([0,1,76,3]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,P=be(P),I=be(I);class v{constructor(){this.a=new Map}add(C,O){P.ok(I.$hg(C)),P.ok(I.$jg(O)),P.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,O)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$vo=new v}),define(le[116],he([0,1,4,79,37]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,v=be(v),e.$wo={JSONContribution:"base.contributions.json"};function k(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class C{constructor(){this.b=new P.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,d){this.a[k(l)]=d,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(l){const d=this.a[l];return d?(0,I.$$j)(d):void 0}hasSchemaContent(l){return!!this.a[l]}}const O=new C;v.$vo.add(e.$wo.JSONContribution,O)}),define(le[40],he([0,1,19,4,3,5,30,116,37]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.ConfigurationScope=e.$Ao=e.EditPresentationTypes=void 0,e.$Lo=S,e.$Mo=b,e.$No=y,e.$Oo=R,e.$Po=$,e.$Qo=i,e.$Ro=a,v=be(v),k=be(k);var l;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Ao={Configuration:"base.contributions.configuration"};var d;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho="vscode://schemas/settings/resourceLanguage",e.$Io="vscode://schemas/settings/configurationDefaults";const h=g.$vo.as(O.$wo.JSONContribution);class w{constructor(){this.a=[],this.i=new Set,this.j=new I.$oe,this.onDidSchemaChange=this.j.event,this.k=new I.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},h.registerSchema(e.$Ho,this.h),this.z()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const s=new Set;this.r(r,t,s),h.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(r){const t=new Set;this.s(r,t),h.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:r,remove:t}){const s=new Set;this.s(t,s),this.r(r,!1,s),h.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(r){const t=new Set;this.l(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(r,t){this.a.push(...r);const s=[];for(const{overrides:o,source:c}of r)for(const m in o){t.add(m);const N=this.b.get(m)??this.b.set(m,{configurationDefaultOverrides:[]}).get(m),T=o[m];if(N.configurationDefaultOverrides.push({value:T,source:c}),e.$Ko.test(m)){const D=this.o(m,T,c,N.configurationDefaultOverrideValue);if(!D)continue;N.configurationDefaultOverrideValue=D,this.n(m,D,c),s.push(...S(m))}else{const D=this.p(m,T,c,N.configurationDefaultOverrideValue);if(!D)continue;N.configurationDefaultOverrideValue=D;const A=this.e[m];A&&(this.A(m,A),this.w(m,A))}}this.q(s)}deregisterDefaultConfigurations(r){const t=new Set;this.m(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(r,t){for(const s of r){const o=this.a.indexOf(s);o!==-1&&this.a.splice(o,1)}for(const{overrides:s,source:o}of r)for(const c in s){const m=this.b.get(c);if(!m)continue;const N=m.configurationDefaultOverrides.findIndex(T=>o?T.source?.id===o.id:T.value===s[c]);if(N!==-1){if(m.configurationDefaultOverrides.splice(N,1),m.configurationDefaultOverrides.length===0&&this.b.delete(c),e.$Ko.test(c)){let T;for(const D of m.configurationDefaultOverrides)T=this.o(c,D.value,D.source,T);T&&!v.$ug(T.value)?(m.configurationDefaultOverrideValue=T,this.n(c,T,o)):(this.b.delete(c),delete this.e[c],delete this.c.properties[c])}else{let T;for(const A of m.configurationDefaultOverrides)T=this.p(c,A.value,A.source,T);m.configurationDefaultOverrideValue=T;const D=this.e[c];D&&(this.A(c,D),this.w(c,D))}t.add(c)}}this.y()}n(r,t,s){const o={type:"object",default:t.value,description:k.localize(1663,null,(0,C.$mj)(r)),$ref:e.$Ho,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[r]=o,this.c.properties[r]=o}o(r,t,s,o){const c=o?.value||{},m=o?.source??new Map;if(!(m instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const N of Object.keys(t)){const T=t[N];if(v.$jg(T)&&(v.$og(c[N])||v.$jg(c[N]))){if(c[N]={...c[N]??{},...T},s)for(const A in T)m.set(`${N}.${A}`,s)}else c[N]=T,s?m.set(N,s):m.delete(N)}return{value:c,source:m}}p(r,t,s,o){const c=this.e[r],m=o?.value??c?.defaultDefaultValue;let N=s;if(v.$jg(t)&&(c!==void 0&&c.type==="object"||c===void 0&&(v.$og(m)||v.$jg(m)))){if(N=o?.source??new Map,!(N instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const D in t)s&&N.set(`${r}.${D}`,s);t={...v.$jg(m)?m:{},...t}}return{value:t,source:N}}deltaConfiguration(r){let t=!1;const s=new Set;r.removedDefaults&&(this.m(r.removedDefaults,s),t=!0),r.addedDefaults&&(this.l(r.addedDefaults,s),t=!0),r.removedConfigurations&&this.s(r.removedConfigurations,s),r.addedConfigurations&&this.r(r.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this.j.fire()}registerOverrideIdentifiers(r){this.q(r),this.j.fire()}q(r){for(const t of r)this.i.add(t);this.y()}r(r,t,s){r.forEach(o=>{this.u(o,t,o.extensionInfo,o.restrictedProperties,void 0,s),this.d.push(o),this.v(o)})}s(r,t){const s=o=>{if(o.properties)for(const c in o.properties){t.add(c);const m=this.e[c];m?.policy?.name&&this.f.delete(m.policy.name),delete this.e[c],this.x(c,o.properties[c])}o.allOf?.forEach(c=>s(c))};for(const o of r){s(o);const c=this.d.indexOf(o);c!==-1&&this.d.splice(c,1)}}u(r,t=!0,s,o,c=d.WINDOW,m){c=v.$qg(r.scope)?c:r.scope;const N=r.properties;if(N)for(const D in N){const A=N[D];if(t&&R(D,A)){delete N[D];continue}if(A.source=s,A.defaultDefaultValue=N[D].default,this.A(D,A),e.$Ko.test(D)?A.scope=void 0:(A.scope=v.$qg(A.scope)?c:A.scope,A.restricted=v.$qg(A.restricted)?!!o?.includes(D):A.restricted),N[D].hasOwnProperty("included")&&!N[D].included){this.g[D]=N[D],delete N[D];continue}else this.e[D]=N[D],N[D].policy?.name&&this.f.set(N[D].policy.name,D);!N[D].deprecationMessage&&N[D].markdownDeprecationMessage&&(N[D].deprecationMessage=N[D].markdownDeprecationMessage),m.add(D)}const T=r.allOf;if(T)for(const D of T)this.u(D,t,s,o,c,m)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const r=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&r.set(t,s.configurationDefaultOverrideValue);return r}v(r){const t=s=>{const o=s.properties;if(o)for(const m in o)this.w(m,o[m]);s.allOf?.forEach(t)};t(r)}w(r,t){switch(e.$Bo.properties[r]=t,t.scope){case d.APPLICATION:e.$Co.properties[r]=t;break;case d.MACHINE:e.$Do.properties[r]=t;break;case d.MACHINE_OVERRIDABLE:e.$Eo.properties[r]=t;break;case d.WINDOW:e.$Fo.properties[r]=t;break;case d.RESOURCE:e.$Go.properties[r]=t;break;case d.LANGUAGE_OVERRIDABLE:e.$Go.properties[r]=t,this.h.properties[r]=t;break}}x(r,t){switch(delete e.$Bo.properties[r],t.scope){case d.APPLICATION:delete e.$Co.properties[r];break;case d.MACHINE:delete e.$Do.properties[r];break;case d.MACHINE_OVERRIDABLE:delete e.$Eo.properties[r];break;case d.WINDOW:delete e.$Fo.properties[r];break;case d.RESOURCE:case d.LANGUAGE_OVERRIDABLE:delete e.$Go.properties[r],delete this.h.properties[r];break}}y(){for(const r of this.i.values()){const t=`[${r}]`,s={type:"object",description:k.localize(1664,null),errorMessage:k.localize(1665,null),$ref:e.$Ho};this.A(t,s),e.$Bo.properties[t]=s,e.$Co.properties[t]=s,e.$Do.properties[t]=s,e.$Eo.properties[t]=s,e.$Fo.properties[t]=s,e.$Go.properties[t]=s}}z(){const r={type:"object",description:k.localize(1666,null),errorMessage:k.localize(1667,null),$ref:e.$Ho};e.$Bo.patternProperties[e.$Jo]=r,e.$Co.patternProperties[e.$Jo]=r,e.$Do.patternProperties[e.$Jo]=r,e.$Eo.patternProperties[e.$Jo]=r,e.$Fo.patternProperties[e.$Jo]=r,e.$Go.patternProperties[e.$Jo]=r,this.j.fire()}A(r,t){const s=this.b.get(r)?.configurationDefaultOverrideValue;let o,c;s&&(!t.disallowConfigurationDefault||!s.source)&&(o=s.value,c=s.source),v.$og(o)&&(o=t.defaultDefaultValue,c=void 0),v.$og(o)&&(o=y(t.type)),t.default=o,t.defaultValueSource=c}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.$Jo=`^(${f})+$`,e.$Ko=new RegExp(e.$Jo);function S(n){const r=[];if(e.$Ko.test(n)){let t=p.exec(n);for(;t?.length;){const s=t[1].trim();s&&r.push(s),t=p.exec(n)}}return(0,P.$Ob)(r)}function b(n){return n.reduce((r,t)=>`${r}[${t}]`,"")}function y(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new w;g.$vo.add(e.$Ao.Configuration,u);function R(n,r){return n.trim()?e.$Ko.test(n)?k.localize(1669,null,n):u.getConfigurationProperties()[n]!==void 0?k.localize(1670,null,n):r.policy?.name&&u.getPolicyConfigurations().get(r.policy?.name)!==void 0?k.localize(1671,null,n,r.policy?.name,u.getPolicyConfigurations().get(r.policy?.name)):null:k.localize(1668,null)}function $(){const n=[],r=u.getConfigurationProperties();for(const t of Object.keys(r))n.push([t,r[t].scope]);return n.push(["launch",d.RESOURCE]),n.push(["task",d.RESOURCE]),n}function i(n){const r={};for(const t of n){const s=t.properties;if(v.$jg(s))for(const o in s)r[o]=s[o];t.allOf&&Object.assign(r,i(t.allOf))}return r}function a(n){switch(n){case"application":return d.APPLICATION;case"machine":return d.MACHINE;case"resource":return d.RESOURCE;case"machine-overridable":return d.MACHINE_OVERRIDABLE;case"language-overridable":return d.LANGUAGE_OVERRIDABLE;default:return d.WINDOW}}}),define(le[68],he([0,1,19,4,34,2,25,27,3,12,30,40,9,37]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Wo=$,P=be(P),v=be(v),O=be(O),g=be(g);function p(r){return Object.isFrozen(r)?r:O.$jo(r)}class S{static createEmptyModel(t){return new S({},[],[],void 0,t)}constructor(t,s,o,c,m){this.b=t,this.c=s,this.d=o,this.raw=c,this.f=m,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof S)return s;const o=new b("",this.f);return o.parseRaw(s),o.configurationModel});this.g=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,d.$kj)(this.contents,t):this.contents}inspect(t,s){const o=this;return{get value(){return p(o.rawConfiguration.getValue(t))},get override(){return s?p(o.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return p(s?o.rawConfiguration.override(s).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const c=[];for(const{contents:m,identifiers:N,keys:T}of o.rawConfiguration.overrides){const D=new S(m,T,[],void 0,o.f).getValue(t);D!==void 0&&c.push({identifiers:N,value:D})}return c.length?p(c):void 0}}}getOverrideValue(t,s){const o=this.j(s);return o?t?(0,d.$kj)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return P.$Ob(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return P.$Ob(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=O.$io(this.contents),o=O.$io(this.overrides),c=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const N of t)if(m.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(s,N.contents);for(const T of N.overrides){const[D]=o.filter(A=>P.$wb(A.identifiers,T.identifiers));D?(this.i(D.contents,T.contents),D.keys.push(...T.keys),D.keys=P.$Ob(D.keys)):o.push(O.$io(T))}for(const T of N.keys)c.indexOf(T)===-1&&c.push(T)}return new S(s,c,o,m.every(N=>N instanceof S)?void 0:m,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const c of P.$Ob([...Object.keys(this.contents),...Object.keys(s)])){let m=this.contents[c];const N=s[c];N&&(typeof m=="object"&&typeof N=="object"?(m=O.$io(m),this.i(m,N)):m=N),o[c]=m}return new S(o,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const o of Object.keys(s)){if(o in t&&g.$jg(t[o])&&g.$jg(s[o])){this.i(t[o],s[o]);continue}t[o]=O.$io(s[o])}}j(t){let s=null,o=null;const c=m=>{m&&(o?this.i(o,m):o=O.$io(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===t?s=m.contents:m.identifiers.includes(t)&&c(m.contents);return c(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,d.$jj)(this.contents,t),h.$Ko.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>P.$wb(o.identifiers,(0,h.$Lo)(t))),1))}k(t,s,o){if((0,d.$ij)(this.contents,t,s,c=>this.f.error(c)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),h.$Ko.test(t)){const c=(0,h.$Lo)(t),m={identifiers:c,keys:Object.keys(this.contents[t]),contents:(0,d.$hj)(this.contents[t],T=>this.f.error(T))},N=this.overrides.findIndex(T=>P.$wb(T.identifiers,c));N!==-1?this.overrides[N]=m:this.overrides.push(m)}}}e.$So=S;class b{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||S.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!g.$qg(t)){const o=this.h(t);this.parseRaw(o,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:o,keys:c,overrides:m,restricted:N,hasExcludedProperties:T}=this.i(t,s);this.b=new S(o,c,m,T?[t]:void 0,this.g),this.c=N||[]}h(t){let s={},o=null,c=[];const m=[],N=[];function T(A){Array.isArray(c)?c.push(A):o!==null&&(c[o]=A)}const D={onObjectBegin:()=>{const A={};T(A),m.push(c),c=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{c=m.pop()},onArrayBegin:()=>{const A=[];T(A),m.push(c),c=A,o=null},onArrayEnd:()=>{c=m.pop()},onLiteralValue:T,onError:(A,F,H)=>{N.push({error:A,offset:F,length:H})}};if(t)try{v.$0n(t,D),s=c[0]||{}}catch(A){this.g.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return s}i(t,s){const o=f.$vo.as(h.$Ao.Configuration).getConfigurationProperties(),c=this.j(t,o,!0,s);t=c.raw;const m=(0,d.$hj)(t,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),N=Object.keys(t),T=this.l(t,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:m,keys:N,overrides:T,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(t,s,o,c){let m=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:m};const N={},T=[];for(const D in t)if(h.$Ko.test(D)&&o){const A=this.j(t[D],s,!1,c);N[D]=A.raw,m=m||A.hasExcludedProperties,T.push(...A.restricted)}else{const A=s[D],F=A?typeof A.scope<"u"?A.scope:h.ConfigurationScope.WINDOW:void 0;A?.restricted&&T.push(D),!c.exclude?.includes(D)&&(c.include?.includes(D)||(F===void 0||c.scopes===void 0||c.scopes.includes(F))&&!(c.skipRestricted&&A?.restricted))?N[D]=t[D]:m=!0}return{raw:N,restricted:T,hasExcludedProperties:m}}l(t,s){const o=[];for(const c of Object.keys(t))if(h.$Ko.test(c)){const m={};for(const N in t[c])m[N]=t[c][N];o.push({identifiers:(0,h.$Lo)(c),keys:Object.keys(m),contents:(0,d.$hj)(m,s)})}return o}}e.$To=b;class y extends k.$Xc{constructor(t,s,o,c,m){super(),this.c=t,this.f=s,this.g=c,this.h=m,this.b=this.B(new I.$oe),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),m),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(I.Event.any(I.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),I.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(w.FileOperation.CREATE)||N.isOperation(w.FileOperation.COPY)||N.isOperation(w.FileOperation.DELETE)||N.isOperation(w.FileOperation.WRITE))&&o.isEqual(N.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return S.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Uo=y;class u{constructor(t,s,o,c,m,N,T,D,A,F,H,Y,ne){this.a=t,this.b=s,this.c=o,this.overrideIdentifiers=c,this.d=m,this.f=N,this.g=T,this.h=D,this.i=A,this.j=F,this.k=H,this.l=Y,this.m=ne}get value(){return p(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class R{constructor(t,s,o,c,m,N,T,D,A,F){this.j=t,this.l=s,this.m=o,this.n=c,this.p=m,this.q=N,this.r=T,this.s=D,this.t=A,this.u=F,this.h=null,this.i=new C.$Dc,this.v=null}getValue(t,s,o){return this.w(t,s,o).getValue(t)}updateValue(t,s,o={}){let c;o.resource?(c=this.t.get(o.resource),c||(c=S.createEmptyModel(this.u),this.t.set(o.resource,c))):c=this.s,s===void 0?c.removeValue(t):c.setValue(t,s),o.resource||(this.h=null)}inspect(t,s,o){const c=this.w(t,s,o),m=this.A(s.resource,o),N=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const D of c.overrides)for(const A of D.identifiers)c.getOverrideValue(t,A)!==void 0&&T.add(A);return new u(t,s,c.getValue(t),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,m||void 0,N)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:c,updated:m,removed:N}=a(this.j,t);s=[...c,...m,...N]}for(const c of s)for(const m of(0,h.$Lo)(c)){const N=this.j.getKeysForOverrideIdentifier(m),T=t.getKeysForOverrideIdentifier(m),D=[...T.filter(A=>N.indexOf(A)===-1),...N.filter(A=>T.indexOf(A)===-1),...N.filter(A=>!O.$mo(this.j.override(m).getValue(A),t.override(m).getValue(A)))];o.push([m,D])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:c}=a(this.l,t),m=[...s,...o,...c];return m.length&&this.updatePolicyConfiguration(t),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:c,overrides:m}=a(this.applicationConfiguration,t),N=[...s,...o,...c];return N.length&&this.updateApplicationConfiguration(t),{keys:N,overrides:m}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:c,overrides:m}=a(this.localUserConfiguration,t),N=[...s,...o,...c];return N.length&&this.updateLocalUserConfiguration(t),{keys:N,overrides:m}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:c,overrides:m}=a(this.remoteUserConfiguration,t),N=[...s,...o,...c];return N.length&&this.updateRemoteUserConfiguration(t),{keys:N,overrides:m}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:c,overrides:m}=a(this.workspaceConfiguration,t),N=[...s,...o,...c];return N.length&&this.updateWorkspaceConfiguration(t),{keys:N,overrides:m}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:c,updated:m,removed:N,overrides:T}=a(o,s),D=[...c,...m,...N];return(D.length||!o)&&this.updateFolderConfiguration(t,s),{keys:D,overrides:T}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:c,removed:m,overrides:N}=a(s,void 0);return{keys:[...o,...c,...m],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,o){let c=this.x(s,o);return s.overrideIdentifier&&(c=c.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(c=c.merge(this.l)),c}x({resource:t},s){let o=this.y();if(s&&t){const c=s.getFolder(t);c&&(o=this.z(c.uri)||o);const m=this.t.get(t);m&&(o=o.merge(m))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const o=this.y(),c=this.r.get(t);c?(s=o.merge(c),this.i.set(t,s)):s=o}return s}A(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:o,overrides:c,keys:m}=this.r.get(s);return t.push([s,{contents:o,overrides:c,keys:m}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(c=>s.add(c))),[...s.values()]}static parse(t,s){const o=this.E(t.defaults,s),c=this.E(t.policy,s),m=this.E(t.application,s),N=this.E(t.user,s),T=this.E(t.workspace,s),D=t.folders.reduce((A,F)=>(A.set(l.URI.revive(F[0]),this.E(F[1],s)),A),new C.$Dc);return new R(o,c,m,N,S.createEmptyModel(s),T,D,S.createEmptyModel(s),new C.$Dc,s)}static E(t,s){return new S(t.contents,t.keys,t.overrides,void 0,s)}}e.$Vo=R;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,s=new Map;for(const c of r)c.keys.forEach(m=>t.add(m)),c.overrides.forEach(([m,N])=>{const T=(0,C.$Ac)(s,m,new Set);N.forEach(D=>T.add(D))});const o=[];return s.forEach((c,m)=>o.push([m,[...c.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,s,o,c,m){this.change=t,this.f=s,this.g=o,this.h=c,this.i=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of t.keys)this.affectedKeys.add(N);for(const[,N]of t.overrides)for(const T of N)this.affectedKeys.add(T);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=R.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const o=this.a+t,c=this.d.indexOf(o);if(c<0)return!1;const m=c+o.length;if(m>=this.d.length)return!1;const N=this.d.charCodeAt(m);if(N!==this.b&&N!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,D=this.g.getValue(t,s,this.h);return!O.$mo(T,D)}return!0}}e.$Xo=i;function a(r,t){const{added:s,removed:o,updated:c}=n(t?.rawConfiguration,r?.rawConfiguration),m=[],N=r?.getAllOverrideIdentifiers()||[],T=t?.getAllOverrideIdentifiers()||[];if(t){const D=T.filter(A=>!N.includes(A));for(const A of D)m.push([A,t.getKeysForOverrideIdentifier(A)])}if(r){const D=N.filter(A=>!T.includes(A));for(const A of D)m.push([A,r.getKeysForOverrideIdentifier(A)])}if(t&&r){for(const D of N)if(T.includes(D)){const A=n({contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)},{contents:t.getOverrideValue(void 0,D)||{},keys:t.getKeysForOverrideIdentifier(D)});m.push([D,[...A.added,...A.removed,...A.updated]])}}return{added:s,removed:o,updated:c,overrides:m}}function n(r,t){const s=r?t?r.keys.filter(m=>t.keys.indexOf(m)===-1):[...r.keys]:[],o=t?r?t.keys.filter(m=>r.keys.indexOf(m)===-1):[...t.keys]:[],c=[];if(r&&t){for(const m of t.keys)if(r.keys.indexOf(m)!==-1){const N=(0,d.$kj)(t.contents,m),T=(0,d.$kj)(r.contents,m);O.$mo(N,T)||c.push(m)}}return{added:s,removed:o,updated:c}}}),define(le[117],he([0,1,19,4,2,27,3,68,40,6,39,37]),function(Z,e,P,I,v,k,C,O,g,l,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=void 0;class w extends v.$Xc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new I.$oe),this.onDidChangeConfiguration=this.a.event,this.b=O.$So.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(h.$vo.as(g.$Ao.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:y})=>this.f(Array.from(b),y))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,y){this.j(b,h.$vo.as(g.$Ao.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=O.$So.createEmptyModel(this.c);const b=h.$vo.as(g.$Ao.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,y){const u=this.g();for(const R of b){const $=u[R],i=y[R];$!==void 0?this.b.setValue(R,$):i?this.b.setValue(R,i.default):this.b.removeValue(R)}}}e.$Yo=w;class f{constructor(){this.onDidChangeConfiguration=I.Event.None,this.configurationModel=O.$So.createEmptyModel(new l.$qk)}async initialize(){return this.configurationModel}}e.$Zo=f;let p=class extends v.$Xc{get configurationModel(){return this.b}constructor(b,y,u){super(),this.c=b,this.f=y,this.g=u,this.a=this.B(new I.$oe),this.onDidChangeConfiguration=this.a.event,this.b=O.$So.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const y={},u=[],R=h.$vo.as(g.$Ao.Configuration).getConfigurationProperties();for(const $ of b){const i=R[$];if(!i){u.push($);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}u.push($),y[i.policy.name]={type:i.type}}}return(0,C.$ug)(y)||await this.f.updatePolicyDefinitions(y),u}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const y=h.$vo.as(g.$Ao.Configuration).getPolicyConfigurations(),u=(0,P.$Jb)(b.map(R=>y.get(R)));this.m(u,!0)}m(b,y){this.g.trace("PolicyConfiguration#update",b);const u=h.$vo.as(g.$Ao.Configuration).getConfigurationProperties(),R=[],$=this.b.isEmpty();for(const i of b){const a=u[i]?.policy?.name;if(a){const n=this.f.getPolicyValue(a);($?n!==void 0:!(0,k.$mo)(this.b.getValue(i),n))&&R.push([i,n])}else this.b.getValue(i)!==void 0&&R.push([i,void 0])}if(R.length){this.g.trace("PolicyConfiguration#changed",R);const i=this.b;this.b=O.$So.createEmptyModel(this.g);for(const a of i.keys)this.b.setValue(a,i.getValue(a));for(const[a,n]of R)n===void 0?this.b.removeValue(a):this.b.setValue(a,n);y&&this.a.fire(this.b)}}};e.$1o=p,e.$1o=p=Ee([oe(1,d.$xo),oe(2,l.$dk)],p)}),define(le[118],he([0,1,19,8,13,4,34,78,2,25,27,11,16,30,68,40,117,9,39]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;class R extends g.$Xc{constructor(a,n,r,t){super(),this.m=a,this.n=t,this.h=this.B(new k.$oe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$Yo(t)),this.c=r instanceof u.$zo?new b.$Zo:this.B(new b.$1o(this.b,r,t)),this.f=this.B(new p.$Uo(this.m,{},w.$ah,n,t)),this.a=new p.$Vo(this.b.configurationModel,this.c.configurationModel,p.$So.createEmptyModel(t),p.$So.createEmptyModel(t),p.$So.createEmptyModel(t),p.$So.createEmptyModel(t),new l.$Dc,p.$So.createEmptyModel(t),new l.$Dc,t),this.j=new $(a,n,this),this.g=this.B(new I.$Uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$Vo(a,n,p.$So.createEmptyModel(this.n),r,p.$So.createEmptyModel(this.n),p.$So.createEmptyModel(this.n),new l.$Dc,p.$So.createEmptyModel(this.n),new l.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,n){const r=typeof a=="string"?a:void 0,t=(0,f.$dj)(a)?a:(0,f.$dj)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(a,n,r,t,s){const o=(0,f.$ej)(r)?r:(0,f.$dj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,c=o?t:r;if(c!==void 0&&c!==f.ConfigurationTarget.USER_LOCAL&&c!==f.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${c}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.$Ob)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const m=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(m.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,d.$mo)(n,m.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(A=>(0,P.$wb)([...A.identifiers].sort(),T));D&&(o.overrideIdentifiers=D.identifiers)}const N=o?.overrideIdentifiers?.length?[(0,S.$Mo)(o.overrideIdentifiers),a]:[a];await this.j.write(N,n),await this.reloadConfiguration()}inspect(a,n={}){return this.a.inspect(a,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,n,f.ConfigurationTarget.USER)}s(a,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(a,n);this.u(t,r,f.ConfigurationTarget.DEFAULT)}t(a){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,n,f.ConfigurationTarget.DEFAULT)}u(a,n,r){const t=new p.$Xo(a,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$2o=R;class ${constructor(a,n,r){this.b=a,this.c=n,this.d=r,this.a=new I.$Ph}write(a,n){return this.a.queue(()=>this.e(a,n))}async e(a,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===y.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const t=[];if((0,C.$3n)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,a,n);r=(0,O.$ho)(r,s),await this.c.writeFile(this.b,v.$Qe.fromString(r))}f(a,n,r){const{tabSize:t,insertSpaces:s,eol:o}=this.h;if(!n.length){const c=JSON.stringify(r,null,s?" ".repeat(t):"	");return[{content:c,length:c.length,offset:0}]}return(0,O.$eo)(a,n,r,{tabSize:t,insertSpaces:s,eol:o})}get h(){if(!this.g){let a=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(a=n),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[69],he([0,1,14]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=I,e.$mn=v,e.$nn=k,e.$on=C;function I(g){return g.scheme===P.Schemas.vscodeRemote?g.authority:void 0}function v(g){if(!g)return;const l=g.indexOf("+");return l<0?g:g.substr(0,l)}function k(g){const{host:l,port:d}=O(g);if(typeof d>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:d}}function C(g,l){let{host:d,port:h}=O(g);return typeof h>"u"&&(h=l),{host:d,port:h}}function O(g){const l=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const d=g.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const h=g.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:g,port:void 0}}}),define(le[22],he([0,1,31,10,69]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$xn=e.$wn=e.$vn=e.TargetPlatform=e.ExtensionType=e.$un=e.$sn=e.$rn=e.$qn=e.$pn=void 0,e.$tn=k,e.$yn=h,e.$zn=w,e.$An=f,e.$Bn=p,e.$Cn=S,e.$Dn=b,P=be(P),e.$pn="extensions.user.cache",e.$qn="extensions.builtin.cache",e.$rn="undefined_publisher",e.$sn=["ui","workspace","web"];function k(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$un=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(C||(e.ExtensionType=C={}));var O;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class g{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,R){if(typeof u>"u"||u===null)return typeof R>"u"||R===null;if(typeof R>"u"||R===null)return!1;if(typeof u=="string"||typeof R=="string"){const $=typeof u=="string"?u:u.value,i=typeof R=="string"?R:R.value;return P.$If($,i)}return u._lower===R._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$vn=g;class l{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const R of u)this.add(R)}add(u){this.c.add(g.toKey(u))}delete(u){return this.c.delete(g.toKey(u))}has(u){return this.c.has(g.toKey(u))}}e.$wn=l;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(g.toKey(u))}get(u){return this.c.get(g.toKey(u))}has(u){return this.c.has(g.toKey(u))}set(u,R){this.c.set(g.toKey(u),R)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$xn=d;function h(y){return w(y)}function w(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function f(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function p(y,u){if(u){const R=`onResolveRemoteAuthority:${(0,v.$mn)(u)}`;return!!y.activationEvents?.includes(R)}return!1}function S(y){return y.map(u=>{const[R,$]=u.split("@");return{proposalName:R,version:$?parseInt($):void 0}})}function b(y){return y.map(u=>u.split("@")[0])}e.$En=(0,I.$Ii)("IBuiltinExtensionsScannerService")}),define(le[20],he([0,1,11,5,22,10]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.ExtensionManagementErrorCode=e.$qp=e.ExtensionGalleryErrorCode=e.$pp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=O,e.$kp=g,e.$lp=l,e.$mp=d,e.$np=h,e.$op=w,e.$cp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$dp=new RegExp(e.$cp),e.$ep="__web_extension",e.$fp="skipWalkthrough",e.$gp="extensionInstallSource",e.$hp="dependecyOrPackExtensionInstall",e.$ip="clientTargetPlatform";var C;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(C||(e.ExtensionInstallSource=C={}));function O(i){switch(i){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function g(i){switch(i){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function l(i,a){switch(i){case P.Platform.Windows:return a==="x64"?v.TargetPlatform.WIN32_X64:a==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Linux:return a==="x64"?v.TargetPlatform.LINUX_X64:a==="arm64"?v.TargetPlatform.LINUX_ARM64:a==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?v.TargetPlatform.ALPINE_X64:a==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Mac:return a==="x64"?v.TargetPlatform.DARWIN_X64:a==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Web:return v.TargetPlatform.WEB}}function d(i,a){return a===v.TargetPlatform.WEB&&!i.includes(v.TargetPlatform.WEB)}function h(i,a,n){return d(a,n)?!1:i===v.TargetPlatform.UNDEFINED||i===v.TargetPlatform.UNIVERSAL?!0:i===v.TargetPlatform.UNKNOWN?!1:i===n}function w(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var f;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var p;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var S;(function(i){i.Install="install",i.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$pp=(0,k.$Ii)("extensionGalleryService");var y;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting",i.Offline="Offline"})(y||(e.ExtensionGalleryErrorCode=y={}));class u extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}e.$qp=u;var R;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(R||(e.ExtensionManagementErrorCode=R={}));class $ extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}e.$rp=$,e.$sp=(0,k.$Ii)("extensionManagementService"),e.$tp="extensionsIdentifiers/disabled",e.$up="extensionsIdentifiers/enabled",e.$vp=(0,k.$Ii)("IGlobalExtensionEnablementService"),e.$wp=(0,k.$Ii)("IExtensionTipsService"),e.$xp=(0,I.localize2)(1780,"Extensions"),e.$yp=(0,I.localize2)(1781,"Preferences")}),define(le[119],he([0,1,2,22,9]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class k extends P.$Xc{constructor(O,g,l,d,h){super(),this.a=O,this.b=g,this.c=l,this.f=h,this.B(d.onDidInstallExtensions(w=>this.g(w))),this.B(d.onDidUninstallExtension(w=>this.h(w)))}g(O){for(const g of O)g.local&&this.invalidate(g.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const g of this.a.profiles)this.c.extUri.isEqual(g.extensionsResource,O)&&await this.j(g);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,I.$pn))}catch(g){(0,v.$ul)(g)!==v.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g)}}}e.$3q=k});var ze=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[44],he([0,1,16,58,5,45,22,98]),function(Z,e,P,I,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=d,e.$5p=h,e.$6p=w,e.$7p=f,e.$8p=p,e.$9p=S,e.$0p=b,e.$$p=y,I=ze(I),v=be(v),k=be(k);const g=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function d($){return $=$.trim(),$==="*"||g.test($)}function h($){if(!d($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=$.match(g);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function w($){if(!$)return null;const i=$.majorBase,a=$.majorMustEqual,n=$.minorBase;let r=$.minorMustEqual;const t=$.patchBase;let s=$.patchMustEqual;$.hasCaret&&(i===0||(r=!1),s=!1);let o=0;if($.preRelease){const c=l.exec($.preRelease);if(c){const[,m,N,T]=c;o=Date.UTC(Number(m),Number(N)-1,Number(T))}}return{majorBase:i,majorMustEqual:a,minorBase:n,minorMustEqual:r,patchBase:t,patchMustEqual:s,isMinimum:$.hasGreaterEquals,notBefore:o}}function f($,i,a){let n;typeof $=="string"?n=w(h($)):n=$;let r;i instanceof Date?r=i.getTime():typeof i=="string"&&(r=new Date(i).getTime());let t;if(typeof a=="string"?t=w(h(a)):t=a,!n||!t)return!1;const s=n.majorBase,o=n.minorBase,c=n.patchBase;let m=t.majorBase,N=t.minorBase,T=t.patchBase;const D=t.notBefore;let A=t.majorMustEqual,F=t.minorMustEqual,H=t.patchMustEqual;return t.isMinimum?s>m?!0:s<m?!1:o>N?!0:o<N||r&&r<D?!1:c>=T:(s===1&&m===0&&(!A||!F||!H)&&(m=1,N=0,T=0,A=!0,F=!1,H=!1),s<m?!1:s>m?!A:o<N?!1:o>N?!F:c<T?!1:c>T?!H:!(r&&r<D))}function p($,i,a,n,r,t){const s=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return s.push([I.default.Error,v.localize(1832,null)]),s;if(typeof n.name!="string")return s.push([I.default.Error,v.localize(1833,null,"name")]),s;if(typeof n.version!="string")return s.push([I.default.Error,v.localize(1834,null,"version")]),s;if(!n.engines)return s.push([I.default.Error,v.localize(1835,null,"engines")]),s;if(typeof n.engines.vscode!="string")return s.push([I.default.Error,v.localize(1836,null,"engines.vscode")]),s;if(typeof n.extensionDependencies<"u"&&!R(n.extensionDependencies))return s.push([I.default.Error,v.localize(1837,null,"extensionDependencies")]),s;if(typeof n.activationEvents<"u"){if(!R(n.activationEvents))return s.push([I.default.Error,v.localize(1838,null,"activationEvents")]),s;if(typeof n.main>"u"&&typeof n.browser>"u")return s.push([I.default.Error,v.localize(1839,null,"activationEvents","main","browser")]),s}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&s.push([I.default.Warning,v.localize(1840,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return s.push([I.default.Error,v.localize(1841,null,"main")]),s;{const m=(0,P.$jh)(a,n.main);(0,P.$dh)(m,a)||s.push([I.default.Warning,v.localize(1842,null,m.path,a.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return s.push([I.default.Error,v.localize(1843,null,"browser")]),s;{const m=(0,P.$jh)(a,n.browser);(0,P.$dh)(m,a)||s.push([I.default.Warning,v.localize(1844,null,m.path,a.path)])}}if(!k.valid(n.version))return s.push([I.default.Error,v.localize(1845,null)]),s;const o=[];if(!S($,i,n,r,o))for(const m of o)s.push([I.default.Error,m]);if(t&&n.enabledApiProposals?.length){const m=[];if(!y([...n.enabledApiProposals],m))for(const N of m)s.push([I.default.Error,N])}return s}function S($,i,a,n,r){return n||typeof a.main>"u"&&typeof a.browser>"u"?!0:u($,i,a.engines.vscode,r)}function b($,i,a){return $==="*"||u(i,a,$)}function y($,i){if($.length===0)return!0;const a=Array.isArray(i)?i:void 0,n=(a?void 0:i)??O.allApiProposals,r=[],t=(0,C.$Cn)($);for(const{proposalName:s,version:o}of t){const c=n[s];c&&o&&c.version!==o&&r.push(v.localize(1846,null,s))}return a?.push(...r),r.length===0}function u($,i,a,n=[]){const r=w(h(a));if(!r)return n.push(v.localize(1847,null,a)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(v.localize(1848,null,a)),!1}else if(!r.majorMustEqual)return n.push(v.localize(1849,null,a)),!1;return f($,i,r)?!0:(n.push(v.localize(1850,null,$,a)),!1)}function R($){if(!Array.isArray($))return!1;for(let i=0,a=$.length;i<a;i++)if(typeof $[i]!="string")return!1;return!0}}),define(le[70],he([0,1,21,2,11,5,20,10]),function(Z,e,P,I,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=void 0,e.$es=g;function g(d){return d.tags.find(h=>h.startsWith("lp-"))?.split("lp-")[1]}e.$fs=(0,O.$Ii)("languagePackService");let l=class extends I.$Xc{constructor(h){super(),this.c=h}async getAvailableLanguages(){const h=new P.$ze;setTimeout(()=>h.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},h.token)}catch{return[]}const p=w.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some(b=>b.startsWith("lp-"))).map(S=>{const b=S.properties.localizedLanguages?.[0],y=g(S);return{...this.f(y,b,S),extensionId:S.identifier.id,galleryExtension:S}});return p.push(this.f("en","English")),p}f(h,w,f){const p=w??h;let S;if(p!==h&&(S=`(${h})`),h.toLowerCase()===v.$x.toLowerCase()&&(S??="",S+=(0,k.localize)(1928,null)),f?.installCount){S??="";const b=f.installCount;let y;b>1e6?y=`${Math.floor(b/1e5)/10}M`:b>1e3?y=`${Math.floor(b/1e3)}K`:y=String(b),S+=` $(cloud-download) ${y}`}return{id:h,label:p,description:S}}};e.$gs=l,e.$gs=l=Ee([oe(0,C.$pp)],l)}),define(le[46],he([0,1,13,7,2,5,40,10,6,37]),function(Z,e,P,I,v,k,C,O,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0,e.$bq=w,e.$cq=f,e.$dq=p,e.$eq=S,e.$fq=b,e.$gq=y,e.$_p=(0,O.$Ii)("requestService");class d{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?i[a]="*****":i[a]=this.b[a];this.a=i}return this.a}}class h extends v.$Xc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,k.localize)(2050,null),when:g.$vk.isEqualTo((0,g.$sk)(g.LogLevel.Trace)).serialize()})}async c(i,a,n){const r=`${i} #${++this.b}: ${a.url}`;this.a.trace(`${r} - begin`,a.type,new d(a.headers??{}));try{const t=await n();return this.a.trace(`${r} - end`,a.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,a.type,(0,I.$_)(t)),t}}}e.$aq=h;function w($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}function f($){return $.res.statusCode===204}async function p($){return f($)?null:(await(0,P.$3e)($.stream)).toString()}async function S($){if(!w($))throw new Error("Server returned "+$.res.statusCode);return p($)}async function b($){if(!w($))throw new Error("Server returned "+$.res.statusCode);if(f($))return null;const a=(await(0,P.$3e)($.stream)).toString();try{return JSON.parse(a)}catch(n){throw n.message+=`:
`+a,n}}function y($){R($)}let u;function R($){const i=l.$vo.as(C.$Ao.Configuration),a=u;u={id:"http",order:15,title:(0,k.localize)(2051,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(2057,null),(0,k.localize)(2058,null),(0,k.localize)(2059,null),(0,k.localize)(2060,null)],default:"override",description:(0,k.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(2063,null),restricted:!0}}},i.updateConfigurations({add:[u],remove:a?[a]:[]})}R(C.ConfigurationScope.APPLICATION)}),define(le[120],he([0,1,21,14,9,46]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iS=void 0;let C=class{constructor(g,l){this.a=g,this.b=l}async download(g,l,d=P.CancellationToken.None){if(g.scheme===I.Schemas.file||g.scheme===I.Schemas.vscodeRemote){await this.b.copy(g,l);return}const h={type:"GET",url:g.toString(!0)},w=await this.a.request(h,d);if(w.res.statusCode===200)await this.b.writeFile(l,w.stream);else{const f=await(0,k.$eq)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${f}`)}}};e.$iS=C,e.$iS=C=Ee([oe(0,k.$_p),oe(1,v.$dl)],C)}),define(le[121],he([0,1,122,3]),function(Z,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=k;function v(C,O){return C.protocol==="http:"?O.HTTP_PROXY||O.http_proxy||null:C.protocol==="https:"&&(O.HTTPS_PROXY||O.https_proxy||O.HTTP_PROXY||O.http_proxy)||null}async function k(C,O,g={}){const l=(0,P.parse)(C),d=g.proxyUrl||v(l,O);if(!d)return null;const h=(0,P.parse)(d);if(!/^https?:$/.test(h.protocol||""))return null;const w={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,I.$ng)(g.strictSSL)?g.strictSSL:!0};if(l.protocol==="http:"){const f=await new Promise((p,S)=>{Z(["http-proxy-agent"],p,S)}).then(be);return new f.HttpProxyAgent(d,w)}else{const f=await new Promise((p,S)=>{Z(["https-proxy-agent"],p,S)}).then(be);return new f.HttpsProxyAgent(d,w)}}}),define(le[123],he([0,1,62,15,5,21,38,7,11,28,86,153,8,80]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=S;let p;async function S(y,u,R,$){return R["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$j?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.$Nm)($)&&!R["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.$Nm)($)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=w.Promises.withAsyncBody(async(i,a)=>{const n=new k.$ze;let r=1e4;const t=y.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,f.$Om)(t,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),a(new Error((0,v.localize)(2064,null)))},r);try{i(await b(u,n.token))}catch(o){!(0,O.$6)(o)&&!n.token.isCancellationRequested?a(new Error((0,v.localize)(2065,null,(0,C.$tj)(o)))):i({})}finally{clearTimeout(s),n.dispose()}})),p)}async function b(y,u){const R=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",R);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",$);const i=(0,l.$5g)().replace(/-/g,"").substr(0,12),a=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};y.trace("getUnixShellEnvironment#env",n);const r=await(0,d.$Dm)(g.OS,n);return y.trace("getUnixShellEnvironment#shell",r),new Promise((t,s)=>{if(u.isCancellationRequested)return s(new O.$7);const o=(0,I.$qc)(r);let c,m;const N="";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${N} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,m=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,m=["-i","-l","-c"]):o==="xonsh"?(c=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,m=["-i","-l","-c"]):(c=`'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?m=["-ic"]:m=["-i","-l","-c"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),c);const T=(0,P.spawn)(r,[...m,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(T.kill(),s(new O.$7))),T.on("error",F=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,C.$tj)(F)),s(F)});const D=[];T.stdout.on("data",F=>D.push(F));const A=[];T.stderr.on("data",F=>A.push(F)),T.on("close",(F,H)=>{const Y=Buffer.concat(D).toString("utf8");y.trace("getUnixShellEnvironment#raw",Y);const ne=Buffer.concat(A).toString("utf8");if(ne.trim()&&y.trace("getUnixShellEnvironment#stderr",ne),F||H)return s(new Error((0,v.localize)(2066,null,F,H)));const ae=a.exec(Y),ue=ae?ae[1]:"{}";try{const me=JSON.parse(ue);R?me.ELECTRON_RUN_AS_NODE=R:delete me.ELECTRON_RUN_AS_NODE,$?me.ELECTRON_NO_ATTACH_CONSOLE=$:delete me.ELECTRON_NO_ATTACH_CONSOLE,delete me.VSCODE_RESOLVING_ENVIRONMENT,delete me.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",me),t(me)}catch(me){y.error("getUnixShellEnvironment#errorCaught",(0,C.$tj)(me)),s(me)}})})}}),define(le[124],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VR=e.$UR=void 0,e.$UR=(0,P.$Ii)("stateReadService"),e.$VR=(0,P.$Ii)("stateService")}),define(le[71],he([0,1,8,13,2,3,17,9,6]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=e.$XR=e.$WR=e.SaveStrategy=void 0;var l;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class d extends v.$Xc{constructor(p,S,b,y){super(),this.h=p,this.j=S,this.m=b,this.n=y,this.a=Object.create(null),this.b="",this.c=this.B(new P.$Gh(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.m.error(p)}}getItem(p,S){const b=this.a[p];return(0,k.$qg)(b)?S:b}setItem(p,S){this.setItems([{key:p,data:S}])}setItems(p){let S=!1;for(const{key:b,data:y}of p)this.a[b]!==y&&((0,k.$qg)(y)?(0,k.$og)(this.a[b])||(this.a[b]=void 0,S=!0):(this.a[b]=y,S=!0));S&&this.s()}removeItem(p){(0,k.$og)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,I.$Qe.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(S){this.m.error(S)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$WR=d;let h=class extends v.$Xc{constructor(p,S,b,y){super(),this.a=this.B(new d(S.stateResource,p,b,y))}async init(){await this.a.init()}getItem(p,S){return this.a.getItem(p,S)}};e.$XR=h,e.$XR=h=Ee([oe(1,C.$Pi),oe(2,g.$dk),oe(3,O.$dl)],h);class w extends h{setItem(p,S){this.a.setItem(p,S)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$YR=w}),define(le[72],he([0,1,11,36,28]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=C,e.$Ap=O;function k(g){if(P.$v===P.Platform.Linux&&/^penguin(\.|$)/i.test(g))return"chromebook"}function C(g,l,d,h,w,f,p,S,b,y){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=p,u["common.devDeviceId"]=S,u.sessionID=(0,v.$5g)()+Date.now(),u.commitHash=h,u.version=w,u["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,P.$i)(P.$v),u["common.nodePlatform"]=I.$gc,u["common.nodeArch"]=d,u["common.product"]=y||"desktop",b&&(u["common.msftInternal"]=b);let R=0;const $=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),P.$m&&(u["common.snap"]="true");const i=k(l);return i&&(u["common.platformDetail"]=i),u}function O(g){const l=I.env.USERDNSDOMAIN;if(!l)return!1;const d=l.toLowerCase();return g.some(h=>d===h)}}),define(le[18],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,P.$Ii)("telemetryService"),e.$dm=(0,P.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var I;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(I||(e.TelemetryLevel=I={}));var v;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(v||(e.TelemetryConfiguration=v={}))}),define(le[73],he([0,1,59,7,10,6,18]),function(Z,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=e.ExtensionSignatureVerificationCode=e.$zq=void 0,e.$zq=(0,v.$Ii)("IExtensionSignatureVerificationService");var O;(function(d){d.Success="Success",d.RequiredArgumentMissing="RequiredArgumentMissing",d.InvalidArgument="InvalidArgument",d.PackageIsUnreadable="PackageIsUnreadable",d.UnhandledException="UnhandledException",d.SignatureManifestIsMissing="SignatureManifestIsMissing",d.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",d.SignatureIsMissing="SignatureIsMissing",d.SignatureIsUnreadable="SignatureIsUnreadable",d.CertificateIsUnreadable="CertificateIsUnreadable",d.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",d.FileAlreadyExists="FileAlreadyExists",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",d.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",d.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",d.SignatureIsInvalid="SignatureIsInvalid",d.SignatureManifestIsInvalid="SignatureManifestIsInvalid",d.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",d.EntryIsMissing="EntryIsMissing",d.EntryIsTampered="EntryIsTampered",d.Untrusted="Untrusted",d.CertificateRevoked="CertificateRevoked",d.SignatureIsNotValid="SignatureIsNotValid",d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(O||(e.ExtensionSignatureVerificationCode=O={}));class g extends Error{constructor(h){super(h),this.code=h}}e.$Aq=g;let l=class{constructor(h,w){this.b=h,this.c=w}d(){return this.a||(this.a=this.f()),this.a}async f(){return(0,P.$xq)("@vscode/vsce-sign","src/main.js")}async verify(h,w,f,p){let S;const b=h.identifier.id;try{S=await this.d()}catch($){return this.b.error("Could not load vsce-sign module",(0,I.$_)($)),this.b.info(`Extension signature verification is not done: ${b}`),!1}const y=new Date().getTime();let u;try{this.b.trace(`Verifying extension signature for ${b}...`),u=await S.verify(w,f,this.b.getLevel()===k.LogLevel.Trace)}catch($){u={code:O.UnknownError,didExecute:!1,output:(0,I.$_)($)}}const R=new Date().getTime()-y;if(this.b.info(`Extension signature verification result for ${b}: ${u.code}. Executed: ${u.didExecute}. Duration: ${R}ms.`),this.b.trace(`Extension signature verification output for ${b}:
${u.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:b,extensionVersion:h.version,code:u.code,internalCode:u.internalCode,duration:R,didExecute:u.didExecute,clientTargetPlatform:p}),u.code===O.Success)return!0;throw new g(u.code)}};e.$Bq=l,e.$Bq=l=Ee([oe(0,k.$dk),oe(1,C.$cm)],l)}),define(le[41],he([0,1,27,3,69,72,18]),function(Z,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0,e.$Ip=d,e.$Jp=h,e.$Kp=w,e.$Lp=f,e.$Mp=S,e.$Np=y,e.$Op=u,e.$Pp=i;class O{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Bp=O;class g{constructor(){this.telemetryLevel=C.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Cp=g,e.$Dp=new g;class l{async publicLog(n,r,t){}async publicLogError(n,r,t){}}e.$Ep=l,e.$Fp="telemetry",e.$Gp="extensionTelemetryLog",e.$Hp={log:()=>null,flush:()=>Promise.resolve(null)};function d(a,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!a.enableTelemetry)}function h(a,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function w(a){const n=a.getValue(C.$lm),r=a.getValue(C.$mm);if(a.getValue(C.$nm)===!1||r===!1)return C.TelemetryLevel.NONE;switch(n??C.TelemetryConfiguration.ON){case C.TelemetryConfiguration.ON:return C.TelemetryLevel.USAGE;case C.TelemetryConfiguration.ERROR:return C.TelemetryLevel.ERROR;case C.TelemetryConfiguration.CRASH:return C.TelemetryLevel.CRASH;case C.TelemetryConfiguration.OFF:return C.TelemetryLevel.NONE}}function f(a){const n={},r={},t={};b(a,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function S(a){if(!a)return"none";const n=(0,v.$mn)(a);return p.has(n)?n:"other"}function b(a,n,r=0,t){if(a)for(const s of Object.getOwnPropertyNames(a)){const o=a[s],c=t?t+s:s;Array.isArray(o)?n[c]=(0,P.$no)(o):o instanceof Date?n[c]=o.toISOString():(0,I.$jg)(o)?r<2?b(o,n,r+1,c+"."):n[c]=(0,P.$no)(o):n[c]=o}}function y(a,n){const r=a.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,k.$Ap)(r)||t}function u(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function R(a,n){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let r=a;const t=[];for(const m of n)for(;;){const N=m.exec(a);if(!N)break;t.push([N.index,m.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(r="";;){const m=o.exec(a);if(!m)break;const N=t.some(([T,D])=>m.index<D&&T<o.lastIndex);!s.test(m[0])&&!N&&(r+=a.substring(c,m.index)+"<REDACTED: user-file-path>",c=o.lastIndex)}return c<a.length&&(r+=a.substr(c)),r}function $(a){if(!a)return a;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(a))return`<REDACTED: ${r.label}>`;return a}function i(a,n){return(0,P.$ko)(a,r=>{if(r instanceof O||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let t=r.replaceAll("%20"," ");t=R(t,n);for(const s of n)t=t.replace(s,"");return t=$(t),t}})}}),define(le[26],he([0,1,31,20,22,11,12,7,36,41]),function(Z,e,P,I,v,k,C,O,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Rp=void 0,e.$Qp=d,e.$Sp=p,e.$Tp=S,e.$Up=b,e.$Vp=y,e.$Wp=u,e.$Xp=R,e.$Yp=$,e.$1p=i,e.$2p=n;function d(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,P.$Df)(r.id,t.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,s,o)}static parse(t){const s=h.exec(t);return s&&s[1]&&s[2]?new w({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o=v.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?d(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Rp=w;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const t=f.exec(r);return t&&t[1]?[b(t[1]),t[2]]:[b(r),void 0]}function S(r,t){return`${r}.${t}`}function b(r){return r.toLowerCase()}function y(r,t){return b(S(r??v.$rn,t))}function u(r,t){const s=[],o=c=>{for(const m of s)if(m.some(N=>d(t(N),t(c))))return m;return null};for(const c of r){const m=o(c);m?m.push(c):s.push([c])}return s}function R(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function $(r){return{id:new l.$Bp(r.identifier.id),name:new l.$Bp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Zp=new v.$vn("pprice.better-merge");function i(r,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&s.every(m=>!d(m.identifier,{id:c}))){const m=r.filter(N=>d(N.identifier,{id:c}));m.length===1&&(s.push(m[0]),o.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function a(r,t){if(!k.$l)return!1;let s;try{s=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,O.$_)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,t){const s=await a(r,t),o=(0,I.$lp)(s?"alpine":k.$v,g.$hc);return t.debug("ComputeTargetPlatform:",o),o}}),define(le[125],he([0,1,21,7,14,16,45,12,5,20,26,22]),function(Z,e,P,I,v,k,C,O,g,l,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;const w=S=>(0,g.localize)(1782,null,S),f=(0,g.localize)(1783,null,"ms-dotnettools.csharp");let p=class{constructor(b,y,u){this.a=b,this.b=y,this.d=u}get f(){}async listExtensions(b,y,u){let R=await this.b.getInstalled(h.ExtensionType.User,u);const $=h.$un.map(a=>a.toLowerCase());if(y&&y!==""){if($.indexOf(y.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}R=R.filter(a=>a.manifest.categories?a.manifest.categories.map(r=>r.toLowerCase()).indexOf(y.toLowerCase())>-1:!1)}else if(y===""){this.a.info("Possible Categories: "),$.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,g.localize)(1784,null,this.f)),R=R.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let i;for(const a of R)i!==a.identifier.id&&(i=a.identifier.id,this.a.info(b?`${i}@${a.manifest.version}`:i))}async installExtensions(b,y,u,R){const $=[];try{b.length&&this.a.info(this.f?(0,g.localize)(1785,null,this.f):(0,g.localize)(1786,null));const i=[],a=[],n=(t,s,o)=>{a.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...u,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||u.installPreReleaseVersion}})};for(const t of b)if(t instanceof O.URI)i.push({vsix:t,installOptions:u});else{const[s,o]=(0,d.$Sp)(t);n(s,o,!1)}for(const t of y)if(t instanceof O.URI)i.push({vsix:t,installOptions:{...u,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,d.$Sp)(t);n(s,o,!0)}const r=await this.b.getInstalled(void 0,u.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:s})=>{try{await this.h(t,s,R,r)}catch(o){this.a.error(o),$.push(t.toString())}})),a.length){const t=await this.g(a,r,R);$.push(...t)}}catch(i){throw this.a.error((0,g.localize)(1787,null,(0,I.$_)(i))),i}if($.length)throw new Error((0,g.localize)(1788,null,$.join(", ")))}async updateExtensions(b){const y=await this.b.getInstalled(h.ExtensionType.User,b),u=[];for(const a of y)a.identifier.uuid&&u.push({...a.identifier,preRelease:a.preRelease});this.a.trace((0,g.localize)(1789,null,u.length));const R=await this.d.getExtensions(u,{compatible:!0},P.CancellationToken.None),$=[];for(const a of R)for(const n of y)(0,d.$Qp)(n.identifier,a.identifier)&&(0,C.gt)(a.version,n.manifest.version)&&$.push({extension:a,options:{operation:l.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:b,isApplicationScoped:n.isApplicationScoped}});if(!$.length){this.a.info((0,g.localize)(1790,null));return}this.a.info((0,g.localize)(1791,null,$.map(a=>a.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions($);for(const a of i)a.error?this.a.error((0,g.localize)(1792,null,a.identifier.id,(0,I.$_)(a.error))):this.a.info((0,g.localize)(1793,null,a.identifier.id,a.local?.manifest.version))}async g(b,y,u){if(b=b.filter(({id:a,version:n})=>{const r=y.find(t=>(0,d.$Qp)(t.identifier,{id:a}));if(r){if(!u&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,g.localize)(1794,null,a,r.manifest.version,a)),!1;if(n&&r.manifest.version===n)return this.a.info((0,g.localize)(1795,null,`${a}@${n}`)),!1}return!0}),!b.length)return[];const R=[],$=[],i=await this.j(b);if(await Promise.all(b.map(async({id:a,version:n,installOptions:r})=>{const t=i.get(a.toLowerCase());if(!t){this.a.error(`${w(n?`${a}@${n}`:a)}
${f}`),R.push(a);return}try{const o=await this.d.getManifest(t,P.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),R.push(a);return}const s=y.find(o=>(0,d.$Qp)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.a.info((0,g.localize)(1796,null,n?`${a}@${n}`:a));return}this.a.info((0,g.localize)(1797,null,a,t.version))}r.isBuiltin?this.a.info(n?(0,g.localize)(1798,null,a,n):(0,g.localize)(1799,null,a)):this.a.info(n?(0,g.localize)(1800,null,a,n):(0,g.localize)(1801,null,a)),$.push({extension:t,options:{...r,installGivenVersion:!!n,isApplicationScoped:r.isApplicationScoped||s?.isApplicationScoped}})})),$.length){const a=await this.b.installGalleryExtensions($);for(const n of a)n.error?(this.a.error((0,g.localize)(1802,null,n.identifier.id,(0,I.$_)(n.error))),R.push(n.identifier.id)):this.a.info((0,g.localize)(1803,null,n.identifier.id,n.local?.manifest.version))}return R}async h(b,y,u,R){const $=await this.b.getManifest(b);if(!$)throw new Error("Invalid vsix");if(await this.l($,u,y.profileLocation,R))try{await this.b.install(b,{...y,installGivenVersion:!0}),this.a.info((0,g.localize)(1804,null,(0,k.$gh)(b)))}catch(a){if((0,I.$6)(a))this.a.info((0,g.localize)(1805,null,(0,k.$gh)(b)));else throw a}}async j(b){const y=new Map,u=b.some(i=>i.installOptions.installPreReleaseVersion),R=await this.b.getTargetPlatform(),$=[];for(const i of b)l.$dp.test(i.id)&&$.push({...i,preRelease:u});if($.length){const i=await this.d.getExtensions($,{targetPlatform:R},P.CancellationToken.None);for(const a of i)y.set(a.identifier.id.toLowerCase(),a)}return y}k(b){return!0}async l(b,y,u,R){if(!y){const $={id:(0,d.$Vp)(b.publisher,b.name)},i=R.find(a=>(0,d.$Qp)($,a.identifier)&&(0,C.gt)(a.manifest.version,b.version));if(i)return this.a.info((0,g.localize)(1806,null,i.identifier.id,i.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,y,u){const R=async i=>{if(i instanceof O.URI){const a=await this.b.getManifest(i);return(0,d.$Tp)(a.publisher,a.name)}return i},$=[];for(const i of b){const a=await R(i),r=(await this.b.getInstalled(void 0,u)).filter(t=>(0,d.$Qp)(t.identifier,{id:a}));if(!r.length)throw new Error(`${this.m(a)}
${f}`);if(r.some(t=>t.type===h.ExtensionType.System)){this.a.info((0,g.localize)(1807,null,a));return}if(!y&&r.some(t=>t.isBuiltin)){this.a.info((0,g.localize)(1808,null,a));return}this.a.info((0,g.localize)(1809,null,a));for(const t of r)await this.b.uninstall(t,{profileLocation:u}),$.push(t);this.f?this.a.info((0,g.localize)(1810,null,a,this.f)):this.a.info((0,g.localize)(1811,null,a))}}async locateExtension(b){const y=await this.b.getInstalled();b.forEach(u=>{y.forEach(R=>{if(R.identifier.id===u&&R.location.scheme===v.Schemas.file){this.a.info(R.location.fsPath);return}})})}m(b){return this.f?(0,g.localize)(1812,null,b,this.f):(0,g.localize)(1813,null,b)}};e.$Cq=p,e.$Cq=p=Ee([oe(1,l.$sp),oe(2,l.$pp)],p)}),define(le[126],he([0,1,7,4,2,25,26,22,9]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;class l extends v.$Xc{constructor(h,w,f,p,S,b,y){super(),this.f=h,this.g=w,this.h=f,this.j=p,this.m=S,this.n=b,this.r=y,this.a=this.B(new I.$oe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new v.$7c),this.s().then(null,u=>y.error("Error while initializing Extensions Watcher",(0,P.$_)(u)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(h=>this.u(h.added))),this.B(this.j.onAddExtensions(h=>this.w(h))),this.B(this.j.onDidAddExtensions(h=>this.y(h))),this.B(this.j.onRemoveExtensions(h=>this.z(h))),this.B(this.j.onDidRemoveExtensions(h=>this.C(h))),this.B(this.n.onDidFilesChange(h=>this.D(h)))}async u(h){try{h.length&&await Promise.all(h.map(w=>(this.c.set(w.id,(0,v.$Uc)(this.n.watch(this.m.extUri.dirname(w.extensionsResource)),this.n.watch(w.extensionsResource))),this.G(w.extensionsResource))))}catch(w){throw this.r.error(w),w}}async w(h){for(const w of h.extensions)this.I(this.L(w.identifier,w.version),h.profileLocation)}async y(h){for(const w of h.extensions){const f=this.L(w.identifier,w.version);h.error?this.J(f,h.profileLocation):this.I(f,h.profileLocation)}}async z(h){for(const w of h.extensions)this.J(this.L(w.identifier,w.version),h.profileLocation)}async C(h){const w=[],f=[];for(const p of h.extensions){const S=this.L(p.identifier,p.version);h.error?this.I(S,h.profileLocation):(this.J(S,h.profileLocation),this.b.has(S)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),f.push(this.f.scanInstalledExtensionAtLocation(p.location).then(b=>{b?w.push(b):this.r.info("Extension not found at the location",p.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(f),w.length&&await this.H(w)}catch(p){this.r.error(p)}}D(h){for(const w of this.h.profiles)h.contains(w.extensionsResource,g.FileChangeType.UPDATED,g.FileChangeType.ADDED)&&this.F(w.extensionsResource)}async F(h){const w=[],f=[],p=await this.j.scanProfileExtensions(h),S=new Set,b=new Set;for(const[y,u]of this.b)u.has(h)&&b.add(y);for(const y of p){const u=this.L(y.identifier,y.version);S.add(u),b.has(u)||(w.push(y.identifier),this.I(u,h))}for(const y of b)if(!S.has(y)){const u=this.M(y);u&&(f.push(u.identifier),this.J(y,h))}(w.length||f.length)&&this.a.fire({added:w.length?{extensions:w,profileLocation:h}:void 0,removed:f.length?{extensions:f,profileLocation:h}:void 0})}async G(h){const w=await this.j.scanProfileExtensions(h);for(const f of w)this.I(this.L(f.identifier,f.version),h)}async H(h){h||(h=(await this.f.scanAllUserInstalledExtensions()).filter(f=>!this.b.has(this.L(f.identifier,f.manifest.version)))),h.length&&await this.f.markAsUninstalled(...h)}I(h,w){let f=this.b.get(h);f||this.b.set(h,f=new k.$Ec(p=>this.m.extUri.getComparisonKey(p))),f.add(w)}J(h,w){const f=this.b.get(h);f&&f.delete(w),f?.size||this.b.delete(h)}L(h,w){return`${O.$vn.toKey(h.id)}@${w}`}M(h){const[w,f]=(0,C.$Sp)(h);return f?{identifier:{id:w},version:f}:void 0}}e.$4q=l}),define(le[127],he([0,1,32,154,19,8,2,14,15,29,17,20,26,6,70,12]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0,P=be(P);let b=class extends p.$gs{constructor($,i,a,n){super(a),this.h=$,this.j=n,this.g=this.B(new y(i,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri($,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const r=n.translations[$];return r?S.URI.file(r):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),i=Object.keys($).map(a=>{const n=$[a];return{...this.f(a,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((a,n)=>a.label.localeCompare(n.label)),i}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const i=await this.g.getLanguagePacks();Object.keys(i).some(a=>i[a]&&i[a].extensions.some(n=>(0,w.$Qp)(n.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),a=await this.g.update(i);return!(0,v.$wb)(Object.keys($),Object.keys(a))}};e.$hs=b,e.$hs=b=Ee([oe(0,h.$sp),oe(1,d.$Qi),oe(2,h.$pp),oe(3,f.$dk)],b);let y=class extends C.$Xc{constructor($,i){super(),this.j=i,this.c={},this.f=(0,g.$mc)($.userDataPath,"languagepacks.json"),this.g=new k.$Ph}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(i=>{Object.keys(i).forEach(a=>delete i[a]),this.m(i,...$)}).then(()=>this.c)}m($,...i){for(const a of i)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.n($,a);Object.keys($).forEach(a=>this.r($[a]))}n($,i){const a=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const r of n)if(i.location.scheme===O.Schemas.file&&u(r)){let t=$[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},$[r.languageId]=t);const s=t.extensions.filter(o=>(0,w.$Qp)(o.extensionIdentifier,a))[0];s?s.version=i.manifest.version:t.extensions.push({extensionIdentifier:a,version:i.manifest.version});for(const o of r.translations)t.translations[o.id]=(0,g.$mc)(i.location.fsPath,o.path)}}r($){if($){const i=(0,I.createHash)("md5");for(const a of $.extensions)i.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);$.hash=i.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let i=null;return P.promises.readFile(this.f,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(i=$(a),a)).then(a=>{for(const r of Object.keys(a))a[r]||delete a[r];this.c=a,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),l.Promises.writeFile(this.f,n)}).then(()=>i,a=>this.j.error(a))})}};y=Ee([oe(0,d.$Qi),oe(1,f.$dk)],y);function u(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const $ of R.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}}),define(le[128],he([0,1,59,55,7,27,11,41]),function(Z,e,P,I,v,k,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QR=void 0;const g="https://mobile.events.data.microsoft.com/OneCollector/1.0",l="https://mobile.events.data.microsoft.com/ping";async function d(w,f,p){const S=await(0,P.$xq)("@microsoft/1ds-core-js","dist/ms.core.js"),b=await(0,P.$xq)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new S.AppInsightsCore,u=new b.PostChannel,R={instrumentationKey:w,endpointUrl:g,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[u]]};if(p){R.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:p};R.extensionConfig[u.identifier]=$}return y.initialize(R,[]),y.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',f&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),y}class h{constructor(f,p,S,b,y){this.f=f,this.g=p,this.h=S,this.i=y,this.c=g,this.d=l,this.e=!1,this.h||(this.h={}),typeof b=="function"?this.a=b():this.a=b,this.b=null}j(f){if(this.a){if(typeof this.a!="string"){f(this.a);return}this.b||(this.b=d(this.a,this.f,this.i)),this.b.then(p=>{f(p)},p=>{I.$T&&C.$p&&this.e||(this.e=!0,(0,v.$2)(p),console.error(p))})}}log(f,p){if(!this.a)return;p=(0,k.$lo)(p,this.h),p=(0,O.$Lp)(p);const S=this.g+"/"+f;try{this.j(b=>{b.pluginVersionString=p?.properties.version??"Unknown",b.track({name:S,baseData:{name:S,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(f=>{this.j(p=>{p.unload(!0,()=>{this.a=void 0,f(void 0)})})}):Promise.resolve(void 0)}}e.$QR=h});var ze=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[129],he([0,1,2,27,11,31,5,30,40,130,33,37,18,41]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0,l=ze(l);let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(y,u,R){this.k=u,this.l=R,this.d={},this.i=new P.$Wc,this.j=[],this.b=y.appenders,this.c=y.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=y.piiPaths||[],this.g=w.TelemetryLevel.USAGE,this.h=!!y.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,k.$kf)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$kf)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(w.$lm)||$.affectsConfiguration(w.$nm)||$.affectsConfiguration(w.$mm))&&this.m()}))}setExperimentProperty(y,u){this.d[y]=u}m(){let y=(0,f.$Kp)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const R=u.usage?w.TelemetryLevel.USAGE:u.error?w.TelemetryLevel.ERROR:w.TelemetryLevel.NONE;y=Math.min(y,R)}this.g=y}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(y,u,R){this.g<u||(R=(0,I.$lo)(R,this.d),R=(0,f.$Pp)(R,this.j),R=(0,I.$lo)(R,this.c),this.b.forEach($=>$.log(y,R)))}publicLog(y,u){this.n(y,w.TelemetryLevel.USAGE,u)}publicLog2(y,u){this.publicLog(y,u)}publicLogError(y,u){this.h&&this.n(y,w.TelemetryLevel.ERROR,u)}publicLogError2(y,u){this.publicLogError(y,u)}};e.$ns=p,e.$ns=p=Ee([oe(1,O.$cj),oe(2,d.$wk)],p);function S(){const b=(0,C.localize)(2068,null,l.default.nameLong),y=l.default.privacyStatementUrl?(0,C.localize)(2070,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,C.localize)(2069,null,"https://aka.ms/vscode-telemetry"),u=v.$p?"":(0,C.localize)(2071,null),R=(0,C.localize)(2072,null),$=(0,C.localize)(2073,null),i=(0,C.localize)(2074,null),a=(0,C.localize)(2075,null),n=`
|       | ${R} | ${$} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(2076,null);return`
${b} ${y} ${u}

&nbsp;

${a}
${n}

&nbsp;

${r}
`}h.$vo.as(g.$Ao.Configuration).registerConfiguration({id:w.$km,order:1,type:"object",title:(0,C.localize)(2077,null),properties:{[w.$lm]:{type:"string",enum:[w.TelemetryConfiguration.ON,w.TelemetryConfiguration.ERROR,w.TelemetryConfiguration.CRASH,w.TelemetryConfiguration.OFF],enumDescriptions:[(0,C.localize)(2078,null),(0,C.localize)(2079,null),(0,C.localize)(2080,null),(0,C.localize)(2081,null)],markdownDescription:S(),default:w.TelemetryConfiguration.ON,restricted:!0,scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.$vo.as(g.$Ao.Configuration).registerConfiguration({id:w.$km,order:110,type:"object",title:(0,C.localize)(2082,null),properties:{[w.$nm]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,C.localize)(2084,null,l.default.nameLong,l.default.privacyStatementUrl):(0,C.localize)(2083,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(2085,null,`\`#${w.$lm}#\``),scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[131],he([0,1,13,21,155,128]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RR=void 0,v=be(v);async function C(d,h){const w=await h.request(d,I.CancellationToken.None),f=(await(0,P.$3e)(w.stream)).toString(),p=w.res.statusCode??200;return{headers:w.res.headers,statusCode:p,responseData:f}}async function O(d){const h={method:d.type,headers:d.headers};return new Promise((f,p)=>{const S=v.request(d.url??"",h,b=>{b.on("data",function(y){f({headers:b.headers,statusCode:b.statusCode??200,responseData:y.toString()})}),b.on("error",function(y){p(y)})});S.write(d.data,b=>{b&&p(b)}),S.end()})}async function g(d,h,w){const f=typeof h.data=="string"?h.data:new TextDecoder().decode(h.data),p={type:"POST",headers:{...h.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(h.data).toString()},url:h.urlString,data:f};try{const S=d?await C(p,d):await O(p);w(S.statusCode,S.headers,S.responseData)}catch{w(0,{})}}class l extends k.$QR{constructor(h,w,f,p,S){const b={sendPOST:(y,u)=>{g(h,y,u)}};super(w,f,p,S,b)}}e.$RR=l}),define(le[132],he([0,1,32,15,29]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=k,P=be(P);async function k(C,O){const g=Object.create(null),l=(h,w)=>{const f=JSON.parse(h);g[w]=f};if(O){const h=[],w=await v.Promises.readdir(O);for(const p of w)try{(await P.promises.stat((0,I.$mc)(O,p))).isDirectory()&&h.push(p)}catch{}const f=[];for(const p of h)(await v.Promises.readdir((0,I.$mc)(O,p))).filter(b=>b==="telemetry.json").length===1&&f.push(p);for(const p of f){const S=(await P.promises.readFile((0,I.$mc)(O,p,"telemetry.json"))).toString();l(S,p)}}let d=(await P.promises.readFile((0,I.$mc)(C,"telemetry-core.json"))).toString();return l(d,"vscode-core"),d=(await P.promises.readFile((0,I.$mc)(C,"telemetry-extensions.json"))).toString(),l(d,"vscode-extensions"),JSON.stringify(g,null,4)}}),define(le[133],he([0,1,11,84,18]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=k,e.$Aic=C,e.$Bic=O;async function k(g,l){let d=g.getItem(v.$hm);return(typeof d!="string"||P.$k&&d==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(d=await(0,I.$Xn)(l.error.bind(l))),d}async function C(g,l){let d=g.getItem(v.$im);return typeof d!="string"&&(d=await(0,I.$Yn)(l.error.bind(l))),d}async function O(g,l){let d=g.getItem(v.$jm);return typeof d!="string"&&(d=await(0,I.$Zn)(l.error.bind(l))),d}}),define(le[23],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,P.$Ii)("IUriIdentityService")}),define(le[134],he([0,1,23,99,9,16,81,4,2]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0;class l{static{this._clock=0}constructor(w){this.uri=w,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let d=class{constructor(w){this.g=w,this.c=new g.$Wc,this.f=2**16;const f=new Map,p=S=>{let b=f.get(S.scheme);return b===void 0&&(b=w.hasProvider(S)&&!this.g.hasCapability(S,v.FileSystemProviderCapabilities.PathCaseSensitive),f.set(S.scheme,b)),b};this.c.add(O.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(S=>{f.delete(S.scheme)})),this.extUri=new k.$$g(p),this.d=new C.$Zs((S,b)=>this.extUri.compare(S,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,k.$kh)(w));const f=this.d.get(w);return f?f.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new l(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((p,S)=>p[1].time<S[1].time?1:p[1].time>S[1].time?-1:0);l._clock=0,this.d.clear();const f=this.f*.5;for(let p=0;p<f;p++)this.d.set(w[p][0],w[p][1].touch())}};e.$1s=d,e.$1s=d=Ee([oe(0,v.$dl)],d),(0,I.$Xs)(P.$Nl,d,I.InstantiationType.Delayed)}),define(le[135],he([0,1,4,2,9,49,25]),function(Z,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class O extends I.$Xc{constructor(l,d,h,w,f,p){super(),this.f=l,this.g=d,this.h=h,this.j=w,this.m=f,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$oe),this.onDidChangeFile=this.a.event,this.b=k.$Oi.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new C.$Ec(S=>this.m.extUri.getComparisonKey(this.t(S))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(S=>this.s(S)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,d){return this.g.open(this.t(l),d)}close(l){return this.g.close(l)}read(l,d,h,w,f){return this.g.read(l,d,h,w,f)}write(l,d,h,w,f){return this.g.write(l,d,h,w,f)}watch(l,d){this.b.set(l,l);const h=this.g.watch(this.t(l),d);return(0,I.$Vc)(()=>{this.b.delete(l),h.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,d,h){return this.g.rename(this.t(l),this.t(d),h)}readFile(l,d){return this.g.readFile(this.t(l),d)}readFileStream(l,d,h){return this.g.readFileStream(this.t(l),d,h)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,d,h){return this.g.writeFile(this.t(l),d,h)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,d){return this.g.delete(this.t(l),d)}copy(l,d,h){if((0,v.$hl)(this.g))return this.g.copy(this.t(l),this.t(d),h);throw new Error("copy not supported")}cloneFile(l,d){if((0,v.$il)(this.g))return this.g.cloneFile(this.t(l),this.t(d));throw new Error("clone not supported")}s(l){const d=[];for(const h of l){if(h.resource.scheme!==this.f)continue;const w=this.u(h.resource);this.b.findSubstr(w)&&d.push({resource:w,type:h.type,cId:h.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$Zic=O}),define(le[136],he([0,1,5,15,49,16,12,10,14]),function(Z,e,P,I,v,k,C,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=l,e.$Ti=d,e.$Wi=h,e.$Xi=w,e.$Yi=f,e.$Zi=S,e.$1i=b,e.$4i=R,e.$9i=$,e.$0i=i,e.$_i=a,e.$aj=n,e.$bj=r,e.$Ri=(0,O.$Ii)("contextService");function l(t){const s=t;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}function d(t){return typeof t?.id=="string"&&!l(t)&&!w(t)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function h(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,I.$qc)(t)}:s?e.$Ui:e.$Vi;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function w(t){const s=t;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}function f(t){const s=t;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var p;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function S(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function b(t){const s=t;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class y{constructor(s,o,c,m,N){this.h=s,this.j=c,this.k=m,this.l=N,this.c=v.$Oi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=v.$Oi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=y;class u{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,k.$jh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=u;function R(t){return new u({uri:t,index:0,name:(0,k.$fh)(t)},{uri:t.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,P.localize)(2489,null),extensions:[e.$5i]}],e.$8i="workspace.json";function $(t,s){return k.$ah.isEqualOrParent(t,s.untitledWorkspacesHome)}function i(t){let s;return C.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===g.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(t){return t.id===e.$$i}function n(t,s){return!$(t,s)&&!i(t)}function r(t){return(typeof t=="string"?(0,I.$rc)(t):(0,k.$hh)(t))===e.$6i}}),define(le[24],he([0,1,43,4,2,16,12,5,17,9,10,6,136,25,23,8,28,31,3]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=$,e.$Ql=i,e.$Rl=a;var R;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(R||(e.ProfileResourceType=R={}));function $(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&C.URI.isUri(s.extensionsResource))}e.$Pl=(0,d.$Ii)("IUserDataProfilesService");function i(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:s}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function a(t,s,o,c,m,N){return{id:t,name:s,location:o,isDefault:!1,shortName:m?.shortName,icon:m?.icon,globalStorageHome:N&&m?.useDefaultFlags?.globalState?N.globalStorageHome:(0,k.$jh)(o,"globalStorage"),settingsResource:N&&m?.useDefaultFlags?.settings?N.settingsResource:(0,k.$jh)(o,"settings.json"),keybindingsResource:N&&m?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,k.$jh)(o,"keybindings.json"),tasksResource:N&&m?.useDefaultFlags?.tasks?N.tasksResource:(0,k.$jh)(o,"tasks.json"),snippetsHome:N&&m?.useDefaultFlags?.snippets?N.snippetsHome:(0,k.$jh)(o,"snippets"),extensionsResource:N&&m?.useDefaultFlags?.extensions?N.extensionsResource:(0,k.$jh)(o,"extensions.json"),cacheHome:(0,k.$jh)(c,t),useDefaultFlags:m?.useDefaultFlags,isTransient:m?.transient}}let n=class extends v.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,c,m){super(),this.t=s,this.u=o,this.w=c,this.y=m,this.f=!0,this.h=this.B(new I.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new I.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new I.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new I.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new f.$Dc,workspaces:new f.$Dc,emptyWindows:new Map},this.profilesHome=(0,k.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,u.$hg)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}o.push(a((0,k.$gh)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},s))}}catch(N){this.y.error(N)}const c=new f.$Dc,m=new Map;if(o.length)try{const N=this.Q();if(N.workspaces)for(const[T,D]of Object.entries(N.workspaces)){const A=C.URI.parse(T),F=o.find(H=>H.id===D);F&&c.set(A,F)}if(N.emptyWindows)for(const[T,D]of Object.entries(N.emptyWindows)){const A=o.find(F=>F.id===D);A&&m.set(T,A)}}catch(N){this.y.error(N)}this.z={profiles:o,workspaces:c,emptyWindows:m}}return this.z}D(){const s=a("__default__profile__",(0,O.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",c=new RegExp(`${(0,y.$kf)(o)}\\s(\\d+)`);let m=0;for(const T of this.profiles){const D=c.exec(T.name),A=D?parseInt(D[1]):0;m=A>m?A:m}const N=`${o} ${m+1}`;return this.createProfile((0,P.$wj)((0,b.$5g)()).toString(16),N,{transient:!0},s)}async createNamedProfile(s,o,c){return this.createProfile((0,P.$wj)((0,b.$5g)()).toString(16),s,o,c)}async createProfile(s,o,c,m){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(s,o,c);return m&&await this.setProfileForWorkspace(m,N),N}async F(s,o,c){if(!(0,u.$hg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let m=this.r.get(o);return m||(m=(async()=>{try{if(this.profiles.find(A=>A.name===o||A.id===s))throw new Error(`Profile with ${o} name already exists`);const T=a(s,o,(0,k.$jh)(this.profilesHome,s),this.g,c,this.defaultProfile);await this.u.createFolder(T.location);const D=[];return this.j.fire({profile:T,join(A){D.push(A)}}),await S.Promises.settled(D),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,m)),m}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(m=>m.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);return c=a(c.id,o.name??c.name,c.location,this.g,{shortName:o.shortName??c.shortName,icon:o.icon===null?void 0:o.icon??c.icon,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.I([],[],[c]),c}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(m=>m.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const c=[];this.m.fire({profile:o,join(m){c.push(m)}});try{await Promise.allSettled(c)}catch(m){this.y.error(m)}for(const m of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(m)?.id&&this.C.emptyWindows.delete(m);for(const m of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(m)?.id&&this.C.workspaces.delete(m);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(m){(0,l.$ul)(m)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(m)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(m=>m.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,c)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.w.extUri.isEqual(c.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),c=C.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return c||((0,w.$Si)(s)?this.s.folders.get(s.uri):(0,w.$Xi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,w.$Si)(s)?s.uri:(0,w.$Xi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,c){const m=[...this.profiles,...s],N=[],T=this.s.profiles;this.s.profiles=[];for(let D of m){if(D.isDefault||o.some(F=>D.id===F.id))continue;D=c.find(F=>D.id===F.id)??D;const A=T.find(F=>D.id===F.id);if(D.isTransient)this.s.profiles.push(D);else{if(A){for(const[F,H]of this.s.emptyWindows.entries())if(D.id===H.id){this.L({id:F},D);break}for(const[F,H]of this.s.workspaces.entries())if(D.id===H.id){this.L({id:"",configPath:F},D);break}for(const[F,H]of this.s.folders.entries())if(D.id===H.id){this.L({id:"",uri:F},D);break}}N.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags})}}this.P(N),this.z=void 0,this.J(s,o,c)}J(s,o,c){this.h.fire({added:s,removed:o,updated:c,all:this.profiles})}L(s,o,c){if(c=o?.isTransient?!0:c,c)(0,w.$Si)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,w.$Xi)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const m=this.G(s);C.URI.isUri(m)?(this.C.workspaces.delete(m),o&&this.C.workspaces.set(m,o)):(this.C.emptyWindows.delete(m),o&&this.C.emptyWindows.set(m,o)),this.M()}}M(){const s={};for(const[c,m]of this.C.workspaces.entries())s[c.toString()]=m.id;const o={};for(const[c,m]of this.C.emptyWindows.entries())o[c.toString()]=m.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},c=this.D();if(s.workspaces)for(const[N,T]of Object.entries(s.workspaces)){const D=C.URI.parse(T);o[N]=this.w.extUri.isEqual(D,c.location)?c.id:this.w.extUri.basename(D)}const m={};if(s.emptyWindows)for(const[N,T]of Object.entries(s.emptyWindows)){const D=C.URI.parse(T);m[N]=this.w.extUri.isEqual(D,c.location)?c.id:this.w.extUri.basename(D)}return{workspaces:o,emptyWindows:m}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Sl=n,e.$Sl=n=Ee([oe(0,g.$Pi),oe(1,l.$dl),oe(2,p.$Nl),oe(3,h.$dk)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Tl=r}),define(le[53],he([0,1,19,8,21,7,4,2,25,11,3,12,5,20,26,22,44,6,33,18,23,24]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u,R,$,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Lq=void 0,e.$Mq=n,w=be(w);let a=class extends O.$Xc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(o,c,m,N,T,D){super(),this.z=o,this.C=c,this.D=m,this.F=N,this.G=T,this.H=D,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new C.$oe),this.s=this.B(new C.$oe),this.t=this.B(new C.$oe),this.u=this.B(new C.$oe),this.w=this.B(new C.$oe),this.y=[],this.B((0,O.$Vc)(()=>{this.j.forEach(({task:A})=>A.cancel()),this.m.forEach(A=>A.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(o){const c=await this.getTargetPlatform();return o.allTargetPlatforms.some(m=>(0,f.$np)(m,o.allTargetPlatforms,c))}async installFromGallery(o,c={}){try{const N=(await this.installGalleryExtensions([{extension:o,options:c}])).find(({identifier:T})=>(0,p.$Qp)(T,o.identifier));if(N?.local)return N?.local;throw N?.error?N.error:new f.$rp(`Unknown error while installing extension ${o.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(m){throw n(m)}}async installGalleryExtensions(o){if(!this.z.isEnabled())throw new f.$rp(w.localize(1767,null),f.ExtensionManagementErrorCode.NotAllowed);const c=[],m=[];return await Promise.allSettled(o.map(async({extension:N,options:T})=>{try{const D=await this.N(N,!!T?.installGivenVersion,!!T?.installPreReleaseVersion,T.productVersion??{version:this.G.version,date:this.G.date});m.push({...D,options:T})}catch(D){c.push({identifier:N.identifier,operation:f.InstallOperation.Install,source:N,error:D,profileLocation:T.profileLocation??this.W()})}})),m.length&&c.push(...await this.I(m)),c}async uninstall(o,c){return this.F.trace("ExtensionManagementService#uninstall",o.identifier.id),this.uninstallExtensions([{extension:o,options:c}])}async toggleAppliationScope(o,c){if((0,S.$yn)(o.manifest)||o.isBuiltin)return o;if(o.isApplicationScoped){let m=await this.updateMetadata(o,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(c,this.H.defaultProfile.extensionsResource)||(m=await this.Z(o,this.H.defaultProfile.extensionsResource,c));for(const N of this.H.profiles){const T=(await this.getInstalled(S.ExtensionType.User,N.extensionsResource)).find(D=>(0,p.$Qp)(D.identifier,o.identifier));T?this.w.fire({local:T,profileLocation:N.extensionsResource}):this.u.fire({identifier:o.identifier,profileLocation:N.extensionsResource})}return m}else{const m=this.D.extUri.isEqual(c,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(o,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(o,c,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:m.identifier,operation:f.InstallOperation.Install,local:m,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),m}}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.g||o-this.h>1e3*60*5)&&(this.g=this.U(),this.h=o),this.g}registerParticipant(o){this.y.push(o)}async resetPinnedStateForAllUserExtensions(o){try{await this.L(this.H.profiles.map(async c=>{const m=await this.getInstalled(S.ExtensionType.User,c.extensionsResource);await this.L(m.map(async N=>{N.pinned!==o&&await this.updateMetadata(N,{pinned:o},c.extensionsResource)}))}))}catch(c){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$_)(c)),c}}async I(o){const c=new Map,m=new Map,N=[],T=(A,F)=>`${p.$Rp.create(A).toString()}-${F.toString()}`,D=(A,F,H,Y)=>{const ne=this.X(A,F,H),ae=`${(0,p.$Vp)(A.publisher,A.name)}-${H.profileLocation.toString()}`;m.set(ae,{task:ne,root:Y}),this.n.fire({identifier:ne.identifier,source:F,profileLocation:H.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,H),h.URI.isUri(F)||this.j.set(T(F,H.profileLocation),{task:ne,waitingTasks:[]})};try{for(const{manifest:A,extension:F,options:H}of o){const Y=H.isApplicationScoped||H.isBuiltin||(0,S.$yn)(A),ne={...H,installOnlyNewlyAddedFromExtensionPack:H.installOnlyNewlyAddedFromExtensionPack??!h.URI.isUri(F),isApplicationScoped:Y,profileLocation:Y?this.H.defaultProfile.extensionsResource:H.profileLocation??this.W(),productVersion:H.productVersion??{version:this.G.version,date:this.G.date}},ae=h.URI.isUri(F)?void 0:this.j.get(T(F,ne.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,ne.profileLocation.toString()),N.push(ae.task.waitUntilTaskIsFinished())):D(A,F,ne,void 0)}return await Promise.all([...m.values()].map(async({task:A})=>{if(A.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const F=await this.M(A.identifier,A.manifest,!!A.options.installOnlyNewlyAddedFromExtensionPack,!!A.options.installPreReleaseVersion,A.options.profileLocation,A.options.productVersion),H=await this.getInstalled(void 0,A.options.profileLocation,A.options.productVersion),Y={...A.options,context:{...A.options.context,[f.$hp]:!0}};for(const{gallery:ne,manifest:ae}of(0,P.$Ob)(F,({gallery:ue})=>ue.identifier.id)){if(m.has(`${ne.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const ue=this.j.get(T(ne,Y.profileLocation));if(ue){if(this.J(A,ue.task)){const me=ue.task.identifier;this.F.info("Waiting for already requested installing extension",me.id,A.identifier.id,Y.profileLocation.toString()),ue.waitingTasks.push(A),N.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,W=>W.some(_=>(0,p.$Qp)(_.identifier,me)))).then(W=>{if(this.F.info("Finished waiting for already requested installing extension",me.id,A.identifier.id,Y.profileLocation.toString()),!W.find(M=>(0,p.$Qp)(M.identifier,me))?.local)throw new Error(`Extension ${me.id} is not installed`)}))}}else H.some(({identifier:me})=>(0,p.$Qp)(me,ne.identifier))||D(ae,ne,Y,A)}}catch(F){if(h.URI.isUri(A.source))(0,P.$Nb)(A.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",A.identifier.id,F.message),(0,P.$Nb)(A.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",A.identifier.id,F.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),F}})),await this.L([...m.entries()].map(async([A,{task:F}])=>{const H=new Date().getTime();let Y;try{Y=await F.run(),await this.L(this.y.map(ne=>ne.postInstall(Y,F.source,F.options,v.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(ne){const ae=n(ne);throw h.URI.isUri(F.source)||r(this.C,F.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Yp)(F.source),error:ae,source:F.options.context?.[f.$gp]}),c.set(A,{error:ae,identifier:F.identifier,operation:F.operation,source:F.source,context:F.options.context,profileLocation:F.options.profileLocation,applicationScoped:F.options.isApplicationScoped}),this.F.error("Error while installing the extension",F.identifier.id,(0,k.$_)(ae),F.options.profileLocation.toString()),ae}if(!h.URI.isUri(F.source)){const ne=F.operation===f.InstallOperation.Update,ae=ne?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(r(this.C,ne?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Yp)(F.source),verificationStatus:F.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:ae,source:F.options.context?.[f.$gp]}),l.$p&&F.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,f.StatisticType.Install)}catch{}}c.set(A,{local:Y,identifier:F.identifier,operation:F.operation,source:F.source,context:F.options.context,profileLocation:F.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),N.length&&await this.L(N),[...c.values()]}catch(A){const F=(ne,ae,ue)=>{const me=[];ne.manifest.extensionDependencies?.length&&me.push(...ne.manifest.extensionDependencies),ne.manifest.extensionPack?.length&&me.push(...ne.manifest.extensionPack);for(const W of me){if(ue.includes(W.toLowerCase()))continue;ue.push(W.toLowerCase());const _=c.get(`${W.toLowerCase()}-${ae.toString()}`);_?.local&&(ue=F(_.local,ae,ue))}return ue},H=ne=>({identifier:ne.identifier,operation:f.InstallOperation.Install,source:ne.source,context:ne.options.context,profileLocation:ne.options.profileLocation,error:A}),Y=[];for(const[ne,{task:ae,root:ue}]of m){const me=c.get(ne);me?me.local&&ue&&!c.get(`${ue.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(Y.push(this.Y(me.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),c.set(ne,H(ae))):(ae.cancel(),c.set(ne,H(ae)))}for(const[ne,{task:ae}]of m){const ue=c.get(ne);if(!ue?.local||ae.options.donotIncludePackAndDependencies)continue;F(ue.local,ae.options.profileLocation,[ue.local.identifier.id.toLowerCase()]).slice(1).some(W=>m.has(`${W.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!c.get(`${W.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(Y.push(this.Y(ue.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),c.set(ne,H(ae)))}throw Y.length&&await Promise.allSettled(Y.map(async ne=>{try{await ne.run(),this.F.info("Rollback: Uninstalled extension",ne.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",ne.extension.identifier.id,(0,k.$_)(ae))}})),A}finally{for(const{task:A}of m.values())A.source&&!h.URI.isUri(A.source)&&this.j.delete(T(A.source,A.options.profileLocation));if(c.size){const A=[...c.values()];for(const F of A)F.local&&this.F.info("Extension installed successfully:",F.identifier.id,F.profileLocation.toString());this.s.fire(A)}}}J(o,c){for(const[,{task:m,waitingTasks:N}]of this.j.entries())if(m===o&&(N.includes(c)||N.some(T=>this.J(T,c)))||m===c&&N[0]&&!this.J(o,N[0]))return!1;return!0}async L(o,c){const m=[],N=[],T=await Promise.allSettled(o);for(const A of T)A.status==="fulfilled"?m.push(A.value):N.push(n(A.reason,c));if(!N.length)return m;if(N.length===1)throw N[0];let D=new f.$rp("",f.ExtensionManagementErrorCode.Unknown);for(const A of N)D=new f.$rp(D.message?`${D.message}, ${A.message}`:A.message,A.code!==f.ExtensionManagementErrorCode.Unknown&&A.code!==f.ExtensionManagementErrorCode.Internal?A.code:D.code);throw D}async M(o,c,m,N,T,D){if(!this.z.isEnabled())return[];const A=await this.getInstalled(void 0,T,D),F=[],H=[],Y=async(ne,ae)=>{F.push(ne);const ue=ae.extensionDependencies||[],me=[...ue];if(ae.extensionPack){const W=m?A.find(_=>(0,p.$Qp)(_.identifier,ne)):void 0;for(const _ of ae.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(M=>(0,p.$Qp)({id:M},{id:_}))||me.every(M=>!(0,p.$Qp)({id:M},{id:_}))&&me.push(_)}if(me.length){const W=me.filter(_=>F.every(M=>!(0,p.$Qp)(M,{id:_})));if(W.length){const _=await this.z.getExtensions(W.map(M=>({id:M,preRelease:N})),v.CancellationToken.None);for(const M of _){if(F.find(Q=>(0,p.$Qp)(Q,M.identifier)))continue;const q=ue.some(Q=>(0,p.$Qp)({id:Q},M.identifier));let x;try{x=await this.N(M,!1,N,D)}catch(Q){if(q)throw Q;this.F.info("Skipping the packed extension as it cannot be installed",M.identifier.id,(0,k.$_)(Q));continue}H.push({gallery:x.extension,manifest:x.manifest}),await Y(x.extension.identifier,x.manifest)}}}};return await Y(o,c),H}async N(o,c,m,N){let T;const D=await this.getExtensionsControlManifest();if(D.malicious.some(H=>(0,p.$Qp)(o.identifier,H)))throw new f.$rp(w.localize(1768,null,o.identifier.id),f.ExtensionManagementErrorCode.Malicious);const A=D.deprecated[o.identifier.id.toLowerCase()];if(A?.extension?.autoMigrate){if(this.F.info(`The '${o.identifier.id}' extension is deprecated, fetching the compatible '${A.extension.id}' extension instead.`),T=(await this.z.getExtensions([{id:A.extension.id,preRelease:A.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:N},v.CancellationToken.None))[0],!T)throw new f.$rp(w.localize(1769,null,o.identifier.id,A.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(o)){const H=await this.getTargetPlatform();throw new f.$rp(w.localize(1770,null,o.identifier.id,this.G.nameLong,(0,f.$jp)(H)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(T=await this.O(o,c,m,N),!T){const H=[];throw(0,b.$$p)(o.properties.enabledApiProposals??[],H)?!m&&o.properties.isPreReleaseVersion&&(await this.z.getExtensions([o.identifier],v.CancellationToken.None))[0]?new f.$rp(w.localize(1772,null,o.displayName??o.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$rp(w.localize(1773,null,o.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible):new f.$rp(w.localize(1771,null,o.displayName??o.identifier.id,H[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",T.identifier.id);const F=await this.z.getManifest(T,v.CancellationToken.None);if(F===null)throw new f.$rp(`Missing manifest for extension ${T.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(F.version!==T.version)throw new f.$rp(`Cannot install '${T.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:T,manifest:F}}async O(o,c,m,N){const T=await this.getTargetPlatform();let D=null;return!c&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==m&&(D=(await this.z.getExtensions([{...o.identifier,preRelease:m}],{targetPlatform:T,compatible:!0,productVersion:N},v.CancellationToken.None))[0]||null),!D&&await this.z.isExtensionCompatible(o,m,T,N)&&(D=o),D||(c?D=(await this.z.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:T,compatible:!0,productVersion:N},v.CancellationToken.None))[0]||null:D=await this.z.getCompatibleExtension(o,m,T,N)),D}async uninstallExtensions(o){const c=(H,Y)=>`${H.identifier.id.toLowerCase()}${Y.versionOnly?`-${H.manifest.version}`:""}@${Y.profileLocation.toString()}`,m=(H,Y)=>{const ne=this.Y(H,Y);return this.m.set(c(ne.extension,Y),ne),this.F.info("Uninstalling extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,Y.profileLocation.toString()),this.t.fire({identifier:H.identifier,profileLocation:Y.profileLocation,applicationScoped:H.isApplicationScoped}),ne},N=(H,Y,ne)=>{ne?this.F.error("Failed to uninstall extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,Y.profileLocation.toString(),ne.message):this.F.info("Successfully uninstalled extension from the profile",`${H.identifier.id}@${H.manifest.version}`,Y.profileLocation.toString()),r(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$Xp)(H),error:ne}),this.u.fire({identifier:H.identifier,error:ne?.code,profileLocation:Y.profileLocation,applicationScoped:H.isApplicationScoped})},T=[],D=[],A=[],F=new g.$Dc;for(const{extension:H,options:Y}of o){const ne={...Y,profileLocation:H.isApplicationScoped?this.H.defaultProfile.extensionsResource:Y?.profileLocation??this.W()},ae=this.m.get(c(H,ne));ae?(this.F.info("Extensions is already requested to uninstall",H.identifier.id),A.push(ae.waitUntilTaskIsFinished())):T.push(m(H,ne))}try{for(const H of T.slice(0)){let Y=F.get(H.options.profileLocation);if(Y||F.set(H.options.profileLocation,Y=await this.getInstalled(S.ExtensionType.User,H.options.profileLocation)),H.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${H.extension.identifier.id}@${H.extension.manifest.version}`);else{const ne=this.R(H.extension,Y);for(const ae of ne)this.m.has(c(ae,H.options))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):T.push(m(ae,H.options))}H.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${H.extension.identifier.id}@${H.extension.manifest.version}`):this.P(T.map(ne=>ne.extension),Y,H.extension)}await this.L(T.map(async H=>{try{if(await H.run(),await this.L(this.y.map(Y=>Y.postUninstall(H.extension,H.options,v.CancellationToken.None))),H.extension.identifier.uuid)try{await this.z.reportStatistic(H.extension.manifest.publisher,H.extension.manifest.name,H.extension.manifest.version,f.StatisticType.Uninstall)}catch{}}catch(Y){const ne=n(Y);throw N(H.extension,H.options,ne),ne}finally{D.push(H)}})),A.length&&await this.L(A);for(const H of T)N(H.extension,H.options)}catch(H){const Y=n(H);for(const ne of T){try{ne.cancel()}catch{}D.includes(ne)||N(ne.extension,ne.options,Y)}throw Y}finally{for(const H of T)this.m.delete(c(H.extension,H.options))||this.F.warn("Uninstallation task is not found in the cache",H.extension.identifier.id)}}P(o,c,m){for(const N of o){const T=this.S(N,c);if(T.length){const D=T.filter(A=>!o.some(F=>(0,p.$Qp)(F.identifier,A.identifier)));if(D.length)throw new Error(this.Q(N,D,m))}}}Q(o,c,m){return m===o?c.length===1?w.localize(1774,null,m.manifest.displayName||m.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?w.localize(1775,null,m.manifest.displayName||m.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):w.localize(1776,null,m.manifest.displayName||m.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?w.localize(1777,null,m.manifest.displayName||m.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?w.localize(1778,null,m.manifest.displayName||m.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):w.localize(1779,null,m.manifest.displayName||m.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}R(o,c,m=[]){if(m.indexOf(o)!==-1)return[];m.push(o);const N=o.manifest.extensionPack?o.manifest.extensionPack:[];if(N.length){const T=c.filter(A=>!A.isBuiltin&&N.some(F=>(0,p.$Qp)({id:F},A.identifier))),D=[];for(const A of T)D.push(...this.R(A,c,m));return[...T,...D]}return[]}S(o,c){return c.filter(m=>m.manifest.extensionDependencies&&m.manifest.extensionDependencies.some(N=>(0,p.$Qp)({id:N},o.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(o){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$_)(o)),{malicious:[],deprecated:{},search:[]}}}};e.$Lq=a,e.$Lq=a=Ee([oe(0,f.$pp),oe(1,R.$cm),oe(2,$.$Nl),oe(3,y.$dk),oe(4,u.$wk),oe(5,i.$Pl)],a);function n(s,o){if(s instanceof f.$rp)return s;let c;return s instanceof f.$qp?c=new f.$rp(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):c=new f.$rp(s.message,(0,k.$6)(s)?f.ExtensionManagementErrorCode.Cancelled:o??f.ExtensionManagementErrorCode.Internal),c.stack=s.stack,c}function r(s,o,{extensionData:c,verificationStatus:m,duration:N,error:T,source:D,durationSinceUpdate:A}){let F,H;(0,d.$pg)(m)&&(m===!0?m="Verified":(m===!1||(F=f.ExtensionManagementErrorCode.Signature,H=m),m="Unverified")),T&&(F=T.code,T.code===f.ExtensionManagementErrorCode.Signature&&(H=T.message)),s.publicLog(o,{...c,verificationStatus:m,success:!T,duration:N,errorcode:F,errorcodeDetail:H,durationSinceUpdate:A,source:D})}class t{constructor(){this.d=new I.$Hh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,I.$vh)(o=>this.h(o))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,I.$vh)(o=>new Promise((c,m)=>{const N=o.onCancellationRequested(()=>{N.dispose(),m(new k.$7)})})),this.d.open()),this.g.cancel()}}e.$Nq=t}),define(le[42],he([0,1,8,13,2,4,25,12,20,26,9,10,6,24,23,3,7,18]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class R extends Error{constructor(r,t){super(r),this.code=t}}e.$Oq=R,e.$Pq=(0,h.$Ii)("IExtensionsProfileScannerService");let $=class extends v.$Xc{constructor(r,t,s,o,c,m){super(),this.j=r,this.m=t,this.n=s,this.r=o,this.s=c,this.t=m,this.b=this.B(new k.$oe),this.onAddExtensions=this.b.event,this.c=this.B(new k.$oe),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$oe),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$oe),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Dc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t,s){const o=[],c=[];try{return await this.u(t,m=>{const N=[];if(s)N.push(...m);else for(const T of m)r.some(([D])=>(0,l.$Qp)(D.identifier,T.identifier)&&D.manifest.version!==T.version)?o.push(T):N.push(T);for(const[T,D]of r){const A=N.findIndex(H=>(0,l.$Qp)(H.identifier,T.identifier)&&H.version===T.manifest.version),F={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:D};A===-1?(c.push(F),N.push(F)):N.splice(A,1,F)}return c.length&&this.b.fire({extensions:c,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),N}),c.length&&this.c.fire({extensions:c,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),c}catch(m){throw c.length&&this.c.fire({extensions:c,error:m,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:m,profileLocation:t}),m}}async updateMetadata(r,t){const s=[];return await this.u(t,o=>{const c=[];for(const m of o){const N=r.find(([T])=>(0,l.$Qp)(T.identifier,m.identifier)&&T.manifest.version===m.version);N&&(m.metadata={...m.metadata,...N[1]},s.push(m)),c.push(m)}return c}),s}async removeExtensionFromProfile(r,t){const s=[];try{await this.u(t,o=>{const c=[];for(const m of o)(0,l.$Qp)(m.identifier,r.identifier)?s.push(m):c.push(m);return s.length&&this.f.fire({extensions:s,profileLocation:t}),c}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:t}),o}}async u(r,t,s){return this.F(r).queue(async()=>{let o=[],c;try{const m=await this.m.readFile(r);c=JSON.parse(m.value.toString().trim()||"[]")}catch(m){if((0,d.$ul)(m)!==d.FileOperationResult.FILE_NOT_FOUND)throw m;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(c=await this.D()),!c&&s?.bailOutWhenFileNotFound)throw new R((0,b.$_)(m),u.ERROR_PROFILE_NOT_FOUND)}if(c){Array.isArray(c)||this.w(r);let m=!1;for(const N of c){i(N)||this.w(r);let T;if((0,S.$hg)(N.relativeLocation)&&N.relativeLocation)T=this.z(N.relativeLocation);else if((0,S.$hg)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{T=O.URI.revive(N.location);const D=this.y(T);D&&(m=!0,N.relativeLocation=D)}(0,S.$og)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&(m=!0,N.metadata.hasPreReleaseVersion=!0),o.push({identifier:N.identifier,location:T,version:N.version,metadata:N.metadata})}m&&await this.m.writeFile(r,I.$Qe.fromString(JSON.stringify(c)))}if(t){o=t(o);const m=o.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(r,I.$Qe.fromString(JSON.stringify(m)))}return o})}w(r){const t=new R(`Invalid extensions content in ${r.toString()}`,u.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(c){if((0,d.$ul)(c)===d.FileOperationResult.FILE_NOT_FOUND)return;throw c}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(m=>i(m))?o=c:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.t.error(c)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,I.$Qe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(c){if((0,d.$ul)(c)===d.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw c}try{await this.m.del(r)}catch(c){(0,d.$ul)(c)!==d.FileOperationResult.FILE_NOT_FOUND&&this.t.error(c)}try{await this.m.del(t)}catch(c){(0,d.$ul)(c)!==d.FileOperationResult.FILE_NOT_FOUND&&this.t.error(c)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new P.$Ph,this.h.set(r,t)),t}};e.$Qq=$,e.$Qq=$=Ee([oe(1,d.$dl),oe(2,f.$Pl),oe(3,p.$Nl),oe(4,y.$cm),oe(5,w.$dk)],$);function i(n){return(0,S.$jg)(n)&&(0,g.$op)(n.identifier)&&(a(n.location)||(0,S.$hg)(n.location)&&n.location)&&((0,S.$og)(n.relativeLocation)||(0,S.$hg)(n.relativeLocation))&&n.version&&(0,S.$hg)(n.version)}function a(n){return n?(0,S.$hg)(n.path)&&(0,S.$hg)(n.scheme):!1}});var ze=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[54],he([0,1,19,8,27,13,7,34,91,2,14,15,11,16,45,58,3,12,5,17,26,22,44,9,10,6,33,4,48,42,24,23,97]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u,R,$,i,a,n,r,t,s,o,c,m,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Vq=e.$Uq=e.$Tq=e.Translations=void 0,e.$Wq=ae,v=be(v),h=be(h),w=be(w),p=be(p),S=ze(S);var A;(function(me){function W(_,M){if(_===M)return!0;const q=Object.keys(_),x=new Set;for(const Q of Object.keys(M))x.add(Q);if(q.length!==x.size)return!1;for(const Q of q){if(_[Q]!==M[Q])return!1;x.delete(Q)}return x.size===0}me.equals=W})(A||(e.Translations=A={})),e.$Tq=(0,r.$Ii)("IExtensionsScannerService");let F=class extends l.$Xc{constructor(W,_,M,q,x,Q,ie,se,L,V,z,E){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=_,this.r=M,this.s=q,this.t=x,this.u=Q,this.w=ie,this.y=se,this.z=L,this.C=V,this.D=z,this.F=E,this.g=this.B(new o.$oe),this.onDidChangeCache=this.g.event,this.h=(0,f.$jh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(Y,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,$.$2p)(this.w,this.y)),this.G}async scanAllExtensions(W,_,M){const[q,x]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(_)]),Q=M?await this.scanExtensionsUnderDevelopment(W,[...q,...x]):[];return this.L(q,x,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const _=[];_.push(this.M(!!W.useCache,W.language)),_.push(this.N(W.language,!!W.checkControlFile));const[M,q]=await Promise.all(_);return this.J([...M,...q],i.ExtensionType.System,W,!1)}async scanUserExtensions(W){const _=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const M=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(_,!!W.profileLocation,i.ExtensionType.User,!W.includeUninstalled,W.language,!0,M,W.productVersion??this.R()),x=W.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let Q;try{Q=await x.scanExtensions(q)}catch(ie){if(ie instanceof m.$Oq&&ie.code===m.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Q=await x.scanExtensions(q);else throw ie}return Q=await this.J(Q,i.ExtensionType.User,W,!0),this.y.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(W,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===d.Schemas.file).map(async q=>{const x=await this.P(q,!1,i.ExtensionType.User,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(x)).map(ie=>(ie.type=_.find(se=>(0,$.$Qp)(se.identifier,ie.identifier))?.type??ie.type,this.n.validate(ie,x)))}))).flat();return this.J(M,"development",W,!0)}return[]}async scanExistingExtension(W,_,M){const q=await this.P(W,!1,_,!0,M.language,!0,void 0,M.productVersion??this.R()),x=await this.n.scanExtension(q);return!x||!M.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(W,_,M){const q=await this.P(W,!1,_,!0,M.language,!0,void 0,M.productVersion??this.R()),x=await this.n.scanOneOrMultipleExtensions(q);return this.J(x,_,M,!0)}async scanMultipleExtensions(W,_,M){const q=[];return await Promise.all(W.map(async x=>{const Q=await this.scanOneOrMultipleExtensions(x,_,M);q.push(...Q)})),this.J(q,_,M,!0)}async scanMetadata(W){const _=(0,f.$jh)(W,"package.json"),M=(await this.w.readFile(_)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(W,_){const M=(0,f.$jh)(W,"package.json"),q=(await this.w.readFile(M)).value.toString(),x=JSON.parse(q);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,x.__metadata={...x.__metadata,..._},await this.w.writeFile((0,f.$jh)(W,"package.json"),k.$Qe.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof m.$Oq&&W.code===m.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Qe.fromString(JSON.stringify([])))}catch(_){(0,n.$ul)(_)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$_)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,_,M,q){return M.includeAllVersions||(W=this.L(_===i.ExtensionType.System?W:void 0,_===i.ExtensionType.User?W:void 0,_==="development"?W:void 0,await this.getTargetPlatform(),q)),M.includeInvalid||(W=W.filter(x=>x.isValid)),W.sort((x,Q)=>{const ie=h.$qc(x.location.fsPath),se=h.$qc(Q.location.fsPath);return ie<se?-1:ie>se?1:0})}L(W,_,M,q,x){const Q=(se,L,V)=>{if(se.isValid&&!L.isValid)return!1;if(se.isValid===L.isValid){if(x&&p.gt(se.manifest.version,L.manifest.version))return this.y.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(p.eq(se.manifest.version,L.manifest.version)){if(se.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${L.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===q)return this.y.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return V?this.y.warn(`Overwriting user extension ${se.location.path} with ${L.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${L.location.path}.`),!0},ie=new i.$xn;return W?.forEach(se=>{const L=ie.get(se.identifier.id);(!L||Q(L,se,!1))&&ie.set(se.identifier.id,se)}),_?.forEach(se=>{const L=ie.get(se.identifier.id);if(!L&&W&&se.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!L||Q(L,se,!1))&&ie.set(se.identifier.id,se)}),M?.forEach(se=>{const L=ie.get(se.identifier.id);(!L||Q(L,se,!0))&&ie.set(se.identifier.id,se),ie.set(se.identifier.id,se)}),[...ie.values()]}async M(W,_){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,_,!0,void 0,this.R()),x=await(W&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",x.length),x}async N(W,_){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const q=_?await this.O():{},x=[],Q=y.URI.file(h.$kc(h.$mc(d.$3g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of M){const L=q[se.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":x.push((0,f.$jh)(Q,se.name));break;default:x.push(y.URI.file(L));break}}const ie=await Promise.all(x.map(async se=>this.n.scanExtension(await this.P(se,!1,i.ExtensionType.System,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ie.length),(0,P.$Jb)(ie)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,_,M,q,x,Q,ie,se){const L=await this.f(x??w.$x),V=await this.Q(W),z=_&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=z?await this.Q(z):void 0;return new H(W,V,z,E,_,ie,M,q,Q,se.version,se.date,this.C.commit,!this.z.isBuilt,x,L)}async Q(W){try{const _=await this.w.stat(W);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Uq=F,e.$Uq=F=Ee([oe(4,N.$Pl),oe(5,m.$Pq),oe(6,n.$dl),oe(7,t.$dk),oe(8,R.$Pi),oe(9,s.$wk),oe(10,T.$Nl),oe(11,r.$Hi)],F);class H{constructor(W,_,M,q,x,Q,ie,se,L,V,z,E,j,X,J){this.location=W,this.mtime=_,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=q,this.profile=x,this.profileScanOptions=Q,this.type=ie,this.excludeObsolete=se,this.validate=L,this.productVersion=V,this.productDate=z,this.productCommit=E,this.devMode=j,this.language=X,this.translations=J}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,_){return(0,f.$ch)(W.location,_.location)&&W.mtime===_.mtime&&(0,f.$ch)(W.applicationExtensionslocation,_.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&W.profile===_.profile&&v.$mo(W.profileScanOptions,_.profileScanOptions)&&W.type===_.type&&W.excludeObsolete===_.excludeObsolete&&W.validate===_.validate&&W.productVersion===_.productVersion&&W.productDate===_.productDate&&W.productCommit===_.productCommit&&W.devMode===_.devMode&&W.language===_.language&&A.equals(W.translations,_.translations)}}e.$Vq=H;let Y=class extends l.$Xc{constructor(W,_,M,q,x,Q,ie){super(),this.g=W,this.h=_,this.j=M,this.m=q,this.n=Q,this.r=ie,this.f=x.extensionsEnabledWithApiProposalVersion?.map(se=>se.toLowerCase())??[]}async scanExtensions(W){const _=W.profile?await this.t(W):await this.s(W);let M={};if(W.excludeObsolete&&W.type===i.ExtensionType.User)try{const q=(await this.m.readFile(this.g)).value.toString();M=JSON.parse(q)}catch{}return(0,b.$ug)(M)?_:_.filter(q=>!M[$.$Rp.create(q).toString()])}async s(W){const _=await this.m.resolve(W.location);if(!_.children?.length)return[];const M=await Promise.all(_.children.map(async q=>{if(!q.isDirectory||W.type===i.ExtensionType.User&&(0,f.$gh)(q.resource).indexOf(".")===0)return null;const x=new H(q.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(x)}));return(0,P.$Jb)(M).sort((q,x)=>q.location.path<x.location.path?-1:1)}async t(W){let _=await this.u(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.j.extUri.isEqual(W.location,W.applicationExtensionslocation)){_=_.filter(q=>!q.metadata?.isApplicationScoped);const M=await this.u(W.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,W);_.push(...M)}return _}async u(W,_,M){const q=await this.h.scanProfileExtensions(W,M.profileScanOptions);if(!q.length)return[];const x=await Promise.all(q.map(async Q=>{if(_(Q)){const ie=new H(Q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(ie,Q.metadata)}return null}));return(0,P.$Jb)(x)}async scanOneOrMultipleExtensions(W){try{if(await this.m.exists((0,f.$jh)(W.location,"package.json"))){const _=await this.scanExtension(W);return _?[_]:[]}else return await this.scanExtensions(W)}catch(_){return this.r.error(`Error scanning extensions at ${W.location.path}:`,(0,C.$_)(_)),[]}}async scanExtension(W,_){try{let M=await this.w(W.location);if(M){M.publisher||(M.publisher=i.$rn),_=_??M.__metadata,delete M.__metadata;const q=(0,$.$Vp)(M.publisher,M.name),x=_?.id?{id:q,uuid:_.id}:{id:q},Q=_?.isSystem?i.ExtensionType.System:W.type,ie=Q===i.ExtensionType.System||!!_?.isBuiltin;M=await this.y(W.location,M,H.createNlsConfiguration(W));let se={type:Q,identifier:x,manifest:M,location:W.location,isBuiltin:ie,targetPlatform:_?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return W.validate&&(se=this.validate(se,W)),M.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(q.toLowerCase()))&&(M.originalEnabledApiProposals=M.enabledApiProposals,M.enabledApiProposals=(0,i.$Dn)([...M.enabledApiProposals])),se}}catch(M){W.type!==i.ExtensionType.System&&this.r.error(M)}return null}validate(W,_){let M=!0;const q=this.n.isBuilt&&this.f.includes(W.identifier.id.toLowerCase()),x=(0,a.$8p)(_.productVersion,_.productDate,_.location,W.manifest,W.isBuiltin,q);for(const[Q,ie]of x)Q===S.default.Error&&(M=!1,this.r.error(this.F(_.location,ie)));return W.isValid=M,W.validations=x,W}async w(W){const _=(0,f.$jh)(W,"package.json");let M;try{M=(await this.m.readFile(_)).value.toString()}catch(x){return(0,n.$ul)(x)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(W,(0,u.localize)(1815,null,_.path,x.message))),null}let q;try{q=JSON.parse(M)}catch{const Q=[];(0,O.$3n)(M,Q);for(const ie of Q)this.r.error(this.F(W,(0,u.localize)(1816,null,_.path,ie.offset,ie.length,(0,g.$Rq)(ie.error))));return null}return(0,O.$$n)(q)!=="object"?(this.r.error(this.F(W,(0,u.localize)(1817,null,_.path))),null):q}async y(W,_,M){const q=await this.z(W,_,M);if(q)try{const x=[],Q=await this.C(q.default,x);if(x.length>0)return x.forEach(se=>{this.r.error(this.F(W,(0,u.localize)(1818,null,q.default?.path,(0,g.$Rq)(se.error))))}),_;if((0,O.$$n)(q)!=="object")return this.r.error(this.F(W,(0,u.localize)(1819,null,q.default?.path))),_;const ie=q.values||Object.create(null);return(0,D.$Sq)(this.r,_,ie,Q)}catch{}return _}async z(W,_,M){const q=(0,f.$jh)(W,"package.nls.json"),x=(L,V)=>{V.forEach(z=>{this.r.error(this.F(W,(0,u.localize)(1820,null,L?.path,(0,g.$Rq)(z.error))))})},Q=L=>{this.r.error(this.F(W,(0,u.localize)(1821,null,L?.path)))},ie=`${_.publisher}.${_.name}`,se=M.translations[ie];if(se)try{const L=y.URI.file(se),V=(await this.m.readFile(L)).value.toString(),z=[],E=(0,O.$3n)(V,z);return z.length>0?(x(L,z),{values:void 0,default:q}):(0,O.$$n)(E)!=="object"?(Q(L),{values:void 0,default:q}):{values:E.contents?E.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.m.exists(q))return;let V;try{V=await this.D(W,M)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const z=(await this.m.readFile(V.localized)).value.toString(),E=[],j=(0,O.$3n)(z,E);return E.length>0?(x(V.localized,E),{values:void 0,default:V.original}):(0,O.$$n)(j)!=="object"?(Q(V.localized),{values:void 0,default:V.original}):{values:j,default:V.original}}catch{return{values:void 0,default:V.original}}}}async C(W,_){if(W)try{const M=(await this.m.readFile(W)).value.toString();return(0,O.$3n)(M,_)}catch{}}D(W,_){return new Promise((M,q)=>{const x=Q=>{const ie=(0,f.$jh)(W,`package.nls.${Q}.json`);this.m.exists(ie).then(se=>{se&&M({localized:ie,original:(0,f.$jh)(W,"package.nls.json")});const L=Q.lastIndexOf("-");L===-1?M({localized:(0,f.$jh)(W,"package.nls.json"),original:null}):(Q=Q.substring(0,L),x(Q))})};if(_.devMode||_.pseudo||!_.language)return M({localized:(0,f.$jh)(W,"package.nls.json"),original:null});x(_.language)})}F(W,_){return`[${W.path}]: ${_}`}};Y=Ee([oe(1,m.$Pq),oe(2,T.$Nl),oe(3,n.$dl),oe(4,s.$wk),oe(5,R.$Pi),oe(6,t.$dk)],Y);let ne=class extends Y{constructor(W,_,M,q,x,Q,ie,se,L){super(_,q,x,Q,ie,se,L),this.J=W,this.L=M,this.H=this.B(new I.$Gh(3e3)),this.I=this.B(new o.$oe),this.onDidChangeCache=this.I.event}async scanExtensions(W){const _=this.P(W),M=await this.M(_);if(this.G=W,M&&M.input&&H.equals(M.input,this.G))return this.r.debug("Using cached extensions scan result",W.type===i.ExtensionType.System?"system":"user",W.location.toString()),this.H.trigger(()=>this.O()),M.result.map(x=>(x.location=y.URI.revive(x.location),x));const q=await super.scanExtensions(W);return await this.N(_,{input:W,result:q}),q}async M(W){try{const _=await this.m.readFile(W),M=JSON.parse(_.value.toString());return{result:M.result,input:(0,c.$fi)(M.input)}}catch(_){this.r.debug("Error while reading the extension cache file:",W.path,(0,C.$_)(_))}return null}async N(W,_){try{await this.m.writeFile(W,k.$Qe.fromString(JSON.stringify(_)))}catch(M){this.r.debug("Error while writing the extension cache file:",W.path,(0,C.$_)(M))}}async O(){if(!this.G)return;const W=this.P(this.G),_=await this.M(W);if(!_)return;const M=_.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!v.$mo(q,M))try{this.r.info("Invalidating Cache",M,q),await this.m.del(W),this.I.fire()}catch(x){this.r.error(x)}}P(W){const _=this.Q(W);return this.j.extUri.joinPath(_.cacheHome,W.type===i.ExtensionType.System?i.$qn:i.$pn)}Q(W){return W.type===i.ExtensionType.System?this.L.defaultProfile:W.profile?this.j.extUri.isEqual(W.location,this.J.extensionsResource)?this.J:this.L.profiles.find(_=>this.j.extUri.isEqual(W.location,_.extensionsResource))??this.J:this.L.defaultProfile}};ne=Ee([oe(2,N.$Pl),oe(3,m.$Pq),oe(4,T.$Nl),oe(5,n.$dl),oe(6,s.$wk),oe(7,R.$Pi),oe(8,t.$dk)],ne);function ae(me,W){const _=(0,$.$Tp)(me.manifest.publisher,me.manifest.name);return{id:_,identifier:new i.$vn(_),isBuiltin:me.type===i.ExtensionType.System,isUserBuiltin:me.type===i.ExtensionType.User&&me.isBuiltin,isUnderDevelopment:W,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,publisherDisplayName:me.publisherDisplayName,...me.manifest}}class ue extends F{constructor(W,_,M,q,x,Q,ie,se,L,V,z,E){super(W,_,(0,f.$jh)(M,".vscode-oss-dev","extensions","control.json"),q,x,Q,ie,se,L,V,z,E),this.S=(async()=>{if(w.$A)try{const j=await this.w.readFile(y.URI.file(w.$A));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$Xq=ue}),define(le[137],he([0,1,62,8,38,4,2,14,15,29,6,24]),function(Z,e,P,I,v,k,C,O,g,l,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let w=class extends C.$Xc{constructor(p,S){super(),this.b=p,this.f=S,this.a=new I.$Oh(5)}async postUninstall(p){const S=this.g(p,"uninstall");S&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(S.script,"uninstall",S.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(b)}}));try{await l.Promises.rm(this.m(p))}catch(b){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(b)}}g(p,S){const b=`vscode:${S}`;if(p.location.scheme===O.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[b]=="string"){const y=p.manifest.scripts[b].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${b} should be a node script`),null):{script:(0,g.$mc)(p.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}h(p,S,b,y,u){return new Promise((R,$)=>{const i=this.j(p,S,b,u);let a;const n=r=>{a&&(clearTimeout(a),a=null),r?$(r):R(void 0)};i.on("error",r=>{n((0,v.$tj)(r)||"Unknown")}),i.on("exit",(r,t)=>{n(r?`post-${S} process exited with code ${r}`:void 0)}),y&&(a=setTimeout(()=>{a=null,i.kill(),$("timed out")},5e3))})}j(p,S,b,y){const u={silent:!0,execArgv:void 0},R=(0,P.fork)(p,[`--type=extension-post-${S}`,...b],u);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const $=k.Event.fromNodeEventEmitter(R.stdout,"data"),i=k.Event.fromNodeEventEmitter(R.stderr,"data");this.B($(r=>this.f.info(y.identifier.id,y.manifest.version,`post-${S}`,r))),this.B(i(r=>this.f.error(y.identifier.id,y.manifest.version,`post-${S}`,r)));const a=k.Event.any(k.Event.map($,r=>({data:`%c${r}`,format:[""]}),this.q),k.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return k.Event.debounce(a,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(y.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),R}m(p){return(0,g.$mc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$2q=w,e.$2q=w=Ee([oe(0,h.$Pl),oe(1,d.$dk)],w)}),define(le[74],he([0,1,50,5,53,20]),function(Z,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=C,e.$Zq=O;function C(g){let l=k.ExtensionManagementErrorCode.Extract;return g instanceof P.$Hq&&(g.type==="CorruptZip"?l=k.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(l=k.ExtensionManagementErrorCode.IncompleteZip)),(0,v.$Mq)(g,l)}async function O(g){let l;try{l=await(0,P.$Kq)(g,"extension/package.json")}catch(d){throw C(d)}try{return JSON.parse(l.toString("utf8"))}catch{throw new k.$rp((0,I.localize)(1831,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(le[138],he([0,1,8,7,2,14,16,45,3,28,29,50,30,17,53,20,26,74,73,9,6,18]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u,R,$,i){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0,O=be(O);let n=class extends v.$Xc{static{a=this}static{this.c=".sigzip"}constructor(t,s,o,c,m,N,T){super(),this.h=s,this.j=o,this.m=c,this.n=m,this.r=N,this.t=T,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,o,c){await this.g;const m=await this.w(t,s);let N=!1;if(o&&this.u(t)){let T;try{T=await this.y(t)}catch(D){try{await this.delete(m)}catch(A){this.t.error(A)}throw D}try{N=await this.n.verify(t,m.fsPath,T.fsPath,c)}catch(D){if(N=D.code,N===u.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===u.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(m)}catch(A){this.t.error(A)}throw new S.$rp(h.$Gq,S.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(D){this.t.error(D)}}}return{location:m,verificationStatus:N}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,g.$ng)(s)?s:!0}async w(t,s){try{const o=(0,C.$jh)(this.extensionsDownloadDir,this.G(t)),c=await this.C(t,"vsix",async()=>{await this.z(t,o,m=>this.j.download(t,m,s));try{await this.D(o.fsPath,"extension/package.json")}catch(m){try{await this.h.del(o)}catch(N){this.t.warn(`Error while deleting: ${o.path}`,(0,I.$_)(N))}throw m}},2);return c>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:c}),o}catch(o){throw(0,p.$Mq)(o,S.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,C.$jh)(this.extensionsDownloadDir,`.${(0,l.$5g)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(c){try{await this.h.del(s)}catch(m){this.t.warn(`Error while deleting: ${s.path}`,(0,I.$_)(m))}throw c}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),s}catch(s){throw(0,p.$Mq)(s,S.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==k.Schemas.file){await o(s);return}const c=(0,C.$jh)(this.extensionsDownloadDir,`.${(0,l.$5g)()}`);try{await o(c)}catch(m){try{await this.h.del(c)}catch{}throw m}try{await d.Promises.rename(c.fsPath,s.fsPath,2*60*1e3)}catch(m){try{await this.h.del(c)}catch{}let N=!1;try{N=await this.h.exists(s)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,I.$_)(m)}. Deleted the file from downloaded location`,c.path),m}}async C(t,s,o,c){let m=1;for(;;)try{return await o(),m}catch(N){if(m++>c)throw N;this.t.warn(`Failed downloading ${s}. ${(0,I.$_)(N)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,h.$Kq)(t,s)}catch(o){throw(0,y.$Yq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],c=[];for(const T of t.children)if(T.name.endsWith(a.c))c.push(T.resource);else{const D=b.$Rp.parse(T.name);D&&o.push([D,T])}const m=(0,b.$Wp)(o,([T])=>T),N=[];for(const T of m)T.sort((D,A)=>O.rcompare(D[0].version,A[0].version)),s.push(...T.slice(1).map(D=>D[1].resource)),N.push(T[0][1]);N.sort((T,D)=>T.mtime-D.mtime),s.push(...N.slice(0,Math.max(0,N.length-this.f)).map(T=>T.resource)),s.push(...c),await P.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(t){this.t.error(t)}}G(t){return this.f?b.$Rp.create(t).toString().toLowerCase():(0,l.$5g)()}};e.$1q=n,e.$1q=n=a=Ee([oe(0,f.$Qi),oe(1,R.$dl),oe(2,S.$pp),oe(3,w.$cj),oe(4,u.$zq),oe(5,i.$cm),oe(6,$.$dk)],n)}),define(le[139],he([0,1,32,8,13,21,38,7,4,43,2,25,14,15,16,45,3,12,28,29,50,5,63,17,53,20,26,42,54,138,137,74,119,126,22,44,9,10,6,33,18,23,24]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u,R,$,i,a,n,r,t,s,o,c,m,N,T,D,A,F,H,Y,ne,ae,ue,me,W,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0,P=be(P),f=be(f),S=be(S),R=be(R),i=be(i),e.$5q=(0,ne.$Ji)(t.$sp);const M=".vsctmp";let q=class extends r.$Lq{constructor(L,V,z,E,j,X,J,G,U,K,re,ce){super(L,V,re,z,K,ce),this.db=j,this.eb=X,this.fb=J,this.gb=G,this.hb=U,this.cb=new Map,this.sb=new h.$Ec;const fe=this.B(G.createInstance(N.$2q));this.$=this.B(G.createInstance(x,de=>fe.postUninstall(de))),this.ab=this.B(new D.$3q(ce,U,re,this,this.F)),this.bb=this.B(G.createInstance(m.$1q));const we=this.B(new A.$4q(this,this.db,ce,X,re,U,z));this.B(we.onDidChangeExtensionsByAnotherSource(de=>this.rb(de))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$2p)(this.hb,this.F)),this.ib}async zip(L){this.F.trace("ExtensionManagementService#zip",L.identifier.id);const V=await this.qb(L),z=await(0,$.zip)((0,p.$jh)(this.bb.extensionsDownloadDir,(0,u.$5g)()).fsPath,V);return y.URI.file(z)}async getManifest(L){const{location:V,cleanup:z}=await this.kb(L),E=f.$nc(V.fsPath);try{return await(0,T.$Zq)(E)}finally{await z()}}getInstalled(L,V=this.H.defaultProfile.extensionsResource,z={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(L??null,V,z)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(L){return this.$.scanUserExtensionAtLocation(L)}async install(L,V={}){this.F.trace("ExtensionManagementService#install",L.toString());const{location:z,cleanup:E}=await this.kb(L);try{const j=await(0,T.$Zq)(f.$nc(z.fsPath)),X=(0,s.$Vp)(j.publisher,j.name);if(j.engines&&j.engines.vscode&&!(0,H.$0p)(j.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(1822,null,X,this.G.version));const G=(await this.I([{manifest:j,extension:z,options:V}])).find(({identifier:U})=>(0,s.$Qp)(U,{id:X}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Mq)(new Error(`Unknown error while installing extension ${X}`))}finally{await E()}}async installFromLocation(L,V){this.F.trace("ExtensionManagementService#installFromLocation",L.toString());const z=await this.$.scanUserExtensionAtLocation(L);if(!z||!z.manifest.name||!z.manifest.version)throw new Error(`Cannot find a valid extension from the location ${L.toString()}`);return await this.vb([[z,{source:"resource"}]],V),this.F.info("Successfully installed extension",z.identifier.id,V.toString()),z}async installExtensionsFromProfile(L,V,z){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",L,V.toString(),z.toString());const E=(await this.getInstalled(F.ExtensionType.User,V)).filter(j=>L.some(X=>(0,s.$Qp)(X,j.identifier)));if(E.length){const j=await Promise.all(E.map(X=>this.$.scanMetadata(X,V)));await this.vb(E.map((X,J)=>[X,j[J]]),z),this.F.info("Successfully installed extensions",E.map(X=>X.identifier.id),z.toString())}return E}async updateMetadata(L,V,z){return this.F.trace("ExtensionManagementService#updateMetadata",L.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0,V.hasPreReleaseVersion=!0),V.isMachineScoped===!1&&(V.isMachineScoped=void 0),V.isBuiltin===!1&&(V.isBuiltin=void 0),V.pinned===!1&&(V.pinned=void 0),L=await this.$.updateMetadata(L,V,z),this.ab.invalidate(z),this.w.fire({local:L,profileLocation:z}),L}async reinstallFromGallery(L){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",L.identifier.id),!this.z.isEnabled())throw new Error(i.localize(1823,null));const V=await this.getTargetPlatform(),[z]=await this.z.getExtensions([{...L.identifier,preRelease:L.preRelease}],{targetPlatform:V,compatible:!0},k.CancellationToken.None);if(!z)throw new Error(i.localize(1824,null));await this.$.setUninstalled(L);try{await this.$.removeUninstalledExtension(L)}catch(E){throw new Error(i.localize(1825,null,(0,C.$tj)(E)))}return this.installFromGallery(z)}Z(L,V,z,E){return this.$.copyExtension(L,V,z,E)}copyExtensions(L,V){return this.$.copyExtensions(L,V,{version:this.G.version,date:this.G.date})}markAsUninstalled(...L){return this.$.setUninstalled(...L)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(L){this.F.error(L)}}async download(L,V,z){const{location:E}=await this.bb.download(L,V,!z);return E}async kb(L){if(L.scheme===w.Schemas.file)return{location:L,async cleanup(){}};this.F.trace("Downloading extension from",L.toString());const V=(0,p.$jh)(this.bb.extensionsDownloadDir,(0,u.$5g)());return await this.fb.download(L,V),this.F.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.hb.del(V)}catch(E){this.F.error(E)}}}}W(){return this.H.defaultProfile.extensionsResource}X(L,V,z){const E=V instanceof y.URI?new s.$Rp({id:(0,s.$Vp)(L.publisher,L.name)},L.version):s.$Rp.create(V);return this.gb.createInstance(Q,E,L,V,z,(j,X)=>{if(V instanceof y.URI)return this.pb(E,V,z,X);let J=this.cb.get(E.toString());return J||(this.cb.set(E.toString(),J=this.ob(E,V,j,z,X)),J.finally(()=>this.cb.delete(E.toString()))),J},this.$)}Y(L,V){return new ie(L,V,this.eb)}async ob(L,V,z,E,j){const{verificationStatus:X,location:J}=await this.bb.download(V,z,!E.donotVerifySignature,E.context?.[t.$ip]);try{if(j.isCancellationRequested)throw new O.$7;const G=await(0,T.$Zq)(J.fsPath);if(!new s.$Rp(V.identifier,V.version).equals(new s.$Rp({id:(0,s.$Vp)(G.publisher,G.name)},G.version)))throw new t.$rp(i.localize(1826,null,V.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(L,J.fsPath,{id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName,targetPlatform:V.properties.targetPlatform,isApplicationScoped:E.isApplicationScoped,isMachineScoped:E.isMachineScoped,isBuiltin:E.isBuiltin,isPreReleaseVersion:V.properties.isPreReleaseVersion,hasPreReleaseVersion:V.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:E.installGivenVersion?!0:!!E.pinned,preRelease:(0,b.$ng)(E.preRelease)?E.preRelease:E.installPreReleaseVersion||V.properties.isPreReleaseVersion,source:"gallery"},!1,j),verificationStatus:X}}catch(G){try{await this.bb.delete(J)}catch(U){this.F.warn("Error while deleting the downloaded file",J.toString(),(0,O.$_)(U))}throw(0,r.$Mq)(G)}}async pb(L,V,z,E){return{local:await this.$.extractUserExtension(L,f.$nc(V.fsPath),{isApplicationScoped:z.isApplicationScoped,isMachineScoped:z.isMachineScoped,isBuiltin:z.isBuiltin,installedTimestamp:Date.now(),pinned:z.installGivenVersion?!0:!!z.pinned,source:"vsix"},z.keepExisting??!0,E)}}async qb(L){const V=async E=>{let j=await R.Promises.readdir(E);j=j.map(G=>f.$mc(E,G));const X=await Promise.all(j.map(G=>P.promises.stat(G)));let J=Promise.resolve([]);return X.forEach((G,U)=>{const K=j[U];G.isFile()&&(J=J.then(re=>[...re,K])),G.isDirectory()&&(J=J.then(re=>V(K).then(ce=>[...re,...ce])))}),J};return(await V(L.location.fsPath)).map(E=>({path:`extension/${f.$oc(L.location.fsPath,E)}`,localPath:E}))}async rb({added:L,removed:V}){if(V){const z=L&&this.D.extUri.isEqual(V.profileLocation,L.profileLocation)?V.extensions.filter(E=>L.extensions.every(j=>!(0,s.$Qp)(j,E))):V.extensions;for(const E of z)this.F.info("Extensions removed from another source",E.id,V.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:V.profileLocation})}if(L){const E=(await this.getInstalled(F.ExtensionType.User,L.profileLocation)).filter(j=>L.extensions.some(X=>(0,s.$Qp)(X,j.identifier)));this.s.fire(E.map(j=>(this.F.info("Extensions added from another source",j.identifier.id,L.profileLocation.toString()),{identifier:j.identifier,local:j,profileLocation:L.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(V=>this.sb.add(V)));const L=await this.hb.resolve(this.db.userExtensionsLocation);for(const V of L.children??[])V.isDirectory&&this.sb.add(V.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(V=>this.ub(V)))}async ub(L){if(!L.affects(this.db.userExtensionsLocation,Y.FileChangeType.ADDED))return;const V=[];for(const z of L.rawAdded){if(this.sb.has(z)||!this.D.extUri.isEqual(this.D.extUri.dirname(z),this.db.userExtensionsLocation)||this.D.extUri.isEqual(z,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(z).startsWith(".")||!(await this.hb.stat(z)).isDirectory)continue;const E=await this.$.scanUserExtensionAtLocation(z);E&&E.installedTimestamp===void 0&&(this.sb.add(z),V.push(E))}V.length&&(await this.vb(V.map(z=>[z,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",V.map(z=>z.identifier.id)))}async vb(L,V){const z=L.map(E=>E[0]);await this.wb(z),await this.eb.addExtensionsToProfile(L,V),this.s.fire(z.map(E=>({local:E,identifier:E.identifier,operation:t.InstallOperation.None,profileLocation:V})))}async wb(L){const V=await this.$.getUninstalledExtensions();for(const z of L){const E=s.$Rp.create(z);V[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.$.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$6q=q,e.$6q=q=Ee([oe(0,t.$pp),oe(1,me.$cm),oe(2,ae.$dk),oe(3,n.$Qi),oe(4,c.$Tq),oe(5,o.$Pq),oe(6,a.$6o),oe(7,ne.$Hi),oe(8,Y.$dl),oe(9,ue.$wk),oe(10,W.$Nl),oe(11,_.$Pl)],q);let x=class extends d.$Xc{constructor(L,V,z,E,j,X,J){super(),this.n=L,this.s=V,this.t=z,this.u=E,this.w=j,this.y=X,this.z=J,this.h=this.B(new g.$oe),this.onExtract=this.h.event,this.j=new h.$Dc,this.m=new h.$Dc,this.c=(0,p.$jh)(this.t.userExtensionsLocation,".obsolete"),this.g=new I.$Ph}async cleanUp(){await this.J(),await this.I()}async scanExtensions(L,V,z){try{const E={includeInvalid:!0,profileLocation:V,productVersion:z};let j=[];if(L===null||L===F.ExtensionType.System){let X=this.j.get(V);X||(X=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},E,!1).finally(()=>this.j.delete(V)),this.j.set(V,X)),j.push(...await X)}else if(L===F.ExtensionType.User){let X=this.m.get(V);X||(X=this.t.scanUserExtensions(E).finally(()=>this.m.delete(V)),this.m.set(V,X)),j.push(...await X)}return j=L!==null?j.filter(X=>X.type===L):j,await Promise.all(j.map(X=>this.H(X)))}catch(E){throw(0,r.$Mq)(E,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(L){try{const V=await this.t.scanUserExtensions({includeAllVersions:!L,includeInvalid:!0});return await Promise.all(V.map(z=>this.H(z)))}catch(V){throw(0,r.$Mq)(V,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(L){try{const V=await this.t.scanExistingExtension(L,F.ExtensionType.User,{includeInvalid:!0});if(V)return await this.H(V)}catch(V){this.z.error(V)}return null}async extractUserExtension(L,V,z,E,j){const X=L.toString(),J=y.URI.file(f.$mc(this.t.userExtensionsLocation.fsPath,`.${(0,u.$5g)()}`)),G=y.URI.file(f.$mc(this.t.userExtensionsLocation.fsPath,X));if(await this.s.exists(G)){if(!E)try{return await this.scanLocalExtension(G,F.ExtensionType.User)}catch(U){this.z.warn(`Error while scanning the existing extension at ${G.path}. Deleting the existing extension and extracting it.`,(0,O.$_)(U))}try{await this.D(L.id,G,"removeExisting")}catch{throw new t.$rp(i.localize(1827,null,G.fsPath,L.id),t.ExtensionManagementErrorCode.Delete)}}try{if(j.isCancellationRequested)throw new O.$7;try{this.z.trace(`Started extracting the extension from ${V} to ${G.fsPath}`),await(0,$.$Jq)(V,J.fsPath,{sourcePath:"extension",overwrite:!0},j),this.z.info(`Extracted extension to ${G}:`,L.id)}catch(U){throw(0,T.$Yq)(U)}try{await this.t.updateMetadata(J,z)}catch(U){throw this.y.publicLog2("extension:extract",{extensionId:L.id,code:`${(0,Y.$ul)(U)}`}),(0,r.$Mq)(U,t.ExtensionManagementErrorCode.UpdateMetadata)}if(j.isCancellationRequested)throw new O.$7;try{this.z.trace(`Started renaming the extension from ${J.fsPath} to ${G.fsPath}`),await this.G(J.fsPath,G.fsPath),this.z.info("Renamed to",G.fsPath)}catch(U){if(U.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",L.id);try{await this.s.del(J,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$_)(U)}. Deleted from extracted location`,J),U}this.h.fire(G)}catch(U){try{await this.s.del(J,{recursive:!0})}catch{}throw U}return this.scanLocalExtension(G,F.ExtensionType.User)}async scanMetadata(L,V){return V?(await this.C(L,V))?.metadata:this.t.scanMetadata(L.location)}async C(L,V){return(await this.u.scanProfileExtensions(V)).find(E=>(0,s.$Qp)(E.identifier,L.identifier))}async updateMetadata(L,V,z){try{z?await this.u.updateMetadata([[L,V]],z):await this.t.updateMetadata(L.location,V)}catch(E){throw this.y.publicLog2("extension:extract",{extensionId:L.identifier.id,code:`${(0,Y.$ul)(E)}`,isProfile:!!z}),(0,r.$Mq)(E,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(L.location,L.type,z)}async getUninstalledExtensions(){try{return await this.F()}catch(L){throw(0,r.$Mq)(L,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...L){const V=L.map(z=>s.$Rp.create(z));await this.F(z=>V.forEach(E=>{z[E.toString()]=!0,this.z.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(L){try{await this.F(V=>delete V[L.toString()])}catch(V){throw(0,r.$Mq)(V,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(L,V){if(this.w.extUri.isEqualOrParent(L.location,this.t.userExtensionsLocation))return this.D(L.identifier.id,L.location,V)}async removeUninstalledExtension(L){await this.removeExtension(L,"uninstalled"),await this.F(V=>delete V[s.$Rp.create(L).toString()])}async copyExtension(L,V,z,E){const j=await this.C(L,V),X=await this.C(L,z);if(E={...j?.metadata,...E},X)if(this.w.extUri.isEqual(X.location,L.location))await this.u.updateMetadata([[L,{...X.metadata,...E}]],z);else{const J=await this.scanLocalExtension(X.location,L.type,z);await this.u.removeExtensionFromProfile(J,z),await this.u.addExtensionsToProfile([[L,{...X.metadata,...E}]],z)}else await this.u.addExtensionsToProfile([[L,E]],z);return this.scanLocalExtension(L.location,L.type,z)}async copyExtensions(L,V,z){const E=await this.scanExtensions(F.ExtensionType.User,L,z),j=await Promise.all(E.filter(X=>!X.isApplicationScoped).map(async X=>[X,await this.scanMetadata(X,L)]));await this.u.addExtensionsToProfile(j,V)}async D(L,V,z){this.z.trace(`Deleting ${z} extension from disk`,L,V.fsPath);const E=this.w.extUri.joinPath(this.w.extUri.dirname(V),`${this.w.extUri.basename(V)}.${(0,l.$wj)((0,u.$5g)()).toString(16)}${M}`);await this.G(V.fsPath,E.fsPath),await this.s.del(E,{recursive:!0}),this.z.info(`Deleted ${z} extension from disk`,L,V.fsPath)}F(L){return this.g.queue(async()=>{let V;try{V=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,Y.$ul)(E)!==Y.FileOperationResult.FILE_NOT_FOUND)throw E}let z={};if(V)try{z=JSON.parse(V)}catch{}return L&&(L(z),Object.keys(z).length?await this.s.writeFile(this.c,v.$Qe.fromString(JSON.stringify(z))):await this.s.del(this.c)),z})}async G(L,V){try{await R.Promises.rename(L,V,2*60*1e3)}catch(z){throw(0,r.$Mq)(z,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(L,V,z){try{if(z){const j=(await this.t.scanUserExtensions({profileLocation:z})).find(X=>this.w.extUri.isEqual(X.location,L));if(j)return await this.H(j)}else{const E=await this.t.scanExistingExtension(L,V,{includeInvalid:!0});if(E)return await this.H(E)}throw new t.$rp(i.localize(1828,null,L.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(E){throw(0,r.$Mq)(E,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(L){const V=await this.s.resolve(L.location);let z,E;return V.children&&(z=V.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,E=V.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:L.identifier,type:L.type,isBuiltin:L.isBuiltin||!!L.metadata?.isBuiltin,location:L.location,manifest:L.manifest,targetPlatform:L.targetPlatform,validations:L.validations,isValid:L.isValid,readmeUrl:z,changelogUrl:E,publisherDisplayName:L.metadata?.publisherDisplayName,publisherId:L.metadata?.publisherId||null,isApplicationScoped:!!L.metadata?.isApplicationScoped,isMachineScoped:!!L.metadata?.isMachineScoped,isPreReleaseVersion:!!L.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!L.metadata?.hasPreReleaseVersion,preRelease:!!L.metadata?.preRelease,installedTimestamp:L.metadata?.installedTimestamp,updated:!!L.metadata?.updated,pinned:!!L.metadata?.pinned,isWorkspaceScoped:!1,source:L.metadata?.source??(L.identifier.uuid?"gallery":"vsix")}}async I(){const L=await this.getUninstalledExtensions();if(Object.keys(L).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(L));const V=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),z=new Set;for(const j of V)L[s.$Rp.create(j).toString()]||z.add(j.identifier.id.toLowerCase());try{const j=(0,s.$Wp)(V,X=>X.identifier);await I.Promises.settled(j.map(async X=>{const J=X.sort((G,U)=>S.rcompare(G.manifest.version,U.manifest.version))[0];z.has(J.identifier.id.toLowerCase())||await this.n(await this.H(J))}))}catch(j){this.z.error(j)}const E=V.filter(j=>j.metadata&&L[s.$Rp.create(j).toString()]);await Promise.allSettled(E.map(j=>this.removeUninstalledExtension(j)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let L;try{L=await this.s.resolve(this.t.userExtensionsLocation)}catch(V){(0,Y.$ul)(V)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(V);return}if(L?.children)try{await Promise.allSettled(L.children.map(async V=>{if(!(!V.isDirectory||!V.name.endsWith(M))){this.z.trace("Deleting the temporarily deleted folder",V.resource.toString());try{await this.s.del(V.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",V.resource.toString())}catch(z){(0,Y.$ul)(z)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(z)}}}))}catch{}}};e.$7q=x,e.$7q=x=Ee([oe(1,Y.$dl),oe(2,c.$Tq),oe(3,o.$Pq),oe(4,W.$Nl),oe(5,me.$cm),oe(6,ae.$dk)],x);let Q=class extends r.$Nq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(L,V,z,E,j,X,J,G,U,K,re,ce){super(),this.l=L,this.manifest=V,this.source=z,this.options=E,this.m=j,this.n=X,this.o=J,this.p=G,this.q=U,this.s=K,this.t=re,this.u=ce,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(L){const z=(await this.n.scanExtensions(F.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(J=>(0,s.$Qp)(J.identifier,this.identifier));z&&(this.j=t.InstallOperation.Update);const E={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===F.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof y.URI?"vsix":"gallery"};let j;if(this.source instanceof y.URI){if(z&&this.l.equals(new s.$Rp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(i.localize(1829,null,this.manifest.displayName||this.manifest.name))}const J=await this.w(this.l);if(J)try{await this.n.removeExtension(J,"existing")}catch{throw new Error(i.localize(1830,null,this.manifest.displayName||this.manifest.name))}}else{if(E.id=this.source.identifier.uuid,E.publisherId=this.source.publisherId,E.publisherDisplayName=this.source.publisherDisplayName,E.targetPlatform=this.source.properties.targetPlatform,E.updated=!!z,E.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,E.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,E.preRelease=(0,b.$ng)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==F.ExtensionType.System&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,E,this.options.profileLocation);j=await this.w(this.l)}if(L.isCancellationRequested)throw(0,r.$Mq)(new O.$7);if(!j){const J=await this.m(this.operation,L);j=J.local,this.k=J.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(J){throw(0,r.$Mq)(J,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(L.isCancellationRequested)throw(0,r.$Mq)(new O.$7);try{await this.t.addExtensionsToProfile([[j,E]],this.options.profileLocation,!j.isValid)}catch(J){throw(0,r.$Mq)(J,t.ExtensionManagementErrorCode.AddToProfile)}const X=await this.n.scanLocalExtension(j.location,F.ExtensionType.User,this.options.profileLocation);if(!X)throw new t.$rp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof y.URI&&this.x(j,L),X}async w(L){return(await this.n.getUninstalledExtensions())[L.toString()]?(this.u.trace("Removing the extension from uninstalled list:",L.id),await this.n.setInstalled(L),this.u.info("Removed the extension from uninstalled list:",L.id),(await this.n.scanAllUserExtensions(!0)).find(E=>s.$Rp.create(E).equals(L))):void 0}async x(L,V){try{let[z]=await this.p.getExtensions([{id:L.identifier.id,version:L.manifest.version}],V);if(z||([z]=await this.p.getExtensions([{id:L.identifier.id}],V)),z){const E={id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:L.hasPreReleaseVersion||z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(L,E,this.options.profileLocation)}}catch{}}};Q=Ee([oe(6,W.$Nl),oe(7,t.$pp),oe(8,_.$Pl),oe(9,c.$Tq),oe(10,o.$Pq),oe(11,ae.$dk)],Q);class ie extends r.$Nq{constructor(L,V,z){super(),this.extension=L,this.options=V,this.j=z}async h(L){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(le[140],he([0,1,6,24,23,18,42,9,17,12]),function(Z,e,P,I,v,k,C,O,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=void 0;let d=class extends C.$Qq{constructor(w,f,p,S,b,y){super(l.URI.file(w.extensionsPath),f,p,S,b,y)}};e.$3R=d,e.$3R=d=Ee([oe(0,g.$Qi),oe(1,O.$dl),oe(2,I.$Pl),oe(3,v.$Nl),oe(4,k.$cm),oe(5,P.$dk)],d)}),define(le[141],he([0,1,12,17,42,54,9,10,6,33,23,24]),function(Z,e,P,I,v,k,C,O,g,l,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;let w=class extends k.$Xq{constructor(p,S,b,y,u,R,$,i){super(P.URI.file(u.builtinExtensionsPath),P.URI.file(u.extensionsPath),u.userHome,p.defaultProfile,p,S,b,y,u,R,$,i)}};e.$wic=w,e.$wic=w=Ee([oe(0,h.$Pl),oe(1,v.$Pq),oe(2,C.$dl),oe(3,g.$dk),oe(4,I.$Qi),oe(5,l.$wk),oe(6,d.$Nl),oe(7,O.$Hi)],w)}),define(le[75],he([0,1,8,4,2,109,3,89,10,24]),function(Z,e,P,I,v,k,C,O,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$oq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$mq=e.$lq=e.$kq=void 0,e.$nq=f,e.$pq=S,e.$rq=y,e.$kq="__$__isNewStorageMarker",e.$lq="__$__targetStorageMarker",e.$mq=(0,g.$Ii)("storageService");var d;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var h;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(h||(e.StorageScope=h={}));var w;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function f(u){const R=u.get(e.$lq);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class p extends v.$Xc{static{this.a=60*1e3}constructor(R={flushInterval:p.a}){super(),this.m=R,this.b=this.B(new I.$re),this.c=this.B(new I.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new I.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(R,$,i){return I.Event.filter(this.b.event,a=>a.scope===R&&($===void 0||a.key===$),i)}n(){this.j.value=(0,P.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(R,$){const{key:i,external:a}=$;if(i===e.$lq){switch(R){case h.APPLICATION:this.H=void 0;break;case h.PROFILE:this.F=void 0;break;case h.WORKSPACE:this.C=void 0;break}this.c.fire({scope:R})}else this.b.fire({scope:R,key:i,target:this.J(R)[i],external:a})}w(R){this.f.fire({reason:R})}get(R,$,i){return this.P($)?.get(R,i)}getBoolean(R,$,i){return this.P($)?.getBoolean(R,i)}getNumber(R,$,i){return this.P($)?.getNumber(R,i)}getObject(R,$,i){return this.P($)?.getObject(R,i)}storeAll(R,$){this.y(()=>{for(const i of R)this.store(i.key,i.value,i.scope,i.target,$)})}store(R,$,i,a,n=!1){if((0,C.$qg)($)){this.remove(R,i,n);return}this.y(()=>{this.z(R,i,a),this.P(i)?.set(R,$,n)})}remove(R,$,i=!1){this.y(()=>{this.z(R,$,void 0),this.P($)?.delete(R,i)})}y(R){this.b.pause(),this.c.pause();try{R()}finally{this.b.resume(),this.c.resume()}}keys(R,$){const i=[],a=this.J(R);for(const n of Object.keys(a))a[n]===$&&i.push(n);return i}z(R,$,i,a=!1){const n=this.J($);typeof i=="number"?n[R]!==i&&(n[R]=i,this.P($)?.set(e.$lq,JSON.stringify(n),a)):typeof n[R]=="number"&&(delete n[R],this.P($)?.set(e.$lq,JSON.stringify(n),a))}get D(){return this.C||(this.C=this.L(h.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(h.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(h.APPLICATION)),this.H}J(R){switch(R){case h.APPLICATION:return this.I;case h.PROFILE:return this.G;default:return this.D}}L(R){const $=this.P(R);return $?f($):Object.create(null)}isNew(R){return this.getBoolean(e.$kq,R)===!0}async flush(R=d.NONE){this.f.fire({reason:R});const $=this.P(h.APPLICATION),i=this.P(h.PROFILE),a=this.P(h.WORKSPACE);switch(R){case d.NONE:await P.Promises.settled([$?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await P.Promises.settled([$?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.P(h.APPLICATION)?.items??new Map,$=this.P(h.PROFILE)?.items??new Map,i=this.P(h.WORKSPACE)?.items??new Map;return y(R,$,i,this.Q(h.APPLICATION)??"",this.Q(h.PROFILE)??"",this.Q(h.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.P(R)?.optimize()}async switch(R,$){return this.w(d.NONE),(0,l.$Ol)(R)?this.R(R,$):this.S(R,$)}M(R,$){return!(R.id===$.id||S($)&&S(R))}N(R,$,i){this.y(()=>{const a=new Set;for(const[n,r]of R)a.add(n),$.get(n)!==r&&this.u(i,{key:n,external:!0});for(const[n]of $.items)a.has(n)||this.u(i,{key:n,external:!0})})}}e.$oq=p;function S(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class b extends p{constructor(){super(),this.U=this.B(new O.$iq(new O.$jq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$iq(new O.$jq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$iq(new O.$jq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(R=>this.u(h.WORKSPACE,R))),this.B(this.W.onDidChangeStorage(R=>this.u(h.PROFILE,R))),this.B(this.U.onDidChangeStorage(R=>this.u(h.APPLICATION,R)))}P(R){switch(R){case h.APPLICATION:return this.U;case h.PROFILE:return this.W;default:return this.X}}Q(R){switch(R){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(R){return!1}}e.$qq=b;async function y(u,R,$,i,a,n){const r=A=>{try{return JSON.parse(A)}catch{return A}},t=new Map,s=new Map;u.forEach((A,F)=>{t.set(F,A),s.set(F,r(A))});const o=new Map,c=new Map;R.forEach((A,F)=>{o.set(F,A),c.set(F,r(A))});const m=new Map,N=new Map;$.forEach((A,F)=>{m.set(F,A),N.set(F,r(A))}),console.group(i!==a?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(t.forEach((A,F)=>{T.push({key:F,value:A})}),console.table(T),console.groupEnd(),console.log(s),i!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const A=[];o.forEach((F,H)=>{A.push({key:H,value:F})}),console.table(A),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${n})`);const D=[];m.forEach((A,F)=>{D.push({key:F,value:A})}),console.table(D),console.groupEnd(),console.log(N)}}),define(le[142],he([0,1,13,28,75]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=k;async function k(C,O,g){let l=g&&g.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(l)return l;try{const h=(await O.readFile(C.serviceMachineIdResource)).value.toString();l=(0,I.$4g)(h)?h:null}catch{l=null}if(!l){l=(0,I.$5g)();try{await O.writeFile(C.serviceMachineIdResource,P.$Qe.fromString(l))}catch{}}return g?.store("storage.serviceMachineId",l,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),l}}),define(le[143],he([0,1,142,18,41]),function(Z,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=k;async function k(C,O,g,l,d,h,w){const f={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${O.nameShort})`};if((0,v.$Ip)(O,g)&&(0,v.$Kp)(l)===I.TelemetryLevel.USAGE){const p=await(0,P.$sq)(g,d,h);f["X-Market-User-Id"]=p,f["VSCode-SessionId"]=w.machineId||p}return f}}),define(le[144],he([0,1,19,21,7,11,36,3,12,88,30,17,20,26,22,44,9,6,33,46,143,75,18,156]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u,R,$,i,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=void 0,e.$uq=V;const r=k.$p?p.TargetPlatform.WEB:(0,w.$lp)(k.$v,C.$hc),t="X-Market-Search-Activity-Id";var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished",G[G.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function o(...G){return String(G.reduce((U,K)=>U|K,0))}var c;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const m={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},N={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},D={pageNumber:1,pageSize:10,sortBy:w.SortBy.NoneOrRelevance,sortOrder:w.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class A{constructor(U=D){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,K=this.d.pageSize){return new A({...this.d,pageNumber:U,pageSize:K})}withFilter(U,...K){const re=[...this.d.criteria,...K.length?K.map(ce=>({filterType:U,value:ce})):[{filterType:U}]];return new A({...this.d,criteria:re})}withSortBy(U){return new A({...this.d,sortBy:U})}withSortOrder(U){return new A({...this.d,sortOrder:U})}withFlags(...U){return new A({...this.d,flags:U.reduce((K,re)=>K|re,0)})}withAssetTypes(...U){return new A({...this.d,assetTypes:U})}withSource(U){return new A({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:K,pageSize:re,sortBy:ce,sortOrder:fe,flags:we,assetTypes:de}=this.d;return{filters:[{criteria:U,pageNumber:K,pageSize:re,sortBy:ce,sortOrder:fe}],assetTypes:de,flags:we}}get searchText(){const U=this.d.criteria.filter(K=>K.filterType===c.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function F(G,U){const K=(G||[]).filter(re=>re.statisticName===U)[0];return K?K.value:0}function H(G){const U="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(re=>re.assetType.indexOf(U)===0).reduce((re,ce)=>{const fe=ae(G,ce.assetType);return fe&&re.push([ce.assetType.substring(U.length),fe]),re},[])}function Y(G){if(G.properties){const U=G.properties.filter(ce=>ce.key===m.Repository),K=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=U.filter(ce=>K.test(ce.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return ae(G,m.Repository)}function ne(G){return{uri:`${G.fallbackAssetUri}/${m.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${m.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function ae(G,U){return G.files.filter(re=>re.assetType===U)[0]?{uri:`${G.assetUri}/${U}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${U}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}:null}function ue(G,U){const K=G.properties?G.properties.filter(ce=>ce.key===U):[],re=K.length>0&&K[0].value;return re?re.split(",").map(ce=>(0,f.$Up)(ce)):[]}function me(G){const U=G.properties?G.properties.filter(K=>K.key===N.Engine):[];return U.length>0&&U[0].value||""}function W(G){const U=G.properties?G.properties.filter(K=>K.key===N.PreRelease):[];return U.length>0&&U[0].value==="true"}function _(G){const U=G.properties?G.properties.filter(K=>K.key===N.ExecutesCode):[];return U.length>0?U[0].value==="true":void 0}function M(G){const U=G.properties?G.properties.filter(re=>re.key===N.EnabledApiProposals):[],K=U.length>0&&U[0].value||"";return K?K.split(","):[]}function q(G){const U=G.properties?G.properties.filter(re=>re.key===N.LocalizedLanguages):[],K=U.length>0&&U[0].value||"";return K?K.split(","):[]}function x(G){return G.properties?.find(U=>U.key===N.SponsorLink)?.value}function Q(G){return G.properties?.find(U=>U.key===N.SupportLink)?.value}function ie(G){return G.indexOf("preview")!==-1}function se(G){return G.targetPlatform?(0,w.$kp)(G.targetPlatform):p.TargetPlatform.UNDEFINED}function L(G){const U=(0,P.$Ob)(G.versions.map(se)),K=!!G.tags?.includes(w.$ep),re=U.indexOf(p.TargetPlatform.WEB);return K?re===-1&&U.push(p.TargetPlatform.WEB):re!==-1&&U.splice(re,1),U}function V(G,U){for(let K=0;K<G.length;K++){const re=G[K];if(re.version===G[K-1]?.version){let ce=K;if(se(re)===U)for(;ce>0&&G[ce-1].version===re.version;)ce--;ce!==K&&(G.splice(K,1),G.splice(ce,0,re))}}return G}function z(G,U,K){G.telemetryData={index:U,querySource:K,queryActivityId:G.queryContext?.[t]}}function E(G,U,K,re){const ce=G.versions[0],fe={manifest:ae(U,m.Manifest),readme:ae(U,m.Details),changelog:ae(U,m.Changelog),license:ae(U,m.License),repository:Y(U),download:ne(U),icon:ae(U,m.Icon),signature:ae(U,m.Signature),coreTranslations:H(U)};return{type:"gallery",identifier:{id:(0,f.$Vp)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:U.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(ce),description:G.shortDescription??"",installCount:F(G.statistics,"install"),rating:F(G.statistics,"averagerating"),ratingCount:F(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:K,assets:fe,properties:{dependencies:ue(U,N.Dependency),extensionPack:ue(U,N.ExtensionPack),engine:me(U),enabledApiProposals:M(U),localizedLanguages:q(U),targetPlatform:se(U),isPreReleaseVersion:W(U),executesCode:_(U)},hasPreReleaseVersion:W(ce),hasReleaseVersion:!0,preview:ie(G.flags),isSigned:!!fe.signature,queryContext:re,supportLink:Q(ce)}}let j=class{constructor(U,K,re,ce,fe,we,de,pe){this.l=K,this.n=re,this.o=ce,this.q=fe,this.u=we,this.w=de,this.x=pe;const ye=de.extensionsGallery,$e=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=$e?ye.servicePPEUrl:ye?.serviceUrl,this.g=$e?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.k=de.extensionsEnabledWithApiProposalVersion?.map(ve=>ve.toLowerCase())??[],this.j=(0,$.$tq)(de.version,de,this.o,this.x,this.u,U,this.q)}y(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,K,re){const ce=I.CancellationToken.isCancellationToken(K)?{}:K,fe=I.CancellationToken.isCancellationToken(K)?K:re,we=[],de=[],pe=[],ye=[];let $e=!0;for(const ee of U){ee.uuid?de.push(ee.uuid):we.push(ee.id);const te=!!(ee.version||ee.preRelease);pe.push({id:ee.id,uuid:ee.uuid,includePreRelease:te}),ee.version&&ye.push({id:ee.id,uuid:ee.uuid,version:ee.version}),$e=$e&&!!ee.hasPreRelease&&!te}if(!de.length&&!we.length)return[];let ve=new A().withPage(1,U.length);de.length&&(ve=ve.withFilter(c.ExtensionId,...de)),we.length&&(ve=ve.withFilter(c.ExtensionName,...we)),(ce.queryAllVersions||$e)&&(ve=ve.withFlags(ve.flags,s.IncludeVersions)),ce.source&&(ve=ve.withSource(ce.source));const{extensions:B}=await this.B(ve,{targetPlatform:ce.targetPlatform??r,includePreRelease:pe,versions:ye,compatible:!!ce.compatible,productVersion:ce.productVersion??{version:this.w.version,date:this.w.date}},fe);return ce.source&&B.forEach((ee,te)=>z(ee,te,ce.source)),B}async getCompatibleExtension(U,K,re,ce={version:this.w.version,date:this.w.date}){if((0,w.$mp)(U.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(U,K,re))return U;const fe=new A().withFlags(s.IncludeVersions).withPage(1,1).withFilter(c.ExtensionId,U.identifier.uuid),{extensions:we}=await this.B(fe,{targetPlatform:re,compatible:!0,includePreRelease:K,productVersion:ce},I.CancellationToken.None);return we[0]||null}async isExtensionCompatible(U,K,re,ce={version:this.w.version,date:this.w.date}){if(!(0,w.$np)(U.properties.targetPlatform,U.allTargetPlatforms,re)||!K&&U.properties.isPreReleaseVersion)return!1;let fe=U.properties.engine;if(!fe){const we=await this.getManifest(U,I.CancellationToken.None);if(!we)throw new Error("Manifest was not found");fe=we.engines.vscode}return!(!(0,S.$0p)(fe,ce.version,ce.date)||!this.z(U.identifier,U.properties.enabledApiProposals))}z(U,K){return!K||!this.k.includes(U.id.toLowerCase())?!0:(0,S.$$p)(K)}async A(U,K,re,ce,fe,we,de={version:this.w.version,date:this.w.date}){if(!(0,w.$np)(se(K),fe,we)||re!=="any"&&W(K)!==(re==="prerelease"))return!1;if(ce)try{const pe=await this.G(U,K);if(!(0,S.$0p)(pe,de.version,de.date))return!1}catch(pe){return this.n.error(`Error while getting the engine for the version ${K.version}.`,(0,v.$_)(pe)),!1}return!0}async query(U,K){let re=U.text||"";const ce=U.pageSize??50;let fe=new A().withPage(1,ce);re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,ve,B)=>(fe=fe.withFilter(c.Category,B||ve),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,ve,B)=>(fe=fe.withFilter(c.Tag,B||ve),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(c.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),fe=fe.withFilter(c.SearchText,re)),fe=fe.withSortBy(w.SortBy.NoneOrRelevance)):U.ids?fe=fe.withFilter(c.ExtensionId,...U.ids):U.names?fe=fe.withFilter(c.ExtensionName,...U.names):fe=fe.withSortBy(w.SortBy.InstallCount),typeof U.sortBy=="number"&&(fe=fe.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(fe=fe.withSortOrder(U.sortOrder)),U.source&&(fe=fe.withSource(U.source));const we=async($e,ve)=>{const{extensions:B,total:ee}=await this.B($e,{targetPlatform:r,compatible:!1,includePreRelease:!!U.includePreRelease,productVersion:U.productVersion??{version:this.w.version,date:this.w.date}},ve);return B.forEach((te,ge)=>z(te,($e.pageNumber-1)*$e.pageSize+ge,U.source)),{extensions:B,total:ee}},{extensions:de,total:pe}=await we(fe,K),ye=async($e,ve)=>{if(ve.isCancellationRequested)throw new v.$7;const{extensions:B}=await we(fe.withPage($e+1),ve);return B};return{firstPage:de,total:pe,pageSize:fe.pageSize,getPage:ye}}async B(U,K,re){const ce=U.flags;U.flags&s.IncludeLatestVersionOnly&&U.flags&s.IncludeVersions&&(U=U.withFlags(U.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(U.flags&s.IncludeLatestVersionOnly)&&!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags,s.IncludeLatestVersionOnly)),K.versions?.length&&(U=U.withFlags(U.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),U=U.withFlags(U.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:fe,total:we,context:de}=await this.D(U,re);if(!(U.flags&s.IncludeLatestVersionOnly)){const ve=[];for(const B of fe){const ee=await this.C(B,K,de);ee&&ve.push(ee)}return{extensions:ve,total:we}}const ye=[],$e=new Map;for(let ve=0;ve<fe.length;ve++){const B=fe[ve],ee={id:(0,f.$Vp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},te=(0,O.$ng)(K.includePreRelease)?K.includePreRelease:!!K.includePreRelease.find(Se=>(0,f.$Qp)(Se,ee))?.includePreRelease;if(K.compatible&&(0,w.$mp)(L(B),K.targetPlatform))continue;const ge=await this.C(B,K,de);!ge||ge.properties.isPreReleaseVersion&&(!te||!ge.hasReleaseVersion)||!ge.properties.isPreReleaseVersion&&ge.properties.targetPlatform!==K.targetPlatform&&ge.hasPreReleaseVersion?$e.set(B.extensionId,ve):ye.push([ve,ge])}if($e.size){const ve=new n.$ie,B=new A().withFlags(ce&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,$e.size).withFilter(c.ExtensionId,...$e.keys()),{extensions:ee}=await this.B(B,K,re);this.q.publicLog2("galleryService:additionalQuery",{duration:ve.elapsed(),count:$e.size});for(const te of ee){const ge=$e.get(te.identifier.uuid);ye.push([ge,te])}}return{extensions:ye.sort((ve,B)=>ve[0]-B[0]).map(([,ve])=>ve),total:we}}async C(U,K,re){const ce={id:(0,f.$Vp)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},fe=K.versions?.find(ye=>(0,f.$Qp)(ye,ce))?.version,we=(0,O.$ng)(K.includePreRelease)?K.includePreRelease:!!K.includePreRelease.find(ye=>(0,f.$Qp)(ye,ce))?.includePreRelease,de=L(U),pe=V(U.versions,K.targetPlatform);if(K.compatible&&(0,w.$mp)(de,K.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const $e=pe[ye];if(!(fe&&$e.version!==fe)){if(await this.A(ce.id,$e,we?"any":"release",K.compatible,de,K.targetPlatform,K.productVersion))return K.compatible&&!this.z(ce,M($e))?null:E(U,$e,de,re);if(fe&&$e.version===fe)return null}}return fe||K.compatible?null:E(U,U.versions[0],de)}async D(U,K){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(c.Target,"Microsoft.VisualStudio.Code").withFilter(c.ExcludeWithFlags,o(s.Unpublished));const re=await this.j,ce=JSON.stringify(U.raw),fe={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},we=new n.$ie;let de,pe,ye=0;try{if(de=await this.l.request({type:"POST",url:this.g&&U.criteria.some(ve=>ve.filterType===c.SearchText)?this.g:this.y("/extensionquery"),data:ce,headers:fe},K),de.res.statusCode&&de.res.statusCode>=400&&de.res.statusCode<500)return{galleryExtensions:[],total:ye};const $e=await(0,R.$fq)(de);if($e){const ve=$e.results[0],B=ve.extensions,ee=ve.resultMetadata&&ve.resultMetadata.filter(te=>te.metadataType==="ResultCount")[0];return ye=ee&&ee.metadataItems.filter(te=>te.name==="TotalCount")[0].count||0,{galleryExtensions:B,total:ye,context:de.res.headers.activityid?{[t]:de.res.headers.activityid}:{}}}return{galleryExtensions:[],total:ye}}catch($e){if((0,v.$6)($e))throw pe=w.ExtensionGalleryErrorCode.Cancelled,$e;{const ve=(0,v.$_)($e);throw pe=(0,l.$ap)($e)?w.ExtensionGalleryErrorCode.Offline:ve.startsWith("XHR timeout")?w.ExtensionGalleryErrorCode.Timeout:w.ExtensionGalleryErrorCode.Failed,new w.$qp(ve,pe)}}finally{this.q.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ce.length),duration:we.elapsed(),success:!!de&&(0,R.$bq)(de),responseBodySize:de?.res.headers["Content-Length"],statusCode:de?String(de.res.statusCode):void 0,errorCode:pe,count:String(ye)})}}async reportStatistic(U,K,re,ce){if(!this.isEnabled())return;const fe=k.$p?this.y(`/itemName/${U}.${K}/version/${re}/statType/${ce===w.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${U}/extensions/${K}/${re}/stats?statType=${ce}`),we=k.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:we};try{await this.l.request({type:"POST",url:fe,headers:pe},I.CancellationToken.None)}catch{}}async download(U,K,re){this.n.trace("ExtensionGalleryService#download",U.identifier.id);const ce=(0,f.$Yp)(U),fe=new Date().getTime(),we=re===w.InstallOperation.Install?"install":re===w.InstallOperation.Update?"update":"",de=we?{uri:`${U.assets.download.uri}${g.URI.parse(U.assets.download.uri).query?"&":"?"}${we}=true`,fallbackUri:`${U.assets.download.fallbackUri}${g.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${we}=true`}:U.assets.download,pe=U.queryContext?.[t]?{[t]:U.queryContext[t]}:void 0,ye=await this.F(U.identifier.id,de,m.VSIX,pe?{headers:pe}:void 0);try{await this.u.writeFile(K,ye.stream)}catch($e){try{await this.u.del(K)}catch(ve){this.n.warn(`Error while deleting the file ${K.toString()}`,(0,v.$_)(ve))}throw new w.$qp((0,v.$_)($e),w.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ce,duration:new Date().getTime()-fe})}async downloadSignatureArchive(U,K){if(!U.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const re=await this.F(U.identifier.id,U.assets.signature,m.Signature);try{await this.u.writeFile(K,re.stream)}catch(ce){try{await this.u.del(K)}catch(fe){this.n.warn(`Error while deleting the file ${K.toString()}`,(0,v.$_)(fe))}throw new w.$qp((0,v.$_)(ce),w.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(U,K){if(U.assets.readme){const re=await this.F(U.identifier.id,U.assets.readme,m.Details,{},K);return await(0,R.$eq)(re)||""}return""}async getManifest(U,K){if(U.assets.manifest){const re=await this.F(U.identifier.id,U.assets.manifest,m.Manifest,{},K),ce=await(0,R.$eq)(re);return ce?JSON.parse(ce):null}return null}async E(U,K,re){const ce=ae(K,m.Manifest);if(!ce)throw new Error("Manifest was not found");const fe={"Accept-Encoding":"gzip"},we=await this.F(U,ce,m.Manifest,{headers:fe});return await(0,R.$fq)(we)}async getCoreTranslation(U,K){const re=U.assets.coreTranslations.filter(ce=>ce[0]===K.toUpperCase())[0];if(re){const ce=await this.F(U.identifier.id,re[1],re[0]),fe=await(0,R.$eq)(ce);return fe?JSON.parse(fe):null}return null}async getChangelog(U,K){if(U.assets.changelog){const re=await this.F(U.identifier.id,U.assets.changelog,m.Changelog,{},K);return await(0,R.$eq)(re)||""}return""}async getAllCompatibleVersions(U,K,re){let ce=new A().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.uuid?ce=ce.withFilter(c.ExtensionId,U.uuid):ce=ce.withFilter(c.ExtensionName,U.id);const{galleryExtensions:fe}=await this.D(ce,I.CancellationToken.None);if(!fe.length)return[];const we=L(fe[0]);if((0,w.$mp)(we,re))return[];const de=[];await Promise.all(fe[0].versions.map(async $e=>{try{await this.A(U.id,$e,K?"any":"release",!0,we,re)&&this.z(U,M($e))&&de.push($e)}catch{}}));const pe=[],ye=new Set;for(const $e of V(de,re))ye.has($e.version)||(ye.add($e.version),pe.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:W($e)}));return pe}async F(U,K,re,ce={},fe=I.CancellationToken.None){const we=await this.j,de={type:"GET"},pe={...we,...ce.headers||{}};ce={...ce,...de,headers:pe};const ye=K.uri,$e=K.fallbackUri,ve={...ce,url:ye};try{const B=await this.l.request(ve,fe);if(B.res.statusCode===200)return B;const ee=await(0,R.$eq)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${ee}`)}catch(B){if((0,v.$6)(B))throw B;const ee=(0,v.$_)(B);this.q.publicLog2("galleryService:cdnFallback",{extension:U,assetType:re,message:ee});const te={...ce,url:$e};return this.l.request(te,fe)}}async G(U,K){let re=me(K);if(!re){this.q.publicLog2("galleryService:engineFallback",{extension:U,version:K.version});const ce=await this.E(U,K,I.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");re=ce.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const U=await this.l.request({type:"GET",url:this.h},I.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const K=await(0,R.$fq)(U),re=[],ce={},fe=[],we=[];if(K){for(const de of K.malicious)re.push({id:de});if(K.migrateToPreRelease)for(const[de,pe]of Object.entries(K.migrateToPreRelease))(!pe.engine||(0,S.$0p)(pe.engine,this.w.version,this.w.date))&&(ce[de.toLowerCase()]={disallowInstall:!0,extension:{id:pe.id,displayName:pe.displayName,autoMigrate:{storage:!!pe.migrateStorage},preRelease:!0}});if(K.deprecated)for(const[de,pe]of Object.entries(K.deprecated))pe&&(ce[de.toLowerCase()]=(0,O.$ng)(pe)?{}:pe);if(K.search)for(const de of K.search)fe.push(de);if(Array.isArray(K.extensionsEnabledWithPreRelease))for(const de of K.extensionsEnabledWithPreRelease)we.push(de.toLowerCase())}return{malicious:re,deprecated:ce,search:fe,extensionsEnabledWithPreRelease:we}}};j=Ee([oe(1,R.$_p),oe(2,y.$dk),oe(3,h.$Pi),oe(4,a.$cm),oe(5,b.$dl),oe(6,u.$wk),oe(7,d.$cj)],j);let X=class extends j{constructor(U,K,re,ce,fe,we,de,pe){super(U,K,re,ce,fe,we,de,pe)}};e.$vq=X,e.$vq=X=Ee([oe(0,i.$mq),oe(1,R.$_p),oe(2,y.$dk),oe(3,h.$Pi),oe(4,a.$cm),oe(5,b.$dl),oe(6,u.$wk),oe(7,d.$cj)],X);let J=class extends j{constructor(U,K,re,ce,fe,we,de){super(void 0,U,K,re,ce,fe,we,de)}};e.$wq=J,e.$wq=J=Ee([oe(0,R.$_p),oe(1,y.$dk),oe(2,h.$Pi),oe(3,a.$cm),oe(4,b.$dl),oe(5,u.$wk),oe(6,d.$cj)],J)}),define(le[145],he([0,1,12,17,9,6,124,23,24,3,71]),function(Z,e,P,I,v,k,C,O,g,l,d){"use strict";var h,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=e.$1R=e.$ZR=void 0;let f=class extends g.$Sl{static{h=this}static{this.a="profileAssociationsMigration"}constructor(y,u,R,$,i){super(R,$,u,i),this.U=y,this.W=R}O(){return this.U.getItem(h.b,[]).map(u=>({...u,location:(0,l.$hg)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):P.URI.revive(u.location)}))}Q(){const y=this.U.getItem(h.c,{});return this.U.getItem(h.a,!1)?y:this.N(y)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$ZR=f,e.$ZR=f=h=Ee([oe(0,C.$UR),oe(1,O.$Nl),oe(2,I.$Qi),oe(3,v.$dl),oe(4,k.$dk)],f);let p=w=class extends f{constructor(y,u,R,$,i){super(y,u,R,$,i),this.$=y}P(y){y.length?this.$.setItem(w.b,y.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(w.b)}O(){const y=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(y),this.$.setItem("userDataProfilesMigration",!0)),y}R(y){y.emptyWindows||y.workspaces?this.$.setItem(w.c,y):this.$.removeItem(w.c)}Q(){const y="workspaceAndProfileInfo",u=this.$.getItem(y,void 0);if(u){this.$.removeItem(y);const $=u.reduce((i,{workspace:a,profile:n})=>(i[P.URI.revive(a).toString()]=P.URI.revive(n).toString(),i),{});this.$.setItem(w.c,{workspaces:$})}const R=super.Q();return this.$.getItem(w.a,!1)||(this.R(R),this.$.setItem(w.a,!0)),R}};e.$1R=p,e.$1R=p=w=Ee([oe(0,C.$VR),oe(1,O.$Nl),oe(2,I.$Qi),oe(3,v.$dl),oe(4,k.$dk)],p);let S=class extends p{constructor(y,u,R,$){super(new d.$YR(d.SaveStrategy.IMMEDIATE,u,$,R),y,u,R,$)}async init(){return await this.$.init(),super.init()}};e.$2R=S,e.$2R=S=Ee([oe(0,O.$Nl),oe(1,I.$Qi),oe(2,v.$dl),oe(3,k.$dk)],S)}),define(le[146],he([0,1,122,8,13,7,3,30,17,123,6,46,121,157]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0,e.$ms=b;let p=class extends h.$aq{constructor(u,R,$,i){super(i),this.m=u,this.n=R,this.r=$,this.s(),this.B(u.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,R){const{f:$,g:i}=this;let a;try{a=await(0,l.$Um)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$_)(t)))}const n={...process.env,...a},r=u.agent?u.agent:await(0,w.$ks)(u.url||"",n,{proxyUrl:$,strictSSL:i});return u.agent=r,u.strictSSL=i,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>b(u,R))}async resolveProxy(u){}async lookupAuthorization(u){}async lookupKerberosAuthorization(u){try{const R=await new Promise((r,t)=>{Z(["kerberos"],r,t)}).then(be),$=new URL(u),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${$.hostname}`:`HTTP@${$.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${$}`,`spn:${i}`),"Negotiate "+await(await R.initializeClient(i)).step("")}catch(R){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",R);return}}async loadCertificates(){return(await new Promise((R,$)=>{Z(["@vscode/proxy-agent"],R,$)}).then(be)).loadSystemCertificates({log:this.r})}};e.$ls=p,e.$ls=p=Ee([oe(0,O.$cj),oe(1,g.$Qi),oe(2,d.$dk),oe(3,d.$ek)],p);async function S(y){return((0,P.parse)(y.url).protocol==="https:"?await new Promise(($,i)=>{Z(["https"],$,i)}).then(be):await new Promise(($,i)=>{Z(["http"],$,i)}).then(be)).request}async function b(y,u){return I.Promises.withAsyncBody(async(R,$)=>{const i=(0,P.parse)(y.url),a=y.getRawRequest?y.getRawRequest(y):await S(y),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,C.$ng)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(n.auth=y.user+":"+y.password);const r=a(n,t=>{const s=(0,C.$lg)(y.followRedirects)?y.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)b({...y,url:t.headers.location,followRedirects:s-1},u).then(R,$);else{let o=t;!y.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,f.createGunzip)())),R({res:t,stream:(0,v.$6e)(o)})}});r.on("error",$),y.timeout&&r.setTimeout(y.timeout),y.isChromiumNetwork&&r.removeHeader("Content-Length"),y.data&&typeof y.data=="string"&&r.write(y.data),r.end(),u.onCancellationRequested(()=>{r.abort(),$(new k.$7)})})}});var ze=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[158],he([0,1,32,35,8,38,7,2,14,15,11,36,12,30,118,63,120,17,96,144,20,73,125,42,54,139,141,9,108,110,51,106,66,70,127,6,114,39,115,130,33,46,146,71,72,18,129,41,131,132,23,134,24,145,133,140,111,113,5,135,159]),function(Z,e,P,I,v,k,C,O,g,l,d,h,w,f,p,S,b,y,u,R,$,i,a,n,r,t,s,o,c,m,N,T,D,A,F,H,Y,ne,ae,ue,me,W,_,M,q,x,Q,ie,se,L,V,z,E,j,X,J,G,U,K,re,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=we,P=be(P),ue=ze(ue);class fe extends O.$Xc{constructor(pe){super(),this.b=pe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[pe,ye]=await this.f();return pe.invokeFunction(async $e=>{const ve=$e.get(H.$dk),B=$e.get(o.$dl),ee=$e.get(y.$Qi),te=$e.get(E.$Pl);ve.info("CLI main",this.b),this.h(ve),await this.j(ee,B,te,pe),await Promise.all(ye.map(ge=>{(0,v.$zh)(ge.flush(),1e3)}))})}async f(){const pe=new D.$Gi,ye={_serviceBrand:void 0,...ue.default};pe.set(me.$wk,ye);const $e=new u.$an(this.b,ye);pe.set(y.$Qi,$e),await Promise.all([this.g($e.appSettingsHome.with({scheme:g.Schemas.file}).fsPath),this.g($e.extensionsPath)].map(Ie=>Ie?P.promises.mkdir(Ie,{recursive:!0}):void 0));const ve=new U.$TR((0,H.$rk)($e),$e.logsHome);pe.set(H.$ek,ve);const B=this.B(ve.createLogger("cli",{name:(0,K.localize)(171,null)})),ee=[];ve.getLogLevel()===H.LogLevel.Trace&&ee.push(new H.$lk(ve.getLogLevel()));const te=this.B(new G.$4R(B,ee));pe.set(H.$dk,te);const ge=this.B(new c.$9q(te));pe.set(o.$dl,ge);const Se=this.B(new m.$zr(te));ge.registerProvider(g.Schemas.file,Se);const De=new z.$1s(ge);pe.set(V.$Nl,De);const ke=new M.$XR(M.SaveStrategy.DELAYED,$e,te,ge),Te=new j.$ZR(ke,De,$e,ge,te);pe.set(E.$Pl,Te),ge.registerProvider(g.Schemas.vscodeUserData,new re.$Zic(g.Schemas.file,Se,g.Schemas.vscodeUserData,Te,De,te));const Re=d.$j&&ye.win32RegValueName?this.B(new ae.$Xic(te,ye.win32RegValueName)):$e.policyFile?this.B(new Y.$Yic($e.policyFile,ge,te)):new ne.$zo;pe.set(ne.$xo,Re);const Ce=this.B(new p.$2o(Te.defaultProfile.settingsResource,ge,Re,te));pe.set(f.$cj,Ce),await Promise.all([ke.init(),Ce.initialize()]);let qe;try{qe=await(0,X.$zic)(ke,te)}catch(Ie){Ie.code!=="ENOENT"&&te.error(Ie)}const Ae=await(0,X.$Aic)(ke,te),Le=await(0,X.$Bic)(ke,te);Te.init(),pe.set(V.$Nl,new z.$1s(ge));const je=new _.$ls(Ce,$e,te,ve);pe.set(W.$_p,je),pe.set(S.$6o,new N.$Fi(b.$iS,void 0,!0)),pe.set(n.$Pq,new N.$Fi(J.$3R,void 0,!0)),pe.set(r.$Tq,new N.$Fi(s.$wic,void 0,!0)),pe.set(i.$zq,new N.$Fi(i.$Bq,void 0,!0)),pe.set(t.$5q,new N.$Fi(t.$6q,void 0,!0)),pe.set($.$pp,new N.$Fi(R.$wq,void 0,!0)),pe.set(A.$fs,new N.$Fi(F.$hs,void 0,!1));const Ue=[],Pe=(0,ie.$Np)(ye,Ce);if((0,ie.$Ip)(ye,$e)){ye.aiConfig&&ye.aiConfig.ariaKey&&Ue.push(new se.$RR(je,Pe,"monacoworkbench",null,ye.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,q.$zp)((0,I.release)(),(0,I.hostname)(),process.arch,ye.commit,ye.version,qe,Ae,Le,Pe),piiPaths:(0,ie.$Op)($e)};pe.set(x.$cm,new N.$Fi(Q.$ns,[Ie],!1))}else pe.set(x.$cm,ie.$Dp);return[new T.$Cr(pe),Ue]}g(pe){if(d.$j){const ye=(0,ce.getUNCHost)(pe);ye&&(0,ce.addUNCHostToAllowlist)(ye)}return pe}h(pe){(0,C.setUnexpectedErrorHandler)(ye=>{const $e=(0,k.$tj)(ye,!0);$e&&pe.error(`[uncaught exception in CLI]: ${$e}`)}),process.on("uncaughtException",ye=>{(0,C.$1)(ye)||(0,C.$2)(ye)}),process.on("unhandledRejection",ye=>(0,C.$2)(ye))}async j(pe,ye,$e,ve){let B;if(pe.args.profile&&(B=$e.profiles.find(te=>te.name===pe.args.profile),!B))throw new Error(`Profile '${pe.args.profile}' not found.`);const ee=(B??$e.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ve.createInstance(a.$Cq,new H.$lk(H.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return ve.createInstance(a.$Cq,new H.$lk(H.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return ve.createInstance(a.$Cq,new H.$lk(H.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return ve.createInstance(a.$Cq,new H.$lk(H.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return ve.createInstance(a.$Cq,new H.$lk(H.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,L.$djc)(pe.appRoot,pe.extensionsPath))}}m(pe){return pe.map(ye=>/\.vsix$/i.test(ye)?w.URI.file((0,l.$lc)(ye)?ye:(0,l.$mc)((0,h.cwd)(),ye)):ye)}}async function we(de){const pe=new fe(de);try{await pe.run()}finally{pe.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2aa3c4625ed4b46448fa546ac5f2e93b0757718/core/vs/code/node/cliProcessMain.js.map
